/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(x){for(var e=[],S=0,M=x.length;S<M;S++)e[S]=Z[x[S]];return e};define(Z[123],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(k,g){const d=Math.pow(10,g);return Math.round(k*d)/d}class M{constructor(g,d,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,d){return g.r===d.r&&g.g===d.g&&g.b===d.b&&g.a===d.a}}e.RGBA=M;class n{constructor(g,d,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,d),0),3),this.l=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.l===d.l&&g.a===d.a}static fromRGBA(g){const d=g.r/255,b=g.g/255,v=g.b/255,y=g.a,h=Math.max(d,b,v),p=Math.min(d,b,v);let w=0,a=0;const f=(p+h)/2,m=h-p;if(m>0){switch(a=Math.min(f<=.5?m/(2*f):m/(2-2*f),1),h){case d:w=(b-v)/m+(b<v?6:0);break;case b:w=(v-d)/m+2;break;case v:w=(d-b)/m+4;break}w*=60,w=Math.round(w)}return new n(w,a,f,y)}static i(g,d,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?g+(d-g)*6*b:b<1/2?d:b<2/3?g+(d-g)*(2/3-b)*6:g}static toRGBA(g){const d=g.h/360,{s:b,l:v,a:y}=g;let h,p,w;if(b===0)h=p=w=v;else{const a=v<.5?v*(1+b):v+b-v*b,f=2*v-a;h=n.i(f,a,d+1/3),p=n.i(f,a,d),w=n.i(f,a,d-1/3)}return new M(Math.round(h*255),Math.round(p*255),Math.round(w*255),y)}}e.HSLA=n;class R{constructor(g,d,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,d),0),3),this.v=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.v===d.v&&g.a===d.a}static fromRGBA(g){const d=g.r/255,b=g.g/255,v=g.b/255,y=Math.max(d,b,v),h=Math.min(d,b,v),p=y-h,w=y===0?0:p/y;let a;return p===0?a=0:y===d?a=((b-v)/p%6+6)%6:y===b?a=(v-d)/p+2:a=(d-b)/p+4,new R(Math.round(a*60),w,y,g.a)}static toRGBA(g){const{h:d,s:b,v,a:y}=g,h=v*b,p=h*(1-Math.abs(d/60%2-1)),w=v-h;let[a,f,m]=[0,0,0];return d<60?(a=h,f=p):d<120?(a=p,f=h):d<180?(f=h,m=p):d<240?(f=p,m=h):d<300?(a=p,m=h):d<=360&&(a=h,m=p),a=Math.round((a+w)*255),f=Math.round((f+w)*255),m=Math.round((m+w)*255),new M(a,f,m,y)}}e.HSVA=R;class C{static fromHex(g){return C.Format.CSS.parseHex(g)||C.red}static equals(g,d){return!g&&!d?!0:!g||!d?!1:g.equals(d)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof M)this.rgba=g;else if(g instanceof n)this.i=g,this.rgba=n.toRGBA(g);else if(g instanceof R)this.j=g,this.rgba=R.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&M.equals(this.rgba,g.rgba)&&n.equals(this.hsla,g.hsla)&&R.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=C.k(this.rgba.r),d=C.k(this.rgba.g),b=C.k(this.rgba.b),v=.2126*g+.7152*d+.0722*b;return S(v,4)}static k(g){const d=g/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(g){const d=this.getRelativeLuminance(),b=g.getRelativeLuminance();return d>b?(d+.05)/(b+.05):(b+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const d=this.getRelativeLuminance(),b=g.getRelativeLuminance();return d>b}isDarkerThan(g){const d=this.getRelativeLuminance(),b=g.getRelativeLuminance();return d<b}lighten(g){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:d,g:b,b:v,a:y}=this.rgba;return new C(new M(d,b,v,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const d=g.rgba,b=this.rgba.a,v=d.a,y=b+v*(1-b);if(y<1e-6)return C.transparent;const h=this.rgba.r*b/y+d.r*v*(1-b)/y,p=this.rgba.g*b/y+d.g*v*(1-b)/y,w=this.rgba.b*b/y+d.b*v*(1-b)/y;return new C(new M(h,p,w,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:d,g:b,b:v,a:y}=this.rgba;return new C(new M(g.rgba.r-y*(g.rgba.r-d),g.rgba.g-y*(g.rgba.g-b),g.rgba.b-y*(g.rgba.b-v),1))}flatten(...g){const d=g.reduceRight((b,v)=>C.o(v,b));return C.o(this,d)}static o(g,d){const b=1-g.rgba.a;return new C(new M(b*d.rgba.r+g.rgba.a*g.rgba.r,b*d.rgba.g+g.rgba.a*g.rgba.g,b*d.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(g,d,b){if(g.isLighterThan(d))return g;b=b||.5;const v=g.getRelativeLuminance(),y=d.getRelativeLuminance();return b=b*(y-v)/y,g.lighten(b)}static getDarkerColor(g,d,b){if(g.isDarkerThan(d))return g;b=b||.5;const v=g.getRelativeLuminance(),y=d.getRelativeLuminance();return b=b*(v-y)/v,g.darken(b)}}C.white=new C(new M(255,255,255,1)),C.black=new C(new M(0,0,0,1)),C.red=new C(new M(255,0,0,1)),C.blue=new C(new M(0,0,255,1)),C.green=new C(new M(0,255,0,1)),C.cyan=new C(new M(0,255,255,1)),C.lightgrey=new C(new M(211,211,211,1)),C.transparent=new C(new M(0,0,0,0)),e.Color=C,function(k){let g;(function(d){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}v.formatRGB=y;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=h;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}v.formatHSL=p;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function a(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function f(t){return`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}`}v.formatHex=f;function m(t,c=!1){return c&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}${a(Math.round(t.rgba.a*255))}`}v.formatHexA=m;function P(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}v.format=P;function E(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),r=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new M(i,r,o,1))}if(c===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),r=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),l=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new M(i,r,o,l/255))}if(c===4){const i=D(t.charCodeAt(1)),r=D(t.charCodeAt(2)),o=D(t.charCodeAt(3));return new k(new M(16*i+i,16*r+r,16*o+o))}if(c===5){const i=D(t.charCodeAt(1)),r=D(t.charCodeAt(2)),o=D(t.charCodeAt(3)),l=D(t.charCodeAt(4));return new k(new M(16*i+i,16*r+r,16*o+o,(16*l+l)/255))}return null}v.parseHex=E;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=d.CSS||(d.CSS={}))})(g=k.Format||(k.Format={}))}(C=e.Color||(e.Color={})),e.Color=C}),define(Z[54],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(C){return(k,g,d)=>{let b=null,v=null;if(typeof d.value=="function"?(b="value",v=d.value):typeof d.get=="function"&&(b="get",v=d.get),!v)throw new Error("not supported");d[b]=C(v,g)}}function M(C,k,g){let d=null,b=null;if(typeof g.value=="function"?(d="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(d="get",b=g.get),!b)throw new Error("not supported");const v=`$memoize$${k}`;g[d]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.memoize=M;function n(C,k,g){return S((d,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...h){this[y]||(this[y]=g?g():void 0),clearTimeout(this[v]),k&&(this[y]=k(this[y],...h),h=[this[y]]),this[v]=setTimeout(()=>{d.apply(this,h),this[y]=g?g():void 0},C)}})}e.debounce=n;function R(C,k,g){return S((d,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,h=`$throttle$lastRun$${b}`,p=`$throttle$pending$${b}`;return function(...w){if(this[y]||(this[y]=g?g():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[y]=k(this[y],...w)),this[p])return;const a=this[h]+C;a<=Date.now()?(this[h]=Date.now(),d.apply(this,[this[y]]),this[y]=g?g():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[h]=Date.now(),d.apply(this,[this[y]]),this[y]=g?g():void 0},a-Date.now()))}})}e.throttle=R}),define(Z[13],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?E.isErrorNoTelemetry(c)?new E(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=S,e.errorHandler=new S;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function n(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function R(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function C(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function k(t){if(t instanceof Error){const{name:c,message:i}=t,r=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:r,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const g="Canceled";function d(t){return t instanceof b?!0:t instanceof Error&&t.name===g&&t.message===g}e.isCancellationError=d;class b extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=b;function v(){const t=new Error(g);return t.name=t.message,t}e.canceled=v;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=h;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function w(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=w;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class f extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=f;class m extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=m;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=P;class E extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof E)return c;const i=new E;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class D extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(Z[25],ee([0,1,13]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(j,K=0){return j[j.length-(1+K)]}e.tail=M;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function R(j,K,Y=(re,de)=>re===de){if(j===K)return!0;if(!j||!K||j.length!==K.length)return!1;for(let re=0,de=j.length;re<de;re++)if(!Y(j[re],K[re]))return!1;return!0}e.equals=R;function C(j,K){const Y=j.length-1;K<Y&&(j[K]=j[Y]),j.pop()}e.removeFastWithoutKeepingOrder=C;function k(j,K,Y){return g(j.length,re=>Y(j[re],K))}e.binarySearch=k;function g(j,K){let Y=0,re=j-1;for(;Y<=re;){const de=(Y+re)/2|0,Re=K(de);if(Re<0)Y=de+1;else if(Re>0)re=de-1;else return de}return-(Y+1)}e.binarySearch2=g;function d(j,K){let Y=0,re=j.length;if(re===0)return 0;for(;Y<re;){const de=Math.floor((Y+re)/2);K(j[de])?re=de:Y=de+1}return Y}e.findFirstInSorted=d;function b(j,K,Y){if(j=j|0,j>=K.length)throw new TypeError("invalid index");const re=K[Math.floor(K.length*Math.random())],de=[],Re=[],Ce=[];for(const De of K){const Oe=Y(De,re);Oe<0?de.push(De):Oe>0?Re.push(De):Ce.push(De)}return j<de.length?b(j,de,Y):j<de.length+Ce.length?Ce[0]:b(j-(de.length+Ce.length),Re,Y)}e.quickSelect=b;function v(j,K){const Y=[];let re;for(const de of j.slice(0).sort(K))!re||K(re[0],de)!==0?(re=[de],Y.push(re)):re.push(de);return Y}e.groupBy=v;function y(j,K,Y){const re=[];function de(De,Oe,$e){if(Oe===0&&$e.length===0)return;const fe=re[re.length-1];fe&&fe.start+fe.deleteCount===De?(fe.deleteCount+=Oe,fe.toInsert.push(...$e)):re.push({start:De,deleteCount:Oe,toInsert:$e})}let Re=0,Ce=0;for(;;){if(Re===j.length){de(Re,0,K.slice(Ce));break}if(Ce===K.length){de(Re,j.length-Re,[]);break}const De=j[Re],Oe=K[Ce],$e=Y(De,Oe);$e===0?(Re+=1,Ce+=1):$e<0?(de(Re,1,[]),Re+=1):$e>0&&(de(Re,0,[Oe]),Ce+=1)}return re}e.sortedDiff=y;function h(j,K,Y){const re=y(j,K,Y),de=[],Re=[];for(const Ce of re)de.push(...j.slice(Ce.start,Ce.start+Ce.deleteCount)),Re.push(...Ce.toInsert);return{removed:de,added:Re}}e.delta=h;function p(j,K,Y){if(Y===0)return[];const re=j.slice(0,Y).sort(K);return a(j,K,re,Y,j.length),re}e.top=p;function w(j,K,Y,re,de){return Y===0?Promise.resolve([]):new Promise((Re,Ce)=>{(async()=>{const De=j.length,Oe=j.slice(0,Y).sort(K);for(let $e=Y,fe=Math.min(Y+re,De);$e<De;$e=fe,fe=Math.min(fe+re,De)){if($e>Y&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new S.CancellationError;a(j,K,Oe,$e,fe)}return Oe})().then(Re,Ce)})}e.topAsync=w;function a(j,K,Y,re,de){for(const Re=Y.length;re<de;re++){const Ce=j[re];if(K(Ce,Y[Re-1])<0){Y.pop();const De=d(Y,Oe=>K(Ce,Oe)<0);Y.splice(De,0,Ce)}}}function f(j){return j.filter(K=>!!K)}e.coalesce=f;function m(j){let K=0;for(let Y=0;Y<j.length;Y++)j[Y]&&(j[K]=j[Y],K+=1);j.length=K}e.coalesceInPlace=m;function P(j,K,Y){j.splice(Y,0,j.splice(K,1)[0])}e.move=P;function E(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=E;function D(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=D;function t(j,K=Y=>Y){const Y=new Set;return j.filter(re=>{const de=K(re);return Y.has(de)?!1:(Y.add(de),!0)})}e.distinct=t;function c(j){const K=new Set;return Y=>{const re=j(Y);return K.has(re)?!1:(K.add(re),!0)}}e.uniqueFilter=c;function i(j,K){const Y=r(j,K);if(Y!==-1)return j[Y]}e.findLast=i;function r(j,K){for(let Y=j.length-1;Y>=0;Y--){const re=j[Y];if(K(re))return Y}return-1}e.lastIndex=r;function o(j,K){return j.length>0?j[0]:K}e.firstOrDefault=o;function l(j,K){return j.length>0?j[j.length-1]:K}e.lastOrDefault=l;function s(j,K,Y=(re,de)=>re===de){let re=0;for(let de=0,Re=Math.min(j.length,K.length);de<Re&&Y(j[de],K[de]);de++)re++;return re}e.commonPrefixLength=s;function u(j){return[].concat(...j)}e.flatten=u;function I(j,K){let Y=typeof K=="number"?j:0;typeof K=="number"?Y=j:(Y=0,K=j);const re=[];if(Y<=K)for(let de=Y;de<K;de++)re.push(de);else for(let de=Y;de>K;de--)re.push(de);return re}e.range=I;function A(j,K,Y){return j.reduce((re,de)=>(re[K(de)]=Y?Y(de):de,re),Object.create(null))}e.index=A;function T(j,K){return j.push(K),()=>N(j,K)}e.insert=T;function N(j,K){const Y=j.indexOf(K);if(Y>-1)return j.splice(Y,1),K}e.remove=N;function z(j,K,Y){const re=j.slice(0,K),de=j.slice(K);return re.concat(Y,de)}e.arrayInsert=z;function H(j,K){let Y;if(typeof K=="number"){let re=K;Y=()=>{const de=Math.sin(re++)*179426549;return de-Math.floor(de)}}else Y=Math.random;for(let re=j.length-1;re>0;re-=1){const de=Math.floor(Y()*(re+1)),Re=j[re];j[re]=j[de],j[de]=Re}}e.shuffle=H;function ie(j,K){const Y=j.indexOf(K);Y>-1&&(j.splice(Y,1),j.unshift(K))}e.pushToStart=ie;function se(j,K){const Y=j.indexOf(K);Y>-1&&(j.splice(Y,1),j.push(K))}e.pushToEnd=se;function oe(j,K){for(const Y of K)j.push(Y)}e.pushMany=oe;function ue(j,K){return Array.isArray(j)?j.map(K):K(j)}e.mapArrayOrNot=ue;function le(j){return Array.isArray(j)?j:[j]}e.asArray=le;function me(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=me;function G(j,K){for(const Y of j){const re=K(Y);if(re!==void 0)return re}}e.mapFind=G;function B(j,K,Y){const re=q(j,K),de=j.length,Re=Y.length;j.length=de+Re;for(let Ce=de-1;Ce>=re;Ce--)j[Ce+Re]=j[Ce];for(let Ce=0;Ce<Re;Ce++)j[Ce+re]=Y[Ce]}e.insertInto=B;function O(j,K,Y,re){const de=q(j,K),Re=j.splice(de,Y);return B(j,de,re),Re}e.splice=O;function q(j,K){return K<0?Math.max(K+j.length,0):Math.min(K,j.length)}var J;(function(j){function K(de){return de<0}j.isLessThan=K;function Y(de){return de>0}j.isGreaterThan=Y;function re(de){return de===0}j.isNeitherLessOrGreaterThan=re,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function te(j,K){return(Y,re)=>K(j(Y),j(re))}e.compareBy=te;function ne(...j){return(K,Y)=>{for(const re of j){const de=re(K,Y);if(!J.isNeitherLessOrGreaterThan(de))return de}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const L=(j,K)=>j-K;e.numberComparator=L;function F(j,K){if(j.length===0)return;let Y=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,Y)>0&&(Y=de)}return Y}e.findMaxBy=F;function W(j,K){if(j.length===0)return;let Y=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,Y)>=0&&(Y=de)}return Y}e.findLastMaxBy=W;function U(j,K){return F(j,(Y,re)=>-K(Y,re))}e.findMinBy=U;class ${constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let Y=this.c;for(;Y<this.f.length&&K(this.f[Y]);)Y++;const re=Y===this.c?null:this.f.slice(this.c,Y);return this.c=Y,re}takeFromEndWhile(K){let Y=this.d;for(;Y>=0&&K(this.f[Y]);)Y--;const re=Y===this.d?null:this.f.slice(Y+1,this.d+1);return this.d=Y,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const Y=this.f.slice(this.c,this.c+K);return this.c+=K,Y}}e.ArrayQueue=$;class V{constructor(K){this.iterate=K}forEach(K){this.iterate(Y=>(K(Y),!0))}toArray(){const K=[];return this.iterate(Y=>(K.push(Y),!0)),K}filter(K){return new V(Y=>this.iterate(re=>K(re)?Y(re):!0))}map(K){return new V(Y=>this.iterate(re=>Y(K(re))))}some(K){let Y=!1;return this.iterate(re=>(Y=K(re),!Y)),Y}findFirst(K){let Y;return this.iterate(re=>K(re)?(Y=re,!1):!0),Y}findLast(K){let Y;return this.iterate(re=>(K(re)&&(Y=re),!0)),Y}findLastMaxBy(K){let Y,re=!0;return this.iterate(de=>((re||J.isGreaterThan(K(de,Y)))&&(re=!1,Y=de),!0)),Y}}V.empty=new V(j=>{}),e.CallbackIterable=V}),define(Z[124],ee([0,1,13]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(g,d){if(!g)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=M;function n(g,d="Unreachable"){throw new Error(d)}e.assertNever=n;function R(g){if(!g)throw new S.BugIndicatingError("Assertion Failed")}e.assert=R;function C(g){if(!g()){debugger;g(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function k(g,d){let b=0;for(;b<g.length-1;){const v=g[b],y=g[b+1];if(!d(v,y))return!1;b++}return!0}e.checkAdjacentItems=k}),define(Z[49],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(M){const n=this;let R=!1,C;return function(){return R||(R=!0,C=M.apply(n,arguments)),C}}e.once=S}),define(Z[69],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(M){function n(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}M.is=n;const R=Object.freeze([]);function C(){return R}M.empty=C;function*k(E){yield E}M.single=k;function g(E){return n(E)?E:k(E)}M.wrap=g;function d(E){return E||R}M.from=d;function b(E){return!E||E[Symbol.iterator]().next().done===!0}M.isEmpty=b;function v(E){return E[Symbol.iterator]().next().value}M.first=v;function y(E,D){for(const t of E)if(D(t))return!0;return!1}M.some=y;function h(E,D){for(const t of E)if(D(t))return t}M.find=h;function*p(E,D){for(const t of E)D(t)&&(yield t)}M.filter=p;function*w(E,D){let t=0;for(const c of E)yield D(c,t++)}M.map=w;function*a(...E){for(const D of E)for(const t of D)yield t}M.concat=a;function f(E,D,t){let c=t;for(const i of E)c=D(c,i);return c}M.reduce=f;function*m(E,D,t=E.length){for(D<0&&(D+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);D<t;D++)yield E[D]}M.slice=m;function P(E,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,E];const c=E[Symbol.iterator]();for(let i=0;i<D;i++){const r=c.next();if(r.done)return[t,M.empty()];t.push(r.value)}return[t,{[Symbol.iterator](){return c}}]}M.consume=P})(S=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(t,c=!1){let i=0;const r=t.length;let o="",l=0,s=16,u=0;function I(se){let oe=0,ue=0;for(;oe<se;){const le=t.charCodeAt(i);if(le>=48&&le<=57)ue=ue*16+le-48;else if(le>=65&&le<=70)ue=ue*16+le-65+10;else if(le>=97&&le<=102)ue=ue*16+le-97+10;else break;i++,oe++}return oe<se&&(ue=-1),ue}function A(se){i=se,o="",l=0,s=16,u=0}function T(){const se=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&d(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&d(t.charCodeAt(i)))for(i++;i<t.length&&d(t.charCodeAt(i));)i++;else return u=3,t.substring(se,i);let oe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&d(t.charCodeAt(i))){for(i++;i<t.length&&d(t.charCodeAt(i));)i++;oe=i}else u=3;return t.substring(se,oe)}function N(){let se="",oe=i;for(;;){if(i>=r){se+=t.substring(oe,i),u=2;break}const ue=t.charCodeAt(i);if(ue===34){se+=t.substring(oe,i),i++;break}if(ue===92){if(se+=t.substring(oe,i),i++,i>=r){u=2;break}switch(t.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const me=I(4);me>=0?se+=String.fromCharCode(me):u=4;break}default:u=5}oe=i;continue}if(ue>=0&&ue<=31)if(g(ue)){se+=t.substring(oe,i),u=2;break}else u=6;i++}return se}function z(){if(o="",u=0,l=i,i>=r)return l=r,s=17;let se=t.charCodeAt(i);if(k(se)){do i++,o+=String.fromCharCode(se),se=t.charCodeAt(i);while(k(se));return s=15}if(g(se))return i++,o+=String.fromCharCode(se),se===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),s=14;switch(se){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,o=N(),s=10;case 47:{const oe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!g(t.charCodeAt(i));)i++;return o=t.substring(oe,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=r-1;let le=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,le=!0;break}i++}return le||(i++,u=1),o=t.substring(oe,i),s=13}return o+=String.fromCharCode(se),i++,s=16}case 45:if(o+=String.fromCharCode(se),i++,i===r||!d(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),s=11;default:for(;i<r&&H(se);)i++,se=t.charCodeAt(i);if(l!==i){switch(o=t.substring(l,i),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(se),i++,s=16}}function H(se){if(k(se)||g(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let se;do se=z();while(se>=12&&se<=15);return se}return{setPosition:A,getPosition:()=>i,scan:c?ie:z,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>u}}e.createScanner=C;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,c){const i=[],r=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(I,A,T,N){l.value=I,l.offset=A,l.length=T,l.type=N,l.colonOffset=void 0,o=l}try{P(t,{onObjectBegin:(I,A)=>{if(c<=I)throw r;o=void 0,s=c>I,i.push("")},onObjectProperty:(I,A,T)=>{if(c<A||(u(I,A,T,"property"),i[i.length-1]=I,c<=A+T))throw r},onObjectEnd:(I,A)=>{if(c<=I)throw r;o=void 0,i.pop()},onArrayBegin:(I,A)=>{if(c<=I)throw r;o=void 0,i.push(0)},onArrayEnd:(I,A)=>{if(c<=I)throw r;o=void 0,i.pop()},onLiteralValue:(I,A,T)=>{if(c<A||(u(I,A,T,D(I)),c<=A+T))throw r},onSeparator:(I,A,T)=>{if(c<=A)throw r;if(I===":"&&o&&o.type==="property")o.colonOffset=A,s=!1,o=void 0;else if(I===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(s=!0,i[i.length-1]=""),o=void 0}}})}catch(I){if(I!==r)throw I}return{path:i,previousNode:o,isAtPropertyKey:s,matches:I=>{let A=0;for(let T=0;A<I.length&&T<i.length;T++)if(I[A]===i[T]||I[A]==="*")A++;else if(I[A]!=="**")return!1;return A===I.length}}}e.getLocation=v;function y(t,c=[],i=R.DEFAULT){let r=null,o=[];const l=[];function s(I){Array.isArray(o)?o.push(I):r!==null&&(o[r]=I)}return P(t,{onObjectBegin:()=>{const I={};s(I),l.push(o),o=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const I=[];s(I),l.push(o),o=I,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:s,onError:(I,A,T)=>{c.push({error:I,offset:A,length:T})}},i),o[0]}e.parse=y;function h(t,c=[],i=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(I){r.type==="property"&&(r.length=I-r.offset,r=r.parent)}function l(I){return r.children.push(I),I}P(t,{onObjectBegin:I=>{r=l({type:"object",offset:I,length:-1,parent:r,children:[]})},onObjectProperty:(I,A,T)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:I,offset:A,length:T,parent:r})},onObjectEnd:(I,A)=>{r.length=I+A-r.offset,r=r.parent,o(I+A)},onArrayBegin:(I,A)=>{r=l({type:"array",offset:I,length:-1,parent:r,children:[]})},onArrayEnd:(I,A)=>{r.length=I+A-r.offset,r=r.parent,o(I+A)},onLiteralValue:(I,A,T)=>{l({type:D(I),offset:A,length:T,parent:r,value:I}),o(A+T)},onSeparator:(I,A,T)=>{r.type==="property"&&(I===":"?r.colonOffset=A:I===","&&o(A))},onError:(I,A,T)=>{c.push({error:I,offset:A,length:T})}},i);const u=r.children[0];return u&&delete u.parent,u}e.parseTree=h;function p(t,c){if(!t)return;let i=t;for(const r of c)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=p;function w(t){if(!t.parent||!t.parent.children)return[];const c=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=w;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const c=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(c[i.children[0].value]=a(r))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function f(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=f;function m(t,c,i=!1){if(f(t,c,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=c;o++){const l=m(r[o],c,i);if(l)return l}return t}}e.findNodeAtOffset=m;function P(t,c,i=R.DEFAULT){const r=C(t,!1);function o(te){return te?()=>te(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(te){return te?ne=>te(ne,r.getTokenOffset(),r.getTokenLength()):()=>!0}const s=o(c.onObjectBegin),u=l(c.onObjectProperty),I=o(c.onObjectEnd),A=o(c.onArrayBegin),T=o(c.onArrayEnd),N=l(c.onLiteralValue),z=l(c.onSeparator),H=o(c.onComment),ie=l(c.onError),se=i&&i.disallowComments,oe=i&&i.allowTrailingComma;function ue(){for(;;){const te=r.scan();switch(r.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:se||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(te){case 12:case 13:se?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return te}}}function le(te,ne=[],L=[]){if(ie(te),ne.length+L.length>0){let F=r.getToken();for(;F!==17;){if(ne.indexOf(F)!==-1){ue();break}else if(L.indexOf(F)!==-1)break;F=ue()}}}function me(te){const ne=r.getTokenValue();return te?N(ne):u(ne),ue(),!0}function G(){switch(r.getToken()){case 11:{let te=0;try{te=JSON.parse(r.getTokenValue()),typeof te!="number"&&(le(2),te=0)}catch{le(2)}N(te);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ue(),!0}function B(){return r.getToken()!==10?(le(3,[],[2,5]),!1):(me(!1),r.getToken()===6?(z(":"),ue(),J()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function O(){s(),ue();let te=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(te||le(4,[],[]),z(","),ue(),r.getToken()===2&&oe)break}else te&&le(6,[],[]);B()||le(4,[],[2,5]),te=!0}return I(),r.getToken()!==2?le(7,[2],[]):ue(),!0}function q(){A(),ue();let te=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(te||le(4,[],[]),z(","),ue(),r.getToken()===4&&oe)break}else te&&le(6,[],[]);J()||le(4,[],[4,5]),te=!0}return T(),r.getToken()!==4?le(8,[4],[]):ue(),!0}function J(){switch(r.getToken()){case 3:return q();case 1:return O();case 10:return me(!0);default:return G()}}return ue(),r.getToken()===17?i.allowEmptyContent?!0:(le(4,[],[]),!1):J()?(r.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=P;function E(t,c){const i=C(t),r=[];let o,l=0,s;do switch(s=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:l!==s&&r.push(t.substring(l,s)),c!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,c)),l=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=E;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(Z[125],ee([0,1,43]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(d,b,v){let y,h,p,w,a;if(b){for(w=b.offset,a=w+b.length,p=w;p>0&&!g(d,p-1);)p--;let s=a;for(;s<d.length&&!g(d,s);)s++;h=d.substring(p,s),y=C(h,v)}else h=d,y=0,p=0,w=0,a=d.length;const f=k(v,d);let m=!1,P=0,E;v.insertSpaces?E=R(" ",v.tabSize||4):E="	";const D=(0,S.createScanner)(h,!1);let t=!1;function c(){return f+R(E,y+P)}function i(){let s=D.scan();for(m=!1;s===15||s===14;)m=m||s===14,s=D.scan();return t=s===16||D.getTokenError()!==0,s}const r=[];function o(s,u,I){!t&&u<a&&I>w&&d.substring(u,I)!==s&&r.push({offset:u,length:I-u,content:s})}let l=i();if(l!==17){const s=D.getTokenOffset()+p,u=R(E,y);o(u,p,s)}for(;l!==17;){let s=D.getTokenOffset()+D.getTokenLength()+p,u=i(),I="";for(;!m&&(u===12||u===13);){const T=D.getTokenOffset()+p;o(" ",s,T),s=D.getTokenOffset()+D.getTokenLength()+p,I=u===12?c():"",u=i()}if(u===2)l!==1&&(P--,I=c());else if(u===4)l!==3&&(P--,I=c());else{switch(l){case 3:case 1:P++,I=c();break;case 5:case 12:I=c();break;case 13:m?I=c():I=" ";break;case 6:I=" ";break;case 10:if(u===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?I=" ":u!==5&&u!==17&&(t=!0);break;case 16:t=!0;break}m&&(u===12||u===13)&&(I=c())}const A=D.getTokenOffset()+p;o(I,s,A),l=u}return r}e.format=M;function n(d,b){const v=JSON.stringify(d,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.toFormattedString=n;function R(d,b){let v="";for(let y=0;y<b;y++)v+=d;return v}function C(d,b){let v=0,y=0;const h=b.tabSize||4;for(;v<d.length;){const p=d.charAt(v);if(p===" ")y++;else if(p==="	")y+=h;else break;v++}return Math.floor(y/h)}function k(d,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=k;function g(d,b){return`\r
`.indexOf(d.charAt(b))!==-1}e.isEOL=g}),define(Z[126],ee([0,1,43,125]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(d,b,v){return R(d,b,void 0,v)}e.removeProperty=n;function R(d,b,v,y,h){const p=b.slice(),w=[],a=(0,S.parseTree)(d,w);let f,m;for(;p.length>0&&(m=p.pop(),f=(0,S.findNodeAtLocation)(a,p),f===void 0&&v!==void 0);)typeof m=="string"?v={[m]:v}:v=[v];if(f)if(f.type==="object"&&typeof m=="string"&&Array.isArray(f.children)){const P=(0,S.findNodeAtLocation)(f,[m]);if(P!==void 0)if(v===void 0){if(!P.parent)throw new Error("Malformed AST");const E=f.children.indexOf(P.parent);let D,t=P.parent.offset+P.parent.length;if(E>0){const c=f.children[E-1];D=c.offset+c.length}else D=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return C(d,{offset:D,length:t-D,content:""},y)}else return C(d,{offset:P.offset,length:P.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const E=`${JSON.stringify(m)}: ${JSON.stringify(v)}`,D=h?h(f.children.map(c=>c.children[0].value)):f.children.length;let t;if(D>0){const c=f.children[D-1];t={offset:c.offset+c.length,length:0,content:","+E}}else f.children.length===0?t={offset:f.offset+1,length:0,content:E}:t={offset:f.offset+1,length:0,content:E+","};return C(d,t,y)}}else if(f.type==="array"&&typeof m=="number"&&Array.isArray(f.children))if(v!==void 0){const P=`${JSON.stringify(v)}`;let E;if(f.children.length===0||m===0)E={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const D=m===-1||m>f.children.length?f.children.length:m,t=f.children[D-1];E={offset:t.offset+t.length,length:0,content:","+P}}return C(d,E,y)}else{const P=m,E=f.children[P];let D;if(f.children.length===1)D={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const t=f.children[P-1],c=t.offset+t.length,i=f.offset+f.length;D={offset:c,length:i-2-c,content:""}}else D={offset:E.offset,length:f.children[P+1].offset-E.offset,content:""};return C(d,D,y)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${f.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(d,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},y)}}e.setProperty=R;function C(d,b,v){let y=k(d,b),h=b.offset,p=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;h>0&&!(0,M.isEOL)(y,h-1);)h--;for(;p<y.length&&!(0,M.isEOL)(y,p);)p++}const w=(0,M.format)(y,{offset:h,length:p-h},v);for(let f=w.length-1;f>=0;f--){const m=w[f];y=k(y,m),h=Math.min(h,m.offset),p=Math.max(p,m.offset+m.length),p+=m.content.length-m.length}const a=d.length-(y.length-p)-h;return[{offset:h,length:a,content:y.substring(h,p)}]}e.withFormatting=C;function k(d,b){return d.substring(0,b.offset)+b.content+d.substring(b.offset+b.length)}e.applyEdit=k;function g(d,b){const v=b.slice(0).sort((h,p)=>{const w=h.offset-p.offset;return w===0?h.length-p.length:w});let y=d.length;for(let h=v.length-1;h>=0;h--){const p=v[h];if(p.offset+p.length<=y)d=k(d,p);else throw new Error("Overlapping edit");y=p.offset}return d}e.applyEdits=g}),define(Z[127],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=S}),define(Z[2],ee([0,1,49,69]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let R=null;function C(l){R=l}if(e.setDisposableTracker=C,n){const l="__is_disposable_tracked__";C(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==m.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function k(l){return R?.trackDisposable(l),l}function g(l){R?.markAsDisposed(l)}function d(l,s){R?.setParent(l,s)}function b(l,s){if(!!R)for(const u of l)R.setParent(u,s)}function v(l){return R?.markAsSingleton(l),l}e.markAsSingleton=v;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=y;function h(l){if(M.Iterable.is(l)){const s=[];for(const u of l)if(u)try{u.dispose()}catch(I){s.push(I)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=h;function p(l){for(const s of l)y(s)&&s.dispose();return[]}e.disposeIfDisposable=p;function w(...l){const s=a(()=>h(l));return b(l,s),s}e.combinedDisposable=w;function a(l){const s=k({dispose:(0,S.once)(()=>{g(s),l()})});return s}e.toDisposable=a;class f{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return d(s,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}f.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=f;class m{constructor(){this.q=new f,k(this),d(this.q,this)}dispose(){g(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class P{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&d(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&d(s,null),s}}e.MutableDisposable=P;class E{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(s){let u=s;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,g(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(s,...u){let I=this.a.get(s);I||(I={counter:0,object:this.b(s,...u)},this.a.set(s,I));const{object:A}=I,T=(0,S.once)(()=>{--I.counter===0&&(this.c(s,I.object),this.a.delete(s))});return I.counter++,{object:A,dispose:T}}}e.ReferenceCollection=t;class c{constructor(s){this.a=s}async acquire(s,...u){const I=this.a.acquire(s,...u);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(A){throw I.dispose(),A}}}e.AsyncReferenceCollection=c;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function r(l){const s=new f;try{l(s)}finally{s.dispose()}}e.disposeOnReturn=r;class o{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,u,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(s)?.dispose(),this.a.set(s,u)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(Z[98],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class M{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let R=this.a;for(;R!==S.Undefined;){const C=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const k=new S(R);if(this.a===S.Undefined)this.a=k,this.b=k;else if(C){const d=this.b;this.b=k,k.prev=d,d.next=k}else{const d=this.a;this.a=k,k.next=d,d.prev=k}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(k))}}shift(){if(this.a!==S.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==S.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===S.Undefined&&R.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):R.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):R.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=M}),define(Z[35],ee([0,1]),function(x,e){"use strict";var S,M,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(p,w,a){let f=p.get(w);return f===void 0&&(f=a,p.set(w,f)),f}e.getOrSet=R;function C(p){const w=[];return p.forEach((a,f)=>{w.push(`${f} => ${a}`)}),`Map(${p.size}) {${w.join(", ")}}`}e.mapToString=C;function k(p){const w=[];return p.forEach(a=>{w.push(a)}),`Set(${p.size}) {${w.join(", ")}}`}e.setToString=k;class g{constructor(w,a){this.uri=w,this.value=a}}class d{constructor(w,a){this[S]="ResourceMap",w instanceof d?(this.b=new Map(w.b),this.c=a??d.a):(this.b=new Map,this.c=w??d.a)}set(w,a){return this.b.set(this.c(w),new g(w,a)),this}get(w){return this.b.get(this.c(w))?.value}has(w){return this.b.has(this.c(w))}get size(){return this.b.size}clear(){this.b.clear()}delete(w){return this.b.delete(this.c(w))}forEach(w,a){typeof a<"u"&&(w=w.bind(a));for(const[f,m]of this.b)w(m.value,m.uri,this)}*values(){for(const w of this.b.values())yield w.value}*keys(){for(const w of this.b.values())yield w.uri}*entries(){for(const w of this.b.values())yield[w.uri,w.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.b)yield[w.uri,w.value]}}d.a=p=>p.toString(),e.ResourceMap=d;class b{constructor(w,a){this[M]="ResourceSet",!w||typeof w=="function"?this.a=new d(w):(this.a=new d(a),w.forEach(this.add,this))}get size(){return this.a.size}add(w){return this.a.set(w,w),this}clear(){this.a.clear()}delete(w){return this.a.delete(w)}forEach(w,a){this.a.forEach((f,m)=>w.call(a,m,m,this))}has(w){return this.a.has(w)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var v;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class y{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(w){return this.a.has(w)}get(w,a=0){const f=this.a.get(w);if(!!f)return a!==0&&this.j(f,a),f.value}set(w,a,f=0){let m=this.a.get(w);if(m)m.value=a,f!==0&&this.j(m,f);else{switch(m={key:w,value:a,next:void 0,previous:void 0},f){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(w,m),this.d++}return this}delete(w){return!!this.remove(w)}remove(w){const a=this.a.get(w);if(!!a)return this.a.delete(w),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const w=this.b;return this.a.delete(w.key),this.i(w),this.d--,w.value}forEach(w,a){const f=this.e;let m=this.b;for(;m;){if(a?w.bind(a)(m.value,m.key,this):w(m.value,m.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const w=this,a=this.e;let f=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:f.key,done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return m}values(){const w=this,a=this.e;let f=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:f.value,done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return m}entries(){const w=this,a=this.e;let f=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:[f.key,f.value],done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return m}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(w){if(w>=this.size)return;if(w===0){this.clear();return}let a=this.b,f=this.size;for(;a&&f>w;)this.a.delete(a.key),a=a.next,f--;this.b=a,this.d=f,a&&(a.previous=void 0),this.e++}g(w){if(!this.b&&!this.c)this.c=w;else if(this.b)w.next=this.b,this.b.previous=w;else throw new Error("Invalid list");this.b=w,this.e++}h(w){if(!this.b&&!this.c)this.b=w;else if(this.c)w.previous=this.c,this.c.next=w;else throw new Error("Invalid list");this.c=w,this.e++}i(w){if(w===this.b&&w===this.c)this.b=void 0,this.c=void 0;else if(w===this.b){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.b=w.next}else if(w===this.c){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.c=w.previous}else{const a=w.next,f=w.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}w.next=void 0,w.previous=void 0,this.e++}j(w,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(w===this.b)return;const f=w.next,m=w.previous;w===this.c?(m.next=void 0,this.c=m):(f.previous=m,m.next=f),w.previous=void 0,w.next=this.b,this.b.previous=w,this.b=w,this.e++}else if(a===2){if(w===this.c)return;const f=w.next,m=w.previous;w===this.b?(f.previous=void 0,this.b=f):(f.previous=m,m.next=f),w.next=void 0,w.previous=this.c,this.c.next=w,this.c=w,this.e++}}}toJSON(){const w=[];return this.forEach((a,f)=>{w.push([f,a])}),w}fromJSON(w){this.clear();for(const[a,f]of w)this.set(a,f)}}e.LinkedMap=y;class h extends y{constructor(w,a=1){super(),this.k=w,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(w){this.k=w,this.m()}get ratio(){return this.l}set ratio(w){this.l=Math.min(Math.max(0,w),1),this.m()}get(w,a=2){return super.get(w,a)}peek(w){return super.get(w,0)}set(w,a){return super.set(w,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(Z[79],ee([0,1,35]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new S.LRUCache(1e4);function n(d){return g(d,"NFC",M)}e.normalizeNFC=n;const R=new S.LRUCache(1e4);function C(d){return g(d,"NFD",R)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function g(d,b,v){if(!d)return d;const y=v.get(d);if(y)return y;let h;return k.test(d)?h=d.normalize(b):h=d,v.set(d,h),h}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(b){return C(b).replace(d,"")}}()}),define(Z[128],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(k,g,d){return Math.min(Math.max(k,g),d)}e.clamp=S;function M(k,g){return(g+k%g)%g}e.rot=M;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class R{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const d=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function x(n){const R=[];typeof n=="number"&&R.push("code/timeOrigin",n);function C(g){R.push(g,Date.now())}function k(){const g=[];for(let d=0;d<R.length;d+=2)g.push({name:R[d],startTime:R[d+1]});return g}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(n+C.startTime)});return R}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function S(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:x)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function S(M){if(e[M])return e[M].exports;var n=e[M]={i:M,l:!1,exports:{}};return x[M].call(n.exports,n,n.exports,S),n.l=!0,n.exports}return S.m=x,S.c=e,S.d=function(M,n,R){S.o(M,n)||Object.defineProperty(M,n,{enumerable:!0,get:R})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,n){if(1&n&&(M=S(M)),8&n||4&n&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&n&&typeof M!="string")for(var C in M)S.d(R,C,function(k){return M[k]}.bind(null,C));return R},S.n=function(M){var n=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(n,"a",n),n},S.o=function(M,n){return Object.prototype.hasOwnProperty.call(M,n)},S.p="",S(S.s=0)}([function(x,e,S){(function(M){var n;e=x.exports=L,n=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],g=e.src=[],d=0,b=d++;g[b]="0|[1-9]\\d*";var v=d++;g[v]="[0-9]+";var y=d++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=d++;g[h]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var p=d++;g[p]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var w=d++;g[w]="(?:"+g[b]+"|"+g[y]+")";var a=d++;g[a]="(?:"+g[v]+"|"+g[y]+")";var f=d++;g[f]="(?:-("+g[w]+"(?:\\."+g[w]+")*))";var m=d++;g[m]="(?:-?("+g[a]+"(?:\\."+g[a]+")*))";var P=d++;g[P]="[0-9A-Za-z-]+";var E=d++;g[E]="(?:\\+("+g[P]+"(?:\\."+g[P]+")*))";var D=d++,t="v?"+g[h]+g[f]+"?"+g[E]+"?";g[D]="^"+t+"$";var c="[v=\\s]*"+g[p]+g[m]+"?"+g[E]+"?",i=d++;g[i]="^"+c+"$";var r=d++;g[r]="((?:<|>)?=?)";var o=d++;g[o]=g[v]+"|x|X|\\*";var l=d++;g[l]=g[b]+"|x|X|\\*";var s=d++;g[s]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[f]+")?"+g[E]+"?)?)?";var u=d++;g[u]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[m]+")?"+g[E]+"?)?)?";var I=d++;g[I]="^"+g[r]+"\\s*"+g[s]+"$";var A=d++;g[A]="^"+g[r]+"\\s*"+g[u]+"$";var T=d++;g[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=d++;g[N]="(?:~>?)";var z=d++;g[z]="(\\s*)"+g[N]+"\\s+",k[z]=new RegExp(g[z],"g");var H=d++;g[H]="^"+g[N]+g[s]+"$";var ie=d++;g[ie]="^"+g[N]+g[u]+"$";var se=d++;g[se]="(?:\\^)";var oe=d++;g[oe]="(\\s*)"+g[se]+"\\s+",k[oe]=new RegExp(g[oe],"g");var ue=d++;g[ue]="^"+g[se]+g[s]+"$";var le=d++;g[le]="^"+g[se]+g[u]+"$";var me=d++;g[me]="^"+g[r]+"\\s*("+c+")$|^$";var G=d++;g[G]="^"+g[r]+"\\s*("+t+")$|^$";var B=d++;g[B]="(\\s*)"+g[r]+"\\s*("+c+"|"+g[s]+")",k[B]=new RegExp(g[B],"g");var O=d++;g[O]="^\\s*("+g[s]+")\\s+-\\s+("+g[s]+")\\s*$";var q=d++;g[q]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var J=d++;g[J]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)n(te,g[te]),k[te]||(k[te]=new RegExp(g[te]));function ne(_,ce){if(_ instanceof L)return _;if(typeof _!="string"||_.length>R||!(ce?k[i]:k[D]).test(_))return null;try{return new L(_,ce)}catch{return null}}function L(_,ce){if(_ instanceof L){if(_.loose===ce)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(_,ce);n("SemVer",_,ce),this.loose=ce;var he=_.trim().match(ce?k[i]:k[D]);if(!he)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Ae=+Ie;if(Ae>=0&&Ae<C)return Ae}return Ie}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=ne,e.valid=function(_,ce){var he=ne(_,ce);return he?he.version:null},e.clean=function(_,ce){var he=ne(_.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(_){return n("SemVer.compare",this.version,this.loose,_),_ instanceof L||(_=new L(_,this.loose)),this.compareMain(_)||this.comparePre(_)},L.prototype.compareMain=function(_){return _ instanceof L||(_=new L(_,this.loose)),W(this.major,_.major)||W(this.minor,_.minor)||W(this.patch,_.patch)},L.prototype.comparePre=function(_){if(_ instanceof L||(_=new L(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],Ie=_.prerelease[ce];if(n("prerelease compare",ce,he,Ie),he===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(he===void 0)return-1;if(he!==Ie)return W(he,Ie)}while(++ce)},L.prototype.inc=function(_,ce){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ce,he,Ie){typeof he=="string"&&(Ie=he,he=void 0);try{return new L(_,he).inc(ce,Ie).version}catch{return null}},e.diff=function(_,ce){if(j(_,ce))return null;var he=ne(_),Ie=ne(ce);if(he.prerelease.length||Ie.prerelease.length){for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return Ae},e.compareIdentifiers=W;var F=/^[0-9]+$/;function W(_,ce){var he=F.test(_),Ie=F.test(ce);return he&&Ie&&(_=+_,ce=+ce),he&&!Ie?-1:Ie&&!he?1:_<ce?-1:_>ce?1:0}function U(_,ce,he){return new L(_,he).compare(new L(ce,he))}function $(_,ce,he){return U(_,ce,he)>0}function V(_,ce,he){return U(_,ce,he)<0}function j(_,ce,he){return U(_,ce,he)===0}function K(_,ce,he){return U(_,ce,he)!==0}function Y(_,ce,he){return U(_,ce,he)>=0}function re(_,ce,he){return U(_,ce,he)<=0}function de(_,ce,he,Ie){var Ae;switch(ce){case"===":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),Ae=_===he;break;case"!==":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),Ae=_!==he;break;case"":case"=":case"==":Ae=j(_,he,Ie);break;case"!=":Ae=K(_,he,Ie);break;case">":Ae=$(_,he,Ie);break;case">=":Ae=Y(_,he,Ie);break;case"<":Ae=V(_,he,Ie);break;case"<=":Ae=re(_,he,Ie);break;default:throw new TypeError("Invalid operator: "+ce)}return Ae}function Re(_,ce){if(_ instanceof Re){if(_.loose===ce)return _;_=_.value}if(!(this instanceof Re))return new Re(_,ce);n("comparator",_,ce),this.loose=ce,this.parse(_),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(_,ce){return W(ce,_)},e.major=function(_,ce){return new L(_,ce).major},e.minor=function(_,ce){return new L(_,ce).minor},e.patch=function(_,ce){return new L(_,ce).patch},e.compare=U,e.compareLoose=function(_,ce){return U(_,ce,!0)},e.rcompare=function(_,ce,he){return U(ce,_,he)},e.sort=function(_,ce){return _.sort(function(he,Ie){return e.compare(he,Ie,ce)})},e.rsort=function(_,ce){return _.sort(function(he,Ie){return e.rcompare(he,Ie,ce)})},e.gt=$,e.lt=V,e.eq=j,e.neq=K,e.gte=Y,e.lte=re,e.cmp=de,e.Comparator=Re;var Ce={};function De(_,ce){if(_ instanceof De)return _.loose===ce?_:new De(_.raw,ce);if(_ instanceof Re)return new De(_.value,ce);if(!(this instanceof De))return new De(_,ce);if(this.loose=ce,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Oe(_){return!_||_.toLowerCase()==="x"||_==="*"}function $e(_,ce,he,Ie,Ae,Te,Fe,je,ze,We,He,X,ae){return((ce=Oe(he)?"":Oe(Ie)?">="+he+".0.0":Oe(Ae)?">="+he+"."+Ie+".0":">="+ce)+" "+(je=Oe(ze)?"":Oe(We)?"<"+(+ze+1)+".0.0":Oe(He)?"<"+ze+"."+(+We+1)+".0":X?"<="+ze+"."+We+"."+He+"-"+X:"<="+je)).trim()}function fe(_,ce){for(var he=0;he<_.length;he++)if(!_[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<_.length;he++)if(n(_[he].semver),_[he].semver!==Ce&&_[he].semver.prerelease.length>0){var Ie=_[he].semver;if(Ie.major===ce.major&&Ie.minor===ce.minor&&Ie.patch===ce.patch)return!0}return!1}return!0}function pe(_,ce,he){try{ce=new De(ce,he)}catch{return!1}return ce.test(_)}function Me(_,ce,he,Ie){var Ae,Te,Fe,je,ze;switch(_=new L(_,Ie),ce=new De(ce,Ie),he){case">":Ae=$,Te=re,Fe=V,je=">",ze=">=";break;case"<":Ae=V,Te=Y,Fe=$,je="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(_,ce,Ie))return!1;for(var We=0;We<ce.set.length;++We){var He=ce.set[We],X=null,ae=null;if(He.forEach(function(ge){ge.semver===Ce&&(ge=new Re(">=0.0.0")),X=X||ge,ae=ae||ge,Ae(ge.semver,X.semver,Ie)?X=ge:Fe(ge.semver,ae.semver,Ie)&&(ae=ge)}),X.operator===je||X.operator===ze||(!ae.operator||ae.operator===je)&&Te(_,ae.semver)||ae.operator===ze&&Fe(_,ae.semver))return!1}return!0}Re.prototype.parse=function(_){var ce=this.loose?k[me]:k[G],he=_.match(ce);if(!he)throw new TypeError("Invalid comparator: "+_);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Ce},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(_){return n("Comparator.test",_,this.loose),this.semver===Ce||(typeof _=="string"&&(_=new L(_,this.loose)),de(_,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(_,ce){if(!(_ instanceof Re))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new De(_.value,ce),pe(this.value,he,ce);if(_.operator==="")return he=new De(this.value,ce),pe(_.semver,he,ce);var Ie=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Te=this.semver.version===_.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),je=de(this.semver,"<",_.semver,ce)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=de(this.semver,">",_.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Ie||Ae||Te&&Fe||je||ze},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(_){var ce=this.loose;_=_.trim(),n("range",_,ce);var he=ce?k[q]:k[O];_=_.replace(he,$e),n("hyphen replace",_),_=_.replace(k[B],"$1$2$3"),n("comparator trim",_,k[B]),_=(_=(_=_.replace(k[z],"$1~")).replace(k[oe],"$1^")).split(/\s+/).join(" ");var Ie=ce?k[me]:k[G],Ae=_.split(" ").map(function(Te){return function(Fe,je){return n("comp",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){n("caret",X,ae);var ge=ae?k[le]:k[ue];return X.replace(ge,function(be,we,Le,Ue,Ve){var Ge;return n("caret",X,be,we,Le,Ue,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=we==="0"?">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+".0 <"+(+we+1)+".0.0":Ve?(n("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+Le+"."+(+Ue+1):">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+Ue+Ve+" <"+(+we+1)+".0.0"):(n("no pr"),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+Ue+" <"+we+"."+Le+"."+(+Ue+1):">="+we+"."+Le+"."+Ue+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+Ue+" <"+(+we+1)+".0.0"),n("caret return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("caret",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){var ge=ae?k[ie]:k[H];return X.replace(ge,function(be,we,Le,Ue,Ve){var Ge;return n("tilde",X,be,we,Le,Ue,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":Ve?(n("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+(+Le+1)+".0"):Ge=">="+we+"."+Le+"."+Ue+" <"+we+"."+(+Le+1)+".0",n("tilde return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("tildes",Fe),Fe=function(ze,We){return n("replaceXRanges",ze,We),ze.split(/\s+/).map(function(He){return function(X,ae){X=X.trim();var ge=ae?k[A]:k[I];return X.replace(ge,function(be,we,Le,Ue,Ve,Ge){n("xRange",X,be,we,Le,Ue,Ve,Ge);var Ke=Oe(Le),Ye=Ke||Oe(Ue),Ze=Ye||Oe(Ve);return we==="="&&Ze&&(we=""),Ke?be=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ue=0),Ze&&(Ve=0),we===">"?(we=">=",Ye?(Le=+Le+1,Ue=0,Ve=0):Ze&&(Ue=+Ue+1,Ve=0)):we==="<="&&(we="<",Ye?Le=+Le+1:Ue=+Ue+1),be=we+Le+"."+Ue+"."+Ve):Ye?be=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ze&&(be=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0"),n("xRange return",be),be})}(He,We)}).join(" ")}(Fe,je),n("xrange",Fe),Fe=function(ze,We){return n("replaceStars",ze,We),ze.trim().replace(k[J],"")}(Fe,je),n("stars",Fe),Fe}(Te,ce)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Te){return!!Te.match(Ie)})),Ae=Ae.map(function(Te){return new Re(Te,ce)})},De.prototype.intersects=function(_,ce){if(!(_ instanceof De))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ie){return _.set.some(function(Ae){return Ae.every(function(Te){return Ie.intersects(Te,ce)})})})})},e.toComparators=function(_,ce){return new De(_,ce).set.map(function(he){return he.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},De.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new L(_,this.loose));for(var ce=0;ce<this.set.length;ce++)if(fe(this.set[ce],_))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(_,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return _.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==-1||(Ae=new L(Ie=Fe,he)))}),Ie},e.minSatisfying=function(_,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return _.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==1||(Ae=new L(Ie=Fe,he)))}),Ie},e.validRange=function(_,ce){try{return new De(_,ce).range||"*"}catch{return null}},e.ltr=function(_,ce,he){return Me(_,ce,"<",he)},e.gtr=function(_,ce,he){return Me(_,ce,">",he)},e.outside=Me,e.prerelease=function(_,ce){var he=ne(_,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(_,ce,he){return _=new De(_,he),ce=new De(ce,he),_.intersects(ce)},e.coerce=function(_){if(_ instanceof L)return _;if(typeof _!="string")return null;var ce=_.match(k[T]);return ce==null?null:ne((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,S(1))},function(x,e){var S,M,n=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(a){if(S===setTimeout)return setTimeout(a,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{M=typeof clearTimeout=="function"?clearTimeout:C}catch{M=C}})();var g,d=[],b=!1,v=-1;function y(){b&&g&&(b=!1,g.length?d=g.concat(d):v=-1,d.length&&h())}function h(){if(!b){var a=k(y);b=!0;for(var f=d.length;f;){for(g=d,d=[];++v<f;)g&&g[v].run();v=-1,f=d.length}g=null,b=!1,function(m){if(M===clearTimeout)return clearTimeout(m);if((M===C||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(m);try{M(m)}catch{try{return M.call(null,m)}catch{return M.call(this,m)}}}(a)}}function p(a,f){this.fun=a,this.array=f}function w(){}n.nextTick=function(a){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];d.push(new p(a,f)),d.length!==1||b||k(h)},p.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=w,n.addListener=w,n.once=w,n.off=w,n.removeListener=w,n.removeAllListeners=w,n.emit=w,n.prependListener=w,n.prependOnceListener=w,n.listeners=function(a){return[]},n.binding=function(a){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(a){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(Z[129],ee([0,1]),function(x,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,g,d){this.level=k,this.key=g,this.value=d,this.forward=[]}}const n=void 0;class R{constructor(k,g=2**16){this.comparator=k,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new M(this.c,n,n)}get size(){return this.f}clear(){this.e=new M(this.c,n,n)}has(k){return Boolean(R.g(this,k,this.comparator))}get(k){return R.g(this,k,this.comparator)?.value}set(k,g){return R.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=R.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let d=this.e.forward[0];for(;d;)k.call(g,d.value,d.key,this),d=d.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,d){let b=k.e;for(let v=k.d-1;v>=0;v--)for(;b.forward[v]&&d(b.forward[v].key,g)<0;)b=b.forward[v];if(b=b.forward[0],b&&d(b.key,g)===0)return b}static h(k,g,d,b){const v=[];let y=k.e;for(let h=k.d-1;h>=0;h--){for(;y.forward[h]&&b(y.forward[h].key,g)<0;)y=y.forward[h];v[h]=y}if(y=y.forward[0],y&&b(y.key,g)===0)return y.value=d,!1;{const h=R.j(k);if(h>k.d){for(let p=k.d;p<h;p++)v[p]=k.e;k.d=h}y=new M(h,g,d);for(let p=0;p<h;p++)y.forward[p]=v[p].forward[p],v[p].forward[p]=y;return!0}}static j(k,g=.5){let d=1;for(;Math.random()<g&&d<k.c;)d+=1;return d}static k(k,g,d){const b=[];let v=k.e;for(let y=k.d-1;y>=0;y--){for(;v.forward[y]&&d(v.forward[y].key,g)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||d(v.key,g)!==0)return!1;for(let y=0;y<k.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;k.d>0&&k.e.forward[k.d-1]===n;)k.d-=1;return!0}}e.SkipList=R}),define(Z[59],ee([0,1,13,2]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(E){const D=E;return D?typeof D.read=="function":!1}e.isReadable=n;function R(E){const D=E;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function C(E){const D=E;return D?R(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(E,D){return new g(E,D)}e.newWriteableStream=k;class g{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,S.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let c;switch(D){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(E,D){const t=[];let c;for(;(c=E.read())!==null;)t.push(c);return D(t)}e.consumeReadable=d;function b(E,D,t){const c=[];let i;for(;(i=E.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?D(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return E.read()}}}e.peekReadable=b;function v(E,D){return new Promise((t,c)=>{const i=[];y(E,{onData:r=>{D&&i.push(r)},onError:r=>{D?c(r):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=v;function y(E,D){let t=!1;return E.on("error",c=>{t||D.onError(c)}),E.on("end",()=>{t||D.onEnd()}),E.on("data",c=>{t||D.onData(c)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=y;function h(E,D){return new Promise((t,c)=>{const i=new M.DisposableStore,r=[],o=u=>{if(r.push(u),r.length>D)return i.dispose(),E.pause(),t({stream:E,buffer:r,ended:!1})},l=u=>c(u),s=()=>t({stream:E,buffer:r,ended:!0});i.add((0,M.toDisposable)(()=>E.removeListener("error",l))),E.on("error",l),i.add((0,M.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),i.add((0,M.toDisposable)(()=>E.removeListener("data",o))),E.on("data",o)})}e.peekStream=h;function p(E,D){const t=k(D);return t.end(E),t}e.toStream=p;function w(){const E=k(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=w;function a(E){let D=!1;return{read:()=>D?null:(D=!0,E)}}e.toReadable=a;function f(E,D,t){const c=k(t);return y(E,{onData:i=>c.write(D.data(i)),onError:i=>c.error(D.error?D.error(i):i),onEnd:()=>c.end()}),c}e.transform=f;function m(E,D,t){let c=!1;return{read:()=>{const i=D.read();return c?i:(c=!0,i!==null?t([E,i]):E)}}}e.prefixedReadable=m;function P(E,D,t){let c=!1;const i=k(t);return y(D,{onData:r=>c?i.write(r):(c=!0,i.write(t([E,r]))),onError:r=>i.error(r),onEnd:()=>{c||(c=!0,i.write(E)),i.end()}}),i}e.prefixedStream=P}),define(Z[17],ee([0,1,59]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let n,R;class C{static alloc(u){return M?new C(Buffer.allocUnsafe(u)):new C(new Uint8Array(u))}static wrap(u){return M&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new C(u)}static fromString(u,I){return!(I?.dontUseNodeBuffer||!1)&&M?new C(Buffer.from(u)):(n||(n=new TextEncoder),new C(n.encode(u)))}static fromByteArray(u){const I=C.alloc(u.length);for(let A=0,T=u.length;A<T;A++)I.buffer[A]=u[A];return I}static concat(u,I){if(typeof I>"u"){I=0;for(let N=0,z=u.length;N<z;N++)I+=u[N].byteLength}const A=C.alloc(I);let T=0;for(let N=0,z=u.length;N<z;N++){const H=u[N];A.set(H,T),T+=H.byteLength}return A}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=C.alloc(this.byteLength);return u.set(this),u}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(u,I){return new C(this.buffer.subarray(u,I))}set(u,I){if(u instanceof C)this.buffer.set(u.buffer,I);else if(u instanceof Uint8Array)this.buffer.set(u,I);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),I);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return d(this.buffer,u)}writeUInt32BE(u,I){b(this.buffer,u,I)}readUInt32LE(u){return v(this.buffer,u)}writeUInt32LE(u,I){y(this.buffer,u,I)}readUInt8(u){return h(this.buffer,u)}writeUInt8(u,I){p(this.buffer,u,I)}}e.VSBuffer=C;function k(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=k;function g(s,u,I){s[I+0]=u&255,u=u>>>8,s[I+1]=u&255}e.writeUInt16LE=g;function d(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=d;function b(s,u,I){s[I+3]=u,u=u>>>8,s[I+2]=u,u=u>>>8,s[I+1]=u,u=u>>>8,s[I]=u}e.writeUInt32BE=b;function v(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=v;function y(s,u,I){s[I+0]=u&255,u=u>>>8,s[I+1]=u&255,u=u>>>8,s[I+2]=u&255,u=u>>>8,s[I+3]=u&255}e.writeUInt32LE=y;function h(s,u){return s[u]}e.readUInt8=h;function p(s,u,I){s[I]=u}e.writeUInt8=p;function w(s){return S.consumeReadable(s,u=>C.concat(u))}e.readableToBuffer=w;function a(s){return S.toReadable(s)}e.bufferToReadable=a;function f(s){return S.consumeStream(s,u=>C.concat(u))}e.streamToBuffer=f;async function m(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=m;function P(s){return S.toStream(s,u=>C.concat(u))}e.bufferToStream=P;function E(s){return S.transform(s,{data:u=>typeof u=="string"?C.fromString(u):C.wrap(u)},u=>C.concat(u))}e.streamToBufferReadableStream=E;function D(s){return S.newWriteableStream(u=>C.concat(u),s)}e.newWriteableBufferStream=D;function t(s,u){return S.prefixedReadable(s,u,I=>C.concat(I))}e.prefixedBufferReadable=t;function c(s,u){return S.prefixedStream(s,u,I=>C.concat(I))}e.prefixedBufferStream=c;function i(s){let u=0,I=0,A=0;const T=new Uint8Array(Math.floor(s.length/4*3)),N=H=>{switch(I){case 3:T[A++]=u|H,I=0;break;case 2:T[A++]=u|H>>>2,u=H<<6,I=3;break;case 1:T[A++]=u|H>>>4,u=H<<4,I=2;break;default:u=H<<2,I=1}};for(let H=0;H<s.length;H++){const ie=s.charCodeAt(H);if(ie>=65&&ie<=90)N(ie-65);else if(ie>=97&&ie<=122)N(ie-97+26);else if(ie>=48&&ie<=57)N(ie-48+52);else if(ie===43||ie===45)N(62);else if(ie===47||ie===95)N(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${s[H]}`)}}const z=A;for(;I>0;)N(0);return C.wrap(T).slice(0,z)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:s},u=!0,I=!1){const A=I?o:r;let T="";const N=s.byteLength%3;let z=0;for(;z<s.byteLength-N;z+=3){const H=s[z+0],ie=s[z+1],se=s[z+2];T+=A[H>>>2],T+=A[(H<<4|ie>>>4)&63],T+=A[(ie<<2|se>>>6)&63],T+=A[se&63]}if(N===1){const H=s[z+0];T+=A[H>>>2],T+=A[H<<4&63],u&&(T+="==")}else if(N===2){const H=s[z+0],ie=s[z+1];T+=A[H>>>2],T+=A[(H<<4|ie>>>4)&63],T+=A[ie<<2&63],u&&(T+="=")}return T}e.encodeBase64=l}),define(Z[130],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Z[10],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(c){return typeof c=="string"}e.isString=S;function M(c){return Array.isArray(c)&&c.every(i=>S(i))}e.isStringArray=M;function n(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=n;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=R;function C(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=C;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function g(c){return c===!0||c===!1}e.isBoolean=g;function d(c){return typeof c>"u"}e.isUndefined=d;function b(c){return!v(c)}e.isDefined=b;function v(c){return d(c)||c===null}e.isUndefinedOrNull=v;function y(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function h(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=h;function p(...c){const i=[];for(let r=0;r<c.length;r++){const o=c[r];if(v(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(o)}return i}e.assertAllDefined=p;const w=Object.prototype.hasOwnProperty;function a(c){if(!n(c))return!1;for(const i in c)if(w.call(c,i))return!1;return!0}e.isEmptyObject=a;function f(c){return typeof c=="function"}e.isFunction=f;function m(...c){return c.length>0&&c.every(f)}e.areFunctions=m;function P(c,i){const r=Math.min(c.length,i.length);for(let o=0;o<r;o++)E(c[o],i[o])}e.validateConstraints=P;function E(c,i){if(S(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(f(i)){try{if(c instanceof i)return}catch{}if(!v(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function D(c){return c===null?void 0:c}e.withNullAsUndefined=D;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(Z[131],ee([0,1,10]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function n(k,g){if((0,S.isString)(g)){const d=M[g];if(d===void 0)throw new Error(`${k} references an unknown codicon: ${g}`);g=d}return M[k]=g,{id:k}}function R(){return M}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(Z[40],ee([0,1,10]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const m=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([P,E])=>{m[P]=E&&typeof E=="object"?M(E):E}),m}e.deepClone=M;function n(f){if(!f||typeof f!="object")return f;const m=[f];for(;m.length>0;){const P=m.shift();Object.freeze(P);for(const E in P)if(R.call(P,E)){const D=P[E];typeof D=="object"&&!Object.isFrozen(D)&&!(0,S.isTypedArray)(D)&&m.push(D)}}return f}e.deepFreeze=n;const R=Object.prototype.hasOwnProperty;function C(f,m){return k(f,m,new Set)}e.cloneAndChange=C;function k(f,m,P){if((0,S.isUndefinedOrNull)(f))return f;const E=m(f);if(typeof E<"u")return E;if(Array.isArray(f)){const D=[];for(const t of f)D.push(k(t,m,P));return D}if((0,S.isObject)(f)){if(P.has(f))throw new Error("Cannot clone recursive data-structure");P.add(f);const D={};for(const t in f)R.call(f,t)&&(D[t]=k(f[t],m,P));return P.delete(f),D}return f}function g(f,m,P=!0){return(0,S.isObject)(f)?((0,S.isObject)(m)&&Object.keys(m).forEach(E=>{E in f?P&&((0,S.isObject)(f[E])&&(0,S.isObject)(m[E])?g(f[E],m[E],P):f[E]=m[E]):f[E]=m[E]}),f):m}e.mixin=g;function d(f,m){if(f===m)return!0;if(f==null||m===null||m===void 0||typeof f!=typeof m||typeof f!="object"||Array.isArray(f)!==Array.isArray(m))return!1;let P,E;if(Array.isArray(f)){if(f.length!==m.length)return!1;for(P=0;P<f.length;P++)if(!d(f[P],m[P]))return!1}else{const D=[];for(E in f)D.push(E);D.sort();const t=[];for(E in m)t.push(E);if(t.sort(),!d(D,t))return!1;for(P=0;P<D.length;P++)if(!d(f[D[P]],m[D[P]]))return!1}return!0}e.equals=d;function b(f){const m=new Set;return JSON.stringify(f,(P,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(m.has(E))return"[Circular]";m.add(E)}return E})}e.safeStringify=b;function v(f,m){const P=Object.create(null);return!f||!m||Object.keys(m).forEach(D=>{const t=f[D],c=m[D];d(t,c)||(P[D]=c)}),P}e.distinct=v;function y(f,m){const P=m.toLowerCase(),E=Object.keys(f).find(D=>D.toLowerCase()===P);return E?f[E]:f[m]}e.getCaseInsensitive=y;function h(f,m){const P=Object.create(null);for(const[E,D]of Object.entries(f))m(E,D)&&(P[E]=D);return P}e.filter=h;function p(f){let m=[],P=Object.getPrototypeOf(f);for(;Object.prototype!==P;)m=m.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return m}e.getAllPropertyNames=p;function w(f){const m=[];for(const P of p(f))typeof f[P]=="function"&&m.push(P);return m}e.getAllMethodNames=w;function a(f,m){const P=D=>function(){const t=Array.prototype.slice.call(arguments,0);return m(D,t)},E={};for(const D of f)E[D]=P(D);return E}e.createProxyObject=a}),define(Z[132],ee([0,1,131]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(C){function k(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=k})(M=e.ThemeColor||(e.ThemeColor={}));function n(C){return{id:C}}e.themeColorFromId=n;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function g(m){const P=k.exec(m.id);if(!P)return g(S.Codicon.error);const[,E,D]=P,t=["codicon","codicon-"+E];return D&&t.push("codicon-modifier-"+D.substring(1)),t}C.asClassNameArray=g;function d(m){return g(m).join(" ")}C.asClassName=d;function b(m){return"."+g(m).join(".")}C.asCSSSelector=b;function v(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||M.isThemeColor(m.color))}C.isThemeIcon=v;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function h(m){const P=y.exec(m);if(!P)return;const[,E]=P;return{id:E}}C.fromString=h;function p(m){return{id:m}}C.fromId=p;function w(m,P){let E=m.id;const D=E.lastIndexOf("~");return D!==-1&&(E=E.substring(0,D)),P&&(E=`${E}~${P}`),{id:E}}C.modify=w;function a(m){const P=m.id.lastIndexOf("~");if(P!==-1)return m.id.substring(P+1)}C.getModifier=a;function f(m,P){return m.id===P.id&&m.color?.id===P.color?.id}C.isEqual=f})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Z[31],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(n){return S.test(n)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){n(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let g=0,d="";return d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d+="-",d+=C[R[g++]],d+=C[R[g++]],d+="-",d+=C[R[g++]],d+=C[R[g++]],d+="-",d+=C[R[g++]],d+=C[R[g++]],d+="-",d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d+=C[R[g++]],d}}()}),define(Z[133],ee([0,1,80,41,49]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(C,k){if(await new Promise((b,v)=>{const y=M.createReadStream(C),h=S.createHash("sha1");y.pipe(h);const p=(0,n.once)((w,a)=>{y.removeAllListeners(),h.removeAllListeners(),w?v(w):b(a)});y.once("error",p),y.once("end",p),h.once("error",p),h.once("data",w=>p(void 0,w.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[134],ee([0,1,26]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(C){const k=C.replace(/\-/g,":").toLowerCase();return!M.has(k)}function R(){const C=(0,S.networkInterfaces)();for(const k in C){const g=C[k];if(g){for(const{mac:d}of g)if(n(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[99],ee([0,1,81]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(k,g,d,b=1){let v=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!v)return v=!0,y(0)},d);n(k,g,b,p=>{if(!v)return v=!0,clearTimeout(h),y(p)})})}e.findFreePort=M;function n(k,g,d,b){if(g===0)return b(0);const v=new S.Socket;v.once("connect",()=>(C(v),n(k+d,g-1,d,b))),v.once("data",()=>{}),v.once("error",y=>(C(v),y.code!=="ECONNREFUSED"?n(k+d,g-1,d,b):b(k))),v.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,g,d,b="127.0.0.1"){let v=!1,y,h=1;const p=S.createServer({pauseOnConnect:!0});function w(a,f){v||(v=!0,p.removeAllListeners(),p.close(),y&&clearTimeout(y),f(a))}return new Promise(a=>{y=setTimeout(()=>{w(0,a)},d),p.on("listening",()=>{w(k,a)}),p.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&h<g?(k++,h++,p.listen(k,b)):w(0,a)}),p.on("close",()=>{w(0,a)}),p.listen(k,b)})}e.findFreePortFaster=R;function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(g){console.error(g)}}}),define(Z[135],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[136],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(n,R){this.a=n,this.onMessage=R}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=S}),define(Z[42],ee([0,1,15,13]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(C,k){const g=(d,...b)=>{this.b(C,d)&&k(d,...b)};return this.a.set(k,g),S.ipcMain.on(C,g),this}once(C,k){return S.ipcMain.once(C,(g,...d)=>{this.b(C,g)&&k(g,...d)}),this}handle(C,k){return S.ipcMain.handle(C,(g,...d)=>this.b(C,g)?k(g,...d):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return S.ipcMain.removeHandler(C),this}removeListener(C,k){const g=this.a.get(k);return g&&(S.ipcMain.removeListener(C,g),this.a.delete(k)),this}b(C,k){if(!C||!C.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const g=k.senderFrame,d=g.url;if(!d)return!0;let b="unknown";try{b=new URL(d).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${d}'.`),!1}return b!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${b}'.`),!1):g.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(Z[137],ee([0,1,15,42,10,135]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){M.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(g,d,b,v,y)=>{const h=k(g,v,b);h.popup({window:(0,n.withNullAsUndefined)(S.BrowserWindow.fromWebContents(g.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{h&&g.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function k(g,d,b){const v=new S.Menu;return b.forEach(y=>{let h;y.type==="separator"?h=new S.MenuItem({type:y.type}):Array.isArray(y.submenu)?h=new S.MenuItem({submenu:k(g,d,y.submenu),label:y.label}):h=new S.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(p,w,a)=>g.sender.send(d,y.id,a)}),v.append(h)}),v}}),define(Z[138],ee([12,11]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[139],ee([0,1,138]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,n=M*60,R=n*24,C=R*7,k=R*30,g=R*365;function d(v,y,h,p){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,S.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(!p&&w<30)return(0,S.localize)(1,null);let a;return w<M?(a=w,y?a===1?h?(0,S.localize)(2,null,a):(0,S.localize)(3,null,a):h?(0,S.localize)(4,null,a):(0,S.localize)(5,null,a):a===1?h?(0,S.localize)(6,null,a):(0,S.localize)(7,null,a):h?(0,S.localize)(8,null,a):(0,S.localize)(9,null,a)):w<n?(a=Math.floor(w/M),y?a===1?h?(0,S.localize)(10,null,a):(0,S.localize)(11,null,a):h?(0,S.localize)(12,null,a):(0,S.localize)(13,null,a):a===1?h?(0,S.localize)(14,null,a):(0,S.localize)(15,null,a):h?(0,S.localize)(16,null,a):(0,S.localize)(17,null,a)):w<R?(a=Math.floor(w/n),y?a===1?h?(0,S.localize)(18,null,a):(0,S.localize)(19,null,a):h?(0,S.localize)(20,null,a):(0,S.localize)(21,null,a):a===1?h?(0,S.localize)(22,null,a):(0,S.localize)(23,null,a):h?(0,S.localize)(24,null,a):(0,S.localize)(25,null,a)):w<C?(a=Math.floor(w/R),y?a===1?(0,S.localize)(26,null,a):(0,S.localize)(27,null,a):a===1?(0,S.localize)(28,null,a):(0,S.localize)(29,null,a)):w<k?(a=Math.floor(w/C),y?a===1?h?(0,S.localize)(30,null,a):(0,S.localize)(31,null,a):h?(0,S.localize)(32,null,a):(0,S.localize)(33,null,a):a===1?h?(0,S.localize)(34,null,a):(0,S.localize)(35,null,a):h?(0,S.localize)(36,null,a):(0,S.localize)(37,null,a)):w<g?(a=Math.floor(w/k),y?a===1?h?(0,S.localize)(38,null,a):(0,S.localize)(39,null,a):h?(0,S.localize)(40,null,a):(0,S.localize)(41,null,a):a===1?h?(0,S.localize)(42,null,a):(0,S.localize)(43,null,a):h?(0,S.localize)(44,null,a):(0,S.localize)(45,null,a)):(a=Math.floor(w/g),y?a===1?h?(0,S.localize)(46,null,a):(0,S.localize)(47,null,a):h?(0,S.localize)(48,null,a):(0,S.localize)(49,null,a):a===1?h?(0,S.localize)(50,null,a):(0,S.localize)(51,null,a):h?(0,S.localize)(52,null,a):(0,S.localize)(53,null,a))}e.fromNow=d;function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Z[140],ee([12,11]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,25,10,140]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(v,y){return y&&(v.stack||v.stacktrace)?n.localize(0,null,k(v),C(v.stack)||C(v.stacktrace)):k(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function k(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function g(v=null,y=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const h=S.coalesce(v),p=g(h[0],y);return h.length>1?n.localize(4,null,p,h.length):p}if(M.isString(v))return v;if(v.detail){const h=v.detail;if(h.error)return R(h.error,y);if(h.exception)return R(h.exception,y)}return v.stack?R(v,y):v.message?v.message:n.localize(5,null)}e.toErrorMessage=g;function d(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=d;function b(v,y){let h;return typeof v=="string"?h=new Error(v):h=v,h.actions=y,h}e.createErrorWithActions=b}),define(Z[141],ee([12,11]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[142],ee([0,1,141]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(n){switch(n){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(Z[143],ee([12,11]),function(x,e){return x.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,143]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,n=!1,R=!1,C=!1,k=!1,g=!1,d=!1,b=!1,v=!1,y=!1,h,p=e.LANGUAGE_DEFAULT,w,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const m=typeof f?.versions?.electron=="string",P=m&&f?.type==="renderer";if(typeof navigator=="object"&&!P)a=navigator.userAgent,M=a.indexOf("Windows")>=0,n=a.indexOf("Macintosh")>=0,b=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,y=a?.indexOf("Mobi")>=0,g=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,p=h;else if(typeof f=="object"){M=f.platform==="win32",n=f.platform==="darwin",R=f.platform==="linux",C=R&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,d=m,v=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),I=u.availableLanguages["*"];h=u.locale,p=I||e.LANGUAGE_DEFAULT,w=u._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function D(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let t=0;n?t=1:M?t=3:R&&(t=2),e.isWindows=M,e.isMacintosh=n,e.isLinux=R,e.isLinuxSnap=C,e.isNative=k,e.isElectron=d,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=v,e.platform=t,e.userAgent=a,e.language=p;var c;(function(s){function u(){return e.language}s.value=u;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=I;function A(){return e.language==="en"}s.isDefault=A})(c=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let A=0,T=s.length;A<T;A++){const N=s[A];if(N.id===I.data.vscodeScheduleAsyncWork){s.splice(A,1),N.callback();return}}});let u=0;return I=>{const A=++u;s.push({id:A,callback:I}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||b?2:M?1:3;let r=!0,o=!1;function l(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],ee([0,1,4]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const n=S.globals.vscode.process;M={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(Z[9],ee([0,1,36]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,n=97,R=90,C=122,k=46,g=47,d=92,b=58,v=63;class y extends Error{constructor(c,i,r){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const l=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${l} ${o} of type ${i}`;s+=`. Received type ${typeof r}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,c){if(t===null||typeof t!="object")throw new y(c,"Object",t)}function p(t,c){if(typeof t!="string")throw new y(c,"string",t)}const w=S.platform==="win32";function a(t){return t===g||t===d}function f(t){return t===g}function m(t){return t>=M&&t<=R||t>=n&&t<=C}function P(t,c,i,r){let o="",l=0,s=-1,u=0,I=0;for(let A=0;A<=t.length;++A){if(A<t.length)I=t.charCodeAt(A);else{if(r(I))break;I=g}if(r(I)){if(!(s===A-1||u===1))if(u===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const T=o.lastIndexOf(i);T===-1?(o="",l=0):(o=o.slice(0,T),l=o.length-1-o.lastIndexOf(i)),s=A,u=0;continue}else if(o.length!==0){o="",l=0,s=A,u=0;continue}}c&&(o+=o.length>0?`${i}..`:"..",l=2)}else o.length>0?o+=`${i}${t.slice(s+1,A)}`:o=t.slice(s+1,A),l=A-s-1;s=A,u=0}else I===k&&u!==-1?++u:u=-1}return o}function E(t,c){h(c,"pathObject");const i=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${r}`:`${i}${t}${r}`:r}e.win32={resolve(...t){let c="",i="",r=!1;for(let o=t.length-1;o>=-1;o--){let l;if(o>=0){if(l=t[o],p(l,"path"),l.length===0)continue}else c.length===0?l=S.cwd():(l=S.env[`=${c}`]||S.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===d)&&(l=`${c}\\`));const s=l.length;let u=0,I="",A=!1;const T=l.charCodeAt(0);if(s===1)a(T)&&(u=1,A=!0);else if(a(T))if(A=!0,a(l.charCodeAt(1))){let N=2,z=N;for(;N<s&&!a(l.charCodeAt(N));)N++;if(N<s&&N!==z){const H=l.slice(z,N);for(z=N;N<s&&a(l.charCodeAt(N));)N++;if(N<s&&N!==z){for(z=N;N<s&&!a(l.charCodeAt(N));)N++;(N===s||N!==z)&&(I=`\\\\${H}\\${l.slice(z,N)}`,u=N)}}}else u=1;else m(T)&&l.charCodeAt(1)===b&&(I=l.slice(0,2),u=2,s>2&&a(l.charCodeAt(2))&&(A=!0,u=3));if(I.length>0)if(c.length>0){if(I.toLowerCase()!==c.toLowerCase())continue}else c=I;if(r){if(c.length>0)break}else if(i=`${l.slice(u)}\\${i}`,r=A,A&&c.length>0)break}return i=P(i,!r,"\\",a),r?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){p(t,"path");const c=t.length;if(c===0)return".";let i=0,r,o=!1;const l=t.charCodeAt(0);if(c===1)return f(l)?"\\":t;if(a(l))if(o=!0,a(t.charCodeAt(1))){let u=2,I=u;for(;u<c&&!a(t.charCodeAt(u));)u++;if(u<c&&u!==I){const A=t.slice(I,u);for(I=u;u<c&&a(t.charCodeAt(u));)u++;if(u<c&&u!==I){for(I=u;u<c&&!a(t.charCodeAt(u));)u++;if(u===c)return`\\\\${A}\\${t.slice(I)}\\`;u!==I&&(r=`\\\\${A}\\${t.slice(I,u)}`,i=u)}}}else i=1;else m(l)&&t.charCodeAt(1)===b&&(r=t.slice(0,2),i=2,c>2&&a(t.charCodeAt(2))&&(o=!0,i=3));let s=i<c?P(t.slice(i),!o,"\\",a):"";return s.length===0&&!o&&(s="."),s.length>0&&a(t.charCodeAt(c-1))&&(s+="\\"),r===void 0?o?`\\${s}`:s:o?`${r}\\${s}`:`${r}${s}`},isAbsolute(t){p(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return a(i)||c>2&&m(i)&&t.charCodeAt(1)===b&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let l=0;l<t.length;++l){const s=t[l];p(s,"path"),s.length>0&&(c===void 0?c=i=s:c+=`\\${s}`)}if(c===void 0)return".";let r=!0,o=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++o;const l=i.length;l>1&&a(i.charCodeAt(1))&&(++o,l>2&&(a(i.charCodeAt(2))?++o:r=!1))}if(r){for(;o<c.length&&a(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(p(t,"from"),p(c,"to"),t===c)return"";const i=e.win32.resolve(t),r=e.win32.resolve(c);if(i===r||(t=i.toLowerCase(),c=r.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===d;)o++;let l=t.length;for(;l-1>o&&t.charCodeAt(l-1)===d;)l--;const s=l-o;let u=0;for(;u<c.length&&c.charCodeAt(u)===d;)u++;let I=c.length;for(;I-1>u&&c.charCodeAt(I-1)===d;)I--;const A=I-u,T=s<A?s:A;let N=-1,z=0;for(;z<T;z++){const ie=t.charCodeAt(o+z);if(ie!==c.charCodeAt(u+z))break;ie===d&&(N=z)}if(z!==T){if(N===-1)return r}else{if(A>T){if(c.charCodeAt(u+z)===d)return r.slice(u+z+1);if(z===2)return r.slice(u+z)}s>T&&(t.charCodeAt(o+z)===d?N=z:z===2&&(N=3)),N===-1&&(N=0)}let H="";for(z=o+N+1;z<=l;++z)(z===l||t.charCodeAt(z)===d)&&(H+=H.length===0?"..":"\\..");return u+=N,H.length>0?`${H}${r.slice(u,I)}`:(r.charCodeAt(u)===d&&++u,r.slice(u,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===d){if(c.charCodeAt(1)===d){const i=c.charCodeAt(2);if(i!==v&&i!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(m(c.charCodeAt(0))&&c.charCodeAt(1)===b&&c.charCodeAt(2)===d)return`\\\\?\\${c}`;return t},dirname(t){p(t,"path");const c=t.length;if(c===0)return".";let i=-1,r=0;const o=t.charCodeAt(0);if(c===1)return a(o)?t:".";if(a(o)){if(i=r=1,a(t.charCodeAt(1))){let u=2,I=u;for(;u<c&&!a(t.charCodeAt(u));)u++;if(u<c&&u!==I){for(I=u;u<c&&a(t.charCodeAt(u));)u++;if(u<c&&u!==I){for(I=u;u<c&&!a(t.charCodeAt(u));)u++;if(u===c)return t;u!==I&&(i=r=u+1)}}}}else m(o)&&t.charCodeAt(1)===b&&(i=c>2&&a(t.charCodeAt(2))?3:2,r=i);let l=-1,s=!0;for(let u=c-1;u>=r;--u)if(a(t.charCodeAt(u))){if(!s){l=u;break}}else s=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,c){c!==void 0&&p(c,"ext"),p(t,"path");let i=0,r=-1,o=!0,l;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,u=-1;for(l=t.length-1;l>=i;--l){const I=t.charCodeAt(l);if(a(I)){if(!o){i=l+1;break}}else u===-1&&(o=!1,u=l+1),s>=0&&(I===c.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=u))}return i===r?r=u:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=i;--l)if(a(t.charCodeAt(l))){if(!o){i=l+1;break}}else r===-1&&(o=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){p(t,"path");let c=0,i=-1,r=0,o=-1,l=!0,s=0;t.length>=2&&t.charCodeAt(1)===b&&m(t.charCodeAt(0))&&(c=r=2);for(let u=t.length-1;u>=c;--u){const I=t.charCodeAt(u);if(a(I)){if(!l){r=u+1;break}continue}o===-1&&(l=!1,o=u+1),I===k?i===-1?i=u:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||o===-1||s===0||s===1&&i===o-1&&i===r+1?"":t.slice(i,o)},format:E.bind(null,"\\"),parse(t){p(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let r=0,o=t.charCodeAt(0);if(i===1)return a(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(a(o)){if(r=1,a(t.charCodeAt(1))){let N=2,z=N;for(;N<i&&!a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&!a(t.charCodeAt(N));)N++;N===i?r=N:N!==z&&(r=N+1)}}}}else if(m(o)&&t.charCodeAt(1)===b){if(i<=2)return c.root=c.dir=t,c;if(r=2,a(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;r=3}}r>0&&(c.root=t.slice(0,r));let l=-1,s=r,u=-1,I=!0,A=t.length-1,T=0;for(;A>=r;--A){if(o=t.charCodeAt(A),a(o)){if(!I){s=A+1;break}continue}u===-1&&(I=!1,u=A+1),o===k?l===-1?l=A:T!==1&&(T=1):l!==-1&&(T=-1)}return u!==-1&&(l===-1||T===0||T===1&&l===u-1&&l===s+1?c.base=c.name=t.slice(s,u):(c.name=t.slice(s,l),c.base=t.slice(s,u),c.ext=t.slice(l,u))),s>0&&s!==r?c.dir=t.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(w){const t=/\\/g;return()=>{const c=S.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>S.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let r=t.length-1;r>=-1&&!i;r--){const o=r>=0?t[r]:D();p(o,"path"),o.length!==0&&(c=`${o}/${c}`,i=o.charCodeAt(0)===g)}return c=P(c,!i,"/",f),i?`/${c}`:c.length>0?c:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g,i=t.charCodeAt(t.length-1)===g;return t=P(t,!c,"/",f),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const r=t[i];p(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(p(t,"from"),p(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,r=t.length,o=r-i,l=1,s=c.length-l,u=o<s?o:s;let I=-1,A=0;for(;A<u;A++){const N=t.charCodeAt(i+A);if(N!==c.charCodeAt(l+A))break;N===g&&(I=A)}if(A===u)if(s>u){if(c.charCodeAt(l+A)===g)return c.slice(l+A+1);if(A===0)return c.slice(l+A)}else o>u&&(t.charCodeAt(i+A)===g?I=A:A===0&&(I=0));let T="";for(A=i+I+1;A<=r;++A)(A===r||t.charCodeAt(A)===g)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(l+I)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g;let i=-1,r=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===g){if(!r){i=o;break}}else r=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&p(c,"ext"),p(t,"path");let i=0,r=-1,o=!0,l;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,u=-1;for(l=t.length-1;l>=0;--l){const I=t.charCodeAt(l);if(I===g){if(!o){i=l+1;break}}else u===-1&&(o=!1,u=l+1),s>=0&&(I===c.charCodeAt(s)?--s===-1&&(r=l):(s=-1,r=u))}return i===r?r=u:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===g){if(!o){i=l+1;break}}else r===-1&&(o=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){p(t,"path");let c=-1,i=0,r=-1,o=!0,l=0;for(let s=t.length-1;s>=0;--s){const u=t.charCodeAt(s);if(u===g){if(!o){i=s+1;break}continue}r===-1&&(o=!1,r=s+1),u===k?c===-1?c=s:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||r===-1||l===0||l===1&&c===r-1&&c===i+1?"":t.slice(c,r)},format:E.bind(null,"/"),parse(t){p(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===g;let r;i?(c.root="/",r=1):r=0;let o=-1,l=0,s=-1,u=!0,I=t.length-1,A=0;for(;I>=r;--I){const T=t.charCodeAt(I);if(T===g){if(!u){l=I+1;break}continue}s===-1&&(u=!1,s=I+1),T===k?o===-1?o=I:A!==1&&(A=1):o!==-1&&(A=-1)}if(s!==-1){const T=l===0&&i?1:l;o===-1||A===0||A===1&&o===s-1&&o===l+1?c.base=c.name=t.slice(T,s):(c.name=t.slice(T,o),c.base=t.slice(T,s),c.ext=t.slice(o,s))}return l>0?c.dir=t.slice(0,l-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(Z[82],ee([0,1,4]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(M=e.Source||(e.Source={}));var n;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...g){const d=g.reduce((y,h)=>(y[h]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!d[y]).forEach(y=>{for(let h=0;h<b.length;h++)if(y.search(b[h])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=R;function C(k){!k||(delete k.DEBUG,S.isMacintosh&&delete k.DYLD_LIBRARY_PATH,S.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Z[70],ee([0,1,4]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=S.globals.performance&&typeof S.globals.performance.now=="function";class n{static create(C=!0){return new n(C)}constructor(C){this.a=M&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?S.globals.performance.now():Date.now()}}e.StopWatch=n}),define(Z[3],ee([0,1,13,49,2,98,70]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,g=!1;var d;(function(l){l.None=()=>n.Disposable.None;function s(U){if(g){const{onDidAddListener:$}=U,V=p.create();let j=0;U.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),$?.()}}}function u(U,$){return oe(U,()=>{},0,void 0,!0,void 0,$)}l.defer=u;function I(U){return($,V=null,j)=>{let K=!1,Y;return Y=U(re=>{if(!K)return Y?Y.dispose():K=!0,$.call(V,re)},null,j),K&&Y.dispose(),Y}}l.once=I;function A(U,$,V){return se((j,K=null,Y)=>U(re=>j.call(K,$(re)),null,Y),V)}l.map=A;function T(U,$,V){return se((j,K=null,Y)=>U(re=>{$(re),j.call(K,re)},null,Y),V)}l.forEach=T;function N(U,$,V){return se((j,K=null,Y)=>U(re=>$(re)&&j.call(K,re),null,Y),V)}l.filter=N;function z(U){return U}l.signal=z;function H(...U){return($,V=null,j)=>(0,n.combinedDisposable)(...U.map(K=>K(Y=>$.call(V,Y),null,j)))}l.any=H;function ie(U,$,V,j){let K=V;return A(U,Y=>(K=$(K,Y),K),j)}l.reduce=ie;function se(U,$){let V;const j={onWillAddFirstListener(){V=U(K.fire,K)},onDidRemoveLastListener(){V?.dispose()}};$||s(j);const K=new a(j);return $?.add(K),K.event}function oe(U,$,V=100,j=!1,K=!1,Y,re){let de,Re,Ce,De=0,Oe;const $e={leakWarningThreshold:Y,onWillAddFirstListener(){de=U(pe=>{De++,Re=$(Re,pe),j&&!Ce&&(fe.fire(Re),Re=void 0),Oe=()=>{const Me=Re;Re=void 0,Ce=void 0,(!j||De>1)&&fe.fire(Me),De=0},typeof V=="number"?(clearTimeout(Ce),Ce=setTimeout(Oe,V)):Ce===void 0&&(Ce=0,queueMicrotask(Oe))})},onWillRemoveListener(){K&&De>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,de.dispose()}};re||s($e);const fe=new a($e);return re?.add(fe),fe.event}l.debounce=oe;function ue(U,$=0,V){return l.debounce(U,(j,K)=>j?(j.push(K),j):[K],$,void 0,!0,void 0,V)}l.accumulate=ue;function le(U,$=(j,K)=>j===K,V){let j=!0,K;return N(U,Y=>{const re=j||!$(Y,K);return j=!1,K=Y,re},V)}l.latch=le;function me(U,$,V){return[l.filter(U,$,V),l.filter(U,j=>!$(j),V)]}l.split=me;function G(U,$=!1,V=[]){let j=V.slice(),K=U(de=>{j?j.push(de):re.fire(de)});const Y=()=>{j?.forEach(de=>re.fire(de)),j=null},re=new a({onWillAddFirstListener(){K||(K=U(de=>re.fire(de)))},onDidAddFirstListener(){j&&($?setTimeout(Y):Y())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return re.event}l.buffer=G;class B{constructor($){this.event=$,this.c=new n.DisposableStore}map($){return new B(A(this.event,$,this.c))}forEach($){return new B(T(this.event,$,this.c))}filter($){return new B(N(this.event,$,this.c))}reduce($,V){return new B(ie(this.event,$,V,this.c))}latch(){return new B(le(this.event,void 0,this.c))}debounce($,V=100,j=!1,K=!1,Y){return new B(oe(this.event,$,V,j,K,Y,this.c))}on($,V,j){return this.event($,V,j)}once($,V,j){return I(this.event)($,V,j)}dispose(){this.c.dispose()}}function O(U){return new B(U)}l.chain=O;function q(U,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>U.on($,j),Y=()=>U.removeListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:Y});return re.event}l.fromNodeEventEmitter=q;function J(U,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>U.addEventListener($,j),Y=()=>U.removeEventListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:Y});return re.event}l.fromDOMEventEmitter=J;function te(U){return new Promise($=>I(U)($))}l.toPromise=te;function ne(U,$){return $(void 0),U(V=>$(V))}l.runAndSubscribe=ne;function L(U,$){let V=null;function j(Y){V?.dispose(),V=new n.DisposableStore,$(Y,V)}j(void 0);const K=U(Y=>j(Y));return(0,n.toDisposable)(()=>{K.dispose(),V?.dispose()})}l.runAndSubscribeWithStore=L;class F{constructor($,V){this.obs=$,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};V||s(j),this.emitter=new a(j),V&&V.add(this.emitter)}beginUpdate($){this.c++}handleChange($,V){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(U,$){return new F(U,$).emitter.event}l.fromObservable=W})(d=e.Event||(e.Event={}));class b{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${b.c++}`,b.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}b.all=new Set,b.c=0,e.EventProfiling=b;let v=-1;function y(l){const s=v;return v=l,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=y;class h{constructor(s,u=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=u,this.d=0}dispose(){this.c?.clear()}check(s,u){const I=this.threshold;if(I<=0||u<I)return;this.c||(this.c=new Map);const A=this.c.get(s.value)||0;if(this.c.set(s.value,A+1),this.d-=1,this.d<=0){this.d=I*.5;let T,N=0;for(const[z,H]of this.c)(!T||N<H)&&(T=z,N=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(s.value)||0;this.c.set(s.value,T-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(s,u,I){this.callback=s,this.callbackThis=u,this.stack=I,this.subscription=new n.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class a{constructor(s){this.j=!1,this.d=s,this.f=v>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const s=Array.from(this.q);queueMicrotask(()=>{for(const u of s)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,u,I)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const A=this.q.isEmpty();A&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=p.create(),T=this.f.check(N,this.q.size+1)),k&&(N=N??p.create());const z=new w(s,u,N),H=this.q.push(z);A&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,u);const ie=z.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return I instanceof n.DisposableStore?I.add(ie):Array.isArray(I)&&I.push(ie),ie}),this.l}fire(s){if(this.q){this.m||(this.m=new m);for(const u of this.q)this.m.push(this,u,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class f{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(s,u,I){this.c.push(new P(s,u,I))}clear(s){const u=new R.LinkedList;for(const I of this.c)I.emitter!==s&&u.push(I);this.c=u}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(u){(0,S.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=f;class m extends f{clear(s){this.c.clear()}}class P{constructor(s,u,I){this.emitter=s,this.listener=u,this.event=I}}class E extends a{async fireAsync(s,u,I){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const A of this.q)this.c.push([A,s]);for(;this.c.size>0&&!u.isCancellationRequested;){const[A,T]=this.c.shift(),N=[],z={...T,token:u,waitUntil:H=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");I&&(H=I(H,A.callback)),N.push(H)}};try{A.invoke(z)}catch(H){(0,S.onUnexpectedError)(H);continue}Object.freeze(N),await Promise.allSettled(N).then(H=>{for(const ie of H)ie.status==="rejected"&&(0,S.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=E;class D extends a{constructor(s){super(s),this.h=0,this.s=new R.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=D;class t extends D{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class c extends a{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const u={event:s,listener:null};this.f.push(u),this.d&&this.j(u);const I=()=>{this.d&&this.k(u);const A=this.f.indexOf(u);this.f.splice(A,1)};return(0,n.toDisposable)((0,M.once)(I))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(u=>this.c.fire(u))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.c=[]}wrapEvent(s){return(u,I,A)=>s(T=>{const N=this.c[this.c.length-1];N?N.push(()=>u.call(I,T)):u.call(I,T)},void 0,A)}bufferEvents(s){const u=[];this.c.push(u);const I=s();return this.c.pop(),u.forEach(A=>A()),I}}e.EventBufferer=r;class o{constructor(){this.c=!1,this.d=d.None,this.f=n.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(Z[22],ee([0,1,3]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(k,g){const d=setTimeout(k.bind(g),0);return{dispose(){clearTimeout(d)}}});var n;(function(k){function g(d){return d===k.None||d===k.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}k.isCancellationToken=g,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(n=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new S.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=n.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=C}),define(Z[144],ee([0,1,22]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new S.CancellationTokenSource,g=this.b(k.token);return this.a={promise:g,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=M;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const g=JSON.stringify(k);return this.b!==g&&(this.b=g,this.a=this.c(k)),this.a}}e.LRUCachedFunction=n;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const g=this.b(k);return this.a.set(k,g),g}}e.CachedFunction=R}),define(Z[27],ee([0,1,144,127]),function(x,e,S,M){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function k(X,...ae){return ae.length===0?X:X.replace(C,function(ge,be){const we=parseInt(be,10);return isNaN(we)||we<0||we>=ae.length?ge:ae[we]})}e.format=k;const g=/{([^}]+)}/g;function d(X,ae){return X.replace(g,(ge,be)=>ae[be]??ge)}e.format2=d;function b(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=b;function v(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function y(X,ae){let ge=0;const be=ae.charCodeAt(0);for(let we=X.length-1;we>=0;we--)X.charCodeAt(we)===be&&ge++;return ge}e.count=y;function h(X,ae,ge="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ge}`}e.truncate=h;function p(X,ae=" "){const ge=w(X,ae);return a(ge,ae)}e.trim=p;function w(X,ae){if(!X||!ae)return X;const ge=ae.length;if(ge===0||X.length===0)return X;let be=0;for(;X.indexOf(ae,be)===be;)be=be+ge;return X.substring(be)}e.ltrim=w;function a(X,ae){if(!X||!ae)return X;const ge=ae.length,be=X.length;if(ge===0||be===0)return X;let we=be,Le=-1;for(;Le=X.lastIndexOf(ae,we-1),!(Le===-1||Le+ge!==we);){if(Le===0)return"";we=Le}return X.substring(0,we)}e.rtrim=a;function f(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function m(X){return X.replace(/\*/g,"")}e.stripWildcards=m;function P(X,ae,ge={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=v(X)),ge.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let be="";return ge.global&&(be+="g"),ge.matchCase||(be+="i"),ge.multiline&&(be+="m"),ge.unicode&&(be+="u"),new RegExp(X,be)}e.createRegExp=P;function E(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function D(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let ae=0,ge=X.length;ae<ge;ae++){const be=X.charCodeAt(ae);if(be!==32&&be!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function r(X,ae=0,ge=X.length){for(let be=ae;be<ge;be++){const we=X.charCodeAt(be);if(we!==32&&we!==9)return X.substring(ae,be)}return X.substring(ae,ge)}e.getLeadingWhitespace=r;function o(X,ae=X.length-1){for(let ge=ae;ge>=0;ge--){const be=X.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function l(X,ae,ge){const be=[];let we=0;for(const Le of X.matchAll(ae)){if(be.push(X.slice(we,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");we=Le.index+Le[0].length,be.push(ge(Le[0],...Le.slice(1),Le.index,X,Le.groups))}return be.push(X.slice(we)),Promise.all(be).then(Le=>Le.join(""))}e.replaceAsync=l;function s(X,ae){return X<ae?-1:X>ae?1:0}e.compare=s;function u(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){const Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ue=be-ge,Ve=Le-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstring=u;function I(X,ae){return A(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=I;function A(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){let Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return u(X.toLowerCase(),ae.toLowerCase(),ge,be,we,Le);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ue=be-ge,Ve=Le-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstringIgnoreCase=A;function T(X){return X>=48&&X<=57}e.isAsciiDigit=T;function N(X){return X>=97&&X<=122}e.isLowerAsciiLetter=N;function z(X){return X>=65&&X<=90}e.isUpperAsciiLetter=z;function H(X,ae){return X.length===ae.length&&A(X,ae)===0}e.equalsIgnoreCase=H;function ie(X,ae){const ge=ae.length;return ae.length>X.length?!1:A(X,ae,0,ge)===0}e.startsWithIgnoreCase=ie;function se(X,ae){const ge=Math.min(X.length,ae.length);let be;for(be=0;be<ge;be++)if(X.charCodeAt(be)!==ae.charCodeAt(be))return be;return ge}e.commonPrefixLength=se;function oe(X,ae){const ge=Math.min(X.length,ae.length);let be;const we=X.length-1,Le=ae.length-1;for(be=0;be<ge;be++)if(X.charCodeAt(we-be)!==ae.charCodeAt(Le-be))return be;return ge}e.commonSuffixLength=oe;function ue(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ue;function le(X){return 56320<=X&&X<=57343}e.isLowSurrogate=le;function me(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=me;function G(X,ae,ge){const be=X.charCodeAt(ge);if(ue(be)&&ge+1<ae){const we=X.charCodeAt(ge+1);if(le(we))return me(be,we)}return be}e.getNextCodePoint=G;function B(X,ae){const ge=X.charCodeAt(ae-1);if(le(ge)&&ae>1){const be=X.charCodeAt(ae-2);if(ue(be))return me(be,ge)}return ge}class O{get offset(){return this.e}constructor(ae,ge=0){this.c=ae,this.d=ae.length,this.e=ge}setOffset(ae){this.e=ae}prevCodePoint(){const ae=B(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=G(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}e.CodePointIterator=O;class q{get offset(){return this.c.offset}constructor(ae,ge=0){this.c=new O(ae,ge)}nextGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Le=ge.offset,Ue=ae.getGraphemeBreakType(ge.nextCodePoint());if(ce(we,Ue)){ge.setOffset(Le);break}we=Ue}return ge.offset-be}prevGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Le=ge.offset,Ue=ae.getGraphemeBreakType(ge.prevCodePoint());if(ce(Ue,we)){ge.setOffset(Le);break}we=Ue}return be-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=q;function J(X,ae){return new q(X,ae).nextGraphemeLength()}e.nextCharLength=J;function te(X,ae){return new q(X,ae).prevGraphemeLength()}e.prevCharLength=te;function ne(X,ae){ae>0&&le(X.charCodeAt(ae))&&ae--;const ge=ae+J(X,ae);return[ge-te(X,ge),ge]}e.getCharContainingOffset=ne;function L(X){const ae=new q(X);let ge=0;for(;!ae.eol();)ge++,ae.nextGraphemeLength();return ge}e.charCount=L;let F;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(X){return F||(F=W()),F.test(X)}e.containsRTL=U;const $=/^[\t\n\r\x20-\x7E]*$/;function V(X){return $.test(X)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=j;function K(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=K;function Y(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=Y;function re(X,ae){if(X.length<ae)return X;const ge=/\b/g;let be=0;for(;ge.test(X)&&!(X.length-ge.lastIndex<ae);)be=ge.lastIndex,ge.lastIndex+=1;return X.substring(be).replace(/^\s/,"")}e.lcut=re;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function Re(X){return X&&(X=X.replace(de,"")),X}e.removeAnsiEscapeCodes=Re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function De(X){return Ce(X)?X.substr(1):X}e.stripUTF8BOM=De;function Oe(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ge=ae.length,be=X.toLowerCase();let we=0,Le=-1;for(;we<ge;){const Ue=be.indexOf(ae[we],Le+1);if(Ue<0)return!1;Le=Ue,we++}return!0}e.fuzzyContains=Oe;function $e(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=$e;function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=fe;function pe(X,ae=1){if(ae===0)return"";let ge=-1;do ge=X.indexOf(`
`,ge+1),ae--;while(ae>0&&ge>=0);return ge===-1?X:(X[ge-1]==="\r"&&ge--,X.substr(0,ge))}e.getNLines=pe;function Me(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Me;function _(X){return Ie.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=_;function ce(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var he;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Ae()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ge=this.d,be=ge.length/3;let we=1;for(;we<=be;)if(ae<ge[3*we])we=2*we;else if(ae>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}Ie.c=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(X,ae){if(X===0)return 0;const ge=Fe(X,ae);if(ge!==void 0)return ge;const be=new O(ae,X);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function Fe(X,ae){const ge=new O(ae,X);let be=ge.prevCodePoint();for(;je(be)||be===65039||be===8419;){if(ge.offset===0)return;be=ge.prevCodePoint()}if(!Y(be))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function je(X){return 127995<=X&&X<=127999}var ze;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class We{static getInstance(ae){return We.d.get(Array.from(ae))}static getLocales(){return We.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}n=We,We.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new S.LRUCachedFunction(X=>{function ae(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function ge(Ke,Ye){const Ze=new Map(Ke);for(const[rt,ct]of Ye)Ze.set(rt,ct);return Ze}function be(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[rt,ct]of Ke)Ye.has(rt)&&Ze.set(rt,ct);return Ze}const we=n.c.value;let Le=X.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Le.length===0&&(Le=["_default"]);let Ue;for(const Ke of Le){const Ye=ae(we[Ke]);Ue=be(Ue,Ye)}const Ve=ae(we._common),Ge=ge(Ve,Ue);return new We(Ge)}),We.e=new M.Lazy(()=>Object.keys(We.c.value).filter(X=>!X.startsWith("_"))),e.AmbiguousCharacters=We;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ae){return He.e().has(ae)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(Z[32],ee([0,1,9,4,27,10]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function k(o){return o.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=k;function g(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=g;function d(o,l=S.posix.sep){if(!o)return"";const s=o.length,u=o.charCodeAt(0);if(C(u)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let A=3;const T=A;for(;A<s&&!C(o.charCodeAt(A));A++);if(T!==A&&!C(o.charCodeAt(A+1))){for(A+=1;A<s;A++)if(C(o.charCodeAt(A)))return o.slice(0,A+1).replace(/[\\/]/g,l)}}return l}else if(f(u)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let I=o.indexOf("://");if(I!==-1){for(I+=3;I<s;I++)if(C(o.charCodeAt(I)))return o.slice(0,I+1)}return""}e.getRoot=d;function b(o){if(!M.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let s=2;const u=s;for(;s<o.length&&(l=o.charCodeAt(s),l!==92);s++);return!(u===s||(l=o.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,l=M.isWindows){const s=l?v:y;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||l&&h.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function w(o,l,s){const u=o===l;return!s||u?u:!o||!l?!1:(0,n.equalsIgnoreCase)(o,l)}e.isEqual=w;function a(o,l,s,u=S.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(s){if(!(0,n.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let A=l.length;return l.charAt(l.length-1)===u&&A--,o.charAt(A)===u}return l.charAt(l.length-1)!==u&&(l+=u),o.indexOf(l)===0}e.isEqualOrParent=a;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function m(o,l){return M.isWindows&&o.endsWith(":")&&(o+=S.sep),(0,S.isAbsolute)(o)||(o=(0,S.join)(l,o)),o=(0,S.normalize)(o),M.isWindows?(o=(0,n.rtrim)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,n.rtrim)(o,S.sep),o||(o=S.sep)),o}e.sanitizeFilePath=m;function P(o){const l=(0,S.normalize)(o);return M.isWindows?o.length>3?!1:E(l)&&(o.length===2||l.charCodeAt(2)===92):l===S.posix.sep}e.isRootOrDriveLetter=P;function E(o,l=M.isWindows){return l?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function D(o){return E(o)?o[0]:void 0}e.getDriveLetter=D;function t(o,l,s){return l.length>o.length?-1:o===l?0:(s&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=t;function c(o){const l=o.split(":");let s,u,I;for(const A of l){const T=Number(A);(0,R.isNumber)(T)?u===void 0?u=T:I===void 0&&(I=T):s=s?[s,A].join(":"):A}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:I!==void 0?I:u!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,l,s=8){let u="";for(let A=0;A<s;A++)u+=i.charAt(Math.floor(Math.random()*i.length));let I;return l?I=`${l}-${u}`:I=u,o?(0,S.join)(o,I):I}e.randomPath=r}),define(Z[71],ee([0,1,27]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(f){return n(f,0)}e.hash=M;function n(f,m){switch(typeof f){case"object":return f===null?R(349,m):Array.isArray(f)?g(f,m):d(f,m);case"string":return k(f,m);case"boolean":return C(f,m);case"number":return R(f,m);case"undefined":return R(937,m);default:return R(617,m)}}e.doHash=n;function R(f,m){return(m<<5)-m+f|0}e.numberHash=R;function C(f,m){return R(f?433:863,m)}function k(f,m){m=R(149417,m);for(let P=0,E=f.length;P<E;P++)m=R(f.charCodeAt(P),m);return m}e.stringHash=k;function g(f,m){return m=R(104579,m),f.reduce((P,E)=>n(E,P),m)}function d(f,m){return m=R(181387,m),Object.keys(f).sort().reduce((P,E)=>(P=k(E,P),n(f[E],P)),m)}class b{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=n(m,this.g),this.g}}e.Hasher=b;var v;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(f,m,P=32){const E=P-m,D=~((1<<E)-1);return(f<<m|(D&f)>>>E)>>>0}function h(f,m=0,P=f.byteLength,E=0){for(let D=0;D<P;D++)f[m+D]=E}function p(f,m,P="0"){for(;f.length<m;)f=P+f;return f}function w(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):p((f>>>0).toString(16),m/4)}e.toHexString=w;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const P=m.length;if(P===0)return;const E=this.p;let D=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=m.charCodeAt(0),i=0);;){let r=c;if(S.isHighSurrogate(c))if(i+1<P){const o=m.charCodeAt(i+1);S.isLowSurrogate(o)?(i++,r=S.computeCodePoint(c,o)):r=65533}else{t=c;break}else S.isLowSurrogate(c)&&(r=65533);if(D=this.w(E,D,r),i++,i<P)c=m.charCodeAt(i);else break}this.r=D,this.u=t}w(m,P,E){return E<128?m[P++]=E:E<2048?(m[P++]=192|(E&1984)>>>6,m[P++]=128|(E&63)>>>0):E<65536?(m[P++]=224|(E&61440)>>>12,m[P++]=128|(E&4032)>>>6,m[P++]=128|(E&63)>>>0):(m[P++]=240|(E&1835008)>>>18,m[P++]=128|(E&258048)>>>12,m[P++]=128|(E&4032)>>>6,m[P++]=128|(E&63)>>>0),P>=64&&(this.y(),P-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=a.g,P=this.q;for(let s=0;s<64;s+=4)m.setUint32(s,P.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)m.setUint32(s,y(m.getUint32(s-12,!1)^m.getUint32(s-32,!1)^m.getUint32(s-56,!1)^m.getUint32(s-64,!1),1),!1);let E=this.h,D=this.l,t=this.m,c=this.n,i=this.o,r,o,l;for(let s=0;s<80;s++)s<20?(r=D&t|~D&c,o=1518500249):s<40?(r=D^t^c,o=1859775393):s<60?(r=D&t|D&c|t&c,o=2400959708):(r=D^t^c,o=3395469782),l=y(E,5)+r+i+o+m.getUint32(s*4,!1)&4294967295,i=c,c=t,t=y(D,30),D=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}a.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(Z[72],ee([0,1,27]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(M||(M={})),function(n){const R="error",C="warning",k="warn",g="info",d="ignore";function b(y){return y?S.equalsIgnoreCase(R,y)?n.Error:S.equalsIgnoreCase(C,y)||S.equalsIgnoreCase(k,y)?n.Warning:S.equalsIgnoreCase(g,y)?n.Info:n.Ignore:n.Ignore}n.fromValue=b;function v(y){switch(y){case n.Error:return R;case n.Warning:return C;case n.Info:return g;default:return d}}n.toString=v}(M||(M={})),e.default=M}),define(Z[60],ee([0,1,25,27]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const p=h.charCodeAt(0),w=this.b.charCodeAt(this.c);return p-w}value(){return this.b[this.c]}}e.StringIterator=n;class R{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,M.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(h=!0,p=!0){this.f=h,this.g=p}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let p=h.length-1;p>=0;p--,this.c--){const w=this.b.charCodeAt(p);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,M.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var k;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(k||(k={}));class g{constructor(h,p){this.f=h,this.g=p,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,M.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=g;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(h=()=>!1,p=()=>!1){return new v(new g(h,p))}static forPaths(h=!1){return new v(new C(void 0,!h))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new R)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,p){if(p){const w=p.slice(0);(0,S.shuffle)(w);for(const a of w)this.set(a,h)}else{const w=h.slice(0);(0,S.shuffle)(w);for(const a of w)this.set(a[0],a[1])}}set(h,p){const w=this.b.reset(h);let a;this.c||(this.c=new d,this.c.segment=w.value());const f=[];for(a=this.c;;){const P=w.cmp(a.segment);if(P>0)a.left||(a.left=new d,a.left.segment=w.value()),f.push([-1,a]),a=a.left;else if(P<0)a.right||(a.right=new d,a.right.segment=w.value()),f.push([1,a]),a=a.right;else if(w.hasNext())w.next(),a.mid||(a.mid=new d,a.mid.segment=w.value()),f.push([0,a]),a=a.mid;else break}const m=a.value;a.value=p,a.key=h;for(let P=f.length-1;P>=0;P--){const E=f[P][1];E.updateHeight();const D=E.balanceFactor();if(D<-1||D>1){const t=f[P][0],c=f[P+1][0];if(t===1&&c===1)f[P][1]=E.rotateLeft();else if(t===-1&&c===-1)f[P][1]=E.rotateRight();else if(t===1&&c===-1)E.right=f[P+1][1]=f[P+1][1].rotateRight(),f[P][1]=E.rotateLeft();else if(t===-1&&c===1)E.left=f[P+1][1]=f[P+1][1].rotateLeft(),f[P][1]=E.rotateRight();else throw new Error;if(P>0)switch(f[P-1][0]){case-1:f[P-1][1].left=f[P][1];break;case 1:f[P-1][1].right=f[P][1];break;case 0:f[P-1][1].mid=f[P][1];break}else this.c=f[0][1]}}return m}get(h){return this.d(h)?.value}d(h){const p=this.b.reset(h);let w=this.c;for(;w;){const a=p.cmp(w.segment);if(a>0)w=w.left;else if(a<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else break}return w}has(h){const p=this.d(h);return!(p?.value===void 0&&p?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,p){const w=this.b.reset(h),a=[];let f=this.c;for(;f;){const m=w.cmp(f.segment);if(m>0)a.push([-1,f]),f=f.left;else if(m<0)a.push([1,f]),f=f.right;else if(w.hasNext())w.next(),a.push([0,f]),f=f.mid;else break}if(!!f){if(p?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const m=this.f(f.right);if(m.key){const{key:P,value:E,segment:D}=m;this.e(m.key,!1),f.key=P,f.value=E,f.segment=D}}else{const m=f.left??f.right;if(a.length>0){const[P,E]=a[a.length-1];switch(P){case-1:E.left=m;break;case 0:E.mid=m;break;case 1:E.right=m;break}}else this.c=m}for(let m=a.length-1;m>=0;m--){const P=a[m][1];P.updateHeight();const E=P.balanceFactor();if(E>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),a[m][1]=P.rotateLeft()):E<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),a[m][1]=P.rotateRight()),m>0)switch(a[m-1][0]){case-1:a[m-1][1].left=a[m][1];break;case 1:a[m-1][1].right=a[m][1];break;case 0:a[m-1][1].mid=a[m][1];break}else this.c=a[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const p=this.b.reset(h);let w=this.c,a;for(;w;){const f=p.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(p.hasNext())p.next(),a=w.value||a,w=w.mid;else break}return w&&w.value||a}findSuperstr(h){return this.g(h,!1)}g(h,p){const w=this.b.reset(h);let a=this.c;for(;a;){const f=w.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(w.hasNext())w.next(),a=a.mid;else return a.mid?this.h(a.mid):p?a.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[p,w]of this)h(w,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const p=[];return this.j(h,p),p[Symbol.iterator]()}j(h,p){!h||(h.left&&this.j(h.left,p),h.value&&p.push([h.key,h.value]),h.mid&&this.j(h.mid,p),h.right&&this.j(h.right,p))}_isBalanced(){const h=p=>{if(!p)return!0;const w=p.balanceFactor();return w<-1||w>1?!1:h(p.left)&&h(p.right)};return h(this.c)}}e.TernarySearchTree=v}),define(Z[7],ee([0,1,9,4]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function k(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,r){return!i&&!r?"file":i}function d(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==v&&(r=v+r):r=v;break}return r}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,l,s,u,I=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=g(r,I),this.authority=o||b,this.path=d(this.scheme,l||b),this.query=s||b,this.fragment=u||b,k(this,I))}get fsPath(){return P(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:l,path:s,query:u,fragment:I}=r;return o===void 0?o=this.scheme:o===null&&(o=b),l===void 0?l=this.authority:l===null&&(l=b),s===void 0?s=this.path:s===null&&(s=b),u===void 0?u=this.query:u===null&&(u=b),I===void 0?I=this.fragment:I===null&&(I=b),o===this.scheme&&l===this.authority&&s===this.path&&u===this.query&&I===this.fragment?this:new w(o,l,s,u,I)}static parse(r,o=!1){const l=y.exec(r);return l?new w(l[2]||b,c(l[4]||b),c(l[5]||b),c(l[7]||b),c(l[9]||b),o):new w(b,b,b,b,b)}static file(r){let o=b;if(M.isWindows&&(r=r.replace(/\\/g,v)),r[0]===v&&r[1]===v){const l=r.indexOf(v,2);l===-1?(o=r.substring(2),r=v):(o=r.substring(2,l),r=r.substring(l)||v)}return new w("file",o,r,b,b)}static from(r){const o=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return k(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return M.isWindows&&r.scheme==="file"?l=h.file(S.win32.join(P(r,!0),...o)).path:l=S.posix.join(r.path,...o),r.with({path:l})}toString(r=!1){return E(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const o=new w(r);return o._formatted=r.external,o._fsPath=r._sep===p?r.fsPath:null,o}}else return r}}e.URI=h;const p=M.isWindows?1:void 0;class w extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(r=!1){return r?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=p),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,r,o){let l,s=-1;for(let u=0;u<i.length;u++){const I=i.charCodeAt(u);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||r&&I===47||o&&I===91||o&&I===93||o&&I===58)s!==-1&&(l+=encodeURIComponent(i.substring(s,u)),s=-1),l!==void 0&&(l+=i.charAt(u));else{l===void 0&&(l=i.substr(0,u));const A=a[I];A!==void 0?(s!==-1&&(l+=encodeURIComponent(i.substring(s,u)),s=-1),l+=A):s===-1&&(s=u)}}return s!==-1&&(l+=encodeURIComponent(i.substring(s))),l!==void 0?l:i}function m(i){let r;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);l===35||l===63?(r===void 0&&(r=i.substr(0,o)),r+=a[l]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function P(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,M.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=P;function E(i,r){const o=r?m:f;let l="",{scheme:s,authority:u,path:I,query:A,fragment:T}=i;if(s&&(l+=s,l+=":"),(u||s==="file")&&(l+=v,l+=v),u){let N=u.indexOf("@");if(N!==-1){const z=u.substr(0,N);u=u.substr(N+1),N=z.lastIndexOf(":"),N===-1?l+=o(z,!1,!1):(l+=o(z.substr(0,N),!1,!1),l+=":",l+=o(z.substr(N+1),!1,!0)),l+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?l+=o(u,!1,!0):(l+=o(u.substr(0,N),!1,!0),l+=u.substr(N))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const N=I.charCodeAt(1);N>=65&&N<=90&&(I=`/${String.fromCharCode(N+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const N=I.charCodeAt(0);N>=65&&N<=90&&(I=`${String.fromCharCode(N+32)}:${I.substr(2)}`)}l+=o(I,!0,!1)}return A&&(l+="?",l+=o(A,!1,!1)),T&&(l+="#",l+=r?T:f(T,!1,!1)),l}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,r=>D(r)):i}}),define(Z[145],ee([0,1,7]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(d){const b=d;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=M;function n(d){const b=[];let v;try{const y=JSON.parse(d.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),v=h.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",d.arguments)}return{args:b,stack:v}}e.parse=n;function R(d){if(typeof d!="string")return R(n(d).stack);const b=d;if(b){const v=C(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function C(d){if(!d)return d;const b=d.indexOf(`
`);return b===-1?d:d.substring(0,b)}function k(d,b){const{args:v,stack:y}=n(d),h=typeof v[0]=="string"&&v.length===1;let p=C(y);p&&(p=`(${p.trim()})`);let w=[];if(typeof v[0]=="string"?p&&h?w=[`%c[${b}] %c${v[0]} %c${p}`,g("blue"),g(""),g("grey")]:w=[`%c[${b}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:w=[`%c[${b}]%`,g("blue"),...v],p&&!h&&w.push(p),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,w)}e.log=k;function g(d){return`color: ${d}`}}),define(Z[83],ee([0,1,17,27,7]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(d){return JSON.stringify(d,k)}e.stringify=R;function C(d){let b=JSON.parse(d);return b=g(b),b}e.parse=C;function k(d,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function g(d,b=0){if(!d||b>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return n.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof S.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let v=0;v<d.length;++v)d[v]=g(d[v],b+1);else for(const v in d)Object.hasOwnProperty.call(d,v)&&(d[v]=g(d[v],b+1))}return d}e.revive=g}),define(Z[14],ee([0,1,13,4,7]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${R.vscodeRemoteResource}`}set(b,v,y){this.a[b]=v,this.b[b]=y}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(a){return S.onUnexpectedError(a),b}const v=b.authority;let y=this.a[v];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const h=this.b[v],p=this.c[v];let w=`path=${encodeURIComponent(b.path)}`;return typeof p=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),n.URI.from({scheme:M.isWeb?this.d:R.vscodeRemoteResource,authority:`${y}:${h}`,path:this.f,query:w})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(b){const v=this.b(b,x);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${R.vscodeFileResource}://${k.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||k.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,x);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==k.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return n.URI.isUri(b)?b:n.URI.parse(v.toUrl(b))}}k.a="vscode-app",e.FileAccess=new k;var g;(function(d){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function y(p){let w;typeof p=="string"?w=new URL(p).searchParams:p instanceof URL?w=p.searchParams:n.URI.isUri(p)&&(w=new URL(p.toString(!0)).searchParams);const a=w?.get(v);if(!!a)return b.get(a)}d.getHeadersFromQuery=y;function h(p,w,a){if(!globalThis.crossOriginIsolated)return;const f=w&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(v,f):p[v]=f}d.addSearchParam=h})(g=e.COI||(e.COI={}))}),define(Z[18],ee([0,1,32,14,9,4,27,7]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=g;class d{constructor(p){this.a=p}compare(p,w,a=!1){return p===w?0:(0,C.compare)(this.getComparisonKey(p,a),this.getComparisonKey(w,a))}isEqual(p,w,a=!1){return p===w?!0:!p||!w?!1:this.getComparisonKey(p,a)===this.getComparisonKey(w,a)}getComparisonKey(p,w=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,w,a=!1){if(p.scheme===w.scheme){if(p.scheme===M.Schemas.file)return S.isEqualOrParent(g(p),g(w),this.a(p))&&p.query===w.query&&(a||p.fragment===w.fragment);if((0,e.isEqualAuthority)(p.authority,w.authority))return S.isEqualOrParent(p.path,w.path,this.a(p),"/")&&p.query===w.query&&(a||p.fragment===w.fragment)}return!1}joinPath(p,...w){return k.URI.joinPath(p,...w)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return n.posix.basename(p.path)}extname(p){return n.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let w;return p.scheme===M.Schemas.file?w=k.URI.file(n.dirname(g(p))).path:(w=n.posix.dirname(p.path),p.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),w="/")),p.with({path:w})}normalizePath(p){if(!p.path.length)return p;let w;return p.scheme===M.Schemas.file?w=k.URI.file(n.normalize(g(p))).path:w=n.posix.normalize(p.path),p.with({path:w})}relativePath(p,w){if(p.scheme!==w.scheme||!(0,e.isEqualAuthority)(p.authority,w.authority))return;if(p.scheme===M.Schemas.file){const m=n.relative(g(p),g(w));return R.isWindows?S.toSlashes(m):m}let a=p.path||"/";const f=w.path||"/";if(this.a(p)){let m=0;for(const P=Math.min(a.length,f.length);m<P&&!(a.charCodeAt(m)!==f.charCodeAt(m)&&a.charAt(m).toLowerCase()!==f.charAt(m).toLowerCase());m++);a=f.substr(0,m)+a.substr(m)}return n.posix.relative(a,f)}resolvePath(p,w){if(p.scheme===M.Schemas.file){const a=k.URI.file(n.resolve(g(p),w));return p.with({authority:a.authority,path:a.path})}return w=S.toPosixPath(w),p.with({path:n.posix.resolve(p.path,w)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,w){return p===w||p!==void 0&&w!==void 0&&(0,C.equalsIgnoreCase)(p,w)}hasTrailingPathSeparator(p,w=n.sep){if(p.scheme===M.Schemas.file){const a=g(p);return a.length>S.getRoot(a).length&&a[a.length-1]===w}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,w=n.sep){return(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,w=n.sep){let a=!1;if(p.scheme===M.Schemas.file){const f=g(p);a=f!==void 0&&f.length===S.getRoot(f).length&&f[f.length-1]===w}else{w="/";const f=p.path;a=f.length===1&&f.charCodeAt(f.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path+"/"}):p}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(h=>h.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new d(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(h,p){const w=[];for(let a=0;a<h.length;a++){const f=p(h[a]);h.some((m,P)=>P===a?!1:(0,e.isEqualOrParent)(f,p(m)))||w.push(h[a])}return w}e.distinctParents=b;var v;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function p(w){const a=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(P=>{const[E,D]=P.split(":");E&&D&&a.set(E,D)});const m=w.path.substring(0,w.path.indexOf(";"));return m&&a.set(h.META_DATA_MIME,m),a}h.parseMetaData=p})(v=e.DataUri||(e.DataUri={}));function y(h,p,w){if(p){let a=h.path;return a&&a[0]!==n.posix.sep&&(a=n.posix.sep+a),h.with({scheme:w,authority:p,path:a})}return h.with({scheme:w})}e.toLocalResource=y}),define(Z[8],ee([0,1,22,13,3,2,18,4,130]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(L){return!!L&&typeof L.then=="function"}e.isThenable=d;function b(L){const F=new S.CancellationTokenSource,W=L(F.token),U=new Promise(($,V)=>{const j=F.token.onCancellationRequested(()=>{j.dispose(),F.dispose(),V(new M.CancellationError)});Promise.resolve(W).then(K=>{j.dispose(),F.dispose(),$(K)},K=>{j.dispose(),F.dispose(),V(K)})});return new class{cancel(){F.cancel()}then($,V){return U.then($,V)}catch($){return this.then(void 0,$)}finally($){return U.finally($)}}}e.createCancelablePromise=b;function v(L,F,W){return new Promise((U,$)=>{const V=F.onCancellationRequested(()=>{V.dispose(),U(W)});L.then(U,$).finally(()=>V.dispose())})}e.raceCancellation=v;function y(L,F){return new Promise((W,U)=>{const $=F.onCancellationRequested(()=>{$.dispose(),U(new M.CancellationError)});L.then(W,U).finally(()=>$.dispose())})}e.raceCancellationError=y;async function h(L){let F=-1;const W=L.map(($,V)=>$.then(j=>(F=V,j))),U=await Promise.race(W);return L.forEach(($,V)=>{V!==F&&$.cancel()}),U}e.raceCancellablePromises=h;function p(L,F,W){let U;const $=setTimeout(()=>{U?.(void 0),W?.()},F);return Promise.race([L.finally(()=>clearTimeout($)),new Promise(V=>U=V)])}e.raceTimeout=p;function w(L){return new Promise((F,W)=>{const U=L();d(U)?U.then(F,W):F(U)})}e.asPromise=w;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(F){if(this.a){if(this.d=F,!this.b){const W=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(W,W).then(U)})}return new Promise((W,U)=>{this.b.then(W,U)})}return this.a=F(),new Promise((W,U)=>{this.a.then($=>{this.a=null,W($)},$=>{this.a=null,U($)})})}}e.Throttler=a;class f{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.Sequencer=f;class m{constructor(){this.a=new Map}queue(F,W){const $=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(F)===$&&this.a.delete(F)});return this.a.set(F,$),$}}e.SequencerByKey=m;const P=(L,F)=>{let W=!0;const U=setTimeout(()=>{W=!1,F()},L);return{isTriggered:()=>W,dispose:()=>{clearTimeout(U),W=!1}}},E=L=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,L())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class D{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,W=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise(($,V)=>{this.d=$,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=W===g.MicrotaskDelay?E(U):P(W,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(F){this.a=new D(F),this.b=new a}trigger(F,W){return this.a.trigger(()=>this.b.queue(F),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((F,W)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function r(L,F){return F?new Promise((W,U)=>{const $=setTimeout(()=>{V.dispose(),W()},L),V=F.onCancellationRequested(()=>{clearTimeout($),V.dispose(),U(new M.CancellationError)})}):b(W=>r(L,W))}e.timeout=r;function o(L,F=0){const W=setTimeout(L,F);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function l(L){const F=[];let W=0;const U=L.length;function $(){return W<U?L[W++]():null}function V(j){j!=null&&F.push(j);const K=$();return K?K.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=l;function s(L,F=U=>!!U,W=null){let U=0;const $=L.length,V=()=>{if(U>=$)return Promise.resolve(W);const j=L[U++];return Promise.resolve(j()).then(Y=>F(Y)?Promise.resolve(Y):V())};return V()}e.first=s;function u(L,F=U=>!!U,W=null){if(L.length===0)return Promise.resolve(W);let U=L.length;const $=()=>{U=-1;for(const V of L)V.cancel?.()};return new Promise((V,j)=>{for(const K of L)K.then(Y=>{--U>=0&&F(Y)?($(),V(Y)):U===0&&V(W)}).catch(Y=>{--U>=0&&($(),j(Y))})})}e.firstParallel=u;class I{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((W,U)=>{this.f.push({factory:F,c:W,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const W=F.factory();W.then(F.c,F.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=I;class A extends I{constructor(){super(1)}}e.Queue=A;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new B;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,W=C.extUri){const U=W.getComparisonKey(F);let $=this.a.get(U);return $||($=new A,n.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,$)),$}f(){!this.d()||this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class N{constructor(F,W){this.a=-1,typeof F=="function"&&typeof W=="number"&&this.setIfNotSet(F,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},W)}setIfNotSet(F,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},W))}}e.TimeoutTimer=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setInterval(()=>{F()},W)}}e.IntervalTimer=z;class H{constructor(F,W){this.b=-1,this.a=F,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class ie{constructor(F,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=F,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class se extends H{constructor(F,W){super(F,W),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=se;class oe extends R.Disposable{constructor(F,W){super(),this.g=F,this.h=W,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of F)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=L=>{(0,k.setTimeout0)(()=>{if(F)return;const W=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(L,F)=>{const W=requestIdleCallback(L,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(W))}}}}();class ue{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ue;async function le(L,F,W){let U;for(let $=0;$<W;$++)try{return await L()}catch(V){U=V,await r(F)}throw U}e.retry=le;class me{hasPending(F){return this.a?typeof F=="number"?this.a.taskId===F:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(F,W,U){return this.a={taskId:F,cancel:()=>U?.(),promise:W},W.then(()=>this.d(F),()=>this.d(F)),W}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this.b)this.b.run=F;else{let W,U;const $=new Promise((V,j)=>{W=V,U=j});this.b={run:F,promise:$,promiseResolve:W,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=me;class G{constructor(F,W=()=>Date.now()){this.d=F,this.f=W,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.IntervalCounter=G;class B{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((F,W)=>{this.a=F,this.b=W})}complete(F){return new Promise(W=>{this.a(F),this.f=!0,W()})}error(F){return new Promise(W=>{this.b(F),this.d=!0,W()})}cancel(){new Promise(F=>{this.b(new M.CancellationError),this.d=!0,F()})}}e.DeferredPromise=B;var O;(function(L){async function F(U){let $;const V=await Promise.all(U.map(j=>j.then(K=>K,K=>{$||($=K)})));if(typeof $<"u")throw $;return V}L.settled=F;function W(U){return new Promise(async($,V)=>{try{await U($,V)}catch(j){V(j)}})}L.withAsyncBody=W})(O=e.Promises||(e.Promises={}));var q;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(q||(q={}));class J{static fromArray(F){return new J(W=>{W.emitMany(F)})}static fromPromise(F){return new J(async W=>{W.emitMany(await F)})}static fromPromises(F){return new J(async W=>{await Promise.all(F.map(async U=>W.emitOne(await U)))})}static merge(F){return new J(async W=>{await Promise.all(F.map(async U=>{for await(const $ of U)W.emitOne($)}))})}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const W={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(F(W)),this.j()}catch(U){this.k(U)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(F,W){return new J(async U=>{for await(const $ of F)U.emitOne(W($))})}map(F){return J.map(this,F)}static filter(F,W){return new J(async U=>{for await(const $ of F)W($)&&U.emitOne($)})}filter(F){return J.filter(this,F)}static coalesce(F){return J.filter(F,W=>!!W)}coalesce(){return J.coalesce(this)}static async toPromise(F){const W=[];for await(const U of F)W.push(U);return W}toPromise(){return J.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}J.EMPTY=J.fromArray([]),e.AsyncIterableObject=J;class te extends J{constructor(F,W){super(W),this.l=F}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=te;function ne(L){const F=new S.CancellationTokenSource,W=L(F.token);return new te(F,async U=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),U.reject(new M.CancellationError)});try{for await(const V of W){if(F.token.isCancellationRequested)return;U.emitOne(V)}$.dispose(),F.dispose()}catch(V){$.dispose(),F.dispose(),U.reject(V)}})}e.createCancelableAsyncIterable=ne}),define(Z[100],ee([0,1,25,8,32,35,9,4,27]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function h(G,B){switch(G){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${B?`|${b}${v}+`:""})*?`}}function p(G,B){if(!G)return[];const O=[];let q=!1,J=!1,te="";for(const ne of G){switch(ne){case B:if(!q&&!J){O.push(te),te="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":J=!0;break;case"]":J=!1;break}te+=ne}return te&&O.push(te),O}e.splitGlobAware=p;function w(G){if(!G)return"";let B="";const O=p(G,e.GLOB_SPLIT);if(O.every(q=>q===e.GLOBSTAR))B=".*";else{let q=!1;O.forEach((J,te)=>{if(J===e.GLOBSTAR){if(q)return;B+=h(2,te===O.length-1)}else{let ne=!1,L="",F=!1,W="";for(const U of J){if(U!=="}"&&ne){L+=U;continue}if(F&&(U!=="]"||!W)){let $;U==="-"?$=U:(U==="^"||U==="!")&&!W?$="^":U===e.GLOB_SPLIT?$="":$=(0,g.escapeRegExpCharacters)(U),W+=$;continue}switch(U){case"{":ne=!0;continue;case"[":F=!0;continue;case"}":{B+=`(?:${p(L,",").map(j=>w(j)).join("|")})`,ne=!1,L="";break}case"]":{B+="["+W+"]",F=!1,W="";break}case"?":B+=v;continue;case"*":B+=h(1);continue;default:B+=(0,g.escapeRegExpCharacters)(U)}}te<O.length-1&&(O[te+1]!==e.GLOBSTAR||te+2<O.length)&&(B+=b)}q=J===e.GLOBSTAR})}return B}const a=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,P=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),c=function(){return!1},i=function(){return null};function r(G,B){if(!G)return i;let O;typeof G!="string"?O=G.pattern:O=G,O=O.trim();const q=`${O}_${!!B.trimForExclusions}`;let J=t.get(q);if(J)return o(J,G);let te;return a.test(O)?J=s(O.substr(4),O):(te=f.exec(l(O,B)))?J=u(te[1],O):(B.trimForExclusions?P:m).test(O)?J=I(O,B):(te=E.exec(l(O,B)))?J=A(te[1].substr(1),O,!0):(te=D.exec(l(O,B)))?J=A(te[1],O,!1):J=T(O),t.set(q,J),o(J,G)}function o(G,B){if(typeof B=="string")return G;const O=function(q,J){return(0,n.isEqualOrParent)(q,B.base,!k.isLinux)?G((0,g.ltrim)(q.substr(B.base.length),C.sep),J):null};return O.allBasenames=G.allBasenames,O.allPaths=G.allPaths,O.basenames=G.basenames,O.patterns=G.patterns,O}function l(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,B){return function(O,q){return typeof O=="string"&&O.endsWith(G)?B:null}}function u(G,B){const O=`/${G}`,q=`\\${G}`,J=function(ne,L){return typeof ne!="string"?null:L?L===G?B:null:ne===G||ne.endsWith(O)||ne.endsWith(q)?B:null},te=[G];return J.basenames=te,J.patterns=[B],J.allBasenames=te,J}function I(G,B){const O=le(G.slice(1,-1).split(",").map(L=>r(L,B)).filter(L=>L!==i),G),q=O.length;if(!q)return i;if(q===1)return O[0];const J=function(L,F){for(let W=0,U=O.length;W<U;W++)if(O[W](L,F))return G;return null},te=O.find(L=>!!L.allBasenames);te&&(J.allBasenames=te.allBasenames);const ne=O.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(J.allPaths=ne),J}function A(G,B,O){const q=C.sep===C.posix.sep,J=q?G:G.replace(y,C.sep),te=C.sep+J,ne=C.posix.sep+G;let L;return O?L=function(F,W){return typeof F=="string"&&(F===J||F.endsWith(te)||!q&&(F===G||F.endsWith(ne)))?B:null}:L=function(F,W){return typeof F=="string"&&(F===J||!q&&F===G)?B:null},L.allPaths=[(O?"*/":"./")+G],L}function T(G){try{const B=new RegExp(`^${w(G)}$`);return function(O){return B.lastIndex=0,typeof O=="string"&&B.test(O)?G:null}}catch{return i}}function N(G,B,O){return!G||typeof B!="string"?!1:z(G)(B,void 0,O)}e.match=N;function z(G,B={}){if(!G)return c;if(typeof G=="string"||H(G)){const O=r(G,B);if(O===i)return c;const q=function(J,te){return!!O(J,te)};return O.allBasenames&&(q.allBasenames=O.allBasenames),O.allPaths&&(q.allPaths=O.allPaths),q}return oe(G,B)}e.parse=z;function H(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=H;function ie(G){return G.allBasenames||[]}e.getBasenameTerms=ie;function se(G){return G.allPaths||[]}e.getPathTerms=se;function oe(G,B){const O=le(Object.getOwnPropertyNames(G).map(L=>ue(L,G[L],B)).filter(L=>L!==i)),q=O.length;if(!q)return i;if(!O.some(L=>!!L.requiresSiblings)){if(q===1)return O[0];const L=function(U,$){let V;for(let j=0,K=O.length;j<K;j++){const Y=O[j](U,$);if(typeof Y=="string")return Y;(0,M.isThenable)(Y)&&(V||(V=[]),V.push(Y))}return V?(async()=>{for(const j of V){const K=await j;if(typeof K=="string")return K}return null})():null},F=O.find(U=>!!U.allBasenames);F&&(L.allBasenames=F.allBasenames);const W=O.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return W.length&&(L.allPaths=W),L}const J=function(L,F,W){let U,$;for(let V=0,j=O.length;V<j;V++){const K=O[V];K.requiresSiblings&&W&&(F||(F=(0,C.basename)(L)),U||(U=F.substr(0,F.length-(0,C.extname)(L).length)));const Y=K(L,F,U,W);if(typeof Y=="string")return Y;(0,M.isThenable)(Y)&&($||($=[]),$.push(Y))}return $?(async()=>{for(const V of $){const j=await V;if(typeof j=="string")return j}return null})():null},te=O.find(L=>!!L.allBasenames);te&&(J.allBasenames=te.allBasenames);const ne=O.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(J.allPaths=ne),J}function ue(G,B,O){if(B===!1)return i;const q=r(G,O);if(q===i)return i;if(typeof B=="boolean")return q;if(B){const J=B.when;if(typeof J=="string"){const te=(ne,L,F,W)=>{if(!W||!q(ne,L))return null;const U=J.replace("$(basename)",()=>F),$=W(U);return(0,M.isThenable)($)?$.then(V=>V?G:null):$?G:null};return te.requiresSiblings=!0,te}}return q}function le(G,B){const O=G.filter(L=>!!L.basenames);if(O.length<2)return G;const q=O.reduce((L,F)=>{const W=F.basenames;return W?L.concat(W):L},[]);let J;if(B){J=[];for(let L=0,F=q.length;L<F;L++)J.push(B)}else J=O.reduce((L,F)=>{const W=F.patterns;return W?L.concat(W):L},[]);const te=function(L,F){if(typeof L!="string")return null;if(!F){let U;for(U=L.length;U>0;U--){const $=L.charCodeAt(U-1);if($===47||$===92)break}F=L.substr(U)}const W=q.indexOf(F);return W!==-1?J[W]:null};te.basenames=q,te.patterns=J,te.allBasenames=q;const ne=G.filter(L=>!L.basenames);return ne.push(te),ne}function me(G,B){return(0,S.equals)(G,B,(O,q)=>typeof O=="string"&&typeof q=="string"?O===q:typeof O!="string"&&typeof q!="string"?O.base===q.base&&O.pattern===q.pattern:!1)}e.patternsEquals=me}),define(Z[45],ee([0,1,25,32,9,4,18,27]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,r){const{os:o,tildify:l,relative:s}=r;if(s){const A=d(i,s,o);if(typeof A=="string")return A}let u=i.fsPath;if(o===1&&!R.isWindows?u=u.replace(/\//g,"\\"):o!==1&&R.isWindows&&(u=u.replace(/\\/g,"/")),o!==1&&l?.userHome){const A=l.userHome.fsPath;let T;i.scheme!==l.userHome.scheme&&i.path.startsWith(n.posix.sep)?T=l.userHome.with({path:i.path}).fsPath:T=i.fsPath,u=y(T,A,o)}return(o===1?n.win32:n.posix).normalize(b(u,o===1))}e.getPathLabel=g;function d(i,r,o){const l=o===1?n.win32:n.posix,s=o===3?C.extUri:C.extUriIgnorePathCase,u=r.getWorkspace(),I=(0,S.firstOrDefault)(u.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=I.uri.with({path:i.path}));const A=r.getWorkspaceFolder(i);if(!A)return;let T;if(s.isEqual(A.uri,i)?T="":T=s.relativePath(A.uri,i)??"",T&&(T=l.normalize(T)),u.folders.length>1&&!r.noPrefix){const N=A.name?A.name:s.basenameOrAuthority(A.uri);T=T?`${N} \u2022 ${T}`:N}return T}function b(i,r=R.isWindows){return(0,M.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let v=Object.create(null);function y(i,r,o=R.OS){if(o===1||!i||!r)return i;let l=v.original===r?v.normalized:void 0;l||(l=r,R.isWindows&&(l=(0,M.toSlashes)(l)),l=`${(0,k.rtrim)(l,n.posix.sep)}${n.posix.sep}`,v={original:r,normalized:l});let s=i;return R.isWindows&&(s=(0,M.toSlashes)(s)),(o===3?s.startsWith(l):(0,k.startsWithIgnoreCase)(s,l))?`~/${s.substr(l.length)}`:i}e.tildify=y;function h(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const p="\u2026",w="\\\\",a="~";function f(i,r=n.sep){const o=new Array(i.length);let l=!1;for(let s=0;s<i.length;s++){const u=i[s];if(u===""){o[s]=`.${r}`;continue}if(!u){o[s]=u;continue}l=!0;let I="",A=u;A.indexOf(w)===0?(I=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(r)===0?(I=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length)):A.indexOf(a)===0&&(I=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length));const T=A.split(r);for(let N=1;l&&N<=T.length;N++)for(let z=T.length-N;l&&z>=0;z--){l=!1;let H=T.slice(z,z+N).join(r);for(let ie=0;!l&&ie<i.length;ie++)if(ie!==s&&i[ie]&&i[ie].indexOf(H)>-1){const se=z+N===T.length,oe=z>0&&i[ie].indexOf(r)>-1?r+H:H,ue=i[ie].endsWith(oe);l=!se||ue}if(!l){let ie="";(T[0].endsWith(":")||I!=="")&&(z===1&&(z=0,N++,H=T[0]+r+H),z>0&&(ie=T[0]+r),ie=I+ie),z>0&&(ie=ie+p+r),ie=ie+H,z+N<T.length&&(ie=ie+r+p),o[s]=ie}}l&&(o[s]=u)}return o}e.shorten=f;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function P(i,r=Object.create(null)){const o=[];let l=!1,s="";for(const u of i)if(u==="$"||l&&u==="{")s&&o.push({value:s,type:m.TEXT}),s="",l=!0;else if(u==="}"&&l){const I=r[s];if(typeof I=="string")I.length&&o.push({value:I,type:m.VARIABLE});else if(I){const A=o[o.length-1];(!A||A.type!==m.SEPARATOR)&&o.push({value:I.label,type:m.SEPARATOR})}s="",l=!1}else s+=u;return s&&!l&&o.push({value:s,type:m.TEXT}),o.filter((u,I)=>{if(u.type===m.SEPARATOR){const A=o[I-1],T=o[I+1];return[A,T].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=P;function E(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function D(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const r=i.indexOf("/")!==-1?n.posix:n.win32,o=r.basename(i),l=r.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(Z[146],ee([0,1,17,7]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class R{constructor(y){this.a=y}transformIncoming(y){const h=this.a.transformIncoming(y);return h===y?y:n(M.URI.from(h))}transformOutgoing(y){const h=this.a.transformOutgoing(y);return h===y?y:n(M.URI.from(h))}transformOutgoingURI(y){const h=this.a.transformOutgoing(y);return h===y?y:M.URI.from(h)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,y,h){if(!v||h>200)return null;if(typeof v=="object"){if(v instanceof M.URI)return y.transformOutgoing(v);for(const p in v)if(Object.hasOwnProperty.call(v,p)){const w=C(v[p],y,h+1);w!==null&&(v[p]=w)}}return null}function k(v,y){const h=C(v,y,0);return h===null?v:h}e.transformOutgoingURIs=k;function g(v,y,h,p){if(!v||p>200)return null;if(typeof v=="object"){if(v.$mid===1)return h?M.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof S.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const a=g(v[w],y,h,p+1);a!==null&&(v[w]=a)}}return null}function d(v,y){const h=g(v,y,!1,0);return h===null?v:h}e.transformIncomingURIs=d;function b(v,y){const h=g(v,y,!0,0);return h===null?v:h}e.transformAndReviveIncomingURIs=b}),define(Z[84],ee([0,1,26,13,60,31,134]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,v=0;const y=(0,S.networkInterfaces)();for(const h in y){const p=y[h];if(p)for(const{mac:w,internal:a}of p)a||(v+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=v>0?b/v:0}return this.b}};let k;async function g(){return k||(k=(async()=>await d()||R.generateUuid())()),k}e.getMachineId=g;async function d(){try{const b=await new Promise((y,h)=>{x(["crypto"],y,h)}),v=(0,C.getMac)();return b.createHash("sha256").update(v,"utf8").digest("hex")}catch(b){M.onUnexpectedError(b);return}}}),define(Z[23],ee([0,1,41,26,147,8,32,79,9,4,18,7]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function h(oe,ue=y.UNLINK){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ue===y.UNLINK?w(oe):p(oe)}async function p(oe){try{const ue=(0,C.randomPath)((0,M.tmpdir)());try{await S.promises.rename(oe,ue)}catch(le){return le.code==="ENOENT"?void 0:w(oe)}w(ue).catch(le=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function w(oe){return(0,n.promisify)(S.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function a(oe){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function f(oe,ue){return E(await(ue?m(oe):(0,n.promisify)(S.readdir)(oe)))}async function m(oe){try{return await(0,n.promisify)(S.readdir)(oe,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const ue=[],le=await f(oe);for(const me of le){let G=!1,B=!1,O=!1;try{const q=await e.Promises.lstat((0,g.join)(oe,me));G=q.isFile(),B=q.isDirectory(),O=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ue.push({name:me,isFile:()=>G,isDirectory:()=>B,isSymbolicLink:()=>O})}return ue}function P(oe){return E(S.readdirSync(oe))}e.readdirSync=P;function E(oe){return oe.map(ue=>typeof ue=="string"?d.isMacintosh?(0,k.normalizeNFC)(ue):ue:(ue.name=d.isMacintosh?(0,k.normalizeNFC)(ue.name):ue.name,ue))}async function D(oe){const ue=await f(oe),le=[];for(const me of ue)await c.existsDirectory((0,g.join)(oe,me))&&le.push(me);return le}function t(oe,ue=1e3){return new Promise(le=>{let me=!1;const G=setInterval(()=>{me||(me=!0,S.access(oe,B=>{me=!1,B&&(clearInterval(G),le(void 0))}))},ue)})}e.whenDeleted=t;var c;(function(oe){async function ue(G){let B;try{if(B=await e.Promises.lstat(G),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(d.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw q}throw O}}oe.stat=ue;async function le(G){try{const{stat:B,symbolicLink:O}=await oe.stat(G);return B.isFile()&&O?.dangling!==!0}catch{}return!1}oe.existsFile=le;async function me(G){try{const{stat:B,symbolicLink:O}=await oe.stat(G);return B.isDirectory()&&O?.dangling!==!0}catch{}return!1}oe.existsDirectory=me})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function r(oe,ue,le){return i.queueFor(v.URI.file(oe),b.extUriBiasedIgnorePathCase).queue(()=>{const me=I(le);return new Promise((G,B)=>s(oe,ue,me,O=>O?B(O):G()))})}let o=!0;function l(oe){o=oe}e.configureFlushOnWrite=l;function s(oe,ue,le,me){if(!o)return S.writeFile(oe,ue,{mode:le.mode,flag:le.flag},me);S.open(oe,le.flag,le.mode,(G,B)=>{if(G)return me(G);S.writeFile(B,ue,O=>{if(O)return S.close(B,()=>me(O));S.fdatasync(B,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l(!1)),S.close(B,J=>me(J))))})})}function u(oe,ue,le){const me=I(le);if(!o)return S.writeFileSync(oe,ue,{mode:me.mode,flag:me.flag});const G=S.openSync(oe,me.flag,me.mode);try{S.writeFileSync(G,ue);try{S.fdatasyncSync(G)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),l(!1)}}finally{S.closeSync(G)}}e.writeFileSync=u;function I(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function A(oe,ue){if(oe!==ue)try{await e.Promises.rename(oe,ue)}catch(le){if(oe.toLowerCase()!==ue.toLowerCase()&&le.code==="EXDEV"||oe.endsWith("."))await T(oe,ue,{preserveSymlinks:!1}),await h(oe,y.MOVE);else throw le}}async function T(oe,ue,le){return z(oe,ue,{root:{source:oe,target:ue},options:le,handledSourcePaths:new Set})}const N=511;async function z(oe,ue,le){if(le.handledSourcePaths.has(oe))return;le.handledSourcePaths.add(oe);const{stat:me,symbolicLink:G}=await c.stat(oe);if(G){if(le.options.preserveSymlinks)try{return await se(oe,ue,le)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(G.dangling)return}return me.isDirectory()?H(oe,ue,me.mode&N,le):ie(oe,ue,me.mode&N)}async function H(oe,ue,le,me){await e.Promises.mkdir(ue,{recursive:!0,mode:le});const G=await f(oe);for(const B of G)await z((0,g.join)(oe,B),(0,g.join)(ue,B),me)}async function ie(oe,ue,le){await e.Promises.copyFile(oe,ue),await e.Promises.chmod(ue,le)}async function se(oe,ue,le){let me=await e.Promises.readlink(oe);(0,C.isEqualOrParent)(me,le.root.source,!d.isLinux)&&(me=(0,g.join)(le.root.target,me.substr(le.root.source.length+1))),await e.Promises.symlink(me,ue)}e.Promises=new class{get access(){return(0,n.promisify)(S.access)}get stat(){return(0,n.promisify)(S.stat)}get lstat(){return(0,n.promisify)(S.lstat)}get utimes(){return(0,n.promisify)(S.utimes)}get read(){return(oe,ue,le,me,G)=>new Promise((B,O)=>{S.read(oe,ue,le,me,G,(q,J,te)=>q?O(q):B({bytesRead:J,buffer:te}))})}get readFile(){return(0,n.promisify)(S.readFile)}get write(){return(oe,ue,le,me,G)=>new Promise((B,O)=>{S.write(oe,ue,le,me,G,(q,J,te)=>q?O(q):B({bytesWritten:J,buffer:te}))})}get appendFile(){return(0,n.promisify)(S.appendFile)}get fdatasync(){return(0,n.promisify)(S.fdatasync)}get truncate(){return(0,n.promisify)(S.truncate)}get rename(){return(0,n.promisify)(S.rename)}get copyFile(){return(0,n.promisify)(S.copyFile)}get open(){return(0,n.promisify)(S.open)}get close(){return(0,n.promisify)(S.close)}get symlink(){return(0,n.promisify)(S.symlink)}get readlink(){return(0,n.promisify)(S.readlink)}get chmod(){return(0,n.promisify)(S.chmod)}get mkdir(){return(0,n.promisify)(S.mkdir)}get unlink(){return(0,n.promisify)(S.unlink)}get rmdir(){return(0,n.promisify)(S.rmdir)}get realpath(){return(0,n.promisify)(S.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return D}get writeFile(){return r}get rm(){return h}get move(){return A}get copy(){return T}}}),define(Z[101],ee([0,1,41,9,4,27,23]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(y){if(n.isLinux)return y;const h=(0,M.dirname)(y);if(y===h)return y;const p=((0,M.basename)(y)||y).toLowerCase();try{const a=(0,C.readdirSync)(h).filter(f=>f.toLowerCase()===p);if(a.length===1){const f=k(h);if(f)return(0,M.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(p);if(f>=0){const m=k(h);if(m)return(0,M.join)(m,a[f])}}}catch{}return null}e.realcaseSync=k;async function g(y){if(n.isLinux)return y;const h=(0,M.dirname)(y);if(y===h)return y;const p=((0,M.basename)(y)||y).toLowerCase();try{const a=(await C.Promises.readdir(h)).filter(f=>f.toLowerCase()===p);if(a.length===1){const f=await g(h);if(f)return(0,M.join)(f,a[0])}else if(a.length>1){const f=a.indexOf(p);if(f>=0){const m=await g(h);if(m)return(0,M.join)(m,a[f])}}}catch{}return null}e.realcase=g;async function d(y){try{return await C.Promises.realpath(y)}catch{const p=v(y);return await C.Promises.access(p,S.constants.R_OK),p}}e.realpath=d;function b(y){try{return S.realpathSync(y)}catch{const p=v(y);return S.accessSync(p,S.constants.R_OK),p}}e.realpathSync=b;function v(y){return(0,R.rtrim)((0,M.normalize)(y),M.sep)}}),define(Z[148],ee([0,1,26,9,23]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(g||(g={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(D,t,c){this.exePath=D,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?d===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:E=!1,findPreview:D=!1}={}){const t=y({useAlternateBitness:E});if(!t)return null;const c=M.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(c))return null;let i=-1,r=null;for(const s of await n.Promises.readdir(c)){let u=-1;if(D){const A=s.indexOf("-");if(A<0)continue;const T=s.substring(0,A);if(!R.test(T)||s.substring(A+1)!=="preview")continue;u=parseInt(T,10)}else{if(!R.test(s))continue;u=parseInt(s,10)}if(u<=i)continue;const I=M.join(c,s,"pwsh.exe");!await n.SymlinkSupport.existsFile(I)||(r=I,i=u)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",l=D?" Preview":"";return new v(r,`PowerShell${l}${o}`,!0)}async function p({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const D=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=E?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(D))if(t.test(i)){const r=M.join(D,i,"pwsh.exe");return new v(r,c)}return null}function w(){const E=M.join(S.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function a(){const E=M.join(process.env.windir,d===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*f(){let E=await h();E&&(yield E),E=await h({useAlternateBitness:!0}),E&&(yield E),E=await p(),E&&(yield E),E=w(),E&&(yield E),E=await h({findPreview:!0}),E&&(yield E),E=await p({findPreview:!0}),E&&(yield E),E=await h({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=a(),E&&(yield E)}async function*m(){for await(const E of f())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=m;async function P(){for await(const E of m())return E;return null}e.getFirstAvailablePowerShellInstallation=P}),define(Z[85],ee([0,1,9,4,36,82,10,23]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=g;function d(v){let y=[],h=!1;const p=function(w){if(h){y.push(w);return}(!v.send(w,f=>{if(f&&console.error(f),h=!1,y.length>0){const m=y.slice(0);y=[],m.forEach(P=>p(P))}})||M.isWindows)&&(h=!0)};return{send:p}}e.createQueuedSender=d;var b;(function(v){async function y(h,p,w){if(S.isAbsolute(h))return h;if(p===void 0&&(p=n.cwd()),S.dirname(h)!=="."||(w===void 0&&C.isString(n.env.PATH)&&(w=n.env.PATH.split(S.delimiter)),w===void 0||w.length===0))return S.join(p,h);async function f(m){if(await k.Promises.exists(m)){let P;try{P=await k.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(P=await k.Promises.lstat(m))}return P?!P.isDirectory():!1}return!1}for(const m of w){let P;if(S.isAbsolute(m)?P=S.join(m,h):P=S.join(p,m,h),await f(P))return P;let E=P+".com";if(await f(E)||(E=P+".exe",await f(E)))return E}return S.join(p,h)}v.findExecutable=y})(b=e.win32||(e.win32={}))}),define(Z[102],ee([0,1,46,14]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(C){return new Promise((k,g)=>{let d;const b=new Map;function v(h,p,w,a,f){const m=b.get(p);if(h===C||m){const P={name:y(w),cmd:w,pid:h,ppid:p,load:a,mem:f};b.set(h,P),h===C&&(d=P),m&&(m.children||(m.children=[]),m.children.push(P),m.children.length>1&&(m.children=m.children.sort((E,D)=>E.pid-D.pid)))}}function y(h){const p=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,a=/--vscode-window-kind=process-explorer/,f=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,P=/--crashes-directory/,E=/\\pipe\\winpty-control/,D=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(P.exec(h))return"electron-crash-reporter";if(E.exec(h))return"winpty-process";if(D.exec(h))return"console-window-host (Windows internal process)";let c=t.exec(h);if(c&&c.length===2){if(c[1]==="renderer")return p.exec(h)?"shared-process":w.exec(h)?"issue-reporter":a.exec(h)?"process-explorer":"window";if(c[1]==="utility"){if(f.exec(h))return"utility-network-service";if(m.exec(h))return"extension-host"}else if(c[1]==="extensionHost")return"extension-host";return c[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do c=i.exec(h),c&&(r+=c+" ");while(c);return r&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${r}`:h}if(process.platform==="win32"){const h=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,w)=>{x(["windows-process-tree"],p,w)}).then(p=>{p.getProcessList(C,w=>{if(!w){g(new Error(`Root process ${C} not found`));return}p.getProcessCpuUsage(w,a=>{const f=new Map;a.forEach(m=>{const P=h(m.commandLine||"");f.set(m.pid,{name:y(P),cmd:P,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),d=f.get(C),d?(f.forEach(m=>{const P=f.get(m.ppid);P&&(P.children||(P.children=[]),P.children.push(m))}),f.forEach(m=>{m.children&&(m.children=m.children.sort((P,E)=>P.pid-E.pid))}),k(d)):g(new Error(`Root process ${C} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let h=function(){let p=[d];const w=[];for(;p.length;){const f=p.shift();f&&(w.push(f.pid),f.children&&(p=p.concat(f.children)))}let a=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+w.join(" "),(0,S.exec)(a,{},(f,m,P)=>{if(f||P)g(f||new Error(P.toString()));else{const E=m.toString().split(`
`);for(let D=0;D<w.length;D++){const t=b.get(w[D]);t.load=parseFloat(E[D])}if(!d){g(new Error(`Root process ${C} not found`));return}k(d)}})};(0,S.exec)("which ps",{},(p,w,a)=>{if(p||a)if(process.platform!=="linux")g(p||new Error(a.toString()));else{const f=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(f,{},(m,P,E)=>{m||E?g(m||new Error(E.toString())):(R(P,v),h())})}else{const f=w.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${f} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,E,D)=>{P||D&&!D.includes("screen size is bogus")?g(P||new Error(D.toString())):(R(E,v),process.platform==="linux"?h():d?k(d):g(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=n;function R(C,k){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=C.toString().split(`
`);for(const b of d){const v=g.exec(b.trim());v&&v.length===6&&k(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[149],ee([0,1,26,4,148,85]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(v,y){return v===1?M.isWindows?b():R.getWindowsShell(y):g(v,y)}e.getSystemShell=C;let k=null;function g(v,y){if(M.isLinux&&v===2||M.isMacintosh&&v===3)return"/bin/bash";if(!k){let h;if(M.isWindows)h="/bin/bash";else{if(h=y.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}k=h}return k}let d=null;async function b(){return d||(d=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),d}});var ve=this&&this.__decorate||function(x,e,S,M){var n=arguments.length,R=n<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,e,S,M);else for(var k=x.length-1;k>=0;k--)(C=x[k])&&(R=(n<3?C(R):n>3?C(e,S,R):C(e,S))||R);return n>3&&R&&Object.defineProperty(e,S,R),R};define(Z[47],ee([0,1,25,8,17,22,54,13,3,2,83,27,10]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(h||(h={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(w||(w={}));function a(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function m(B){let O=0;for(let q=0;;q+=7){const J=B.read(1);if(O|=(J.buffer[0]&127)<<q,!(J.buffer[0]&128))return O}}const P=i(0);function E(B,O){if(O===0){B.write(P);return}let q=0;for(let te=O;te!==0;te=te>>>7)q++;const J=n.VSBuffer.alloc(q);for(let te=0;O!==0;te++)J.buffer[te]=O&127,O=O>>>7,O>0&&(J.buffer[te]|=128);B.write(J)}class D{constructor(O){this.b=O,this.a=0}read(O){const q=this.b.slice(this.a,this.a+O);return this.a+=q.byteLength,q}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(O){this.a.push(O)}}e.BufferWriter=t;var c;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(c||(c={}));function i(B){const O=n.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const r={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},o=typeof Buffer<"u";function l(B,O){if(typeof O>"u")B.write(r.Undefined);else if(typeof O=="string"){const q=n.VSBuffer.fromString(O);B.write(r.String),E(B,q.byteLength),B.write(q)}else if(o&&Buffer.isBuffer(O)){const q=n.VSBuffer.wrap(O);B.write(r.Buffer),E(B,q.byteLength),B.write(q)}else if(O instanceof n.VSBuffer)B.write(r.VSBuffer),E(B,O.byteLength),B.write(O);else if(Array.isArray(O)){B.write(r.Array),E(B,O.length);for(const q of O)l(B,q)}else if(typeof O=="number"&&(O|0)===O)B.write(r.Uint),E(B,O);else{const q=n.VSBuffer.fromString(JSON.stringify(O));B.write(r.Object),E(B,q.byteLength),B.write(q)}}e.serialize=l;function s(B){switch(B.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return B.read(m(B)).toString();case c.Buffer:return B.read(m(B)).buffer;case c.VSBuffer:return B.read(m(B));case c.Array:{const q=m(B),J=[];for(let te=0;te<q;te++)J.push(s(B));return J}case c.Object:return JSON.parse(B.read(m(B)).toString());case c.Int:return m(B)}}e.deserialize=s;class u{constructor(O,q,J=null,te=1e3){this.h=O,this.j=q,this.k=J,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(O,q){this.b.set(O,q),setTimeout(()=>this.w(O),0)}m(O){switch(O.type){case 200:{const q=this.o([O.type]);this.k?.logOutgoing(q,0,1,a(O.type));return}case 201:case 202:case 204:case 203:{const q=this.o([O.type,O.id],O.data);this.k?.logOutgoing(q,O.id,1,a(O.type),O.data);return}}}o(O,q=void 0){const J=new t;return l(J,O),l(J,q),this.p(J.buffer)}p(O){try{return this.h.send(O),O.byteLength}catch{return 0}}q(O){const q=new D(O),J=s(q),te=s(q),ne=J[0];switch(ne){case 100:return this.k?.logIncoming(O.byteLength,J[1],1,`${p(ne)}: ${J[2]}.${J[3]}`,te),this.s({type:ne,id:J[1],channelName:J[2],name:J[3],arg:te});case 102:return this.k?.logIncoming(O.byteLength,J[1],1,`${p(ne)}: ${J[2]}.${J[3]}`,te),this.t({type:ne,id:J[1],channelName:J[2],name:J[3],arg:te});case 101:return this.k?.logIncoming(O.byteLength,J[1],1,`${p(ne)}`),this.u({type:ne,id:J[1]});case 103:return this.k?.logIncoming(O.byteLength,J[1],1,`${p(ne)}`),this.u({type:ne,id:J[1]})}}s(O){const q=this.b.get(O.channelName);if(!q){this.v(O);return}const J=new R.CancellationTokenSource;let te;try{te=q.call(this.j,O.name,O.arg,J.token)}catch(F){te=Promise.reject(F)}const ne=O.id;te.then(F=>{this.m({id:ne,data:F,type:201}),this.d.delete(O.id)},F=>{F instanceof Error?this.m({id:ne,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:ne,data:F,type:203}),this.d.delete(O.id)});const L=(0,d.toDisposable)(()=>J.cancel());this.d.set(O.id,L)}t(O){const q=this.b.get(O.channelName);if(!q){this.v(O);return}const J=O.id,ne=q.listen(this.j,O.name,O.arg)(L=>this.m({id:J,data:L,type:204}));this.d.set(O.id,ne)}u(O){const q=this.d.get(O.id);q&&(q.dispose(),this.d.delete(O.id))}v(O){let q=this.g.get(O.channelName);q||(q=[],this.g.set(O.channelName,q));const J=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.m({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:O,timeoutTimer:J})}w(O){const q=this.g.get(O);if(q){for(const J of q)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(O)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var I;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(O,q=null){this.l=O,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=q}getChannel(O){const q=this;return{call(J,te,ne){return q.a?Promise.reject(new k.CancellationError):q.m(O,J,te,ne)},listen(J,te){return q.a?g.Event.None:q.o(O,J,te)}}}m(O,q,J,te=R.CancellationToken.None){const ne=this.g++,F={id:ne,type:100,channelName:O,name:q,arg:J};if(te.isCancellationRequested)return Promise.reject(new k.CancellationError);let W;return new Promise(($,V)=>{if(te.isCancellationRequested)return V(new k.CancellationError);const j=()=>{const de=Re=>{switch(Re.type){case 201:this.f.delete(ne),$(Re.data);break;case 202:{this.f.delete(ne);const Ce=new Error(Re.data.message);Ce.stack=Array.isArray(Re.data.stack)?Re.data.stack.join(`
`):Re.data.stack,Ce.name=Re.data.name,V(Ce);break}case 203:this.f.delete(ne),V(Re.data);break}};this.f.set(ne,de),this.p(F)};let K=null;this.b===f.Idle?j():(K=(0,M.createCancelablePromise)(de=>this.u()),K.then(()=>{K=null,j()}));const Y=()=>{K?(K.cancel(),K=null):this.p({id:ne,type:101}),V(new k.CancellationError)},re=te.onCancellationRequested(Y);W=(0,d.combinedDisposable)((0,d.toDisposable)(Y),re),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(O,q,J){const te=this.g++,L={id:te,type:102,channelName:O,name:q,arg:J};let F=null;const W=new g.Emitter({onWillAddFirstListener:()=>{F=(0,M.createCancelablePromise)($=>this.u()),F.then(()=>{F=null,this.d.add(W),this.p(L)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(W),this.p({id:te,type:103}))}}),U=$=>W.fire($.data);return this.f.set(te,U),W.event}p(O){switch(O.type){case 100:case 102:{const q=this.q([O.type,O.id,O.channelName,O.name],O.arg);this.j?.logOutgoing(q,O.id,0,`${p(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const q=this.q([O.type,O.id]);this.j?.logOutgoing(q,O.id,0,p(O.type));return}}}q(O,q=void 0){const J=new t;return l(J,O),l(J,q),this.r(J.buffer)}r(O){try{return this.l.send(O),O.byteLength}catch{return 0}}s(O){const q=new D(O),J=s(q),te=s(q),ne=J[0];switch(ne){case 200:return this.j?.logIncoming(O.byteLength,0,0,a(ne)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(O.byteLength,J[1],0,a(ne),te),this.t({type:J[0],id:J[1],data:te})}}t(O){if(O.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(O.id)?.(O)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}ve([C.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class T{get connections(){const O=[];return this.f.forEach(q=>O.push(q)),O}constructor(O){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,O(({protocol:q,onDidClientDisconnect:J})=>{g.Event.once(q.onMessage)(ne=>{const L=new D(ne),F=s(L),W=new u(q,F),U=new A(q);this.a.forEach((V,j)=>W.registerChannel(j,V));const $={channelServer:W,channelClient:U,ctx:F};this.f.add($),this.g.fire($),J(()=>{W.dispose(),U.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(O,q){const J=this;return{call(te,ne,L){let F;if((0,y.isFunction)(q)){const U=(0,S.getRandomElement)(J.connections.filter(q));F=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(J.onDidAddConnection,q))}else F=q.routeCall(J,te,ne);const W=F.then(U=>U.channelClient.getChannel(O));return z(W).call(te,ne,L)},listen(te,ne){if((0,y.isFunction)(q))return J.j(O,q,te,ne);const L=q.routeEvent(J,te,ne).then(F=>F.channelClient.getChannel(O));return z(L).listen(te,ne)}}}j(O,q,J,te){const ne=this;let L=new d.DisposableStore;const F=new g.Emitter({onWillAddFirstListener:()=>{L=new d.DisposableStore;const W=new g.EventMultiplexer,U=new Map,$=j=>{const Y=j.channelClient.getChannel(O).listen(J,te),re=W.add(Y);U.set(j,re)},V=j=>{const K=U.get(j);!K||(K.dispose(),U.delete(j))};ne.connections.filter(q).forEach($),g.Event.filter(ne.onDidAddConnection,q)($,void 0,L),ne.onDidRemoveConnection(V,void 0,L),W.event(F.fire,F,L),L.add(W)},onDidRemoveLastListener:()=>{L.dispose()}});return F.event}registerChannel(O,q){this.a.set(O,q),this.f.forEach(J=>{J.channelServer.registerChannel(O,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(O,q,J=null){const te=new t;l(te,q),O.send(te.buffer),this.a=new A(O,J),this.d=new u(O,q,J)}getChannel(O){return this.a.getChannel(O)}registerChannel(O,q){this.d.registerChannel(O,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function z(B){return{call(O,q,J){return B.then(te=>te.call(O,q,J))},listen(O,q){const J=new g.Relay;return B.then(te=>J.input=te.listen(O,q)),J.event}}}e.getDelayedChannel=z;function H(B){let O=!1;return{call(q,J,te){return O?B.call(q,J,te):(0,M.timeout)(0).then(()=>O=!0).then(()=>B.call(q,J,te))},listen(q,J){if(O)return B.listen(q,J);const te=new g.Relay;return(0,M.timeout)(0).then(()=>O=!0).then(()=>te.input=B.listen(q,J)),te.event}}}e.getNextTickChannel=H;class ie{constructor(O){this.a=O}routeCall(O){return this.b(O)}routeEvent(O){return this.b(O)}async b(O){for(const q of O.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await g.Event.toPromise(O.onDidAddConnection),await this.b(O)}}e.StaticRouter=ie;var se;(function(B){function O(ne,L){const F=ne,W=L&&L.disableMarshalling,U=new Map;for(const $ in F)J($)&&U.set($,g.Event.buffer(F[$],!0));return new class{listen($,V,j){const K=U.get(V);if(K)return K;if(te(V)){const Y=F[V];if(typeof Y=="function")return Y.call(F,j)}throw new Error(`Event not found: ${V}`)}call($,V,j){const K=F[V];if(typeof K=="function"){if(!W&&Array.isArray(j))for(let Y=0;Y<j.length;Y++)j[Y]=(0,b.revive)(j[Y]);return K.apply(F,j)}throw new Error(`Method not found: ${V}`)}}}B.fromService=O;function q(ne,L){const F=L&&L.disableMarshalling;return new Proxy({},{get(W,U){if(typeof U=="string")return L?.properties?.has(U)?L.properties.get(U):te(U)?function($){return ne.listen(U,$)}:J(U)?ne.listen(U):async function(...$){let V;L&&!(0,y.isUndefinedOrNull)(L.context)?V=[L.context,...$]:V=$;const j=await ne.call(U,V);return F?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}B.toService=q;function J(ne){return ne[0]==="o"&&ne[1]==="n"&&v.isUpperAsciiLetter(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&v.isUpperAsciiLetter(ne.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const O=B.toString();if(O!=="[object Object]")return O}return B}function le(B){return Array.isArray(B)?B.map(ue):ue(B)}function me(B,O,q,J,te,ne,L){L=le(L);const F=oe[te],W=F[J%F.length];let U=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ne)?(U=U.concat(L),U.push(")")):U.push(L),console.log.apply(console,U)}class G{constructor(O,q){this.d=O,this.f=q,this.a=0,this.b=0}logOutgoing(O,q,J,te,ne){this.b+=O,me(this.d,this.b,O,q,J,te,ne)}logIncoming(O,q,J,te,ne){this.a+=O,me(this.f,this.a,O,q,J,te,ne)}}e.IPCLogger=G}),define(Z[150],ee([0,1,17,3,47]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.a=g,this.onMessage=M.Event.fromDOMEventEmitter(this.a,"message",d=>S.VSBuffer.wrap(d.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class C extends n.IPCClient{constructor(g,d){const b=new R(g);super(b,d),this.b=b}dispose(){this.b.disconnect()}}e.Client=C}),define(Z[103],ee([0,1,8,17,3,2,47]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(A){A.Created="created",A.Read="read",A.Write="write",A.Open="open",A.Error="error",A.Close="close",A.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",A.NodeEndReceived="nodeEndReceived",A.NodeEndSent="nodeEndSent",A.NodeDrainBegin="nodeDrainBegin",A.NodeDrainEnd="nodeDrainEnd",A.zlibInflateError="zlibInflateError",A.zlibInflateData="zlibInflateData",A.zlibInflateInitialWrite="zlibInflateInitialWrite",A.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",A.zlibInflateWrite="zlibInflateWrite",A.zlibInflateFlushFired="zlibInflateFlushFired",A.zlibDeflateError="zlibDeflateError",A.zlibDeflateData="zlibDeflateData",A.zlibDeflateWrite="zlibDeflateWrite",A.zlibDeflateFlushFired="zlibDeflateFlushFired",A.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",A.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",A.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",A.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",A.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",A.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",A.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",A.ProtocolHeaderRead="protocolHeaderRead",A.ProtocolMessageRead="protocolMessageRead",A.ProtocolHeaderWrite="protocolHeaderWrite",A.ProtocolMessageWrite="protocolMessageWrite",A.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(A){A.enableDiagnostics=!1,A.records=[];const T=new WeakMap;let N=0;function z(ie,se){if(!T.has(ie)){const oe=String(++N);T.set(ie,oe)}return T.get(ie)}function H(ie,se,oe,ue){if(!A.enableDiagnostics)return;const le=z(ie,se);if(ue instanceof M.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const me=M.VSBuffer.alloc(ue.byteLength);me.set(ue),A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,buff:me})}else A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,data:ue})}A.traceSocketEvent=H})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(A){A[A.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",A[A.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function v(){return b||(b=M.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return v();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const se=this.a[0];return N&&(this.a.shift(),this.b-=T),se}if(this.a[0].byteLength>T){const se=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),se}const z=M.VSBuffer.alloc(T);let H=0,ie=0;for(;T>0;){const se=this.a[ie];if(se.byteLength>T){const oe=se.slice(0,T);z.set(oe,H),H+=T,N&&(this.a[ie]=se.slice(T),this.b-=T),T-=T}else z.set(se,H),H+=se.byteLength,N?(this.a.shift(),this.b-=se.byteLength):ie++,T-=se.byteLength}return z}}e.ChunkStream=y;var h;(function(A){A[A.None=0]="None",A[A.Regular=1]="Regular",A[A.Control=2]="Control",A[A.Ack=3]="Ack",A[A.Disconnect=5]="Disconnect",A[A.ReplayRequest=6]="ReplayRequest",A[A.Pause=7]="Pause",A[A.Resume=8]="Resume",A[A.KeepAlive=9]="KeepAlive",A[A.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",A[A.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function p(A){switch(A){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(A){A[A.HeaderLength=13]="HeaderLength",A[A.AcknowledgeTime=2e3]="AcknowledgeTime",A[A.TimeoutTime=2e4]="TimeoutTime",A[A.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",A[A.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",A[A.KeepAliveSendTime=5e3]="KeepAliveSendTime",A[A.LatencySampleTime=6e4]="LatencySampleTime",A[A.LatencySampleCount=5]="LatencySampleCount",A[A.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",A[A.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(T,N,z,H){this.type=T,this.id=N,this.ack=z,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(T){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new y,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,H=this.g.id,ie=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new a(z,H,ie,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=M.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const z=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,z}h(){const T=M.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class P extends R.Disposable{constructor(T){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new m(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new a(1,0,0,T))}}e.Protocol=P;class E extends C.IPCClient{static fromSocket(T,N){return new E(new P(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,z=null){super(T,N,z),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=E;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,z=this.a;for(;z;)T[N++]=z.data,z=z.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new t(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<i.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+i.a)*1e3;let z=0;for(let H=0;H<i.a;H++)T-this.c[H]<=N&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var r;(function(A){A[A.Good=0]="Good",A[A.Poor=1]="Poor"})(r=e.ConnectionHealth||(e.ConnectionHealth={}));function o(A){switch(A){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class l{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=l;class s{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=s;class u{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new I),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new a(5,0,0,v());this.p.write(T),this.p.flush()}sendPause(){const T=new a(7,0,0,v());this.p.write(T)}sendResume(){const T=new a(8,0,0,v());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new I),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new a(3,0,this.h,v());this.p.write(T);const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new a(6,0,0,v())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const z=new a(1,N,this.h,T);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(T){const N=new a(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,z=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(N>=2e4&&z>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:z});return}const ie=Math.max(2e4-N,2e4-z,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},ie)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new a(3,0,this.h,v());this.p.write(T)}I(){this.h=this.g;const T=new a(9,0,this.h,v());this.p.write(T)}J(T){this.h=this.g;const N=new a(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new a(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=u;class I extends R.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new S.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=M.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const z=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=z;const ie=this.l,se=this.j.filter(oe=>oe>=1e3).length;this.l=se>=3?1:0,z>1e3&&this.b.fire(new s(z,se)),ie!==this.l&&this.c.fire(this.l)}}}),define(Z[151],ee([0,1,42,17,3,2,47,136]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(b,v){const y=n.Event.fromNodeEventEmitter(S.validatedIpcMain,v,(p,w)=>({event:p,message:w})),h=n.Event.filter(y,({event:p})=>p.sender.id===b);return n.Event.map(h,({message:p})=>p&&M.VSBuffer.wrap(p))}class d extends C.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:y})=>y);return n.Event.map(v,y=>{const h=y.id;d.b.get(h)?.dispose();const w=new n.Emitter;d.b.set(h,(0,R.toDisposable)(()=>w.fire()));const a=g(h,"vscode:message"),f=n.Event.any(n.Event.signal(g(h,"vscode:disconnect")),w.event);return{protocol:new k.Protocol(y,a),onDidClientDisconnect:f}})}constructor(){super(d.d())}}d.b=new Map,e.Server=d}),define(Z[104],ee([0,1,42,3,31,150]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class C extends R.Client{constructor(d,b){super({addEventListener:(v,y)=>d.addListener(v,y),removeEventListener:(v,y)=>d.removeListener(v,y),postMessage:v=>d.postMessage(v),start:()=>d.start(),close:()=>d.close()},b)}}e.Client=C;async function k(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,n.generateUuid)();g.webContents.send("vscode:createMessageChannel",d);const b=M.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:v}=await M.Event.toPromise(M.Event.once(M.Event.filter(b,y=>y.nonce===d)));return v}e.connect=k}),define(Z[152],ee([0,1,46,8,17,22,145,13,3,2,40,85,82,47]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends h.ChannelServer{constructor(f){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>n.VSBuffer.wrap(Buffer.from(m,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=p;class w{constructor(f,m){this.i=f,this.j=m,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const P=m&&m.timeout?m.timeout:6e4;this.b=new M.Delayer(P),this.d=null,this.f=null}getChannel(f){const m=this;return{call(P,E,D){return m.k(f,P,E,D)},listen(P,E){return m.l(f,P,E)}}}k(f,m,P,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const D=this.n(f),t=(0,M.createCancelablePromise)(r=>D.call(m,P,r)),c=E.onCancellationRequested(()=>t.cancel()),i=(0,d.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,m,P){if(!this.b)return g.Event.None;this.b.cancel();let E;const D=new g.Emitter({onWillAddFirstListener:()=>{E=this.n(f).listen(m,P)(D.fire,D),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(m.env),this.d=(0,S.fork)(this.i,f,m);const P=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.isRemoteConsoleLog)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}P.fire(n.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),c=P.event,i={send:t,onMessage:c};this.f=new h.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",r),this.c.forEach(s=>(0,d.dispose)(s)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(f){let m=this.g.get(f);return m||(m=this.m.getChannel(f),this.g.set(f,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(Z[86],ee([0,1,17,13,3,2,9,4,31,47,103]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,u){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,u)}constructor(s,u=""){this.f=!0,this.debugLabel=u,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,M.onUnexpectedError)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const u=I=>{this.traceSocketEvent("read",I),s(S.VSBuffer.wrap(I))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(s){const u=I=>{s({type:0,hadError:I,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(s){const u=()=>{s()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,M.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,M.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.NodeSocket=y;var h;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class w extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,u){this.socket.traceSocketEvent(s,u)}constructor(s,u,I,A){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:I?.byteLength||0,recordInflateBytes:A}),this.a=this.B(new a(this,u,I,A,this.f,(T,N)=>this.k(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,M.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new b.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let I=2;s.byteLength<126?I+=0:s.byteLength<2**16?I+=2:I+=8;const A=S.VSBuffer.alloc(I);if(u?A.writeUInt8(194,0):A.writeUInt8(130,0),s.byteLength<126)A.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){A.writeUInt8(126,1);let T=1;A.writeUInt8(s.byteLength>>>8&255,++T),A.writeUInt8(s.byteLength>>>0&255,++T)}else{A.writeUInt8(127,1);let T=1;A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(s.byteLength>>>24&255,++T),A.writeUInt8(s.byteLength>>>16&255,++T),A.writeUInt8(s.byteLength>>>8&255,++T),A.writeUInt8(s.byteLength>>>0&255,++T)}this.socket.write(S.VSBuffer.concat([A,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),I=u.readUInt8(0),A=(I&128)>>>7,T=(I&64)>>>6,N=u.readUInt8(1),z=(N&128)>>>7,H=N&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=A,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(A),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),I=u.readUInt8(1),A=(I&128)>>>7;let T=I&127,N=1;T===126?T=u.readUInt8(++N)*2**8+u.readUInt8(++N):T===127&&(T=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let z=0;A&&(z=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),P(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class a extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.VSBuffer.alloc(0)}constructor(s,u,I,A,T,N){super(),this.k=s,this.l=T,this.m=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new f(this.k,A,I,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const u=await this.r(this.f,s);this.m(u,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,u){return new Promise((I,A)=>{s.write(u),s.flush(T=>I(T))})}acceptFrame(s,u,I){this.h.push({data:s,isCompressed:u,isLastFrameOfMessage:I}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const u=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(s.data)}this.s=!1}}u(s,u,I){return new Promise((A,T)=>{s.write(u),I&&s.write(S.VSBuffer.fromByteArray([0,0,255,255])),s.flush(N=>A(N))})}}class f extends R.Disposable{get recordedInflateBytes(){return this.j?S.VSBuffer.concat(this.f):S.VSBuffer.alloc(0)}constructor(s,u,I,A){super(),this.h=s,this.j=u,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(A),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(S.VSBuffer.wrap(T))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=S.VSBuffer.concat(this.g);this.g.length=0,s(u)})}}class m extends R.Disposable{constructor(s,u){super(),this.g=s,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(S.VSBuffer.wrap(I))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=S.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),s(u)})}}function P(l,s){if(s===0)return;const u=l.byteLength>>>2;for(let H=0;H<u;H++){const ie=l.readUInt32BE(H*4);l.writeUInt32BE(ie^s,H*4)}const I=u*4,A=l.byteLength-I,T=s>>>24&255,N=s>>>16&255,z=s>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(I)^T,I),A>=2&&l.writeUInt8(l.readUInt8(I+1)^N,I+1),A>=3&&l.writeUInt8(l.readUInt8(I+2)^z,I+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function D(){const l=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):s=(0,C.join)(v().os.tmpdir(),`vscode-ipc-${l}.sock`),c(s),s}e.createRandomIPCHandle=D;function t(l,s,u){const I=v().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${u}-${s}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${I.substr(0,8)}-${u}-${s}.sock`):A=(0,C.join)(l,`${u}-${s}.sock`),c(A),A}e.createStaticIPCHandle=t;function c(l){const s=E[k.platform];typeof s=="number"&&l.length>=s&&console.warn(`WARNING: IPC handle "${l}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends d.IPCServer{static b(s){const u=n.Event.fromNodeEventEmitter(s,"connection");return n.Event.map(u,I=>({protocol:new b.Protocol(new y(I,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(I,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function r(l){return new Promise((s,u)=>{const I=v().net.createServer();I.on("error",u),I.listen(l,()=>{I.removeListener("error",u),s(new i(I))})})}e.serve=r;function o(l,s){return new Promise((u,I)=>{const A=v().net.createConnection(l,()=>{A.removeListener("error",I),u(b.Client.fromSocket(new y(A,`ipc-client${s}`),s))});A.once("error",I)})}e.connect=o}),define(Z[105],ee([0,1,8,3,2,10]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function k(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var g;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class d extends n.Disposable{constructor(y,h=Object.create(null)){super(),this.m=y,this.n=h,this.b=this.B(new M.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new S.ThrottledDelayer(d.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((h,p)=>this.s(p,h)),y.deleted?.forEach(h=>this.s(h,void 0))}s(y,h){if(this.c===g.Closed)return;let p=!1;(0,R.isUndefinedOrNull)(h)?p=this.f.delete(y):this.f.get(y)!==h&&(this.f.set(y,h),p=!0),p&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,h){const p=this.f.get(y);return(0,R.isUndefinedOrNull)(p)?h:p}getBoolean(y,h){const p=this.get(y);return(0,R.isUndefinedOrNull)(p)?h:p==="true"}getNumber(y,h){const p=this.get(y);return(0,R.isUndefinedOrNull)(p)?h:parseInt(p,10)}async set(y,h){if(this.c===g.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(y);const p=String(h);if(this.f.get(y)!==p)return this.f.set(y,p),this.j.set(y,p),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}d.a=100,e.Storage=d;class b{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((h,p)=>this.a.set(p,h)),y.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[153],ee([0,1,8,3,35,9,23]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return M.Event.None}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,R.basename)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(h=>v.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,h=v.delete;if(y&&y.size>0){const p=[];p.push([]);let w=0;y.forEach((a,f)=>{let m=p[w];m.length>k.b&&(w++,m=[],p.push(m)),m.push(f,a)}),p.forEach(a=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,f=>f.run(a),()=>{const f=[];let m=0;return y.forEach((P,E)=>{f.push(E),m+=P.length}),`Keys: ${f.join(", ")} Length: ${m}`})})}if(h&&h.size){const p=[];p.push([]);let w=0;h.forEach(a=>{let f=p[w];f.length>k.b&&(w++,f=[],p.push(f)),f.push(a)}),p.forEach(a=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,f=>f.run(a),()=>{const f=[];return h.forEach(m=>{f.push(m)}),`Keys: ${f.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,h)=>{b.db.close(p=>(p&&this.o(b,`[storage ${this.c}] close(): ${p}`),this.g===k.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),y())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const a=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>a(),f=>(a(),Promise.reject(f)))})).then(y,h):h(p||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return C.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),h=b?y.integrity_check:y.quick_check;return v.isErroneous?`${h} (last error: ${v.lastError})`:v.isInMemory?`${h} (in-memory!)`:h}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,S.timeout)(k.a),this.n(b,!1);try{await C.Promises.unlink(b);try{await C.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(k.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((h,p)=>{x(["@vscode/sqlite3"],h,p)}).then(h=>{const p={db:new(this.d.isTracing?h.verbose().Database:h.Database)(b,w=>w?p.db&&w.code!=="SQLITE_CANTOPEN"?p.db.close(()=>y(w)):y(w):this.q(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(p),a=>p.db.close(()=>y(a)))),isInMemory:b===k.IN_MEMORY_PATH};p.db.on("error",w=>this.o(p,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&p.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},y)})}q(b,v){return new Promise((y,h)=>{b.db.exec(v,p=>p?(this.o(b,`[storage ${this.c}] exec(): ${p}`),h(p)):y())})}r(b,v){return new Promise((y,h)=>{b.db.get(v,(p,w)=>p?(this.o(b,`[storage ${this.c}] get(): ${p}`),h(p)):y(w))})}s(b,v){return new Promise((y,h)=>{b.db.all(v,(p,w)=>p?(this.o(b,`[storage ${this.c}] all(): ${p}`),h(p)):y(w))})}t(b,v){return new Promise((y,h)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",p=>p?(this.o(b,`[storage ${this.c}] transaction(): ${p}`),h(p)):y())})})}u(b,v,y,h){const p=b.db.prepare(v),w=a=>{this.o(b,`[storage ${this.c}] prepare(): ${a} (${v}). Details: ${h()}`)};p.on("error",w),y(p),p.finalize(a=>{a&&w(a),p.removeListener("error",w)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class g{constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[154],ee([12,11]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(Z[155],ee([12,11]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[156],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(Z[157],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[158],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(Z[159],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(Z[160],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[161],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[162],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[163],ee([12,11]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[164],ee([12,11]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[165],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[166],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(Z[167],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[168],ee([12,11]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[169],ee([12,11]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[170],ee([12,11]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[171],ee([12,11]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[172],ee([12,11]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[173],ee([12,11]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[174],ee([12,11]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[175],ee([12,11]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[176],ee([12,11]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[177],ee([12,11]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[178],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[179],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[180],ee([12,11]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[181],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[182],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[183],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function M(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(Z[184],ee([0,1,7]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(C){return typeof C?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function n(C){let k=[];try{Array.isArray(C.workspaces)&&(k=C.workspaces.map(g=>({workspace:{id:g.id,configPath:S.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=n;function R(C){let k=[];try{Array.isArray(C.folders)&&(k=C.folders.map(g=>({folderUri:S.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=R}),define(Z[185],ee([0,1,3,2]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new S.Emitter,this.b=new S.Emitter,this.c=new S.Emitter,this.d=new S.Emitter}call(k,g,d){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(k,g,d){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class R extends M.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,g,d){this.b.call("attach",[k,g,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,g){this.b.call("terminate",[k,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,g){return this.b.call("openExtensionDevelopmentHostWindow",[k,g])}}e.ExtensionHostDebugChannelClient=R}),define(Z[186],ee([0,1,139,54,14,9,36,18,7]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,R.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(g.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=C.env.VSCODE_PORTABLE;return p?g.URI.file((0,R.join)(p,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,R.resolve)(p):(0,R.normalize)((0,R.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?g.URI.file((0,R.resolve)(p)):g.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,R.resolve)(p);const w=C.env.VSCODE_EXTENSIONS;if(w)return w;const a=C.env.VSCODE_PORTABLE;return a?(0,R.join)(a,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(w=>/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,R.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const w of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);a&&a[1]&&a[2]&&p.push([a[1],a[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=C.env.VSCODE_PORTABLE;return p?g.URI.file((0,R.join)(p,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,w,a){this.a=p,this.b=w,this.c=a,this.editSessionId=this.args.editSessionId}}ve([M.memoize],d.prototype,"appRoot",null),ve([M.memoize],d.prototype,"userHome",null),ve([M.memoize],d.prototype,"userDataPath",null),ve([M.memoize],d.prototype,"appSettingsHome",null),ve([M.memoize],d.prototype,"tmpDir",null),ve([M.memoize],d.prototype,"cacheHome",null),ve([M.memoize],d.prototype,"stateResource",null),ve([M.memoize],d.prototype,"userRoamingDataHome",null),ve([M.memoize],d.prototype,"userDataSyncHome",null),ve([M.memoize],d.prototype,"userDataSyncLogResource",null),ve([M.memoize],d.prototype,"editSessionsLogResource",null),ve([M.memoize],d.prototype,"sync",null),ve([M.memoize],d.prototype,"machineSettingsResource",null),ve([M.memoize],d.prototype,"workspaceStorageHome",null),ve([M.memoize],d.prototype,"localHistoryHome",null),ve([M.memoize],d.prototype,"keyboardLayoutResource",null),ve([M.memoize],d.prototype,"argvResource",null),ve([M.memoize],d.prototype,"isExtensionDevelopment",null),ve([M.memoize],d.prototype,"untitledWorkspacesHome",null),ve([M.memoize],d.prototype,"installSourcePath",null),ve([M.memoize],d.prototype,"builtinExtensionsPath",null),ve([M.memoize],d.prototype,"extensionsPath",null),ve([M.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ve([M.memoize],d.prototype,"extensionDevelopmentKind",null),ve([M.memoize],d.prototype,"extensionTestsLocationURI",null),ve([M.memoize],d.prototype,"debugExtensionHost",null),ve([M.memoize],d.prototype,"logLevel",null),ve([M.memoize],d.prototype,"extensionLogLevel",null),ve([M.memoize],d.prototype,"serviceMachineIdResource",null),ve([M.memoize],d.prototype,"telemetryLogResource",null),ve([M.memoize],d.prototype,"disableWorkspaceTrust",null),ve([M.memoize],d.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=d;function b(h,p){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=b;function v(h,p){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,p,h.extensionEnvironment)}e.parsePtyHostPort=v;function y(h,p,w,a,f,m){const E=Number(p||h)||(a?null:w),D=E?Boolean(!!p):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:E,break:D,debugId:f,env:t}}}),define(Z[106],ee([0,1,287,4,158]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(w,a,f=C){const m=w.find(l=>l.length>0&&l[0]!=="-"),P={},E=["_"],D=[],t={};let c;for(const l in a){const s=a[l];s.type==="subcommand"?l===m&&(c=s):(s.alias&&(P[l]=s.alias),s.type==="string"||s.type==="string[]"?(E.push(l),s.deprecates&&E.push(...s.deprecates)):s.type==="boolean"&&(D.push(l),s.deprecates&&D.push(...s.deprecates)),s.global&&(t[l]=s))}if(c&&m){const l=t;for(const A in c.options)l[A]=c.options[A];const s=w.filter(A=>A!==m),u=f.getSubcommandReporter?f.getSubcommandReporter(m):void 0,I=k(s,l,u);return{[m]:I,_:[]}}const i=S(w,{string:E,boolean:D,alias:P}),r={},o=i;r._=i._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(const l in a){const s=a[l];if(s.type==="subcommand")continue;s.alias&&delete o[s.alias];let u=o[l];if(s.deprecates)for(const I of s.deprecates)o.hasOwnProperty(I)&&(u||(u=o[I],u&&f.onDeprecatedOption(I,s.deprecationMessage||(0,n.localize)(36,null,l))),delete o[I]);if(typeof u<"u"){if(s.type==="string[]"){if(Array.isArray(u)||(u=[u]),!s.allowEmptyValue){const I=u.filter(A=>A.length>0);I.length!==u.length&&(f.onEmptyValue(l),u=I.length>0?I:void 0)}}else s.type==="string"&&(Array.isArray(u)?(u=u.pop(),f.onMultipleValues(l,u)):!u&&!s.allowEmptyValue&&(f.onEmptyValue(l),u=void 0));r[l]=u,s.deprecationMessage&&f.onDeprecatedOption(l,s.deprecationMessage)}delete o[l]}for(const l in o)f.onUnknownOption(l);return r}e.parseArgs=k;function g(w,a){let f="";return a.args&&(Array.isArray(a.args)?f=` <${a.args.join("> <")}>`:f=` <${a.args}>`),a.alias?`-${a.alias} --${w}${f}`:`--${w}${f}`}function d(w,a){const f=[];for(const m in w){const P=w[m],E=g(m,P);f.push([E,P.description])}return b(f,a)}e.formatOptions=d;function b(w,a){const m=w.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(a-m<25)return w.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const P=a-m-1,E=[];for(const D of w){const t=D[0],c=y(D[1],P),i=v(m-t.length-2);E.push("  "+t+i+c[0]);for(let r=1;r<c.length;r++)E.push(v(m)+c[r])}return E}function v(w){return" ".repeat(w)}function y(w,a){const f=[];for(;w.length;){const m=w.length<a?w.length:w.lastIndexOf(" ",a),P=w.slice(0,m).trim();w=w.slice(m),f.push(P)}return f}function h(w,a,f,m,P){const E=process.stdout.isTTY&&process.stdout.columns||80,D=P?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${w} ${f}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${a} [${(0,n.localize)(39,null)}]${D}`),t.push(""),P?.noPipe!==!0&&(M.isWindows?t.push((0,n.localize)(40,null,a)):t.push((0,n.localize)(41,null,a)),t.push(""));const c={},i=[];for(const r in m){const o=m[r];if(o.type==="subcommand")o.description&&i.push({command:r,description:o.description});else if(o.description&&o.cat){let l=c[o.cat];l||(c[o.cat]=l={}),l[r]=o}}for(const r in c){const o=r,l=c[o];l&&(t.push(R[o]),t.push(...d(l,E)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...b(i.map(r=>[r.command,r.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=h;function p(w,a){return`${w||(0,n.localize)(43,null)}
${a||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[187],ee([0,1,81,185,106]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends M.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,g,d){return g==="openExtensionDevelopmentHostWindow"?this.g(d[0],d[1]):super.call(k,g,d)}async g(k,g){const d=(0,n.parseArgs)(k,n.OPTIONS);d.debugRenderer=g;const b=d.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!g)return{success:!0};const y=v.win;if(!y)return{success:!0};const h=y.webContents.debugger;let p=h.isAttached()?1/0:0;const w=(0,S.createServer)(a=>{p++===0&&h.attach();let f=!1;const m=D=>{f||a.write(JSON.stringify(D)+"\0")},P=(D,t,c,i)=>m({method:t,params:c,sessionId:i});y.on("close",()=>{h.removeListener("message",P),a.end(),f=!0}),h.addListener("message",P);let E=Buffer.alloc(0);a.on("data",D=>{E=Buffer.concat([E,D]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let c;try{const i=E.slice(0,t).toString("utf8");E=E.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(c.method,c.params,c.sessionId).then(i=>m({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>m({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),a.on("error",D=>{console.error("error on cdp pipe:",D)}),a.on("close",()=>{f=!0,--p===0&&h.detach()})});return await new Promise(a=>w.listen(0,a)),y.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[61],ee([0,1,288,159,106]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function C(y,h){const p=(E,D)=>{console.warn((0,M.localize)(0,null,E,D))},w=E=>{console.warn((0,M.localize)(1,null,E))},a=(E,D)=>{console.warn((0,M.localize)(2,null,E,D))},f=E=>({onUnknownOption:D=>{E!=="tunnel"&&console.warn((0,M.localize)(3,null,D,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:a,getSubcommandReporter:E!=="tunnel"?f:void 0}),m={onUnknownOption:E=>{console.warn((0,M.localize)(4,null,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:a,getSubcommandReporter:f},P=(0,n.parseArgs)(y,n.OPTIONS,h?m:void 0);return P.goto&&P._.forEach(E=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,M.localize)(5,null))),P["max-memory"]&&S(parseInt(P["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),P}function k(y){const h=y.findIndex(p=>!/^-/.test(p));if(h>-1)return[...y.slice(0,h),...y.slice(h+1)]}function g(y){let[,...h]=y;process.env.VSCODE_DEV&&(h=k(h)||[]);const p=!v(process.env);return C(h,p)}e.parseMainProcessArgv=g;function d(y){let[,,...h]=y;return process.env.VSCODE_DEV&&(h=k(h)||[]),C(h,!0)}e.parseCLIProcessArgv=d;function b(y,...h){const p=y.indexOf("--");return p===-1?y.push(...h):y.splice(p,0,...h),y}e.addArg=b;function v(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function x(e,S,M){function n(C,k){const g=R(C,k),d=[g];return e.isAbsolute(g)||d.unshift(M),e.resolve(...d)}function R(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,k);const b=C["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(S.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,k)}return{getUserDataPath:n}}if(typeof define=="function")define(Z[188],ee([189,26,36]),function(e,S,M){return x(e,S,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=x(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[190],ee([0,1,26,186,188]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends M.AbstractNativeEnvironmentService{constructor(k,g){super(k,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,n.getUserDataPath)(k,g.nameShort)},g)}}e.NativeEnvironmentService=R}),define(Z[191],ee([0,1,41,26,32]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(C){const k=(0,n.randomPath)((0,M.tmpdir)());try{return(0,S.writeFileSync)(k,""),C&&console.log(`Marker file for --wait created: ${k}`),k}catch(g){C&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=R}),define(Z[192],ee([0,1,10,161]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(C,k,g){try{R(C,k,g)}catch(d){console.error(d?.message??d)}return C}e.localizeManifest=n;function R(C,k,g){const d=(b,v,y)=>{const h=b[v];if((0,S.isString)(h)){const p=h,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const a=p.substr(1,w-2);let f=k[a];f===void 0&&g&&(f=g[a]);const m=typeof f=="string"?f:f?.message,P=g?.[a],E=typeof P=="string"?P:P?.message;if(!m){E||console.warn(`[${C.name}]: ${(0,M.localize)(0,null,a)}`);return}if(y&&(v==="title"||v==="category")&&E&&E!==m){const D={value:m,original:E};b[v]=D}else b[v]=m}}else if((0,S.isObject)(h))for(const p in h)h.hasOwnProperty(p)&&(p==="commands"?d(h,p,!0):d(h,p,y));else if(Array.isArray(h))for(let p=0;p<h.length;p++)d(h,p,y)};for(const b in C)C.hasOwnProperty(b)&&d(C,b)}}),define(Z[193],ee([0,1,13]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class M{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const k=this.a.get(C);if(!k)continue;const g=R.contributes[C],d=Array.isArray(g)?g:[g];try{k(d,R.activationEvents)}catch(b){(0,S.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=M,e.ImplicitActivationEvents=new M}),define(Z[194],ee([0,1,18,72,163,195]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=g;function d(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=f.match(C);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=d;function b(f){if(!f)return null;const m=f.majorBase,P=f.majorMustEqual,E=f.minorBase;let D=f.minorMustEqual;const t=f.patchBase;let c=f.patchMustEqual;f.hasCaret&&(m===0||(D=!1),c=!1);let i=0;if(f.preRelease){const r=k.exec(f.preRelease);if(r){const[,o,l,s]=r;i=Date.UTC(Number(o),Number(l)-1,Number(s))}}return{majorBase:m,majorMustEqual:P,minorBase:E,minorMustEqual:D,patchBase:t,patchMustEqual:c,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function v(f,m,P){let E;typeof f=="string"?E=b(d(f)):E=f;let D;m instanceof Date?D=m.getTime():typeof m=="string"&&(D=new Date(m).getTime());let t;if(typeof P=="string"?t=b(d(P)):t=P,!E||!t)return!1;const c=E.majorBase,i=E.minorBase,r=E.patchBase;let o=t.majorBase,l=t.minorBase,s=t.patchBase;const u=t.notBefore;let I=t.majorMustEqual,A=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>l?!0:i<l||D&&D<u?!1:r>=s:(c===1&&o===0&&(!I||!A||!T)&&(o=1,l=0,s=0,I=!0,A=!1,T=!1),c<o?!1:c>o?!I:i<l?!1:i>l?!A:r<s?!1:r>s?!T:!(D&&D<u))}e.isValidVersion=v;function y(f,m,P,E,D){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([M.default.Error,n.localize(0,null)]),t;if(typeof E.name!="string")return t.push([M.default.Error,n.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([M.default.Error,n.localize(2,null,"version")]),t;if(!E.engines)return t.push([M.default.Error,n.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([M.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!a(E.extensionDependencies))return t.push([M.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!a(E.activationEvents))return t.push([M.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([M.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([M.default.Warning,n.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([M.default.Error,n.localize(9,null,"main")]),t;{const r=(0,S.joinPath)(P,E.main);(0,S.isEqualOrParent)(r,P)||t.push([M.default.Warning,n.localize(10,null,r.path,P.path)])}if(typeof E.activationEvents>"u")return t.push([M.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([M.default.Error,n.localize(12,null,"browser")]),t;{const r=(0,S.joinPath)(P,E.browser);(0,S.isEqualOrParent)(r,P)||t.push([M.default.Warning,n.localize(13,null,r.path,P.path)])}if(typeof E.activationEvents>"u")return t.push([M.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(E.version))return t.push([M.default.Error,n.localize(15,null)]),t;const c=[];if(!h(f,m,E,D,c))for(const r of c)t.push([M.default.Error,r]);return t}e.validateExtensionManifest=y;function h(f,m,P,E,D){return E||typeof P.main>"u"&&typeof P.browser>"u"?!0:w(f,m,P.engines.vscode,D)}e.isValidExtensionVersion=h;function p(f,m,P){return f==="*"||w(m,P,f)}e.isEngineValid=p;function w(f,m,P,E=[]){const D=b(d(P));if(!D)return E.push(n.localize(16,null,P)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return E.push(n.localize(17,null,P)),!1}else if(!D.majorMustEqual)return E.push(n.localize(18,null,P)),!1;return v(f,m,D)?!0:(E.push(n.localize(19,null,f,P)),!1)}function a(f){if(!Array.isArray(f))return!1;for(let m=0,P=f.length;m<P;m++)if(typeof f[m]!="string")return!1;return!0}}),define(Z[196],ee([0,1,17,31]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(R,C,k){let g=k&&k.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await C.readFile(R.serviceMachineIdResource)).value.toString();g=(0,M.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,M.generateUuid)();try{await C.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(g))}catch{}}return k?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=n}),define(Z[73],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(n,R=[],C=!1){this.ctor=n,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=S}),define(Z[197],ee([0,1,73]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var n;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function R(k,g,d){g instanceof S.SyncDescriptor||(g=new S.SyncDescriptor(g,[],Boolean(d))),M.push([k,g])}e.registerSingleton=R;function C(){return M}e.getSingletonServiceDescriptors=C}),define(Z[198],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const k=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(C);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let k=this.a.get(C);return k||(k=new S(C,R),this.a.set(C,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,k]of this.a)R.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const k=new Set([R]),g=this.c(C,k);if(g)return g}}c(R,C){for(const[k,g]of R.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const d=this.c(g,C);if(d)return d;C.delete(k)}}}e.Graph=M}),define(Z[6],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(g){return g[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(S=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function M(C,k,g){k[S.DI_TARGET]===k?k[S.DI_DEPENDENCIES].push({id:C,index:g}):(k[S.DI_DEPENDENCIES]=[{id:C,index:g}],k[S.DI_TARGET]=k)}function n(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const k=function(g,d,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(k,g,b)};return k.toString=()=>C,S.serviceIds.set(C,k),k}e.createDecorator=n;function R(C){return C}e.refineServiceDecorator=R}),define(Z[62],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,10,7,6]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationOverrides=R;function C(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function d(a,f){const m=Object.create(null);for(const P in a)b(m,P,a[P],f);return m}e.toValuesTree=d;function b(a,f,m,P){const E=f.split("."),D=E.pop();let t=a;for(let c=0;c<E.length;c++){const i=E[c];let r=t[i];switch(typeof r){case"undefined":r=t[i]=Object.create(null);break;case"object":break;default:P(`Ignoring ${f} as ${E.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}t=r}if(typeof t=="object"&&t!==null)try{t[D]=m}catch{P(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(t)}`)}else P(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function v(a,f){const m=f.split(".");y(a,m)}e.removeFromValueTree=v;function y(a,f){const m=f.shift();if(f.length===0){delete a[m];return}if(Object.keys(a).indexOf(m)!==-1){const P=a[m];typeof P=="object"&&!Array.isArray(P)&&(y(P,f),Object.keys(P).length===0&&delete a[m])}}function h(a,f,m){function P(t,c){let i=t;for(const r of c){if(typeof i!="object"||i===null)return;i=i[r]}return i}const E=f.split("."),D=P(a,E);return typeof D>"u"?m:D}e.getConfigurationValue=h;function p(a,f,m){Object.keys(f).forEach(P=>{P!=="__proto__"&&(P in a?S.isObject(a[P])&&S.isObject(f[P])?p(a[P],f[P],m):m&&(a[P]=f[P]):a[P]=f[P])})}e.merge=p;function w(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(Z[74],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class M{constructor(){this.a={}}async getPassword(R,C){return this.a[R]?.[C]??null}async setPassword(R,C,k){this.a[R]=this.a[R]??{},this.a[R][C]=k}async deletePassword(R,C){return this.a[R]?.[C]?(delete this.a[R][C],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const C=[];for(const k of Object.keys(this.a[R]||{}))C.push({account:k,password:this.a[R][k]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=M}),define(Z[87],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function M(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=M;class n{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=n}),define(Z[88],ee([0,1,18,72,156,6,45,4,40]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var d;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(d||(d={}));class b{a(a){return this.d(a,d.Confirmation)}b(a){return this.d(a,d.Prompt)}c(a){return this.d(a,d.Input)}d(a,f){const m=[];switch(f){case d.Confirmation:{const P=a;P.primaryButton?m.push(P.primaryButton):m.push((0,n.localize)(0,null)),P.cancelButton?m.push(P.cancelButton):m.push((0,n.localize)(1,null));break}case d.Prompt:{const P=a;Array.isArray(P.buttons)&&P.buttons.length>0&&m.push(...P.buttons.map(E=>E.label)),P.cancelButton&&(P.cancelButton===!0?m.push((0,n.localize)(2,null)):typeof P.cancelButton=="string"?m.push(P.cancelButton):P.cancelButton.label?m.push(P.cancelButton.label):m.push((0,n.localize)(3,null))),m.length===0&&m.push((0,n.localize)(4,null));break}case d.Input:{const P=a;P.primaryButton?m.push(P.primaryButton):m.push((0,n.localize)(5,null)),P.cancelButton?m.push(P.cancelButton):m.push((0,n.localize)(6,null));break}}return m}e(a){if(typeof a=="string")return a;if(typeof a=="number")return a===M.default.Info?"info":a===M.default.Error?"error":a===M.default.Warning?"warning":"none"}async f(a,f,m){const P=[...a.buttons??[]];return a.cancelButton&&typeof a.cancelButton!="string"&&typeof a.cancelButton!="boolean"&&P.push(a.cancelButton),{result:await P[f]?.run({checkboxChecked:m}),checkboxChecked:m}}}e.AbstractDialogHandler=b,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v=e.ConfirmResult||(e.ConfirmResult={}));const y=10;function h(w){const a=[];return a.push(...w.slice(0,y).map(f=>typeof f=="string"?f:(0,S.basename)(f))),w.length>y&&(w.length-y===1?a.push((0,n.localize)(7,null)):a.push((0,n.localize)(8,null,w.length-y))),a.push(""),a.join(`
`)}e.getFileNamesMessage=h;function p(w,a){const f=(0,g.deepClone)(w);let m=(f.buttons??[]).map(t=>(0,C.mnemonicButtonLabel)(t)),P=(w.buttons||[]).map((t,c)=>c),E=0,D=f.cancelId??m.length-1;if(m.length>1){const t=typeof D=="number"?m[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&m.length>1&&D!==1){m.splice(D,1),m.splice(1,0,t);const c=P[D];P.splice(D,1),P.splice(1,0,c),D=1}k.isLinux&&m.length>1&&(m=m.reverse(),P=P.reverse(),E=m.length-1,typeof t=="string"&&(D=E-1))}else if(k.isWindows&&typeof t=="string"&&m.length>1&&D!==m.length-1){m.splice(D,1),m.push(t);const c=P[D];P.splice(D,1),P.push(c),D=m.length-1}}return f.buttons=m,f.defaultId=E,f.cancelId=D,f.noLink=!0,f.title=f.title||a.nameLong,{options:f,buttonIndeces:P}}e.massageMessageBoxOptions=p}),define(Z[107],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(Z[33],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],ee([0,1,54,9,86,33,190,6]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(R.IEnvironmentService);class g extends C.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([S.memoize],g.prototype,"cachedLanguagesPath",null),ve([S.memoize],g.prototype,"backupHome",null),ve([S.memoize],g.prototype,"mainIPCHandle",null),ve([S.memoize],g.prototype,"mainLockfile",null),ve([S.memoize],g.prototype,"disableUpdates",null),ve([S.memoize],g.prototype,"disableKeytar",null),ve([S.memoize],g.prototype,"crossOriginIsolated",null),ve([S.memoize],g.prototype,"codeCachePath",null),ve([S.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(Z[108],ee([0,1,160,6]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(f,m){switch(f){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function k(f,m){return m==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function g(f,m,P){return k(m,P)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===P?!0:d(P).includes(f)}e.isTargetPlatformCompatible=g;function d(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var v;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var y;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var h;(function(f){f.Install="install",f.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var p;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(m,P){super(m),this.code=P,this.name=P}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,S.localize)(1,null),original:"Preferences"}}),define(Z[199],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(Z[200],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[109],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(Z[201],ee([0,1,46,14,9,4,82,23,85,164,109]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=d.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{openTerminal(E,D){return this.spawnTerminal(S,E,g.getWindowsShell(),D)}spawnTerminal(E,D,t,c){const i=D.windowsExec||h.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const r=n.basename(i,".exe").toLowerCase();if(r==="cmder")return E.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),r==="wt"&&o.push("-d ."),new Promise((l,s)=>{const u=a(process),I=E.spawn(t,o,{cwd:c,env:u});I.on("error",s),I.on("exit",()=>l())})}runInTerminal(E,D,t,c,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((o,l)=>{const s=`"${D} - ${v}"`,u=`""${t.join('" "')}" & pause"`,I=Object.assign({},a(process),c);Object.keys(I).filter(H=>I[H]===null).forEach(H=>delete I[H]);const A={cwd:D,env:I,windowsVerbatimArguments:!0};let T,N;n.basename(r,".exe")==="wt"?(T=r,N=["-d",".",h.b,"/c",u]):(T=h.b,N=["/c","start",s,"/wait",r,"/c",u]),S.spawn(T,N,A).on("error",H=>{l(f(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return h.d}}h.b="cmd.exe",e.WindowsExternalTerminalService=h;class p extends y{openTerminal(E,D){return this.spawnTerminal(S,E,D)}runInTerminal(E,D,t,c,i){const r=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{if(r===b.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const s=r===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",I=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",E||v,"-w",D];for(const N of t)I.push("-a"),I.push(N);if(c){const N=Object.assign({},a(process),c);for(const z in N){const H=N[z];H===null?(I.push("-u"),I.push(z)):(I.push("-e"),I.push(`${z}=${H}`))}}let A="";const T=S.spawn(p.b,I);T.on("error",N=>{l(f(N))}),T.stderr.on("data",N=>{A+=N.toString()}),T.on("exit",N=>{if(N===0)o(void 0);else if(A){const z=A.split(`
`,1);l(new Error(z[0]))}else l(new Error(d.localize(1,null,s,N)))})}else l(new Error(d.localize(2,null,r)))})}spawnTerminal(E,D,t){const c=D.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const o=["-a",c];t&&o.push(t);const l=a(process),s=E.spawn("/usr/bin/open",o,{cwd:t,env:l});s.on("error",r),s.on("exit",()=>i())})}}p.b="/usr/bin/osascript",e.MacExternalTerminalService=p;class w extends y{openTerminal(E,D){return this.spawnTerminal(S,E,D)}runInTerminal(E,D,t,c,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{const s=[];r.then(u=>{u.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const I=`${m(t)}; echo; read -p "${w.b}" -n1;`;s.push(`''${I}''`);const A=Object.assign({},a(process),c);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const T={cwd:D,env:A};let N="";const z=S.spawn(u,s,T);z.on("error",H=>{l(f(H))}),z.stderr.on("data",H=>{N+=H.toString()}),z.on("exit",H=>{if(H===0)o(void 0);else if(N){const ie=N.split(`
`,1);l(new Error(ie[0]))}else l(new Error(d.localize(4,null,u,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!R.isLinux)w.d=Promise.resolve("xterm");else{const E=await k.Promises.exists("/etc/debian_version");w.d=new Promise(D=>{E?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return w.d}spawnTerminal(E,D,t){const c=D.linuxExec?Promise.resolve(D.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{c.then(o=>{const l=a(process),s=E.spawn(o,[],{cwd:t,env:l});s.on("error",r),s.on("exit",()=>i())})})}}w.b=d.localize(3,null),e.LinuxExternalTerminalService=w;function a(P){const E={...P.env};return(0,C.sanitizeProcessEnvironment)(E),E}function f(P){return"errno"in P&&P.errno==="ENOENT"&&"path"in P&&typeof P.path=="string"?new Error(d.localize(5,null,P.path)):P}function m(P){let E="";for(const D of P)D.indexOf(" ")>=0?E+='"'+D+'"':E+=D,E+=" ";return E}}),define(Z[16],ee([0,1,60,9,27,10,7,166,6,4,14]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function v(O){return O.create===!0}e.isFileOpenForWriteOptions=v;var y;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var h;(function(O){O[O.Readonly=1]="Readonly"})(h=e.FilePermission||(e.FilePermission={}));var p;(function(O){O[O.None=0]="None",O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock",O[O.FileAtomicRead=16384]="FileAtomicRead",O[O.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=w;function a(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=a;function f(O){return!!(O.capabilities&32768)}e.hasFileCloneCapability=f;function m(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function P(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=P;function E(O){return w(O)?!!(O.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var D;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(q,J){const te=new t(q.toString(),J);return r(te,J),te}constructor(q,J){super(q),this.code=J}}e.FileSystemProviderError=t;function c(O,q){return t.create(O,q)}e.createFileSystemProviderError=c;function i(O){return O||c((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function r(O,q){return O.name=q?`${q} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=r;function o(O){if(!O)return D.Unknown;if(O instanceof t)return O.code;const q=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!q)return D.Unknown;switch(q[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function l(O){if(O instanceof N)return O.fileOperationResult;switch(o(O)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var s;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY",O[O.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(q,J,te){this.resource=q,this.operation=J,this.target=te}isOperation(q){return this.operation===q}}e.FileOperationEvent=u;var I;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(I=e.FileChangeType||(e.FileChangeType={}));class A{constructor(q,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of q){const L=te.get(ne.type);switch(L?L.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,L]of te)switch(ne){case 1:this.a=S.TernarySearchTree.forUris(()=>J),this.a.fill(L);break;case 0:this.b=S.TernarySearchTree.forUris(()=>J),this.b.fill(L);break;case 2:this.c=S.TernarySearchTree.forUris(()=>J),this.c.fill(L);break}}contains(q,...J){return this.d(q,{includeChildren:!1},...J)}affects(q,...J){return this.d(q,{includeChildren:!0},...J)}d(q,J,...te){if(!q)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.a?.get(q)||J.includeChildren&&this.a?.findSuperstr(q))||(!ne||te.includes(0))&&(this.b?.get(q)||J.includeChildren&&this.b?.findSuperstr(q))||(!ne||te.includes(2))&&(this.c?.findSubstr(q)||J.includeChildren&&this.c?.findSuperstr(q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=A;function T(O,q,J){return!O||!q||O===q||q.length>O.length?!1:(q.charAt(q.length-1)!==M.sep&&(q+=M.sep),J?(0,n.startsWithIgnoreCase)(O,q):O.indexOf(q)===0)}e.isParent=T;class N extends Error{constructor(q,J,te){super(q),this.fileOperationResult=J,this.options=te}}e.FileOperationError=N;class z extends N{constructor(q,J,te,ne){super(q,J,ne),this.fileOperationResult=J,this.size=te}}e.TooLargeFileOperationError=z;class H extends N{constructor(q,J,te){super(q,2,te),this.stat=J}}e.NotModifiedSinceFileOperationError=H;var ie;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function oe(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=oe;async function ue(O,q){if(!q.hasProvider(C.URI.from({scheme:O.scheme})))return new Promise(J=>{const te=q.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===O.scheme&&ne.added&&(te.dispose(),J())})})}e.whenProviderRegistered=ue,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(q){return(0,R.isNumber)(q)||(q=0),q<le.KB?(0,k.localize)(1,null,q.toFixed(0)):q<le.MB?(0,k.localize)(2,null,(q/le.KB).toFixed(2)):q<le.GB?(0,k.localize)(3,null,(q/le.MB).toFixed(2)):q<le.TB?(0,k.localize)(4,null,(q/le.GB).toFixed(2)):(0,k.localize)(5,null,(q/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var me;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function G(O){return{maxFileSize:O===0?300*le.MB:16*le.GB,maxHeapSize:O===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=G;function B(O){const q=typeof O=="string"||O?.scheme===b.Schemas.vscodeRemote;return typeof O!="string"&&O?.scheme===b.Schemas.file?1024*le.MB:q?10*le.MB:d.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=B}),define(Z[202],ee([0,1,17,44,13,3,2,59,7,31,16]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends C.Disposable{constructor(h,p){super(),this.a=h,this.b=p,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,d.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,p){const{buffer:w}=await this.a.call("readFile",[h,p]);return w}readFileStream(h,p,w){const a=(0,k.newWriteableStream)(m=>S.VSBuffer.concat(m.map(P=>S.VSBuffer.wrap(P))).buffer),f=this.a.listen("readFileStream",[h,p])(m=>{if(m instanceof S.VSBuffer)a.write(m.buffer);else{if(m==="end")a.end();else{let P;if(m instanceof Error)P=m;else{const E=m;P=(0,b.createFileSystemProviderError)(E.message??(0,M.toErrorMessage)(E),E.code??b.FileSystemProviderErrorCode.Unknown)}a.error(P),a.end()}f.dispose()}});return w.onCancellationRequested(()=>{a.error((0,n.canceled)()),a.end(),f.dispose()}),a}writeFile(h,p,w){return this.a.call("writeFile",[h,S.VSBuffer.wrap(p),w])}open(h,p){return this.a.call("open",[h,p])}close(h){return this.a.call("close",[h])}async read(h,p,w,a,f){const[m,P]=await this.a.call("read",[h,p,f]);return w.set(m.buffer.slice(0,P),a),P}write(h,p,w,a,f){return this.a.call("write",[h,p,S.VSBuffer.wrap(w),a,f])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,p){return this.a.call("delete",[h,p])}rename(h,p,w){return this.a.call("rename",[h,p,w])}copy(h,p,w){return this.a.call("copy",[h,p,w])}cloneFile(h,p){return this.a.call("cloneFile",[h,p])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const p=h;this.f.fire(p.map(w=>({resource:g.URI.revive(w.resource),type:w.type})))}else{const p=h;this.g.fire(p)}}))}watch(h,p){const w=(0,d.generateUuid)();return this.a.call("watch",[this.h,w,h,p]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(Z[110],ee([0,1,17,13,167,16]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(b,v,y,h,p,w){let a;try{await k(b,v,y,h,p,w)}catch(f){a=f}finally{a&&p.errorTransformer&&(a=p.errorTransformer(a)),typeof a<"u"&&y.error(a),y.end()}}e.readFileIntoStream=C;async function k(b,v,y,h,p,w){g(w);const a=await b.open(v,{create:!1});try{g(w);let f=0,m=0,P=p&&typeof p.length=="number"?p.length:void 0,E=S.VSBuffer.alloc(Math.min(p.bufferSize,typeof P=="number"?P:p.bufferSize)),D=p&&typeof p.position=="number"?p.position:0,t=0;do m=await b.read(a,D,E.buffer,t,E.byteLength-t),D+=m,t+=m,f+=m,typeof P=="number"&&(P-=m),t===E.byteLength&&(await y.write(h(E)),E=S.VSBuffer.alloc(Math.min(p.bufferSize,typeof P=="number"?P:p.bufferSize)),t=0);while(m>0&&(typeof P!="number"||P>0)&&g(w)&&d(f,p));if(t>0){let c=t;typeof P=="number"&&(c=Math.min(t,P)),y.write(h(E.slice(0,c)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await b.close(a)}}function g(b){if(b.isCancellationRequested)throw(0,M.canceled)();return!0}function d(b,v){if(v?.limits){if(typeof v.limits.memory=="number"&&b>v.limits.memory)throw(0,R.createFileSystemProviderError)((0,n.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&b>v.limits.size)throw(0,R.createFileSystemProviderError)((0,n.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[75],ee([0,1,100,2,9,4,7,16]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(f){return f.recursive===!0}e.isRecursiveWatchRequest=g;class d extends M.Disposable{constructor(m,P,E,D){super(),this.h=m,this.i=P,this.j=E,this.k=D,this.c=this.B(new M.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new M.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(P=>this.h(P))),m.add(this.b.onDidLogMessage(P=>this.i(P))),m.add(this.b.onDidError(P=>this.n(P)))}n(m){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}d.a=5,e.AbstractWatcherClient=d;class b extends d{constructor(m,P,E){super(m,P,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class v extends d{constructor(m,P,E){super(m,P,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function y(f){return f.map(m=>({type:m.type,resource:C.URI.file(m.path)}))}e.toFileChanges=y;function h(f){const m=new a;for(const P of f)m.processEvent(P);return m.coalesce()}e.coalesceEvents=h;function p(f,m){return typeof m=="string"&&!m.startsWith(S.GLOBSTAR)&&!(0,n.isAbsolute)(m)?{base:f,pattern:m}:m}e.normalizeWatcherPattern=p;function w(f,m){const P=[];for(const E of m)P.push((0,S.parse)(p(f,E)));return P}e.parseWatcherPatterns=w;class a{constructor(){this.a=new Set,this.b=new Map}c(m){return R.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const P=this.b.get(this.c(m));let E=!1;if(P){const D=P.type,t=m.type;P.path!==m.path&&(m.type===2||m.type===1)?E=!0:D===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(P)):D===2&&t===1?P.type=0:D===1&&t===0||(P.type=t)}else E=!0;E&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],P=[];return Array.from(this.a).filter(E=>E.type!==2?(m.push(E),!1):!0).sort((E,D)=>E.path.length-D.path.length).filter(E=>P.some(D=>(0,k.isParent)(E.path,D,!R.isLinux))?!1:(P.push(E.path),!0)).concat(m)}}}),define(Z[203],ee([0,1,41,8,22,32,2,79,9,4,101,23,75]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends C.Disposable{constructor(a,f,m,P){super(),this.j=a,this.k=f,this.l=m,this.m=P,this.c=this.B(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new M.RunOnceWorker(E=>this.u(E),h.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const f=await v.Promises.stat(a);this.B(await this.s(a,f.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let f=a.path;try{f=await v.Promises.realpath(a.path),a.path===f&&(f=await(0,b.realcase)(a.path)??a.path),a.path!==f&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${f})`)}catch{}return f}async s(a,f){if(d.isMacintosh&&(0,R.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const m=new n.CancellationTokenSource(this.i.token),P=new C.DisposableStore;try{const E=(0,g.basename)(a),D=(0,S.watch)(a);P.add((0,C.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${a}'`);const t=new Set;if(f)try{for(const i of await v.Promises.readdir(a))t.add(i)}catch(i){this.w(i)}const c=new Map;P.add((0,C.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),D.on("error",(i,r)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),D.on("change",(i,r)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${r}`);let o="";if(r&&(o=r.toString(),d.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(f)if(i==="rename"){c.get(o)?.dispose();const l=setTimeout(async()=>{if(c.delete(o),o===E&&!await v.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,g.join)(a,o));if(m.token.isCancellationRequested)return;let u;s?t.has(o)?u=0:(u=1,t.add(o)):(t.delete(o),u=2),this.t({path:(0,g.join)(this.j.path,o),type:u})},h.a);c.set(o,(0,C.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(o)?l=0:(l=1,t.add(o)),this.t({path:(0,g.join)(this.j.path,o),type:l})}else if(i==="rename"||o!==E){const l=setTimeout(async()=>{const s=await v.Promises.exists(a);m.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),P.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);P.clear(),P.add((0,C.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await v.Promises.exists(a)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${E.toString()})`)}return(0,C.toDisposable)(()=>{m.dispose(!0),P.dispose()})}t(a,f=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!f&&this.g.some(m=>m(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(m=>m(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const f=(0,y.coalesceEvents)(a);if(f.length>0){if(this.m)for(const P of f)this.z(`>> normalized ${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`);this.c.work(f)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(d.isLinux)return v.Promises.exists(a);try{const f=(0,g.basename)(a);return(await v.Promises.readdir((0,g.dirname)(a))).some(P=>P===f)}catch(f){return this.z(f),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}h.a=100,h.b=75,e.NodeJSFileWatcherLibrary=h;async function p(w,a,f,m,P=512){const E=await v.Promises.open(w,"r"),D=Buffer.allocUnsafe(P),t=new n.CancellationTokenSource(m);let c,i=!1;const r={path:w,excludes:[],recursive:!1},o=new h(r,l=>{(async()=>{for(const{type:s}of l)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:u}=await v.Promises.read(E,D,0,P,null);if(!u||t.token.isCancellationRequested)break;a(D.slice(0,u))}}catch(u){c=new Error(u),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,f(),new Promise((l,s)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await v.Promises.close(E)}catch(u){c=new Error(u)}c?s(c):l()})})}e.watchFileContents=p}),define(Z[204],ee([0,1,3,100,2,4,203]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new S.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new S.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(d){const b=this.i(d),v=b.filter(h=>{const p=this.c.get(h.path);return p?!(0,M.patternsEquals)(p.request.excludes,h.excludes)||!(0,M.patternsEquals)(p.request.includes,h.includes):!0}),y=Array.from(this.c.values()).filter(({request:h})=>!b.find(p=>p.path===h.path&&(0,M.patternsEquals)(p.excludes,h.excludes)&&(0,M.patternsEquals)(p.includes,h.includes))).map(({request:h})=>h.path);v.length&&this.j(`Request to start watching: ${v.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.h(h);for(const h of v)this.g(h)}g(d){const b=new C.NodeJSFileWatcherLibrary(d,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:d,instance:b};this.c.set(d.path,v)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const b=this.c.get(d);b&&(this.c.delete(d),b.instance.dispose())}i(d){const b=new Map;for(const v of d){const y=R.isLinux?v.path:v.path.toLowerCase();b.set(y,v)}return Array.from(b.values())}async setVerboseLogging(d){this.f=d;for(const[,b]of this.c)b.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,b){return b?`[File Watcher (node.js)] ${d} (path: ${b.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=k}),define(Z[205],ee([0,1,75,204]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends S.AbstractNonRecursiveWatcherClient{constructor(C,k,g){super(C,k,g),this.m()}l(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(Z[206],ee([0,1,14,47,152,75]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends R.AbstractUniversalWatcherClient{constructor(g,d,b){super(g,d,b),this.m()}l(g){const d=g.add(new n.Client(S.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(d.onDidProcessExit(({code:b,signal:v})=>this.n(`terminated by itself with code ${b}, signal: ${v}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(Z[89],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...n){this.a=new Map;for(const[R,C]of n)this.set(R,C)}set(n,R){const C=this.a.get(n);return this.a.set(n,R),C}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=S}),define(Z[207],ee([0,1,8,13,2,73,198,6,89,98]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class y{constructor(a=new g.ServiceCollection,f=!1,m,P=b){this.f=a,this.g=f,this.h=m,this.i=P,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=P?m?._globalGraph??new C.Graph(E=>E):void 0}createChild(a){return new y(a,this.g,this,this.i)}invokeFunction(a,...f){const m=p.traceInvocation(this.i,a);let P=!1;try{return a({get:D=>{if(P)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,m);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...f)}finally{P=!0,m.stop()}}createInstance(a,...f){let m,P;return a instanceof R.SyncDescriptor?(m=p.traceCreation(this.i,a.ctor),P=this.j(a.ctor,a.staticArguments.concat(f),m)):(m=p.traceCreation(this.i,a),P=this.j(a,f,m)),m.stop(),P}j(a,f=[],m){const P=k._util.getServiceDependencies(a).sort((t,c)=>t.index-c.index),E=[];for(const t of P){const c=this.m(t.id,m);c||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(c)}const D=P.length>0?P[0].index:f.length;if(f.length!==D){console.trace(`[createInstance] First service dependency of ${a.name} at position ${D+1} conflicts with ${f.length} static arguments`);const t=D-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,D)}return Reflect.construct(a,f.concat(E))}k(a,f){if(this.f.get(a)instanceof R.SyncDescriptor)this.f.set(a,f);else if(this.h)this.h.k(a,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const f=this.f.get(a);return!f&&this.h?this.h.l(a):f}m(a,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const m=this.l(a);return m instanceof R.SyncDescriptor?this.q(a,m,f.branch(a,!0)):(f.branch(a,!1),m)}q(a,f,m){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,f,m)}finally{this.o.delete(a)}}r(a,f,m){const P=new C.Graph(t=>t.id.toString());let E=0;const D=[{id:a,desc:f,_trace:m}];for(;D.length;){const t=D.pop();if(P.lookupOrInsertNode(t),E++>1e3)throw new v(P);for(const c of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof R.SyncDescriptor){const r={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};P.insertEdge(t,r),D.push(r)}}}for(;;){const t=P.roots();if(t.length===0){if(!P.isEmpty())throw new v(P);break}for(const{data:c}of t){if(this.l(c.id)instanceof R.SyncDescriptor){const r=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,r)}P.removeNode(c)}}return this.l(a)}s(a,f,m=[],P,E){if(this.f.get(a)instanceof R.SyncDescriptor)return this.t(a,f,m,P,E);if(this.h)return this.h.s(a,f,m,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(a,f,m=[],P,E){if(P){const D=new y(void 0,this.g,this,this.i);D.c=String(a);const t=new Map,c=new S.IdleValue(()=>{const i=D.j(f,m,E);for(const[r,o]of t){const l=i[r];if(typeof l=="function")for(const s of o)l.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!c.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let s=t.get(r);return s||(s=new d.LinkedList,t.set(r,s)),(I,A,T)=>{const N=s.push([I,A,T]);return(0,n.toDisposable)(N)}}if(r in i)return i[r];const o=c.value;let l=o[r];return typeof l!="function"||(l=l.bind(o),i[r]=l),l},set(i,r,o){return c.value[r]=o,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,m,E)}u(a,f){if(f&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=y;var h;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(h||(h={}));class p{static traceInvocation(a,f){return a?new p(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(a,f){return a?new p(1,f.name):p.c}constructor(a,f){this.type=a,this.name=f,this.g=Date.now(),this.h=[]}branch(a,f){const m=new p(3,a.toString());return this.h.push([a,f,m]),m}stop(){const a=Date.now()-this.g;p.f+=a;let f=!1;function m(E,D){const t=[],c=new Array(E+1).join("	");for(const[i,r,o]of D.h)if(r&&o){f=!0,t.push(`${c}CREATES -> ${i}`);const l=m(E+1,o);l&&t.push(l)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const P=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(a>2||f)&&p.all.add(P.join(`
`))}}p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0,e.Trace=p}),define(Z[5],ee([0,1,44,3,2,35,4,10,7,6]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function b(){return new Date().toISOString()}function v(s){return(0,k.isNumber)(s)}e.isLogLevel=v;var y;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function h(s,u,I){switch(u){case y.Trace:s.trace(I);break;case y.Debug:s.debug(I);break;case y.Info:s.info(I);break;case y.Warning:s.warn(I);break;case y.Error:s.error(I);break;case y.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=h;function p(s){let u="";for(let I=0;I<s.length;I++){let A=s[I];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}u+=(I>0?" ":"")+A}return u}e.format=p;class w extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new M.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==y.Off&&this.b<=u}}e.AbstractLogger=w;class a extends w{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...I){this.f(y.Trace)&&this.g(y.Trace,p([u,...I]))}debug(u,...I){this.f(y.Debug)&&this.g(y.Debug,p([u,...I]))}info(u,...I){this.f(y.Info)&&this.g(y.Info,p([u,...I]))}warn(u,...I){this.f(y.Warning)&&this.g(y.Warning,p([u,...I]))}error(u,...I){if(this.f(y.Error))if(u instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=u.stack,this.g(y.Error,p(A))}else this.g(y.Error,p([u,...I]))}flush(){}}e.AbstractMessageLogger=a;class f extends w{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u),this.g=!C.isWindows}trace(u,...I){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...I):console.log(`[main ${b()}]`,u,...I))}debug(u,...I){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...I):console.log(`[main ${b()}]`,u,...I))}info(u,...I){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...I):console.log(`[main ${b()}]`,u,...I))}warn(u,...I){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,u,...I):console.warn(`[main ${b()}]`,u,...I))}error(u,...I){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,u,...I):console.error(`[main ${b()}]`,u,...I))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class m extends w{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u)}trace(u,...I){this.f(y.Trace)&&console.log("%cTRACE","color: #888",u,...I)}debug(u,...I){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",u,...I)}info(u,...I){this.f(y.Info)&&console.log("%c INFO","color: #33f",u,...I)}warn(u,...I){this.f(y.Warning)&&console.log("%c WARN","color: #993",u,...I)}error(u,...I){this.f(y.Error)&&console.log("%c  ERR","color: #f33",u,...I)}dispose(){}flush(){}}e.ConsoleLogger=m;class P extends w{constructor(u,I=e.DEFAULT_LOG_LEVEL){super(),this.g=u,this.setLevel(I)}trace(u,...I){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(u),...I])}debug(u,...I){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(u),...I])}info(u,...I){this.f(y.Info)&&this.g.log(y.Info,[this.h(u),...I])}warn(u,...I){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(u),...I])}error(u,...I){this.f(y.Error)&&this.g.log(y.Error,[this.h(u),...I])}h(u){return typeof u=="string"?u:(0,S.toErrorMessage)(u,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=P;class E extends w{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const I of this.g)I.setLevel(u);super.setLevel(u)}trace(u,...I){for(const A of this.g)A.trace(u,...I)}debug(u,...I){for(const A of this.g)A.debug(u,...I)}info(u,...I){for(const A of this.g)A.info(u,...I)}warn(u,...I){for(const A of this.g)A.warn(u,...I)}error(u,...I){for(const A of this.g)A.error(u,...I)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.MultiplexLogger=E;class D extends n.Disposable{constructor(u,I){if(super(),this.j=u,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new M.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new M.Emitter),this.onDidChangeVisibility=this.h.event,I)for(const A of I)this.c.set(A.resource,A)}getLogger(u){return this.b.get(u)}createLogger(u,I){let A=this.b.get(u);const T=I?.logLevel==="always"?y.Trace:I?.logLevel;return A||(A=this.k(u,T??this.getLogLevel(u)??this.j,I),this.b.set(u,A)),this.registerLogger({resource:u,id:I?.id??u.toString(),logLevel:T,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId}),A}setLogLevel(u,I){if(g.URI.isUri(u)){const A=u,T=I,N=this.c.get(A);N&&T!==N.logLevel&&(N.logLevel=T===this.j?void 0:T,this.b.get(A)?.setLevel(T),this.c.set(N.resource,N),this.g.fire([A,T]))}else{this.j=u;for(const[A,T]of this.b.entries())this.c.get(A)?.logLevel===void 0&&T.setLevel(this.j);this.g.fire(this.j)}}setVisibility(u,I){const A=this.c.get(u);A&&I!==!A.hidden&&(A.hidden=!I,this.c.set(A.resource,A),this.h.fire([u,I]))}getLogLevel(u){let I;return u&&(I=this.c.get(u)?.logLevel),I??this.j}registerLogger(u){const I=this.c.get(u.resource);I?I.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.c.set(u.resource,u),this.f.fire({added:[u],removed:[]}))}deregisterLogger(u){const I=this.c.get(u);if(I){this.c.delete(u);const A=this.b.get(u);A&&(this.b.delete(u),A.dispose()),this.f.fire({added:[],removed:[I]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(u){return this.c.get(u)}dispose(){this.b.forEach(u=>u.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=D;class t{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(u){}getLevel(){return y.Info}trace(u,...I){}debug(u,...I){}info(u,...I){}warn(u,...I){}error(u,...I){}critical(u,...I){}dispose(){}flush(){}}e.NullLogger=t;class c extends t{}e.NullLogService=c;class i extends D{constructor(){super(y.Info)}k(u,I,A){return new t}}e.NullLoggerService=i;function r(s){if(s.verbose)return y.Trace;if(typeof s.logLevel=="string"){const u=l(s.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function o(s){switch(s){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=o;function l(s){switch(s){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=l});var Q=this&&this.__param||function(x,e){return function(S,M){e(S,M,x)}};define(Z[208],ee([0,1,74,3,2,5,4,8]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class ut extends n.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new M.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,v){this.g.trace("Getting password from keytar:",b,v);let y;try{y=await this.h()}catch{return null}const h=await(0,k.retry)(()=>y.getPassword(b,v),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",v),h;let p,w;try{const a=JSON.parse(h);p=a.content,w=a.hasNextChunk}catch{}if(!p||!w)return this.g.trace("Got password from keytar for account:",v),h;try{let a=1;for(;w;){const f=await(0,k.retry)(()=>y.getPassword(b,`${v}-${a}`),50,3),m=JSON.parse(f);p+=m.content,w=m.hasNextChunk,a++}return this.g.trace(`Got ${a}-chunked password from keytar for account:`,v),p}catch(a){return this.g.error(a),h}}async setPassword(b,v,y){this.g.trace("Setting password using keytar:",b,v);let h;try{h=await this.h()}catch(p){throw this.i?.(p),p}if(C.isWindows&&y.length>ut.a){let p=0,w=0,a=!0;for(;a;){const f=y.substring(p,p+ut.b);p+=ut.b,a=y.length-p>0;const m={content:f,hasNextChunk:a};await(0,k.retry)(()=>h.setPassword(b,w?`${v}-${w}`:v,JSON.stringify(m)),50,3),w++}this.g.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,v)}else await(0,k.retry)(()=>h.setPassword(b,v,y),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:b,account:v})}async deletePassword(b,v){this.g.trace("Deleting password using keytar:",b,v);let y;try{y=await this.h()}catch(f){throw this.i?.(f),f}const h=await y.getPassword(b,v);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let p,w;try{const f=JSON.parse(h);p=f.content,w=f.hasNextChunk}catch{}let a=0;if(p&&w)try{for(a++;w;){const f=`${v}-${a}`,m=await y.getPassword(b,f);await y.deletePassword(b,f),w=JSON.parse(m).hasNextChunk,a++}}catch(f){this.g.error(f)}return await y.deletePassword(b,v)?(this.c.fire({service:b,account:v}),this.g.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,v),!1)}async findPassword(b){let v;try{v=await this.h()}catch{return null}return await v.findPassword(b)}async findCredentials(b){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(b)}clear(){return this.f instanceof S.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};g.a=2500,g.b=g.a-100,g=ve([Q(0,R.ILogService)],g),e.BaseCredentialsMainService=g}),define(Z[209],ee([0,1,5]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=class{constructor(R,C){this.a=R,this.b=C}c(){return new Promise((R,C)=>x(["vscode-encrypt"],R,C))}async encrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.encrypt(this.a,R)}catch(k){return this.b.error(k),R}}async decrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.decrypt(this.a,R)}catch(k){return this.b.error(k),R}}};M=ve([Q(1,S.ILogService)],M),e.EncryptionMainService=M}),define(Z[210],ee([0,1,25,8,13,3,2,9,75,5]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends C.Disposable{constructor(y,h){super(),this.a=y,this.b=h,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.ThrottledDelayer(0)),this.s=[],this.t=this.B(new M.ThrottledDelayer(0))}watch(y,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(y,h):this.u(y,h)}l(y,h){const p={path:this.C(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive},w=(0,S.insert)(this.j,p);return this.m(),(0,C.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,n.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,g.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.j)(0,g.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.j)(0,g.isRecursiveWatchRequest)(h)&&y.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,h){const p={path:this.C(y),excludes:h.excludes,includes:h.includes,recursive:!1},w=(0,S.insert)(this.s,p);return this.v(),(0,C.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,n.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,g.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,k.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Z[211],ee([0,1,25,8,17,22,3,71,69,2,60,14,63,18,59,165,16,110,5,13]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends d.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const i=new d.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(r=>this.R.fire(new a.FileChangesEvent(r,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(r=>this.S.fire(new Error(r)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,d.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,d.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await M.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return g.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,h.isAbsolutePath)(t))throw new a.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new P.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c)||(0,a.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,a.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),r=this.O(i),o=c?.resolveTo,l=c?.resolveSingleChildDescendants,s=c?.resolveMetadata,u=await i.stat(t);let I;return this.p(i,t,u,void 0,!!s,(A,T)=>(I||(I=b.TernarySearchTree.forUris(()=>!r),I.set(t,!0),o&&I.fill(!0,o)),I.get(A.resource)||I.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&l?T===1:!1))}async p(t,c,i,r,o,l){const{providerExtUri:s}=this.N(t),u={resource:c,name:s.basename(c),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(u.isDirectory&&l(u,r)){try{const I=await t.readdir(c),A=await M.Promises.settled(I.map(async([T,N])=>{try{const z=s.joinPath(c,T),H=o?await t.stat(z):{type:N};return await this.p(t,z,H,I.length,o,l)}catch(z){return this.b.trace(z),null}}));u.children=(0,S.coalesce)(A)}catch(I){this.b.trace(I),u.children=[]}return u}return u}async resolveAll(t){return M.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(i){return i}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=n.VSBuffer.fromString(""),i){await this.r(t,i);const r=await this.writeFile(t,c);return this.m.fire(new a.FileOperationEvent(t,0,r)),r}async writeFile(t,c,i){const r=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(r);try{await this.s(r,t,i)||await this.P(r,o.dirname(t));let s;if((0,a.hasReadWriteCapability)(r)&&!(c instanceof n.VSBuffer))if((0,p.isReadableStream)(c)){const u=await(0,p.peekStream)(c,3);u.ended?s=n.VSBuffer.concat(u.buffer):s=u}else s=(0,p.peekReadable)(c,u=>n.VSBuffer.concat(u),3);else s=c;!(0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)&&s instanceof n.VSBuffer?await this.cb(r,t,i,s):await this.Y(r,t,i,s instanceof n.VSBuffer?(0,n.bufferToReadable)(s):s),this.m.fire(new a.FileOperationEvent(t,4))}catch(l){throw new a.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,a.ensureFileSystemProviderError)(l).toString()),(0,a.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(c)));let o;try{o=await t.stat(c)}catch{return}if((o.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,w.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:o.size}))throw new a.FileOperationError((0,w.localize)(7,null),3,i);return o}async readFile(t,c,i){const r=await this.k(t);return c?.atomic?this.t(r,t,c,i):this.u(r,t,c,i)}async t(t,c,i,r){return new Promise((o,l)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,c,i,r);o(s)}catch(s){l(s)}})})}async u(t,c,i,r){const o=await this.v(t,c,{...i,preferUnbuffered:!0},r);return{...o,value:await(0,n.streamToBuffer)(o.value)}}async readFileStream(t,c,i){const r=await this.k(t);return this.v(r,t,c,i)}async v(t,c,i,r){const o=new R.CancellationTokenSource(r),l=this.F(c,i).then(u=>u,u=>{throw o.cancel(),u});let s;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await l,i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,c,i):(0,a.hasFileReadStreamCapability)(t)?s=this.z(t,c,o.token,i):s=this.C(t,c,o.token,i),{...await l,value:s}}catch(u){throw s&&await(0,p.consumeStream)(s),this.w(u,c,i)}}w(t,c,i){const r=(0,w.localize)(8,null,this.nb(c),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new a.FileOperationError(r,(0,a.toFileOperationResult)(t),i)}z(t,c,i,r=Object.create(null)){const o=t.readFileStream(c,r,i);return(0,p.transform)(o,{data:l=>l instanceof n.VSBuffer?l:n.VSBuffer.wrap(l),error:l=>this.w(l,c,r)},l=>n.VSBuffer.concat(l))}C(t,c,i,r=Object.create(null)){const o=(0,n.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,c,o,l=>l,{...r,bufferSize:this.a,errorTransformer:l=>this.w(l,c,r)},i),o}D(t,c,i){const r=(0,p.newWriteableStream)(o=>n.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(c,o.byteLength,i),r.end(n.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==a.ETAG_DISABLED&&c.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let r;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(r=9),typeof i.limits.size=="number"&&c>i.limits.size&&(r=7),typeof r=="number")throw new a.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),r,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,r){if(t.toString()!==c.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(c),c);await this.M(o,t,l,c,i,r)}catch(o){return o}return!0}async move(t,c,i){const r=this.lb(await this.l(t),t),o=this.lb(await this.l(c),c),l=await this.I(r,t,o,c,"move",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="move"?2:3,s)),s}async copy(t,c,i){const r=await this.k(t),o=this.lb(await this.l(c),c),l=await this.I(r,t,o,c,"copy",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="copy"?3:2,s)),s}async I(t,c,i,r,o,l){if(c.toString()===r.toString())return o;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.M(t,c,i,r,o,l);if(s&&!u&&l&&await this.del(r,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(r)),o==="copy"){if(t===i&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(c,r,{overwrite:l});else{const I=await this.resolve(c);I.isDirectory?await this.L(t,I,i,r):await this.J(t,c,i,r)}return o}else return t===i?(await t.rename(c,r,{overwrite:l}),o):(await this.I(t,c,i,r,"copy",l),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,r){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,r);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.kb(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.gb(t,c,i,r)}async L(t,c,i,r){await i.mkdir(r),Array.isArray(c.children)&&await M.Promises.settled(c.children.map(async o=>{const l=this.N(i).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,l):this.J(t,o.resource,i,l)}))}async M(t,c,i,r,o,l){let s=!1;if(t===i){const{providerExtUri:I,isPathCaseSensitive:A}=this.N(t);if(A||(s=I.isEqual(c,r)),s&&o==="copy")throw new Error((0,w.localize)(12,null,this.nb(c),this.nb(r)));if(!s&&I.isEqualOrParent(r,c))throw new Error((0,w.localize)(13,null,this.nb(c),this.nb(r)))}const u=await this.exists(r);if(u&&!s){if(!l)throw new a.FileOperationError((0,w.localize)(14,null,this.nb(c),this.nb(r)),4);if(t===i){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(c,r))throw new Error((0,w.localize)(15,null,this.nb(c),this.nb(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}N(t){const c=this.O(t);return{providerExtUri:c?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:r}=this.N(t);for(;!r.isEqual(c,r.dirname(c));)try{if(((await t.stat(c)).type&a.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(c)));break}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(r.basename(c)),c=r.dirname(c)}for(let o=i.length-1;o>=0;o--){c=r.joinPath(c,i[o]);try{await t.mkdir(c)}catch(l){if((0,a.toFileSystemProviderErrorCode)(l)!==a.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new a.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),r=!!c?.useTrash,o=!!c?.recursive;await i.delete(t,{recursive:o,useTrash:r}),this.m.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),r=this.lb(await this.l(c),c);if(i===r&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===r&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(r,this.N(r).providerExtUri.dirname(c));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===r&&(0,a.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,c,{overwrite:!0})):o.queue(()=>this.J(i,t,r,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new d.DisposableStore;let r=!1,o=()=>{r=!0};return i.add((0,d.toDisposable)(()=>o())),(async()=>{try{const l=await this.W(t,c);r?(0,d.dispose)(l):o=()=>(0,d.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,c){const i=await this.j(t),r=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let o=this.U.get(r);return o||(o={count:0,disposable:i.watch(t,c)},this.U.set(r,o)),o.count+=1,(0,d.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,d.dispose)(o.disposable),this.U.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(r)||(0,p.isReadableBufferedStream)(r)?await this.Z(t,o,r):await this.ab(t,o,r)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await t.close(o)}})}async Z(t,c,i){let r=0,o;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=n.VSBuffer.concat(i.buffer);await this.bb(t,c,l,l.byteLength,r,0),r+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,s)=>{(0,p.listenStream)(o,{onData:async u=>{o.pause();try{await this.bb(t,c,u,u.byteLength,r,0)}catch(I){return s(I)}r+=u.byteLength,setTimeout(()=>o.resume())},onError:u=>s(u),onEnd:()=>l()})})}async ab(t,c,i){let r=0,o;for(;(o=i.read())!==null;)await this.bb(t,c,o,o.byteLength,r,0),r+=o.byteLength}async bb(t,c,i,r,o,l){let s=0;for(;s<r;)s+=await t.write(c,o+s,i.buffer,l+s,r-s)}async cb(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,r))}async db(t,c,i,r){let o;r instanceof n.VSBuffer?o=r:(0,p.isReadableStream)(r)?o=await(0,n.streamToBuffer)(r):(0,p.isReadableBufferedStream)(r)?o=await(0,n.bufferedStreamToBuffer)(r):o=(0,n.readableToBuffer)(r),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,r))}async fb(t,c,i,r){let o,l;try{o=await t.open(c,{create:!1}),l=await i.open(r,{create:!0,unlock:!1});const s=n.VSBuffer.alloc(this.a);let u=0,I=0,A=0;do A=await t.read(o,u,s.buffer,I,s.byteLength-I),await this.bb(i,l,s,A,u,I),u+=A,I+=A,I===s.byteLength&&(I=0);while(A>0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await M.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,r))}async hb(t,c,i,r){return i.writeFile(r,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,r))}async jb(t,c,i,r){const o=await i.open(r,{create:!0,unlock:!1});try{const l=await t.readFile(c);await this.bb(i,o,n.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await i.close(o)}}async kb(t,c,i,r){const o=await(0,n.streamToBuffer)(this.C(t,c,R.CancellationToken.None));await this.cb(i,r,void 0,o)}lb(t,c){if(t.capabilities&2048)throw new a.FileOperationError((0,w.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};E=ve([Q(0,m.ILogService)],E),e.FileService=E}),define(Z[90],ee([0,1,41,289,8,35,17,3,32,2,9,4,18,59,23,169,16,110,210,44,206,205]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(S)}catch(c){console.error(`Error enabling graceful-fs: ${(0,P.toErrorMessage)(c)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=k.Event.None,this.H=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:o}=await p.SymlinkSupport.stat(this.C(i));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await p.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async l=>{try{let s;l.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(i,l.name))).type:s=this.G(l),o.push([l.name,s])}catch(s){this.a.trace(s)}})),o}catch(r){throw this.Y(r)}}G(i,r){let o;return r?.dangling?o=a.FileType.Unknown:i.isFile()?o=a.FileType.File:i.isDirectory()?o=a.FileType.Directory:o=a.FileType.Unknown,r&&(o|=a.FileType.SymbolicLink),o}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const l=new n.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const l=this.C(i);return await p.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,o){const l=(0,h.newWriteableStream)(s=>C.VSBuffer.concat(s.map(u=>C.VSBuffer.wrap(u))).buffer);return(0,f.readFileIntoStream)(this,i,l,s=>s.buffer,{...r,bufferSize:256*1024},o),l}async writeFile(i,r,o){let l;try{const s=this.C(i);if(!o.create||!o.overwrite){if(await p.Promises.exists(s)){if(!o.overwrite)throw(0,a.createFileSystemProviderError)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,a.createFileSystemProviderError)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const o=this.C(i);let l;(0,a.isFileOpenForWriteOptions)(r)&&(l=await this.I(i));let s;try{if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:I}=await p.SymlinkSupport.stat(o);I.mode&128||await p.Promises.chmod(o,I.mode|128)}catch(I){this.a.trace(I)}let u;if((0,a.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await p.Promises.truncate(o,0),u="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}u||(u="w")}else u="r";s=await p.Promises.open(o,u)}catch(u){throw l?.dispose(),(0,a.isFileOpenForWriteOptions)(r)?await this.Z(i,u):this.Y(u)}if(this.L.set(s,0),(0,a.isFileOpenForWriteOptions)(r)&&this.N.set(s,i),l){const u=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${o})`),this.M.set(s,l),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${o})`),u.dispose())}return s}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await p.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await p.Promises.close(i)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,l,s){const u=this.P(i,r);let I=null;try{I=(await p.Promises.read(i,o,l,s,u)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,u,I)}return I}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,o){const l=this.L.get(i);typeof l=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(i,l+o):this.L.delete(i)))}async write(i,r,o,l,s){return(0,n.retry)(()=>this.R(i,r,o,l,s),100,3)}async R(i,r,o,l,s){const u=this.P(i,r);let I=null;try{I=(await p.Promises.write(i,o,l,s,u)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,u,I)}return I}async mkdir(i){try{await p.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const o=this.C(i);r.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,r,o){const l=this.C(i),s=this.C(r);if(l!==s)try{await this.S(i,r,"move",o.overwrite),await p.Promises.move(l,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(s)),u.toString()))),this.Y(u)}}async copy(i,r,o){const l=this.C(i),s=this.C(r);if(l!==s)try{await this.S(i,r,"copy",o.overwrite),await p.Promises.copy(l,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(s)),u.toString()))),this.Y(u)}}async S(i,r,o,l){const s=this.C(i),u=this.C(r);let I=!1;if(!!(this.capabilities&1024)||(I=(0,g.isEqual)(s,u,!0)),I&&o==="copy")throw(0,a.createFileSystemProviderError)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!I&&await p.Promises.exists(u)){if(!l)throw(0,a.createFileSystemProviderError)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,o){const l=this.C(i),s=this.C(r),u=!!(this.capabilities&1024);if((0,g.isEqual)(l,s,!u))return;const I=new d.DisposableStore;try{const[A,T]=await Promise.all([this.I(i),this.I(r)]);I.add(A),I.add(T),o&&await p.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await p.Promises.copyFile(l,s)}catch(A){if(A.code==="ENOENT"&&!o)return this.U(i,r,!0);throw this.Y(A)}finally{I.dispose()}}p(i,r,o){return new E.UniversalWatcherClient(l=>i(l),l=>r(l),o)}y(i,r,o){return new D.NodeJSWatcherClient(l=>i(l),l=>r(l),o)}Y(i){if(i instanceof a.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async Z(i,r){let o=this.Y(r);if(i&&o.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.C(i));l.mode&128||(o=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Z[212],ee([0,1,3,90,2,17,59,22]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends n.Disposable{constructor(v,y){super(),this.a=v,this.b=y,this.w=new Map,this.y=new Map}call(v,y,h){const p=this.c(v);switch(y){case"stat":return this.g(p,h[0]);case"readdir":return this.h(p,h[0]);case"open":return this.l(p,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(p,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(p,h[0],h[1],h[2]);case"rename":return this.t(p,h[0],h[1],h[2]);case"copy":return this.u(p,h[0],h[1],h[2]);case"cloneFile":return this.v(p,h[0],h[1]);case"mkdir":return this.r(p,h[0]);case"delete":return this.s(p,h[0],h[1]);case"watch":return this.C(p,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,h){const p=this.c(v);switch(y){case"fileChange":return this.z(p,h[0]);case"readFileStream":return this.j(p,h[0],h[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const h=this.f(v,y,!0);return this.a.stat(h)}h(v,y){const h=this.f(v,y);return this.a.readdir(h)}async i(v,y,h){const p=this.f(v,y,!0),w=await this.a.readFile(p,h);return R.VSBuffer.wrap(w)}j(v,y,h){const p=this.f(v,y,!0),w=new k.CancellationTokenSource,a=new S.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),f=this.a.readFileStream(p,h,w.token);return(0,C.listenStream)(f,{onData:m=>a.fire(R.VSBuffer.wrap(m)),onError:m=>a.fire(m),onEnd:()=>{a.fire("end"),a.dispose(),w.dispose()}}),a.event}k(v,y,h,p){const w=this.f(v,y);return this.a.writeFile(w,h.buffer,p)}l(v,y,h){const p=this.f(v,y,!0);return this.a.open(p,h)}m(v){return this.a.close(v)}async n(v,y,h){const p=R.VSBuffer.alloc(h),w=0,a=await this.a.read(v,y,p.buffer,w,h);return[p,a]}p(v,y,h,p,w){return this.a.write(v,y,h.buffer,p,w)}r(v,y){const h=this.f(v,y);return this.a.mkdir(h)}s(v,y,h){const p=this.f(v,y);return this.a.delete(p,h)}t(v,y,h,p){const w=this.f(v,y),a=this.f(v,h);return this.a.rename(w,a,p)}u(v,y,h,p){const w=this.f(v,y),a=this.f(v,h);return this.a.copy(w,a,p)}v(v,y,h){const p=this.f(v,y),w=this.f(v,h);return this.a.cloneFile(p,w)}z(v,y){const h=new S.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(v,h))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(y)),this.w.delete(y)}});return h.event}async C(v,y,h,p,w){const a=this.w.get(y);if(a){const f=this.f(v,p),m=a.watch(h,f,w);this.y.set(y+h,m)}}async D(v,y){const h=v+y,p=this.y.get(h);p&&((0,n.dispose)(p),this.y.delete(h))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class d extends n.Disposable{constructor(v,y,h,p){super(),this.c=v,this.f=h,this.g=p,this.a=new Map,this.b=this.B(new M.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(v){const y=this.B(new S.Emitter);this.B(y.event(h=>{v.fire(h.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(h=>y.fire(h))),this.B(this.b.onDidWatchError(h=>v.fire(h)))}i(v){}j(v){}watch(v,y,h){const p=this.j(this.g);return Array.isArray(p)&&(h.excludes=[...h.excludes,...p]),this.a.set(v,this.b.watch(y,h)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=d}),define(Z[213],ee([0,1,15,168,4,7,16,9,212,146]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends g.AbstractDiskFileSystemProviderChannel{constructor(h,p,w){super(h,p),this.G=w}c(h){return d.DefaultURITransformer}f(h,p){return R.URI.revive(p)}async s(h,p,w){if(!w.useTrash)return super.s(h,p,w);const a=this.f(h,p),f=(0,k.normalize)(a.fsPath);try{await S.shell.trashItem(f)}catch{throw(0,C.createFileSystemProviderError)(n.isWindows?(0,M.localize)(0,null,(0,k.basename)(f)):(0,M.localize)(1,null,(0,k.basename)(f)),C.FileSystemProviderErrorCode.Unknown)}}F(h,p){return new v(h,p,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class v extends g.AbstractSessionFileWatcher{watch(h,p,w){if(w.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(h,p,w)}}}),define(Z[214],ee([0,1,5]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends S.AbstractMessageLogger{constructor(R=S.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(C=>{this.l?.setLevel(C)}))}set logger(R){this.l=R;for(const{level:C,message:k}of this.k)(0,S.log)(R,C,k);this.k=[]}g(R,C){this.l?(0,S.log)(this.l,R,C):this.getLevel()<=R&&this.k.push({level:R,message:C})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=M}),define(Z[215],ee([0,1,2,5]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends S.Disposable{constructor(C,k=[]){super(),this.a=new M.MultiplexLogger([C,...k]),this.B(C.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.LogService=n}),define(Z[216],ee([0,1,35,7,5]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class R{constructor(k){this.b=k,this.a=new S.ResourceMap}listen(k,g,d){switch(g){case"onDidChangeLoggers":return d?this.b.getOnDidChangeLoggersEvent(d):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return d?this.b.getOnDidChangeLogLevelEvent(d):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return d?this.b.getOnDidChangeVisibilityEvent(d):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(k,g,d){switch(g){case"createLogger":this.c(M.URI.revive(d[0]),d[1],d[2]);return;case"log":return this.e(M.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1]);case"setLogLevel":return(0,n.isLogLevel)(d[0])?this.b.setLogLevel(d[0]):this.b.setLogLevel(M.URI.revive(d[0]),d[1]);case"setVisibility":return this.b.setVisibility(M.URI.revive(d[0]),d[1]);case"registerLogger":return this.b.registerLogger({...d[0],resource:M.URI.revive(d[0].resource)},d[1]);case"deregisterLogger":return this.b.deregisterLogger(M.URI.revive(d[0]))}throw new Error(`Call not found: ${g}`)}c(k,g,d){this.a.set(k,this.b.createLogger(k,g,d))}d(k,g){let d=console.log;switch(k){case n.LogLevel.Error:d=console.error;break;case n.LogLevel.Warning:d=console.warn;break;case n.LogLevel.Info:d=console.info;break}d.call(console,...g)}e(k,g){const d=this.a.get(k);if(!d)throw new Error("Create the logger before logging");for(const[b,v]of g)(0,n.log)(d,b,v)}}e.LoggerChannel=R}),define(Z[217],ee([0,1,16,5]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(n||(n={}));async function R(d,b,v,y,h){try{const p=await new Promise((a,f)=>{x(["spdlog"],a,f)});p.setFlushOn(n.Trace);const w=await p.createAsyncRotatingLogger(d,b,v,y);return h?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(p){console.error(p)}return null}function C(d,b,v){switch(b){case M.LogLevel.Trace:d.trace(v);break;case M.LogLevel.Debug:d.debug(v);break;case M.LogLevel.Info:d.info(v);break;case M.LogLevel.Warning:d.warn(v);break;case M.LogLevel.Error:d.error(v);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function k(d,b){switch(b){case M.LogLevel.Trace:d.setLevel(n.Trace);break;case M.LogLevel.Debug:d.setLevel(n.Debug);break;case M.LogLevel.Info:d.setLevel(n.Info);break;case M.LogLevel.Warning:d.setLevel(n.Warning);break;case M.LogLevel.Error:d.setLevel(n.Error);break;case M.LogLevel.Off:d.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends M.AbstractMessageLogger{constructor(b,v,y,h,p){super(),this.k=[],this.setLevel(p),this.l=this.n(b,v,y,h),this.B(this.onDidChangeLogLevel(w=>{this.m&&k(this.m,w)}))}async n(b,v,y,h){const p=y?6:1,w=30/p*S.ByteSize.MB,a=await R(b,v,w,p,h);if(a){this.m=a,k(this.m,this.getLevel());for(const{level:f,message:m}of this.k)C(this.m,f,m);this.k=[]}}g(b,v){this.m?C(this.m,b,v):this.getLevel()<=b&&this.k.push({level:b,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[218],ee([0,1,31,5,217]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends M.AbstractLoggerService{k(k,g,d){return new n.SpdLogLogger((0,S.generateUuid)(),k.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,g)}}e.LoggerService=R}),define(Z[64],ee([0,1,35,3,6,5,218]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(R.ILoggerService);class k extends C.LoggerService{constructor(){super(...arguments),this.m=new S.ResourceMap}createLogger(d,b,v){v!==void 0&&this.m.set(d,v);try{return super.createLogger(d,b)}catch(y){throw this.m.delete(d),y}}registerLogger(d,b){b!==void 0&&this.m.set(d.resource,b),super.registerLogger(d)}deregisterLogger(d){this.m.delete(d),super.deregisterLogger(d)}getRegisteredLoggers(d){const b=[];for(const v of super.getRegisteredLoggers())d===this.m.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(d){return M.Event.filter(this.onDidChangeLogLevel,b=>(0,R.isLogLevel)(b)||this.n(b[0],d))}getOnDidChangeVisibilityEvent(d){return M.Event.filter(this.onDidChangeVisibility,([b])=>this.n(b,d))}getOnDidChangeLoggersEvent(d){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.n(y.resource,d)),removed:[...b.removed].filter(y=>this.n(y.resource,d))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(d){for(const[b,v]of this.m)v===d&&this.deregisterLogger(b)}n(d,b){const v=this.m.get(d);return v===void 0||v===b}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=k}),define(Z[219],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(C){return C.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function M(C){return C.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function n(C){return C.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function R(C){return!S(C)&&!M(C)&&!n(C)}e.isMenubarMenuItemAction=R}),define(Z[37],ee([0,1,3,69,2,6]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class C extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const b=Object.keys(this.f).length;return this.f={...d,...this.f},b!==Object.keys(this.f).length&&await this.i(d),M.Iterable.reduce(this.g.entries(),(v,[y,h])=>({...v,[y]:h}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(d,[b,v])=>({...d,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=C;class k{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(Z[220],ee([0,1,8,3,69,10,16,5,37]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(v,y){const h=[];for(const p of new Set(n.Iterable.concat(v.keys(),y.keys())))v.get(p)!==y.get(p)&&h.push(p);return h}let b=class extends g.AbstractPolicyService{constructor(y,h,p){super(),this.j=y,this.k=h,this.l=p,this.c=this.B(new S.ThrottledDelayer(500));const w=M.Event.filter(h.onDidFilesChange,a=>a.affects(y));this.B(h.watch(y)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const h=await this.k.readFile(this.j),p=JSON.parse(h.value.toString());if(!(0,R.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(p))this.f[w]&&y.set(w,p[w])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return y}async p(){const y=await this.n(),h=d(this.g,y);this.g=y,h.length>0&&this.h.fire(h)}};b=ve([Q(1,C.IFileService),Q(2,k.ILogService)],b),e.FilePolicyService=b}),define(Z[221],ee([0,1,3,2,37]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(g){this.b=g,this.a=new M.DisposableStore}listen(g,d){switch(d){case"onDidChange":return S.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(g,d,b){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class C extends n.AbstractPolicyService{constructor(g,d){super(),this.a=d;for(const b in g){const{definition:v,value:y}=g[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async i(g){const d=await this.a.call("updatePolicyDefinitions",g);for(const b in d)this.g.set(b,d[b])}}e.PolicyChannelClient=C}),define(Z[65],ee([0,1,4,36]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.context<"u"){const R=S.globals.vscode.context.configuration();if(R)n=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:R.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(Z[20],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[222],ee([0,1,80,5,20]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(k,g){this.b=k,this.c=g,this.a=new Map}async isExtensionUrlTrusted(k,g){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(g);if(!d)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,b,v]=d;let y=this.a.get(k);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[k],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...y])}const h=Buffer.from(decodeURIComponent(v),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const p=h.slice(0,6),w=h.readUIntBE(0,6),a=Date.now()-w;if(a<0||a>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const f=h.slice(6),m=S.createVerify("SHA256");m.write(p),m.write(Buffer.from(b)),m.end();for(let P=0;P<y.length;P++){let E=y[P];if(E!==null){if(typeof E=="string")try{E=S.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),y[P]=E}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${P+1} for ${k}:`,D),y[P]=null;continue}if(m.verify(E,f))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};R=ve([Q(0,n.IProductService),Q(1,M.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[223],ee([0,1,8,5]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(C,k,g){this.a=C,this.b=k,this.c=g}async inspect(C){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.timeout)(C);const g=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};n=ve([Q(2,M.ILogService)],n),e.WindowProfiler=n}),define(Z[66],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(Z[50],ee([0,1,124,10]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(C,k){S.ok(M.isString(C)),S.ok(M.isObject(k)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new n}),define(Z[224],ee([0,1,3,50]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new S.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,d){this.a[n(g)]=d,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;M.Registry.add(e.Extensions.JSONContribution,C)}),define(Z[67],ee([0,1,25,3,10,155,19,224,50]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=g.Registry.as(k.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new M.Emitter,this.onDidSchemaChange=this.i.event,this.j=new M.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:r,source:o}of t)for(const l in r)if(c.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const s=this.a.get(l),u=s?.valuesSources??new Map;if(o)for(const N of Object.keys(r[l]))u.set(N,o);const I={...s?.value||{},...r[l]};this.a.set(l,{source:o,value:I,valuesSources:u});const A=(0,C.getLanguageTagSettingPlainKey)(l),T={type:"object",default:I,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:I,source:n.isString(o)?void 0:o,defaultValueSource:o};i.push(...w(l)),this.d[l]=T,this.b.properties[l]=T}else{this.a.set(l,{value:r[l],source:o});const s=this.d[l];s&&(this.w(l,s),this.r(l,s))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:r}of t)for(const o in i){const l=this.a.get(o),s=n.isString(r)?r:r?.id,u=n.isString(l?.source)?l?.source:l?.source?.id;if(s===u)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const I=this.d[o];I&&(this.w(o,I),this.r(o,I))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(r=>{this.p(r,c,r.extensionInfo,r.restrictedProperties,void 0,i),this.c.push(r),this.q(r)})}o(t,c){const i=r=>{if(r.properties)for(const o in r.properties){c.add(o);const l=this.d[o];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[o],this.s(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}}p(t,c=!0,i,r,o=3,l){o=n.isUndefinedOrNull(t.scope)?o:t.scope;const s=t.properties;if(s)for(const I in s){const A=s[I];if(c&&P(I,A)){delete s[I];continue}if(A.source=i,A.defaultDefaultValue=s[I].default,this.w(I,A),e.OVERRIDE_PROPERTY_REGEX.test(I)?A.scope=void 0:(A.scope=n.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=n.isUndefinedOrNull(A.restricted)?!!r?.includes(I):A.restricted),s[I].hasOwnProperty("included")&&!s[I].included){this.f[I]=s[I],delete s[I];continue}else this.d[I]=s[I],s[I].policy?.name&&this.e.set(s[I].policy.name,I);!s[I].deprecationMessage&&s[I].markdownDeprecationMessage&&(s[I].deprecationMessage=s[I].markdownDeprecationMessage),l.add(I)}const u=t.allOf;if(u)for(const I of u)this.p(I,c,i,r,o,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const r=i.properties;if(r)for(const l in r)this.r(l,r[l]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let r=i?.value,o=i?.source;n.isUndefined(r)&&(r=c.defaultDefaultValue,o=void 0),n.isUndefined(r)&&(r=f(c.type)),c.default=r,c.defaultValueSource=o}}const h="\\[([^\\]]+)\\]",p=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let c=p.exec(D);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=p.exec(D)}}return(0,S.distinct)(t)}e.overrideIdentifiersFromKey=w;function a(D){return D.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=a;function f(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const m=new y;g.Registry.add(e.Extensions.Configuration,m);function P(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?R.localize(7,null,D):m.getConfigurationProperties()[D]!==void 0?R.localize(8,null,D):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,D,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=P;function E(){const D=[],t=m.getConfigurationProperties();for(const c of Object.keys(t))D.push([c,t[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=E}),define(Z[111],ee([0,1,25,3,43,2,35,40,10,7,19,67,50]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(c){return Object.isFrozen(c)?c:k.deepFreeze(c)}class p{constructor(i={},r=[],o=[],l){this.b=i,this.c=r,this.d=o,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof p)return r;const o=new w("");return o.parseRaw(r),o.configurationModel});this.f=i.reduce((r,o)=>o===r?o:r.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const o=this.rawConfiguration.getValue(i),l=r?this.rawConfiguration.getOverrideValue(i,r):void 0,s=r?this.rawConfiguration.override(r).getValue(i):o;return{value:o,override:l,merged:s}}getOverrideValue(i,r){const o=this.i(r);return o?i?(0,b.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const o of this.overrides)o.identifiers.includes(i)&&r.push(...o.keys);return S.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return S.distinct(i)}override(i){let r=this.a.get(i);return r||(r=this.g(i),this.a.set(i,r)),r}merge(...i){const r=k.deepClone(this.contents),o=k.deepClone(this.overrides),l=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of i)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(r,u.contents);for(const I of u.overrides){const[A]=o.filter(T=>S.equals(T.identifiers,I.identifiers));A?(this.h(A.contents,I.contents),A.keys.push(...I.keys),A.keys=S.distinct(A.keys)):o.push(k.deepClone(I))}for(const I of u.keys)l.indexOf(I)===-1&&l.push(I)}return new p(r,l,o,s.every(u=>u instanceof p)?void 0:s)}g(i){const r=this.i(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const l of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let s=this.contents[l];const u=r[l];u&&(typeof s=="object"&&typeof u=="object"?(s=k.deepClone(s),this.h(s,u)):s=u),o[l]=s}return new p(o,this.keys,this.overrides)}h(i,r){for(const o of Object.keys(r)){if(o in i&&g.isObject(i[o])&&g.isObject(r[o])){this.h(i[o],r[o]);continue}i[o]=k.deepClone(r[o])}}i(i){let r=null,o=null;const l=s=>{s&&(o?this.h(o,s):o=k.deepClone(s))};for(const s of this.overrides)S.equals(s.identifiers,[i])?r=s.contents:s.identifiers.includes(i)&&l(s.contents);return l(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.j(i,r,!0)}setValue(i,r){this.j(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,b.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>S.equals(o.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,r,o){(0,b.addToValueTree)(this.contents,i,r,l=>console.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=p;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,r){if(!g.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,r)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,r){this.a=i;const{contents:o,keys:l,overrides:s,restricted:u,hasExcludedProperties:I}=this.h(i,r);this.b=new p(o,l,s,I?[i]:void 0),this.c=u||[]}g(i){let r={},o=null,l=[];const s=[],u=[];function I(T){Array.isArray(l)?l.push(T):o!==null&&(l[o]=T)}const A={onObjectBegin:()=>{const T={};I(T),s.push(l),l=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{l=s.pop()},onArrayBegin:()=>{const T=[];I(T),s.push(l),l=T,o=null},onArrayEnd:()=>{l=s.pop()},onLiteralValue:I,onError:(T,N,z)=>{u.push({error:T,offset:N,length:z})}};if(i)try{n.visit(i,A),r=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return r}h(i,r){const o=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,o,!0,r);i=l.raw;const s=(0,b.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),u=Object.keys(i),I=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:s,keys:u,overrides:I,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,r,o,l){let s=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const u={},I=[];for(const A in i)if(v.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const T=this.i(i[A],r,!1,l);u[A]=T.raw,s=s||T.hasExcludedProperties,I.push(...T.restricted)}else{const T=r[A],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&I.push(A),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&T?.restricted)?u[A]=i[A]:s=!0}return{raw:u,restricted:I,hasExcludedProperties:s}}j(i,r){const o=[];for(const l of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(l)){const s={};for(const u in i[l])s[u]=i[l][u];o.push({identifiers:(0,v.overrideIdentifiersFromKey)(l),keys:Object.keys(s),contents:(0,b.toValuesTree)(s,r)})}return o}}e.ConfigurationModelParser=w;class a extends R.Disposable{constructor(i,r,o,l){super(),this.f=i,this.g=r,this.h=l,this.c=this.B(new M.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class f{constructor(i,r,o,l,s,u,I,A,T,N,z,H,ie){this.a=i,this.b=r,this.c=o,this.overrideIdentifiers=l,this.d=s,this.f=u,this.g=I,this.h=A,this.i=T,this.j=N,this.k=z,this.l=H,this.m=ie}get value(){return h(this.c)}n(i,r,o){const l=i.inspect(r,o);return{get value(){return h(l.value)},get override(){return h(l.override)},get merged(){return h(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(i,r,o,l,s=new p,u=new p,I=new C.ResourceMap,A=new p,T=new C.ResourceMap){this.c=i,this.d=r,this.f=o,this.g=l,this.h=s,this.i=u,this.j=I,this.l=A,this.m=T,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(i,r,o){return this.q(i,r,o).getValue(i)}updateValue(i,r,o={}){let l;o.resource?(l=this.m.get(o.resource),l||(l=new p,this.m.set(o.resource,l))):l=this.l,r===void 0?l.removeValue(i):l.setValue(i,r),o.resource||(this.a=null)}inspect(i,r,o){const l=this.q(i,r,o),s=this.u(r.resource,o),u=r.resource?this.m.get(r.resource)||this.l:this.l,I=new Set;for(const A of l.overrides)for(const T of A.identifiers)l.getOverrideValue(i,T)!==void 0&&I.add(T);return new f(i,r,l.getValue(i),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,s||void 0,u)}keys(i){const r=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,r){this.j.set(i,r),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const o=[];if(!r){const{added:l,updated:s,removed:u}=D(this.c,i);r=[...l,...s,...u]}for(const l of r)for(const s of(0,v.overrideIdentifiersFromKey)(l)){const u=this.c.getKeysForOverrideIdentifier(s),I=i.getKeysForOverrideIdentifier(s),A=[...I.filter(T=>u.indexOf(T)===-1),...u.filter(T=>I.indexOf(T)===-1),...u.filter(T=>!k.equals(this.c.override(s).getValue(T),i.override(s).getValue(T)))];o.push([s,A])}return this.updateDefaultConfiguration(i),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:o,removed:l}=D(this.d,i),s=[...r,...o,...l];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:o,removed:l,overrides:s}=D(this.applicationConfiguration,i),u=[...r,...o,...l];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:o,removed:l,overrides:s}=D(this.localUserConfiguration,i),u=[...r,...o,...l];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:o,removed:l,overrides:s}=D(this.remoteUserConfiguration,i),u=[...r,...o,...l];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:o,removed:l,overrides:s}=D(this.workspaceConfiguration,i),u=[...r,...o,...l];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(i,r){const o=this.p.get(i),{added:l,updated:s,removed:u,overrides:I}=D(o,r),A=[...l,...s,...u];return(A.length||!o)&&this.updateFolderConfiguration(i,r),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(i){const r=this.p.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:s,overrides:u}=D(r,void 0);return{keys:[...o,...l,...s],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,r,o){let l=this.r(r,o);return r.overrideIdentifier&&(l=l.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},r){let o=this.s();if(r&&i){const l=r.getFolder(i);l&&(o=this.t(l.uri)||o);const s=this.m.get(i);s&&(o=o.merge(s))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let r=this.b.get(i);if(!r){const o=this.s(),l=this.j.get(i);l?(r=o.merge(l),this.b.set(i,r)):r=o}return r}u(i,r){if(r&&i){const o=r.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,r)=>{const{contents:o,overrides:l,keys:s}=this.j.get(r);return i.push([r,{contents:o,overrides:l,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this.i.keys.forEach(r=>i.add(r)),this.j.forEach(r=>r.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const r=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l))),[...r.values()]}static parse(i){const r=this.x(i.defaults),o=this.x(i.policy),l=this.x(i.application),s=this.x(i.user),u=this.x(i.workspace),I=i.folders.reduce((A,T)=>(A.set(d.URI.revive(T[0]),this.x(T[1])),A),new C.ResourceMap);return new m(r,o,l,s,new p,u,I,new p,new C.ResourceMap)}static x(i){return new p(i.contents,i.keys,i.overrides)}}e.Configuration=m;function P(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,r=new Map;for(const l of c)l.keys.forEach(s=>i.add(s)),l.overrides.forEach(([s,u])=>{const I=(0,C.getOrSet)(r,s,new Set);u.forEach(A=>I.add(A))});const o=[];return r.forEach((l,s)=>o.push([s,[...l.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=P;class E{constructor(i,r,o,l){this.change=i,this.f=r,this.g=o,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const u of s)this.affectedKeys.add(u);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(i,r){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const s=l+o.length;if(s>=this.d.length)return!1;const u=this.d.charCodeAt(s);if(u!==this.b&&u!==this.c)return!1;if(r){const I=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.f?.workspace):void 0,A=this.g.getValue(i,r,this.h);return!k.equals(I,A)}return!0}}e.ConfigurationChangeEvent=E;function D(c,i){const{added:r,removed:o,updated:l}=t(i?.rawConfiguration,c?.rawConfiguration),s=[],u=c?.getAllOverrideIdentifiers()||[],I=i?.getAllOverrideIdentifiers()||[];if(i){const A=I.filter(T=>!u.includes(T));for(const T of A)s.push([T,i.getKeysForOverrideIdentifier(T)])}if(c){const A=u.filter(T=>!I.includes(T));for(const T of A)s.push([T,c.getKeysForOverrideIdentifier(T)])}if(i&&c){for(const A of u)if(I.includes(A)){const T=t({contents:c.getOverrideValue(void 0,A)||{},keys:c.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});s.push([A,[...T.added,...T.removed,...T.updated]])}}return{added:r,removed:o,updated:l,overrides:s}}function t(c,i){const r=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],o=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],l=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const u=(0,b.getConfigurationValue)(i.contents,s),I=(0,b.getConfigurationValue)(c.contents,s);k.equals(u,I)||l.push(s)}}return{added:r,removed:o,updated:l}}}),define(Z[225],ee([0,1,25,3,2,40,10,111,67,5,37,50]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:f})=>this.c(Array.from(a),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,f){this.h(a,v.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new k.ConfigurationModel;const a=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,f){const m=this.f();for(const P of a){const E=m[P],D=f[P];E!==void 0?this.b.addValue(P,E):D?this.b.addValue(P,D.default):this.b.removeValue(P)}}}e.DefaultConfiguration=y;class h{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let p=class extends n.Disposable{get configurationModel(){return this.b}constructor(a,f,m){super(),this.c=a,this.f=f,this.g=m,this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const f={},m=[],P=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const E of a){const D=P[E];if(!D){m.push(E);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}m.push(E),f[D.policy.name]={type:D.type}}}return(0,C.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),m}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const f=v.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),m=(0,S.coalesce)(a.map(P=>f.get(P)));this.j(m,!0)}j(a,f){this.g.trace("PolicyConfiguration#update",a);const m=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),P=[],E=this.b.isEmpty();for(const D of a){const t=m[D]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(E?c!==void 0:!(0,R.equals)(this.b.getValue(D),c))&&P.push([D,c])}else this.b.getValue(D)!==void 0&&P.push([D,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const D=this.b;this.b=new k.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,c]of P)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);f&&this.a.fire(this.b)}}};p=ve([Q(1,b.IPolicyService),Q(2,d.ILogService)],p),e.PolicyConfiguration=p}),define(Z[226],ee([0,1,8,3,2,18,19,111,225,37]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends n.Disposable{constructor(y,h,p,w){super(),this.i=y,this.h=this.B(new M.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=p instanceof d.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,p,w)),this.f=this.B(new k.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,h)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:f})=>this.k(a,f))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,h,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(y,h,new k.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(y,h){const p=typeof y=="string"?y:void 0,w=(0,C.isConfigurationOverrides)(y)?y:(0,C.isConfigurationOverrides)(h)?h:{};return this.a.getValue(p,w,void 0)}updateValue(y,h,p,w){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const h=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(p,h,2)}k(y,h){const p=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(y,h);this.m(w,p,7)}l(y){const h=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(y);this.m(p,h,7)}m(y,h,p){const w=new k.ConfigurationChangeEvent(y,{data:h},this.a);w.source=p,w.sourceConfig=this.n(p),this.h.fire(w)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Z[227],ee([0,1,13,6]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var n;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof R&&g._code===n.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof R&&g._code===n.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof R&&g._code===n.NoResolverFound}static isHandled(g){return g instanceof R&&g.isHandled}constructor(g,d=n.Unknown,b){super(g),this._message=g,this._code=d,this._detail=b,this.isHandled=d===n.NotAvailable&&b===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(k){const g=k.indexOf("+");return g===-1?k:k.substring(0,g)}e.getRemoteAuthorityPrefix=C}),define(Z[55],ee([0,1,14]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(d){return d.scheme===S.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=M;function n(d){if(!d)return;const b=d.indexOf("+");return b<0?d:d.substr(0,b)}e.getRemoteName=n;function R(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(d){const{host:b,port:v}=g(d);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:v}}e.parseAuthorityWithPort=C;function k(d,b){let{host:v,port:y}=g(d);return typeof y>"u"&&(y=b),{host:v,port:y}}e.parseAuthorityWithOptionalPort=k;function g(d){const b=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=d.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=d.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:d,port:void 0}}}),define(Z[112],ee([0,1,27,6,55]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var k;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(p){this.value=p,this.c=p.toLowerCase()}static equals(p,w){if(typeof p>"u"||p===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof p=="string"||typeof w=="string"){const a=typeof p=="string"?p:p.value,f=typeof w=="string"?w:w.value;return S.equalsIgnoreCase(a,f)}return p.c===w.c}static toKey(p){return typeof p=="string"?p.toLowerCase():p.c}}e.ExtensionIdentifier=g;function d(h){return b(h)}e.isApplicationScopedExtension=d;function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function v(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function y(h,p){if(p){const w=`onResolveRemoteAuthority:${(0,n.getRemoteName)(p)}`;return h.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[228],ee([0,1,8,17,22,13,3,2,63,70,31,103,227,55]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var w;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function a(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(W){const U=new n.CancellationTokenSource;return setTimeout(()=>U.cancel(),W),U.token}function m(W,U){if(W.isCancellationRequested||U.isCancellationRequested)return n.CancellationToken.Cancelled;const $=new n.CancellationTokenSource;return W.onCancellationRequested(()=>$.cancel()),U.onCancellationRequested(()=>$.cancel()),$.token}class P{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise(($,V)=>{this.f=$,this.g=V}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function E(W,U){const $=new P(U);return $.registerDisposable(W.onControlMessage(V=>{const j=JSON.parse(V.toString()),K=q(j);K?$.reject(K):$.resolve(j)})),$.promise}function D(W,U,$,V,j,K,Y,re,de){const Re=new P(de),Ce=d.StopWatch.create(!1);return W.info(`Creating a socket (${re})...`),g.mark(`code/willCreateSocket/${Y}`),U.connect($,V,j,K,re,(De,Oe)=>{Re.didTimeout?(g.mark(`code/didCreateSocketError/${Y}`),W.info(`Creating a socket (${re}) finished after ${Ce.elapsed()} ms, but this is too late and has timed out already.`),De&&W.error(De),Oe?.dispose()):De||!Oe?(g.mark(`code/didCreateSocketError/${Y}`),W.info(`Creating a socket (${re}) returned an error after ${Ce.elapsed()} ms.`),Re.reject(De)):(g.mark(`code/didCreateSocketOK/${Y}`),W.info(`Creating a socket (${re}) was successful after ${Ce.elapsed()} ms.`),Re.resolve(Oe))}),Re.promise}function t(W,U){const $=new P(U);return W.then(V=>{$.didTimeout||$.resolve(V)},V=>{$.didTimeout||$.reject(V)}),$.promise}async function c(W,U,$,V){const j=L(W,U);W.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let K;try{K=await D(W.logService,W.socketFactory,W.host,W.port,(0,h.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,a(U),`renderer-${a(U)}-${W.reconnectionToken}`,V)}catch(Ce){throw W.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),W.logService.error(Ce),Ce}W.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let Y,re;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(K,null),Y=W.reconnectionProtocol,re=!1):(Y=new v.PersistentProtocol({socket:K,measureRoundTripTime:!0}),re=!0),W.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await t(W.signService.createNewMessage((0,b.generateUuid)()),V),Re={type:"auth",auth:W.connectionToken||"00000000000000000000",data:de.data};Y.sendControl(M.VSBuffer.fromString(JSON.stringify(Re)));try{const Ce=await E(Y,m(V,f(1e4)));if(Ce.type!=="sign"||typeof Ce.data!="string"){const fe=new Error("Unexpected handshake message");throw fe.code="VSCODE_CONNECTION_ERROR",fe}if(W.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(W.signService.validate(de,Ce.signedData),V)){const fe=new Error("Refused to connect to unsupported server");throw fe.code="VSCODE_CONNECTION_ERROR",fe}const Oe=await t(W.signService.sign(Ce.data),V),$e={type:"connectionType",commit:W.commit,signedData:Oe,desiredConnectionType:U};return $&&($e.args=$),W.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(M.VSBuffer.fromString(JSON.stringify($e))),{protocol:Y,ownsProtocol:re}}catch(Ce){throw Ce&&Ce.code==="ETIMEDOUT"&&(W.logService.error(`${j} the handshake timed out. Error:`),W.logService.error(Ce)),Ce&&Ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(Ce)),re&&O(Y),Ce}}async function i(W,U,$,V){const j=Date.now(),K=L(W,U),{protocol:Y,ownsProtocol:re}=await c(W,U,$,V),de=new P(V);return de.registerDisposable(Y.onControlMessage(Re=>{const Ce=JSON.parse(Re.toString()),De=q(Ce);De?(W.logService.error(`${K} received error control message when negotiating connection. Error:`),W.logService.error(De),re&&O(Y),de.reject(De)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${F(j)}!`),de.resolve({protocol:Y,firstMessage:Ce}))})),de.promise}async function r(W,U){const{protocol:$}=await i(W,1,void 0,U);return{protocol:$}}async function o(W,U,$){const{protocol:V,firstMessage:j}=await i(W,2,U,$),K=j&&j.debugPort;return{protocol:V,debugPort:K}}async function l(W,U,$){const V=Date.now(),j=L(W,3),{protocol:K}=await c(W,3,U,$);return W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${F(V)}!`),K}async function s(W,U,$){const{host:V,port:j,connectionToken:K}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:V,port:j,connectionToken:K,reconnectionToken:U,reconnectionProtocol:$,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function u(W,U,$){return A(W,async V=>{const{protocol:j}=await r(V,n.CancellationToken.None);return new G(W,U,$,V.reconnectionToken,j)})}e.connectRemoteAgentManagement=u;async function I(W,U){return A(W,async $=>{const{protocol:V,debugPort:j}=await o($,U,n.CancellationToken.None);return new B(W,U,$.reconnectionToken,V,j)})}e.connectRemoteAgentExtensionHost=I;async function A(W,U){for(let V=1;;V++)try{const j=(0,b.generateUuid)(),K=await s(W,j,null);return await U(K)}catch(j){if(V<5)W.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(j);else throw W.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(j),me.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(j)),j}}async function T(W,U,$){const V=await s(W,(0,b.generateUuid)(),null);return await l(V,{host:U,port:$},n.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(W){return(0,S.createCancelablePromise)(U=>new Promise(($,V)=>{const j=setTimeout($,W*1e3);U.onCancellationRequested(()=>{clearTimeout(j),$()})}))}var z;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class H{constructor(U,$){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=H;class ie{constructor(U,$,V,j){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.durationSeconds=V,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ie;class se{constructor(U,$,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=se;class oe{constructor(U,$,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(U,$){this.reconnectionToken=U,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=ue;class le{constructor(U,$,V,j){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class me extends k.Disposable{static triggerPermanentFailure(U,$,V){this._permanentFailure=!0,this.f=U,this.g=$,this.h=V,this.i.forEach(j=>j.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.r())}static debugPauseSocketWriting(){this.i.forEach(U=>U.v())}get k(){return this.c||me._permanentFailure}constructor(U,$,V,j,K){super(),this.m=U,this.n=$,this.reconnectionToken=V,this.protocol=j,this.p=K,this.j=this.B(new C.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new oe(this.reconnectionToken,0,0)),this.B(j.onSocketClose(Y=>{const re=ne(this.m,this.reconnectionToken,!0);Y?Y.type===0?(this.n.logService.info(`${re} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.n.logService.error(Y.error)):(this.n.logService.info(`${re} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.n.logService.error(Y.event)):this.n.logService.info(`${re} received socket close event.`),this.r()})),this.B(j.onSocketTimeout(Y=>{const re=ne(this.m,this.reconnectionToken,!0);this.n.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(j.onHighRoundTripTime(Y=>{const re=te(this.m,this.reconnectionToken);this.n.logService.info(`${re} high roundtrip time: ${Y.roundTripTime}ms (${Y.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(Y=>{this.j.fire(new ue(this.reconnectionToken,Y))})),me.i.push(this),this.B((0,k.toDisposable)(()=>{const Y=me.i.indexOf(this);Y>=0&&me.i.splice(Y,1)})),this.k&&this.u(me.f,me.g,me.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const U=ne(this.m,this.reconnectionToken,!0);this.n.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const j=V<$.length?$[V]:$[$.length-1];try{if(j>0){const Y=N(j);this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,Y)),this.n.logService.info(`${U} waiting for ${j} seconds before reconnecting...`);try{await Y}catch{}}if(this.k){this.n.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.n.logService.info(`${U} resolving connection...`);const K=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${U} connecting to ${K.host}:${K.port}...`),await this.w(K,f(p)),this.n.logService.info(`${U} reconnected!`),this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(K),this.t(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.n.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(K),this.t(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this.n.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.n.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(K);continue}if((0,R.isCancellationError)(K)){this.n.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(K);continue}if(K instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(K),this.t(this.protocol.getMillisSinceLastIncomingData(),V+1,y.RemoteAuthorityResolverError.isHandled(K));break}this.n.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(K),this.t(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.k)}t(U,$,V){this.p?me.triggerPermanentFailure(U,$,V):this.u(U,$,V)}u(U,$,V){this.j.fire(new le(this.reconnectionToken,U,$,V)),O(this.protocol)}v(){this.protocol.pauseSocketWriting()}}me._permanentFailure=!1,me.f=0,me.g=0,me.h=!1,me.i=[],e.PersistentConnection=me;class G extends me{constructor(U,$,V,j,K){super(1,U,j,K,!0),this.client=this.B(new v.Client(K,{remoteAuthority:$,clientId:V},U.ipcLogger))}async w(U,$){await r(U,$)}}e.ManagementPersistentConnection=G;class B extends me{constructor(U,$,V,j,K){super(2,U,V,j,!1),this.y=$,this.debugPort=K}async w(U,$){await o(U,this.y,$)}}e.ExtensionHostPersistentConnection=B;function O(W){try{W.acceptDisconnect();const U=W.getSocket();W.dispose(),U.dispose()}catch(U){(0,R.onUnexpectedError)(U)}}function q(W){if(W&&W.type==="error"){const U=new Error(`Connection error: ${W.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function J(W,U){for(;W.length<U;)W+=" ";return W}function te(W,U){return`[remote-connection][${J(a(W),13)}][${U.substr(0,5)}\u2026]`}function ne(W,U,$){return`${te(W,U)}[${$?"reconnect":"initial"}]`}function L(W,U){return`${ne(U,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function F(W){return`${Date.now()-W} ms`}}),define(Z[229],ee([0,1,81,86]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,R,C,k,g,d){const b=y=>d(y,void 0),v=S.createConnection({host:n,port:R},()=>{v.removeListener("error",b);const y=Buffer.alloc(16);for(let a=0;a<16;a++)y[a]=Math.round(Math.random()*256);const h=y.toString("base64"),p=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${R}${C}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];v.write(p.join(`\r
`)+`\r
\r
`);const w=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),d(void 0,new M.NodeSocket(v,g)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",b)}}}),define(Z[230],ee([0,1,26,46,41,189]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let C;async function k(h=!1){return(C===void 0||h)&&(C=g()),C}e.hasWSLFeatureInstalled=k;async function g(){const h=d();if(h===void 0)return!1;if(h>=22e3){const p=v();if(p)return new Promise(w=>{M.execFile(p,["--status"],a=>w(!a))})}else{const p=y();if(p)try{if((await n.promises.stat(p)).isFile())return!0}catch{}}return!1}function d(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(h)return parseInt(h[3])}function b(h){const p=process.env.SystemRoot;if(p){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(p,w?"Sysnative":"System32",h)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(Z[56],ee([0,1,17,173,67,6,50]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function k(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=k;function g(w){return w.res.statusCode===204}async function d(w){return g(w)?null:(await(0,S.streamToBuffer)(w.stream)).toString()}e.asText=d;async function b(w){if(!k(w))throw new Error("Server returned "+w.res.statusCode);return d(w)}e.asTextOrError=b;async function v(w){if(!k(w))throw new Error("Server returned "+w.res.statusCode);if(g(w))return null;const f=(await(0,S.streamToBuffer)(w.stream)).toString();try{return JSON.parse(f)}catch(m){throw m.message+=`:
`+f,m}}e.asJson=v;function y(w){p(w)}e.updateProxyConfigurationsScope=y;let h;function p(w){const a=C.Registry.as(n.Extensions.Configuration),f=h;h={id:"http",order:15,title:(0,M.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(4,null),(0,M.localize)(5,null),(0,M.localize)(6,null),(0,M.localize)(7,null)],default:"override",description:(0,M.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[h],remove:f?[f]:[]})}p(2)}),define(Z[231],ee([0,1,17,22]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){throw new Error("Invalid listen")}call(k,g,d,b=M.CancellationToken.None){switch(g){case"request":return this.a.request(d[0],b).then(async({res:v,stream:y})=>{const h=await(0,S.streamToBuffer)(y);return[{statusCode:v.statusCode,headers:v.headers},h]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class R{constructor(k){this.a=k}async request(k,g){const[d,b]=await this.a.call("request",[k],g);return{res:d,stream:(0,S.bufferToStream)(b)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=R}),define(Z[232],ee([0,1,233,10]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(C,k,g={}){const d=(0,S.parse)(C),b=g.proxyUrl||n(d,k);if(!b)return null;const v=(0,S.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((h,p)=>{x(["http-proxy-agent"],h,p)}))(y):new(await new Promise((h,p)=>{x(["https-proxy-agent"],h,p)}))(y)}e.getProxyAgent=R}),define(Z[113],ee([0,1,46,9,174,22,44,13,4,31,149,61,8,128]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function w(f,m,P,E){return P["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(E)&&!P["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(E)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=y.Promises.withAsyncBody(async(D,t)=>{const c=new R.CancellationTokenSource;let i=1e4;const r=f.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,h.clamp)(r,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{D(await a(m,c.token))}catch(l){!(0,k.isCancellationError)(l)&&!c.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,C.toErrorMessage)(l)))):D({})}finally{clearTimeout(o),c.dispose()}})),p)}e.getResolvedShellEnv=w;async function a(f,m){const P=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",P);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",E);const D=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",c);const i=await(0,b.getSystemShell)(g.OS,c);return f.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(m.isCancellationRequested)return o(new k.CancellationError);const l=(0,M.basename)(i);let s,u;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(s=`& '${process.execPath}' ${I} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,u=["-Login","-Command"]):(s=`'${process.execPath}' ${I} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,l==="tcsh"||l==="csh"?u=["-ic"]:u=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),s);const A=(0,S.spawn)(i,[...u,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});m.onCancellationRequested(()=>(A.kill(),o(new k.CancellationError))),A.on("error",z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(z)),o(z)});const T=[];A.stdout.on("data",z=>T.push(z));const N=[];A.stderr.on("data",z=>N.push(z)),A.on("close",(z,H)=>{const ie=Buffer.concat(T).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const se=Buffer.concat(N).toString("utf8");if(se.trim()&&f.trace("getUnixShellEnvironment#stderr",se),z||H)return o(new Error((0,n.localize)(2,null,z,H)));const oe=t.exec(ie),ue=oe?oe[1]:"{}";try{const le=JSON.parse(ue);P?le.ELECTRON_RUN_AS_NODE=P:delete le.ELECTRON_RUN_AS_NODE,E?le.ELECTRON_NO_ATTACH_CONSOLE=E:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",le),r(le)}catch(le){f.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(le)),o(le)}})})}}),define(Z[91],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[234],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.b=new Map}c(){return new Promise((n,R)=>x(["vsda"],n,R))}async createNewMessage(n){try{const R=await this.c(),C=new R.validator;if(C){const k=String(S.a++);return this.b.set(k,C),{id:k,data:C.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,R){if(!n.id)return!0;const C=this.b.get(n.id);if(!C)return!1;this.b.delete(n.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(n){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(n)}catch{}return n}}S.a=1,e.SignService=S}),define(Z[34],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(Z[21],ee([0,1,15,42,8,3,2,4,36,10,6,5,34,28]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var p;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class ht extends C.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(m,P,E){super(),this.v=m,this.w=P,this.y=E,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ht.b),this.j&&this.w.removeItem(ht.b)}C(){const m=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};S.app.addListener("before-quit",m);const P=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",P),S.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit) - begin"),E.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),S.app.removeListener("before-quit",m),S.app.removeListener("window-all-closed",P),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}D(m){if(this.s)return this.s;const P=this.v;this.L("Lifecycle#onWillShutdown.fire()");const E=[];return this.f.fire({reason:m,join(D,t){P.trace(`Lifecycle#onWillShutdown - begin '${D}'`),E.push(t.finally(()=>{P.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.s=(async()=>{try{await n.Promises.settled(E)}catch(D){this.v.error(D)}try{await this.w.close()}catch(D){this.v.error(D)}})(),this.s}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===m)return;this.L(`lifecycle (main): phase changed (value: ${m})`),this.k=m;const P=this.u.get(this.k);P&&(P.open(),this.u.delete(this.k))}async when(m){if(m<=this.k)return;let P=this.u.get(m);P||(P=new n.Barrier,this.u.set(m,P)),await P.wait()}registerWindow(m){const P=new C.DisposableStore;this.n++,P.add(m.onWillLoad(D=>this.g.fire({window:m,workspace:D.workspace,reason:D.reason})));const E=(0,d.assertIsDefined)(m.win);E.on("close",D=>{const t=m.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${m.id}`),D.preventDefault(),this.unload(m,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(m),m.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.n--,P.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(m,P){await this.unload(m,3)||m.reload(P)}unload(m,P){const E=this.t.get(m.id);if(E)return E;const D=this.F(m,P).finally(()=>{this.t.delete(m.id)});return this.t.set(m.id,D),D}async F(m,P){if(!m.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${m.id}`);const E=this.i?2:P,D=await this.I(m,E);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.G(D)):(await this.J(m,E),!1)}G(m){return m?(this.H(!0),this.i=!1,!0):!1}H(m){this.r&&(this.r(m),this.r=void 0,this.p=void 0)}I(m,P){return new Promise(E=>{const D=this.m++,t=`vscode:ok${D}`,c=`vscode:cancel${D}`;M.validatedIpcMain.once(t,()=>{E(!1)}),M.validatedIpcMain.once(c,()=>{E(!0)}),m.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:P})})}J(m,P){return new Promise(E=>{const t=`vscode:reply${this.m++}`;M.validatedIpcMain.once(t,()=>E()),m.send("vscode:onWillUnload",{replyChannel:t,reason:P})})}quit(m){return this.L(`Lifecycle#quit() - begin (willRestart: ${m})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(m&&this.w.setItem(ht.b,!0),this.p=new Promise(P=>{this.r=P,this.L("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.p)}L(m){this.y.args["enable-smoke-test-driver"]?this.v.info(m):this.v.trace(m)}async relaunch(m){this.L("Lifecycle#relaunch()");const P=process.argv.slice(1);if(m?.addArgs&&P.push(...m.addArgs),m?.removeArgs)for(const t of m.removeArgs){const c=P.indexOf(t);c>=0&&P.splice(c,1)}const E=()=>{try{if(k.isWindows){const t=(0,g.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:P})};S.app.once("quit",E),await this.quit(!0)&&S.app.removeListener("quit",E)}async kill(m){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const P of S.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let E;P.webContents&&!P.webContents.isDestroyed()?E=new Promise(D=>P.once("closed",D)):E=Promise.resolve(),P.destroy(),await E}})()]),S.app.exit(m)}};a.b="lifecycle.quitAndRestart",a=ve([Q(0,v.ILogService),Q(1,y.IStateMainService),Q(2,h.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(Z[235],ee([0,1,4,3,2,6,21]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(b){super(),this.a=this.B(new M.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{x(["native-keymap"],v,y)});this.c=g(b),S.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=g(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ve([Q(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function g(d){const b=d.getKeyMap(),v=d.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(Z[236],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(Z[237],ee([0,1,8,17,10,33,16,5]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(v,y,h){this.f=v,this.g=y,this.h=h,this.a=Object.create(null),this.b="",this.c=new S.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,y){const h=this.a[v];return(0,n.isUndefinedOrNull)(h)?y:h}setItem(v,y){this.setItems([{key:v,data:y}])}setItems(v){let y=!1;for(const{key:h,data:p}of v)this.a[h]!==p&&((0,n.isUndefinedOrNull)(p)?(0,n.isUndefined)(this.a[h])||(this.a[h]=void 0,y=!0):(this.a[h]=p,y=!0));y&&this.j()}removeItem(v){(0,n.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,M.VSBuffer.fromString(v)),this.b=v}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let d=class{constructor(v,y,h){this.a=new g(v.stateResource,y,h)}async init(){await this.a.init()}getItem(v,y){return this.a.getItem(v,y)}};d=ve([Q(0,R.IEnvironmentService),Q(1,k.ILogService),Q(2,C.IFileService)],d),e.StateService=d}),define(Z[238],ee([0,1,237]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class M extends S.StateService{setItem(R,C){this.a.setItem(R,C)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=M}),define(Z[92],ee([0,1,4,36,7,31]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(d){if(S.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function k(d,b,v,y,h,p,w,a,f,m){const P=Object.create(null);P["common.machineId"]=w,P.sessionID=(0,R.generateUuid)()+Date.now(),P.commitHash=h,P.version=p,P["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),P["common.platform"]=(0,S.PlatformToString)(S.platform),P["common.nodePlatform"]=M.platform,P["common.nodeArch"]=y,P["common.product"]=m||"desktop",a&&(P["common.msftInternal"]=a);let E=0;const D=Date.now();Object.defineProperties(P,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),S.isLinuxSnap&&(P["common.snap"]="true");const t=C(v);t&&(P["common.platformDetail"]=t);try{const c=await d.readFile(n.URI.file(f));P["common.source"]=c.value.toString().slice(0,30)}catch{}return P}e.resolveCommonProperties=k;function g(d){const b=M.env.USERDNSDOMAIN;if(!b)return!1;const v=b.toLowerCase();return d.some(y=>v===y)}e.verifyMicrosoftInternalDomain=g}),define(Z[24],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[239],ee([0,1,26,8,43,14,9,4,7,84,23,102,87,16,20,24]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function f(t,c){const i=`${t}::${c.join(":")}`,r=a.get(i);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,s=new Map,u=2e4;function I(T,N,z,H){const ie=N.substring(T.length+1);return M.Promises.withAsyncBody(async se=>{let oe;try{oe=await b.Promises.readdir(N,{withFileTypes:!0})}catch{se();return}if(H.count>=u){H.count+=oe.length,H.maxReached=!0,se();return}let ue=oe.length;if(ue===0){se();return}let le=oe;H.count+oe.length>u&&(H.maxReached=!0,ue=u-H.count,le=oe.slice(0,ue)),H.count+=oe.length;for(const me of le)if(me.isDirectory()){if(z.includes(me.name)||await I(T,(0,C.join)(N,me.name),z,H),--ue===0){se();return}}else{const G=me.name.lastIndexOf(".");if(G>=0){const B=me.name.substring(G+1);B&&l.set(B,(l.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(ie)!==!1&&B.filePattern.test(me.name)&&s.set(B.tag,(s.get(B.tag)??0)+1);if(--ue===0){se();return}}})}const A=M.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await I(t,t,c,N);const z=await E(t);T({configFiles:m(s),fileTypes:m(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:z})});return a.set(i,A),A}e.collectWorkspaceStats=f;function m(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function P(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},c=S.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=P;async function E(t){try{const c=new Map,i=(0,C.join)(t,".vscode","launch.json"),r=await b.Promises.readFile(i),o=[],l=(0,n.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(l)==="object"&&l.configurations)for(const s of l.configurations){const u=s.type;u&&(c.has(u)?c.set(u,c.get(u)+1):c.set(u,1))}return m(c)}catch{return[]}}e.collectLaunchConfigs=E;let D=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const r=S.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${S.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,v.listProcesses)(c.mainPID),this.k(c)]).then(async r=>{let[o,l]=r,s=this.m(c,o);return i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))s+=`
${u.errorMessage}`,l+=`
${u.errorMessage}`;else if(s+=`

Remote: ${u.hostName}`,u.processes&&(s+=`
${this.m(c,u.processes)}`),u.workspaceMetadata){l+=`
|  Remote: ${u.hostName}`;for(const I of Object.keys(u.workspaceMetadata)){const A=u.workspaceMetadata[I];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${I}): ${T}`,l+=this.h(A)}}}),{processInfo:s,workspaceInfo:l}})}async getSystemInfo(c,i){const{memory:r,vmHint:o,os:l,cpus:s}=P(),u={os:l,memory:r,cpus:s,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(u.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),k.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(c,i){const r=[];return(0,v.listProcesses)(c.mainPID).then(async o=>(r.push(""),r.push(this.g(c)),r.push(""),r.push(this.m(c,o)),c.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(c))),i.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.f(l.machineInfo)),l.processes&&r.push(this.m(c,l.processes)),l.workspaceMetadata)for(const s of Object.keys(l.workspaceMetadata)){const u=l.workspaceMetadata[s];let I=`${u.fileCount} files`;u.maxFilesReached&&(I=`more than ${I}`),r.push(`Folder (${s}): ${I}`),r.push(this.h(u))}}),r.push(""),r.push(""),r.join(`
`)))}h(c){const i=[];let o=0;const l=(A,T)=>{const N=` ${A}(${T})`;o+N.length>60?(i.push(s),s="|                 ",o=s.length):o+=N.length,s+=N};let s="|      File types:";const u=10,I=c.fileTypes.length>u?u:c.fileTypes.length;for(let A=0;A<I;A++){const T=c.fileTypes[A];l(T.name,T.count)}if(i.push(s),c.configFiles.length>=0&&(s="|      Conf files:",o=0,c.configFiles.forEach(A=>{l(A.name,A.count)}),i.push(s)),c.launchConfigFiles.length>0){let A="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{A+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(A)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(r=>r.length));return Object.keys(c).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${c[r]}`).join(`
                  `)}k(c){const i=[],r=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const s=g.URI.revive(l);if(s.scheme===R.Schemas.file){const u=s.fsPath;r.push(f(u,["node_modules",".git"]).then(I=>{let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,C.basename)(u)}): ${A}`),i.push(this.h(I))}).catch(I=>{i.push(`|      Error: Unable to collect workspace stats for folder ${u} (${I.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,i){const r=new Map;c.windows.forEach(l=>r.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,r,o,i,0),o.join(`
`)}n(c,i,r,o,l){const s=l===0;let u;s?u=o.pid===c?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(u=`${u} (${i.get(o.pid)})`));const I=process.platform==="win32"?o.mem:S.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(I/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(A=>this.n(c,i,r,A,l+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:r}of c.folders){const o=g.URI.revive(r);if(o.scheme!==R.Schemas.file)continue;const l=o.fsPath;try{(await f(l,["node_modules",".git"])).fileTypes.forEach(u=>i.add(u.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const r=g.URI.revive(i);if(r.scheme!==R.Schemas.file)continue;const o=r.fsPath;try{const l=await f(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),l.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),l.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),l.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};D=ve([Q(0,w.ITelemetryService),Q(1,p.IProductService)],D),e.DiagnosticsService=D}),define(Z[240],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.b=R}listen(R,C){throw new Error(`Event not found: ${C}`)}call(R,C,{eventName:k,data:g}){return this.b.forEach(d=>d.log(k,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class M{constructor(R){this.b=R}log(R,C){return this.b.call("log",{eventName:R,data:C}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(Z[51],ee([0,1,40,10,3,19,55,92,24]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(s){this.value=s}}e.TelemetryTrustedValue=d;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,u){return Promise.resolve(void 0)}publicLog2(s,u){return this.publicLog(s,u)}publicLogError(s,u){return Promise.resolve(void 0)}publicLogError2(s,u){return this.publicLogError(s,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class v{async publicLog(s,u,I){}async publicLogError(s,u,I){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(l,s){return n.Event.debounce(s.onDidChangeConfiguration,(I,A)=>{const T=I?new Set([...I.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:T}},1e3,!0)(I=>{I.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(I.source),configurationKeys:E(I.affectedKeys)})})}e.configurationTelemetry=y;function h(l,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!l.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=h;function p(l,s){return!(s.isBuilt||s.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=p;function w(l){const s=l.getValue(g.TELEMETRY_SETTING_ID),u=l.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function a(l){const s={},u={},I={};P(l,I);for(let A in I){A=A.length>150?A.substr(A.length-149):A;const T=I[A];typeof T=="number"?u[A]=T:typeof T=="boolean"?u[A]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${T.length}`),s[A]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(s[A]=T)}return{properties:s,measurements:u}}e.validateTelemetryData=a;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(l){if(!l)return"none";const s=(0,C.getRemoteName)(l);return f.has(s)?s:"other"}e.cleanRemoteAuthority=m;function P(l,s,u=0,I){if(!!l)for(const A of Object.getOwnPropertyNames(l)){const T=l[A],N=I?I+A:A;Array.isArray(T)?s[N]=(0,S.safeStringify)(T):T instanceof Date?s[N]=T.toISOString():(0,M.isObject)(T)?u<2?P(T,s,u+1,N+"."):s[N]=(0,S.safeStringify)(T):s[N]=T}}function E(l){if(!l)return[];const s=[];return D(s,"",l),s}function D(l,s,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(I=>D(l,s?`${s}.${I}`:I,u[I])):l.push(s)}function t(l,s){const u=l.msftInternalDomains||[],I=s.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(u)||I}e.isInternalTelemetry=t;function c(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(l,s){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let u=l;const I=[];for(const z of s)for(;;){const H=z.exec(l);if(!H)break;I.push([H.index,z.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(u="";;){const z=T.exec(l);if(!z)break;const H=I.some(([ie,se])=>z.index<se&&ie<T.lastIndex);!A.test(z[0])&&!H&&(u+=l.substring(N,z.index)+"<REDACTED: user-file-path>",N=T.lastIndex)}return N<l.length&&(u+=l.substr(N)),u}function r(l){if(!l)return l;const s=l.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const I of u)if(I.regex.test(s))return`<REDACTED: ${I.label}>`;return l}function o(l,s){return(0,S.cloneAndChange)(l,u=>{if(u instanceof d)return u.value;if(typeof u=="string"){let I=u.replaceAll("%20"," ");I=i(I,s);for(const A of s)I=I.replace(A,"");return I=r(I),I}})}e.cleanData=o}),define(Z[114],ee([0,1,27,108,112,4,7,13,36,51]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,S.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(r){const o=r.manifest?r.manifest.version:r.version,l=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new y(r.identifier,o,l)}static parse(r){const o=v.exec(r);return o&&o[1]&&o[2]?new y({id:o[1]},o[2],o[4]||void 0):null}constructor(r,o,l="undefined"){this.version=o,this.targetPlatform=l,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof y?b(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=y;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(i){const r=h.exec(i);return r&&r[1]?[a(r[1]),r[2]]:[a(i),void 0]}e.getIdAndVersion=p;function w(i,r){return`${i}.${r}`}e.getExtensionId=w;function a(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function f(i,r){return a(w(i,r))}e.getGalleryExtensionId=f;function m(i,r){const o=[],l=s=>{for(const u of o)if(u.some(I=>b(r(I),r(s))))return u;return null};for(const s of i){const u=l(s);u?u.push(s):o.push([s])}return o}e.groupByExtension=m;function P(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(i){return{id:new d.TelemetryTrustedValue(i.identifier.id),name:new d.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function D(i,r){const o=[],l=r.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const s=l.shift();if(s&&o.every(u=>!b(u.identifier,{id:s}))){const u=i.filter(I=>b(I.identifier,{id:s}));u.length===1&&(o.push(u[0]),l.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function t(i,r){if(!R.isLinux)return!1;let o;try{o=(await i.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){r.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,r){const o=await t(i,r),l=(0,M.getTargetPlatform)(o?"alpine":R.platform,g.arch);return r.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=c}),define(Z[241],ee([0,1,196,51]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(R,C,k,g,d,b,v){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${C.nameShort})`};if((0,M.supportsTelemetry)(C,k)&&(0,M.getTelemetryLevel)(g)===3){const h=await(0,S.getServiceMachineId)(k,d,b),{machineId:p}=await v.getTelemetryInfo();y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=p||h}return y}e.resolveMarketplaceHeaders=n}),define(Z[242],ee([0,1,13,40,51]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function k(d,b,v){const y=await new Promise((f,m)=>{x(["@microsoft/1ds-core-js"],f,m)}),h=await new Promise((f,m)=>{x(["@microsoft/1ds-post-js"],f,m)}),p=new y.AppInsightsCore,w=new h.PostChannel,a={instrumentationKey:d,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){a.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[w.identifier]=f}return p.initialize(a,[]),p.addTelemetryInitializer(f=>{b&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),p}class g{constructor(b,v,y,h,p){this.e=b,this.f=v,this.g=y,this.h=p,this.c=R,this.d=C,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(v=>{b(v)},v=>{(0,S.onUnexpectedError)(v),console.error(v)})}}log(b,v){if(!this.a)return;v=(0,M.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const y=this.f+"/"+b;try{this.i(h=>{h.pluginVersionString=v?.properties.version??"Unknown",h.track({name:y,baseData:{name:y,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[115],ee([0,1,2,40,4,27,175,19,67,65,20,50,24,51]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(f,m,P){this.k=m,this.l=P,this.d={},this.i=new S.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.TELEMETRY_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,m){this.d[f]=m}m(){let f=(0,h.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const P=m.usage?3:m.error?2:0;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,m=f.sessionID,P=f["common.machineId"],E=f["common.firstSessionDate"],D=f["common.msftInternal"];return{sessionId:m,machineId:P,firstSessionDate:E,msftInternal:D}}dispose(){this.i.dispose()}n(f,m,P){return this.g<m?Promise.resolve(void 0):this.c.then(E=>{P=(0,M.mixin)(P,this.d),P=(0,h.cleanData)(P,this.j),P=(0,M.mixin)(P,E),this.b.forEach(D=>D.log(f,P))},E=>{console.error(E)})}publicLog(f,m){return this.n(f,3,m)}publicLog2(f,m){return this.publicLog(f,m)}publicLogError(f,m){return this.h?this.n(f,2,m):Promise.resolve(void 0)}publicLogError2(f,m){return this.publicLogError(f,m)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ve([Q(1,k.IConfigurationService),Q(2,b.IProductService)],p),e.TelemetryService=p;function w(){const a=(0,C.localize)(0,null,d.default.nameLong),f=d.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=n.isWeb?"":(0,C.localize)(3,null),P=(0,C.localize)(4,null),E=(0,C.localize)(5,null),D=(0,C.localize)(6,null),t=(0,C.localize)(7,null),c=`
|       | ${P} | ${E} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${a} ${f} ${m}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,C.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,C.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[243],ee([0,1,290,242]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends M.AbstractOneDataSystemAppender{constructor(C,k,g,d){const b={sendPOST:(v,y)=>{const h={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const p=S.request(v.urlString,h,w=>{w.on("data",function(a){y(w.statusCode??200,w.headers,a.toString())}),w.on("error",function(a){y(0,{})})});p.write(v.data),p.end()}catch{y(0,{})}}};super(C,k,g,d,b)}}e.OneDataSystemAppender=n}),define(Z[244],ee([0,1,4,84,24]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(C){let k=C.getItem(n.machineIdKey);return(typeof k!="string"||S.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,M.getMachineId)()),k}e.resolveMachineId=R}),define(Z[116],ee([0,1,24,244]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(R){const C=await(0,M.resolveMachineId)(R);return R.setItem(S.machineIdKey,C),C}e.resolveMachineId=n}),define(Z[68],ee([0,1,15,3,2,4,19,6,34]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const d="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",h="theme",p="themeBackground",w="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let a=class extends n.Disposable{constructor(m,P){super(),this.b=m,this.c=P,this.a=this.B(new M.Emitter),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return m.dark?v:y;let P=this.b.getItem(p,null);if(!P)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":P=d;break;case"hc-black":P=v;break;case"hc-light":P=y;break;default:P=b}return R.isMacintosh&&P.toUpperCase()===b&&(P="#171717"),P}saveWindowSplash(m,P){this.b.setItems([{key:h,data:P.baseTheme},{key:p,data:P.colorInfo.background},{key:w,data:P}]),typeof m=="number"&&this.f(m,P)}f(m,P){for(const E of S.BrowserWindow.getAllWindows())if(E.id===m){E.setBackgroundColor(P.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};a=ve([Q(0,g.IStateMainService),Q(1,C.IConfigurationService)],a),e.ThemeMainService=a}),define(Z[117],ee([0,1,3,19,6,5]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function y(w,a,f,m){if(f===1)return!1;if(f===2&&v(a)){const P=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(P?.length===4&&parseInt(P[1])>=18)return!1}return w<1024}e.isPortPrivileged=y;class h{constructor(a,f,m){this.remoteAddress=a,this.localAddress=f,this.b=m,this.a=new S.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let p=class{constructor(a,f){this.i=a,this.j=f,this.a=new S.Emitter,this.onTunnelOpened=this.a.event,this.b=new S.Emitter,this.onTunnelClosed=this.b.event,this.c=new S.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],f=Array.from(this.d.values());for(const m of f){const P=Array.from(m.values());for(const E of P){const D=await E.value;D&&a.push(D)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:f}of a.values())await f.then(m=>m?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,f,m,P,E){this.o(a,f,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:f,localAddress:m,privacy:P,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,f){(v(a)||b(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const m=this.q(a,f);if(m)return++m.refcount,m.value}openTunnel(a,f,m,P,E,D=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${m} on local port ${E}.`),!a)return;if(f||(f="localhost"),P||(P=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(a,f,m,P,E,D,t,c);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const f=this.d.get(a.tunnelRemoteHost);if(f){const m=f.get(a.tunnelRemotePort);m&&(m.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,m))}}}}async n(a,f,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${f}.`);const P=m.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(f),P}}async closeTunnel(a,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${f} `);const m=this.d.get(a);if(m&&m.has(f)){const P=m.get(f);P.refcount=0,await this.n(a,f,P)}}o(a,f,m){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(f,{refcount:1,value:m})}async p(a,f){const m=this.d.get(a);m&&(await m.get(f)||m.delete(f),m.size===0&&this.d.delete(a))}q(a,f){const m=[a];b(a)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const P=m.map(E=>this.d.get(E));for(const E of P){const D=E?.get(f);if(D)return D}}canTunnel(a){return!!d(a)}s(a,f,m,P,E,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${m} on local port ${P}.`);const c=m;this.h.add(c);const i=P===void 0?m:P,r={elevationRequired:E?this.isPortPrivileged(i):!1},o={remoteAddress:{host:f,port:m},localAddressPort:P,privacy:D,public:D?D!==k.Private:void 0,protocol:t},l=a.forwardPort(o,r);return l?(this.o(f,m,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),l}};p=ve([Q(0,R.ILogService),Q(1,M.IConfigurationService)],p),e.AbstractTunnelService=p}),define(Z[245],ee([0,1,81,26,99,229,8,2,19,5,20,228,117,91,4]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(E,D,t,c,i){let r;for(let o=3;o&&(r?.dispose(),r=await new a(E,D,t,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class a extends k.Disposable{constructor(D,t,c,i,r){super(),this.j=t,this.k=r,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=S.createServer(),this.c=new C.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,n.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&D.write(r.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let f=class extends y.AbstractTunnelService{constructor(D,t,c,i,r){super(t,r),this.t=D,this.u=c,this.v=i}isPortPrivileged(D){return(0,y.isPortPrivileged)(D,this.k,p.OS,M.release())}r(D,t,c,i,r,o,l,s){const u=this.q(t,c);if(u)return++u.refcount,u.value;if(this.e)return this.s(this.e,t,c,r,o,l,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${r}.`);const I={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},A=w(I,i,t,c,r);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,A),A}}};f=ve([Q(1,d.ILogService),Q(2,h.ISignService),Q(3,b.IProductService),Q(4,g.IConfigurationService)],f),e.BaseTunnelService=f;let m=class extends f{constructor(D,t,c,i){super(R.nodeSocketFactory,D,t,c,i)}};m=ve([Q(0,d.ILogService),Q(1,h.ISignService),Q(2,b.IProductService),Q(3,g.IConfigurationService)],m),e.TunnelService=m;let P=class extends k.Disposable{constructor(D,t,c,i){super(),this.b=D,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(D,t,c,i,r,o,l,s,u){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this.a.has(D)){const I=new m(this.b,this.f,this.c,this.g);this.B(I),this.a.set(D,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,c,i,r,o,l,s,u)}};P=ve([Q(0,d.ILogService),Q(1,b.IProductService),Q(2,h.ISignService),Q(3,g.IConfigurationService)],P),e.SharedTunnelsService=P}),define(Z[48],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(M=e.StateType||(e.StateType={}));var n;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,C)=>({type:"idle",updateType:R,error:C}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(Z[246],ee([0,1,4,176,67,50]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[247],ee([0,1,3,48]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(k,g,d){switch(g){case"checkForUpdates":return this.a.checkForUpdates(d);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(d)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=n;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new S.Emitter,this.onStateChange=this.a.event,this.b=M.State.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=R}),define(Z[93],ee([0,1,8,22,3,19,28,21,5,20,56,48]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(p,w,a){return`${a.updateUrl}/api/update/${p}/${w}/${a.commit}`}e.createUpdateURL=y;let h=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,a,f,m,P,E){this.f=w,this.g=a,this.h=f,this.i=m,this.j=P,this.k=E,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),a=this.l(w);if(!a){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(a),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,f=>this.j.error(f))}l(w){return w==="none"?void 0:this.k.quality}m(w=60*60*1e3){return(0,S.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},M.CancellationToken.None)).res.statusCode===204}catch(a){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(a);return}}async _applySpecificUpdate(w){}p(){return 1}q(){}};h=ve([Q(0,k.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,C.IEnvironmentMainService),Q(3,b.IRequestService),Q(4,g.ILogService),Q(5,d.IProductService)],h),e.AbstractUpdateService=h}),define(Z[248],ee([0,1,15,54,3,2,19,28,21,5,20,56,24,48,93]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends p.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(S.autoUpdater,"error",(f,m)=>m)}get v(){return n.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(f,m,P)=>({url:m,version:P,productVersion:P}))}get x(){return n.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(f,m,P,E)=>({releaseNotes:m,version:P,productVersion:P,date:E}))}constructor(f,m,P,E,D,t,c){super(f,m,E,D,t,c),this.y=P,this.t=new R.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(f){this.j.error("UpdateService error:",f);const P=(this.state.type==="checking for updates"?this.state.explicit:!0)?f:void 0;this.d(h.State.Idle(1,P))}r(f){let m;this.k.darwinUniversalAssetId?m=this.k.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const P=(0,p.createUpdateURL)(m,f,this.k);try{S.autoUpdater.setFeedURL({url:P})}catch(E){this.j.error("Failed to set update feed URL",E);return}return P}s(f){this.d(h.State.CheckingForUpdates(f)),S.autoUpdater.checkForUpdates()}C(f){this.state.type==="checking for updates"&&this.d(h.State.Downloading(f))}D(f){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:f.version}),this.d(h.State.Ready(f)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ve([M.memoize],w.prototype,"u",null),ve([M.memoize],w.prototype,"v",null),ve([M.memoize],w.prototype,"w",null),ve([M.memoize],w.prototype,"x",null),w=ve([Q(0,g.ILifecycleMainService),Q(1,C.IConfigurationService),Q(2,y.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,v.IRequestService),Q(5,d.ILogService),Q(6,b.IProductService)],w),e.DarwinUpdateService=w}),define(Z[249],ee([0,1,46,41,8,3,9,28,21,5,24,48]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,a,f){if(this.f=w,this.g=f,this.a=v.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,a.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(w=60*60*1e3){return(0,n.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};y=ve([Q(0,g.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,d.ILogService)],y);let h=class extends y{constructor(w,a,f,m,P,E){super(f,m,P),this.o=w,this.p=a,this.q=E;const D=(0,M.watch)(C.dirname(this.o)),t=R.Event.fromNodeEventEmitter(D,"change",(o,l)=>l),c=R.Event.filter(t,o=>o==="current"),r=R.Event.debounce(c,(o,l)=>l,2e3)(()=>this.checkForUpdates(!1));f.onWillShutdown(()=>{r.dispose(),D.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((f,m)=>(0,M.realpath)(`${C.dirname(this.o)}/current`,(P,E)=>P?m(P):f(E))),a=C.basename(w);return this.p!==a}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=ve([Q(2,g.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,d.ILogService),Q(5,b.ITelemetryService)],h),e.SnapUpdateService=h}),define(Z[38],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(Z[250],ee([0,1,38,197,16,18,129,3,2]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(y){this.uri=y,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let b=class{constructor(y){this.g=y,this.c=new g.DisposableStore,this.f=2**16;const h=new Map,p=w=>{let a=h.get(w.scheme);return a===void 0&&(a=y.hasProvider(w)&&!this.g.hasCapability(w,1024),h.set(w.scheme,a)),a};this.c.add(k.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{h.delete(w.scheme)})),this.extUri=new R.ExtUri(p),this.d=new C.SkipList((w,a)=>this.extUri.compare(w,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.normalizePath)(y));const h=this.d.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new d(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((p,w)=>p[1].touch<w[1].touch?1:p[1].touch>w[1].touch?-1:0);d._clock=0,this.d.clear();const h=this.f*.5;for(let p=0;p<h;p++)this.d.set(y[p][0],y[p][1].touch())}};b=ve([Q(0,n.IFileService)],b),e.UriIdentityService=b,(0,M.registerSingleton)(S.IUriIdentityService,b,1)}),define(Z[118],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(Z[251],ee([0,1,7]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(k){this.a=k}listen(k,g){throw new Error(`Event not found: ${g}`)}call(k,g,d){switch(g){case"handleURL":return this.a.handleURL(S.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=M;class n{constructor(k){this.a=k}handleURL(k,g){return this.a.call("handleURL",[k.toJSON(),g])}}e.URLHandlerChannelClient=n;class R{constructor(k,g){this.a=k,this.b=g}async routeCall(k,g,d,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(d)&&d.length>0){const v=S.URI.revive(d[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const h=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,v.toString(!0));const p=new RegExp(`window:${h}`),w=k.connections.find(a=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",a.ctx),p.test(a.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,g,d,b)}routeEvent(k,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=R}),define(Z[252],ee([0,1,8,2,7,20]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends M.Disposable{constructor(){super(...arguments),this.a=new Set}open(d,b){const v=[...this.a.values()];return(0,S.first)(v.map(y=>()=>y.handleURL(d,b)),void 0,!1).then(y=>y||!1)}registerHandler(d){return this.a.add(d),(0,M.toDisposable)(()=>this.a.delete(d))}}e.AbstractURLService=C;let k=class extends C{constructor(d){super(),this.b=d}create(d){let{authority:b,path:v,query:y,fragment:h}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:h})}};k=ve([Q(0,R.IProductService)],k),e.NativeURLService=k}),define(Z[253],ee([0,1,15,8,3,2,4,7]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g{constructor(b,v,y,h,p,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,b&&(w.trace("ElectronURLListener initialUrisToHandle:",b.map(m=>m.originalUrl)),this.a=b),C.isWindows){const m=h.isBuilt?[]:[`"${h.appRoot}"`];m.push("--open-url","--"),S.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,m)}const a=n.Event.map(n.Event.fromNodeEventEmitter(S.app,"open-url",(m,P)=>({event:m,url:P})),({event:m,url:P})=>(m.preventDefault(),P));this.d.add(a(m=>{const P=this.h(m);!P||this.f.open(P,{originalUrl:m})})),y.getWindows().filter(m=>m.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(y.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return k.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,this.c=(0,M.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=g}),define(Z[254],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(Z[255],ee([0,1,15,2,14,7]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends M.Disposable{constructor(){super();const g=this.b.bind(this);S.protocol.registerFileProtocol(n.Schemas.vscodeWebview,g)}b(g,d){try{const b=R.URI.parse(g.url),v=C.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,h=n.FileAccess.asFileUri(y);return d({path:decodeURIComponent(h.fsPath),headers:{...n.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return d({error:-10})}catch{}return d({error:-2})}}C.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=C}),define(Z[76],ee([0,1,4]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(b){return!!b.workspaceUri}e.isWorkspaceToOpen=M;function n(b){return!!b.folderUri}e.isFolderToOpen=n;function R(b){return!!b.fileUri}e.isFileToOpen=R;function C(b){const v=k(b),y=b.getValue("window.menuBarVisibility");return y==="default"||v==="native"&&y==="compact"||S.isMacintosh&&S.isNative?"classic":y}e.getMenuBarVisibility=C;function k(b){if(S.isWeb)return"custom";const v=b.getValue("window");if(v){if(S.isMacintosh&&v.nativeTabs===!0||S.isMacintosh&&v.nativeFullScreen===!1)return"native";const p=v.titleBarStyle;if(p==="native"||p==="custom")return p}return S.isLinux?"native":"custom"}e.getTitleBarStyle=k;function g(b){if(!S.isWindows||S.isWeb||k(b)==="native")return!1;const v=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=g;function d(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=d}),define(Z[119],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var M;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));const n=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=n;var R;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var C;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(C=e.WindowError||(e.WindowError={}))}),define(Z[30],ee([0,1,6]),function(x,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var M;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}))}),define(Z[256],ee([0,1,15,22,3,71,2,31,74,107,5,20,30]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let p=class extends C.Disposable{constructor(a,f,m,P,E){super(),this.g=a,this.h=f,this.i=m,this.j=P,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const a=n.Event.fromNodeEventEmitter(S.app,"login",(f,m,P,E,D)=>({event:f,webContents:m,req:P,authInfo:E,callback:D}));this.B(a(this.m,this))}async m({event:a,authInfo:f,req:m,callback:P}){if(!f.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(f);try{E=await this.b}finally{this.b=void 0}}P(E?.username,E?.password)}async n(a){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const f=await this.p(a);if(f)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),f;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(a){this.g.trace("auth#doResolveProxyCredentials - enter",a);const f=String((0,R.hash)({scheme:a.scheme,host:a.host,port:a.port}));let m,P;try{const c=await this.i.getPassword(this.a,f);if(c){const i=JSON.parse(await this.j.decrypt(c));m=i.username,P=i.password}}catch(c){this.g.error(c)}if(this.c!==h.StoredCredentialsUsed&&typeof m=="string"&&typeof P=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:m,password:P};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const D={authInfo:a,username:this.f?.username??m,password:this.f?.password??P,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,D),this.c=h.LoginDialogShown;const t=await new Promise(c=>{const i=async(r,o,l)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",i),l){const s={username:l.username,password:l.password};try{if(l.remember){const u=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,f,u)}else await this.i.deletePassword(this.a,f)}catch(u){this.g.error(u)}c({username:s.username,password:s.password})}else c(void 0)};E.win?.webContents.on("ipc-message",i)});return this.f=t,t}};p=ve([Q(0,b.ILogService),Q(1,y.IWindowsMainService),Q(2,g.ICredentialsMainService),Q(3,d.IEncryptionMainService),Q(4,v.IProductService)],p),e.ProxyAuthHandler=p}),define(Z[257],ee([0,1,74,5,33,20,30,208]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends k.BaseCredentialsMainService{constructor(b,v,y,h){super(b),this.j=v,this.k=y,this.l=h,this.i=p=>{this.l.sendToFocused("vscode:showCredentialsError",p.message??p)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new S.InMemoryCredentialsProvider,this.f;const b=await new Promise((v,y)=>{x(["keytar"],v,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};g=ve([Q(0,M.ILogService),Q(1,n.INativeEnvironmentService),Q(2,R.IProductService),Q(3,C.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(Z[258],ee([0,1,15,25,4,7,23,19,61,6,5,118,30]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,d.createDecorator)(e.ID);let h=class{constructor(w,a,f,m){this.a=w,this.b=a,this.c=f,this.d=m}async start(w,a){this.a.trace("Received data from other instance: ",w,a),n.isMacintosh&&S.app.focus({steal:!0});const f=this.e(w);if(f.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const P=(0,M.firstOrDefault)(await this.b.openEmptyWindow({context:4}));P&&(m=P.ready())}m.then(()=>{for(const{uri:P,originalUrl:E}of f)this.c.open(P,{originalUrl:E})})}else return this.f(w,a)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,M.coalesce)(w._urls.map(a=>{try{return{uri:R.URI.parse(a),originalUrl:a}}catch{return null}})):[]}async f(w,a){const f=(0,g.isLaunchedFromCli)(a)?0:4;let m=[];const P=w.wait&&w.waitMarkerFilePath?R.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,D={context:f,cli:w,userEnv:a,waitMarkerFileURI:P,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,D);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)m=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,D),m=[c]):m=await this.b.open({...D,forceEmpty:!0})}}else m=await this.b.open({...D,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(P&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,C.whenDeleted)(P.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=ve([Q(0,b.ILogService),Q(1,y.IWindowsMainService),Q(2,v.IURLService),Q(3,k.IConfigurationService)],h),e.LaunchMainService=h}),define(Z[259],ee([0,1,15,2,3,5,260,8,14,30,72,24]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let y=class Et extends M.Disposable{constructor(p,w,a){super(),this.n=p,this.p=w,this.r=a,this.b=String(++Et.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(p,w){let a;switch(this.l?.correlationId?a=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${p}`:a=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${p}`,w){case b.default.Error:this.n.error(a);break;case b.default.Warning:this.n.warn(a);break;case b.default.Info:this.n.info(a);break}}t(p){if(this.j){this.s("Cannot start utility process because it is already running...",b.default.Error);return}const w=this.p.getWindowById(p.responseWindowId)?.win;if(!w||w.isDestroyed()||w.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error);return}return w}start(p){const w=this.t(p);if(!w)return;this.l=p;const a=`${this.l.type}-${this.b}`,f=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,m=[...this.l.args??[],`--type=${this.l.type}`],P=this.l.execArgv,E=this.l.allowLoadingUnsignedLibraries,D="pipe";let t=this.l.env;if(t){t={...t};for(const c of Object.keys(t))t[c]=String(t[c])}this.s("creating new...",b.default.Info),this.j=S.utilityProcess.fork(f,m,{serviceName:a,env:t,execArgv:P,allowLoadingUnsignedLibraries:E,stdio:D}),this.u(this.j,this.l,a),this.v(this.j,this.l,w)}u(p,w,a){if(p.stdout){const f=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(p.stdout,"data")(m=>this.c.fire(typeof m=="string"?m:f.write(m))))}if(p.stderr){const f=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(p.stderr,"data")(m=>this.f.fire(typeof m=="string"?m:f.write(m))))}this.B(n.Event.fromNodeEventEmitter(p,"message")(f=>this.g.fire(f))),this.B(n.Event.fromNodeEventEmitter(p,"spawn")(()=>{this.k=p.pid,this.s("successfully created",b.default.Info)})),this.B(n.Event.fromNodeEventEmitter(p,"exit")(f=>{this.s(`received exit event with code ${f}`,b.default.Info),this.m=!0,this.h.fire({pid:this.k,code:f,signal:"unknown"})})),this.B(n.Event.fromNodeEventEmitter(S.app,"child-process-gone",(f,m)=>({event:f,details:m}))(({details:f})=>{f.type==="Utility"&&f.name===a&&(this.s(`crashed with code ${f.exitCode} and reason '${f.reason}'`,b.default.Error),this.r.publicLog2("utilityprocesscrash",{type:w.type,reason:f.reason,code:f.exitCode}),this.i.fire({pid:this.k,code:f.exitCode,reason:f.reason}))}))}v(p,w,a){const{port1:f,port2:m}=new S.MessageChannelMain;p.postMessage("null",[m]),a.webContents.postMessage(w.responseChannel,w.responseNonce,[f])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",b.default.Info);const p=process;return typeof p._debugProcess=="function"?(p._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",b.default.Warning);return}this.s("attempting to kill the process...",b.default.Info),this.j.kill()?this.s("successfully killed the process",b.default.Info):this.s("unable to kill the process",b.default.Warning)}async waitForExit(p){if(!this.j){this.s("no running process to wait for exit",b.default.Warning);return}this.m||(this.s("waiting to exit...",b.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,k.timeout)(p)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",b.default.Info),this.kill()))}};y.a=0,y=ve([Q(0,R.ILogService),Q(1,d.IWindowsMainService),Q(2,v.ITelemetryService)],y),e.UtilityProcess=y}),define(Z[261],ee([0,1,13,2,3,5,21,70,46,260,8,14,40,4,36,259,30,24]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let m=class It{constructor(D,t,c,i){this.d=D,this.f=c,this.g=i,this.c=!1,this.b=new Map,t.onWillShutdown(r=>{this.c=!0,r.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}h(D){const t=this.b.get(D);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(D){return this.h(D).onStdout}onDynamicStderr(D){return this.h(D).onStderr}onDynamicMessage(D){return this.h(D).onMessage}onDynamicError(D){const t=this.h(D);return t instanceof w.UtilityProcess?n.Event.None:t.onError}onDynamicExit(D){return this.h(D).onExit}async createExtensionHost(D){if(this.c)throw(0,S.canceled)();const t=String(++It.a);let c;return D?c=new w.UtilityProcess(this.d,this.f,this.g):c=new P(t,this.d),this.b.set(t,c),c.onExit(({pid:i,code:r,signal:o})=>{this.d.info(`Extension host with pid ${i} exited with code: ${r}, signal: ${o}.`),setTimeout(()=>{c.dispose(),this.b.delete(t)})}),{id:t}}async start(D,t){if(this.c)throw(0,S.canceled)();return this.h(D).start({...t,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:D})}async enableInspectPort(D){if(this.c)throw(0,S.canceled)();const t=this.b.get(D);return t?t.enableInspectPort():!1}async kill(D){if(this.c)throw(0,S.canceled)();const t=this.b.get(D);!t||t.kill()}async _killAllNow(){for(const[,D]of this.b)D.kill()}async _waitForAllExit(D){const t=[];for(const[,c]of this.b)t.push(c.waitForExit(D));return b.Promises.settled(t).then(()=>{})}};m.a=0,m=ve([Q(0,R.ILogService),Q(1,C.ILifecycleMainService),Q(2,a.IWindowsMainService),Q(3,f.ITelemetryService)],m),e.ExtensionHostStarter=m;let P=class extends M.Disposable{constructor(D,t){super(),this.id=D,this.c=t,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(D){h.isCI&&this.c.info("Calling fork to start extension host...");const t=k.StopWatch.create(!1);this.a=(0,g.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,p.cwd)()},D));const c=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${c} ms).`);const r=new d.StringDecoder("utf-8");this.a.stdout?.on("data",l=>{const s=typeof l=="string"?l:r.write(l);this._onStdout.fire(s)});const o=new d.StringDecoder("utf-8");this.a.stderr?.on("data",l=>{const s=typeof l=="string"?l:o.write(l);this._onStderr.fire(s)}),this.a.on("message",l=>{this._onMessage.fire(l)}),this.a.on("error",l=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(l)})}),this.a.on("exit",(l,s)=>{this.b=!0,this._onExit.fire({pid:i,code:l,signal:s})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(D){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,b.timeout)(D)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${D}ms.`),this.a.kill())}};P=ve([Q(1,R.ILogService)],P)}),define(Z[262],ee([0,1,15,3,2,255,30]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends n.Disposable{constructor(d){super(),this.b=d,this.a=this.B(new M.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,b){let v;if(typeof d.windowId=="number"){const{windowId:y}=d,h=this.b.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);v=h.win.webContents}else{const{webContentsId:y}=d;if(v=S.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(d,b,v,y){const p=this.c(d,b);if(typeof p.findInFrame=="function"){p.findInFrame(v,{findNext:y.findNext,forward:y.forward});const w=(a,f)=>{f.finalUpdate&&(this.a.fire(f),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(d,b,v){const h=this.c(d,b);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(d,b){const v=this.b.getWindowById(d.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${d}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};k=ve([Q(0,C.IWindowsMainService)],k),e.WebviewMainService=k}),define(Z[263],ee([0,1,8,3,2]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends n.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:g,getActiveWindowId:d}){super(),this.a=this.B(new n.DisposableStore),M.Event.latch(M.Event.any(k,g))(this.f,this,this.a),this.b=(0,S.createCancelablePromise)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(Z[29],ee([0,1,180,9,60,18,7,6,14]),function(x,e,S,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function d(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=d;function b(i){return typeof i?.id=="string"&&!d(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function y(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=y;function h(i){const r=i;if(r?.uri)return{id:r.id,uri:C.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function w(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=w;function a(i){const r=i;return!!(r&&typeof r=="object"&&C.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class f{constructor(r,o,l,s,u){this.h=r,this.j=l,this.k=s,this.l=u,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class m{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function P(i){return new m({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=P,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function D(i){let r;return C.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=D;function t(i,r){return!E(i,r)&&!D(i)}e.isSavedWorkspace=t;function c(i){return(typeof i=="string"?(0,M.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(Z[57],ee([0,1,15,8,71,45,2,79,4,10,23,157,88,6,5,20,29]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,h.createDecorator)("dialogMainService");let f=class{constructor(P,E){this.d=P,this.e=E,this.a=new Map,this.b=new Map,this.c=new M.Queue}pickFileFolder(P,E){return this.f({...P,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},E)}pickFolder(P,E){return this.f({...P,pickFolders:!0,title:(0,v.localize)(1,null)},E)}pickFile(P,E){return this.f({...P,pickFiles:!0,title:(0,v.localize)(2,null)},E)}pickWorkspace(P,E){const D=(0,v.localize)(3,null),t=(0,R.mnemonicButtonLabel)((0,v.localize)(4,null)),c=a.WORKSPACE_FILTER;return this.f({...P,pickFiles:!0,title:D,filters:c,buttonLabel:t},E)}async f(P,E){const D={title:P.title,buttonLabel:P.buttonLabel,filters:P.filters,defaultPath:P.defaultPath};(typeof P.pickFiles=="boolean"||typeof P.pickFolders=="boolean")&&(D.properties=void 0,P.pickFiles&&P.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",P.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,d.withNullAsUndefined)(E||S.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(P){if(P){let E=this.b.get(P.id);return E||(E=new M.Queue,this.b.set(P.id,E)),E}else return this.c}showMessageBox(P,E){return this.g(E).queue(async()=>{const{options:D,buttonIndeces:t}=(0,y.massageMessageBoxOptions)(P,this.e);let c;return E?c=await S.dialog.showMessageBox(E,D):c=await S.dialog.showMessageBox(D),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(P,E){const D=this.j(P,E);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(E).queue(async()=>{let t;return E?t=await S.dialog.showSaveDialog(E,P):t=await S.dialog.showSaveDialog(P),t.filePath=this.h(t.filePath),t})}finally{(0,C.dispose)(D)}}h(P){return P&&g.isMacintosh&&(P=(0,k.normalizeNFC)(P)),P}i(P){return P.map(E=>this.h(E))}async showOpenDialog(P,E){P.defaultPath&&(await b.Promises.exists(P.defaultPath)||(P.defaultPath=void 0));const D=this.j(P,E);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(E).queue(async()=>{let t;return E?t=await S.dialog.showOpenDialog(E,P):t=await S.dialog.showOpenDialog(P),t.filePaths=this.i(t.filePaths),t})}finally{(0,C.dispose)(D)}}j(P,E){if(!E)return C.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",P);let D=this.a.get(E.id);D||(D=new Set,this.a.set(E.id,D));const t=(0,n.hash)(P);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",P),D.add(t),(0,C.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",P),D?.delete(t),D?.size===0&&this.a.delete(E.id)})}};f=ve([Q(0,p.ILogService),Q(1,w.IProductService)],f),e.DialogMainService=f}),define(Z[264],ee([0,1,3,2,83,29]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends M.Disposable{constructor(g,d){super(),this.f=g,this.g=d,this.b=this.B(new S.Emitter),this.c=new Map,this.h(d.applicationStorage,this.b)}h(g,d){this.B(S.Event.debounce(g.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),C.a)(b=>{b.length&&d.fire(this.i(b,g))}))}i(g,d){const b=new Map,v=new Set;return g.forEach(y=>{const h=d.get(y.key);typeof h=="string"?b.set(y.key,h):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(g,d,b){switch(d){case"onDidChangeStorage":{const v=b.profile?(0,n.revive)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new S.Emitter),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${d}`)}async call(g,d,b){const v=b.profile?(0,n.revive)(b.profile):void 0,y=(0,R.reviveIdentifier)(b.workspace),h=await this.j(v,y);switch(d){case"getItems":return Array.from(h.items.entries());case"updateItems":{const p=b;if(p.insert)for(const[w,a]of p.insert)h.set(w,a);p.delete?.forEach(w=>h.delete(w));break}case"isUsed":{const p=b.payload;if(typeof p=="string")return this.g.isUsed(p)}default:throw new Error(`Call not found: ${d}`)}}async j(g,d){let b;d?b=this.g.workspaceStorage(d):g?b=this.g.profileStorage(g):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${d?"workspace":g?"profile":"application"} storage due to ${v}`)}return b}}C.a=100,e.StorageDatabaseChannel=C}),define(Z[39],ee([0,1,71,3,2,18,7,177,33,16,6,5,29,35,38,8,31,27,10]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function P(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&C.URI.isUri(r.location)&&C.URI.isUri(r.globalStorageHome)&&C.URI.isUri(r.settingsResource)&&C.URI.isUri(r.keybindingsResource)&&C.URI.isUri(r.tasksResource)&&C.URI.isUri(r.snippetsHome)&&C.URI.isUri(r.extensionsResource))}e.isUserDataProfile=P,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function E(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:C.URI.revive(i.location).with({scheme:r}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:C.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=E;function D(i,r,o,l){return{id:i,name:r,location:o,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=D;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,o,l,s){super(),this.m=r,this.n=o,this.r=l,this.s=s,this.f=!0,this.g=this.B(new M.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new M.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new M.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new M.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)try{for(const u of this.I()){if(!u.name||!(0,m.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}r.push(D((0,R.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}}catch(u){this.s.error(u)}const o=new h.ResourceMap,l=new Map,s=this.v();if(r.unshift({...s,extensionsResource:this.N()??s.extensionsResource,isDefault:!0}),r.length)try{const u=this.L();if(u.workspaces)for(const[I,A]of Object.entries(u.workspaces)){const T=C.URI.parse(I),N=r.find(z=>z.id===A);N&&o.set(T,N)}if(u.emptyWindows)for(const[I,A]of Object.entries(u.emptyWindows)){const T=r.find(N=>N.id===A);T&&l.set(I,T)}}catch(u){this.s.error(u)}this.t={profiles:r,workspaces:o,emptyWindows:l}}return this.t}v(){return D("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(r){const o="Temp",l=new RegExp(`${(0,f.escapeRegExpCharacters)(o)}\\s(\\d+)`);let s=0;for(const I of this.profiles){const A=l.exec(I.name),T=A?parseInt(A[1]):0;s=T>s?T:s}const u=`${o} ${s+1}`;return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),u,{transient:!0},r)}async createNamedProfile(r,o,l){return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),r,o,l)}async createProfile(r,o,l,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.w(r,o,l);return s&&await this.setProfileForWorkspace(s,u),u}async w(r,o,l){if(!(0,m.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(o);return s||(s=(async()=>{try{const u=this.profiles.find(T=>T.name===o||T.id===r);if(u)return u;const I=D(r,o,(0,R.joinPath)(this.profilesHome,r),l);await this.n.createFolder(I.location);const A=[];return this.h.fire({profile:I,join(T){A.push(T)}}),await w.Promises.settled(A),this.C([I],[],[]),I}finally{this.k.delete(o)}})(),this.k.set(o,s)),s}async updateProfile(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(s=>s.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=D(l.id,o.name??l.name,l.location,{shortName:o.shortName??l.shortName,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(s=>s.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this.i.fire({profile:o,join(s){l.push(s)}});try{await Promise.allSettled(l)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(s=>s.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.F(r,l)}unsetWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(r,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.y(r);return C.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:r.id}z(r){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location)))}C(r,o,l){const s=[...this.profiles,...r],u=[];this.l.profiles=[];for(let I of s)I.isDefault||o.some(A=>I.id===A.id)||(I=l.find(A=>I.id===A.id)??I,I.isTransient?this.l.profiles.push(I):u.push({location:I.location,name:I.name,shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}));this.J(u),this.t=void 0,this.D(r,o,l)}D(r,o,l){this.g.fire({added:r,removed:o,updated:l,all:this.profiles})}F(r,o,l){l=o?.isTransient?!0:l,l||this.F(r,void 0,!0);const s=this.y(r),u=l?this.l:this.u;C.URI.isUri(s)?(u.workspaces.delete(s),o&&u.workspaces.set(s,o)):(u.emptyWindows.delete(s),o&&u.emptyWindows.set(s,o)),l||this.G()}G(){const r={};for(const[l,s]of this.u.workspaces.entries())r[l.toString()]=s.id;const o={};for(const[l,s]of this.u.emptyWindows.entries())o[l.toString()]=s.id;this.M({workspaces:r,emptyWindows:o}),this.t=void 0}H(r){const o={},l=this.v();if(r.workspaces)for(const[u,I]of Object.entries(r.workspaces)){const A=C.URI.parse(I);o[u]=this.r.extUri.isEqual(A,l.location)?l.id:this.r.extUri.basename(A)}const s={};if(r.emptyWindows)for(const[u,I]of Object.entries(r.emptyWindows)){const A=C.URI.parse(I);s[u]=this.r.extUri.isEqual(A,l.location)?l.id:this.r.extUri.basename(A)}return{workspaces:o,emptyWindows:s}}I(){return[]}J(r){throw new Error("not implemented")}L(){return{}}M(r){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([Q(0,g.IEnvironmentService),Q(1,d.IFileService),Q(2,p.IUriIdentityService),Q(3,v.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(r){this.a=r}L(){return this.Q}M(r){this.Q=r}}e.InMemoryUserDataProfilesService=c}),define(Z[77],ee([0,1,8,17,2,3,35,7,108,114,16,6,5,39,38,10,13,24]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class P extends Error{constructor(i,r){super(i),this.code=r}}e.ExtensionsProfileScanningError=P,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let E=class extends n.Disposable{constructor(i,r,o,l,s,u){super(),this.i=i,this.j=r,this.k=o,this.l=l,this.m=s,this.n=u,this.b=this.B(new R.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(i,r){return this.p(i,void 0,r)}async addExtensionsToProfile(i,r){const o=[],l=[];try{return await this.p(r,s=>{const u=[];for(const I of s)i.some(([A])=>(0,d.areSameExtensions)(A.identifier,I.identifier)&&A.manifest.version!==I.version)?o.push(I):u.push(I);for(const[I,A]of i)if(!u.some(T=>(0,d.areSameExtensions)(T.identifier,I.identifier)&&T.version===I.manifest.version)){const T={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:A};l.push(T),u.push(T)}return l.length&&this.b.fire({extensions:l,profileLocation:r}),o.length&&this.f.fire({extensions:o,profileLocation:r}),u}),l.length&&this.c.fire({extensions:l,profileLocation:r}),o.length&&this.g.fire({extensions:o,profileLocation:r}),l}catch(s){throw l.length&&this.c.fire({extensions:l,error:s,profileLocation:r}),o.length&&this.g.fire({extensions:o,error:s,profileLocation:r}),s}}async updateMetadata(i,r){const o=[];return await this.p(r,l=>{const s=[];for(const u of l){const I=i.find(([A])=>(0,d.areSameExtensions)(A.identifier,u.identifier)&&A.manifest.version===u.version);I&&(u.metadata={...u.metadata,...I[1]},o.push(u)),s.push(u)}return s}),o}async removeExtensionFromProfile(i,r){const o=[];this.f.fire({extensions:o,profileLocation:r});try{await this.p(r,l=>{const s=[];for(const u of l)(0,d.areSameExtensions)(u.identifier,i.identifier)?o.push(u):s.push(u);return o.length&&this.f.fire({extensions:o,profileLocation:r}),s}),o.length&&this.g.fire({extensions:o,profileLocation:r})}catch(l){throw o.length&&this.g.fire({extensions:o,error:l,profileLocation:r}),l}}async p(i,r,o){return this.w(i).queue(async()=>{let l=[],s;try{const u=await this.j.readFile(i);s=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,b.toFileOperationResult)(u)!==1)throw u;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&o?.bailOutWhenFileNotFound)throw new P((0,a.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(i);let u=!1;for(const I of s){D(I)||this.r(i);let A;if((0,w.isString)(I.relativeLocation))A=this.t(I.relativeLocation);else if((0,w.isString)(I.location))A=this.t(I.location),u=!0,I.relativeLocation=I.location,I.location=A.toJSON();else{A=k.URI.revive(I.location);const T=this.s(A);T&&(u=!0,I.relativeLocation=T)}l.push({identifier:I.identifier,location:A,version:I.version,metadata:I.metadata})}u&&await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(s)))}if(r){l=r(l);const u=l.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(u)))}return l})}r(i){const r=new P(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}s(i){return this.l.extUri.isEqualOrParent(i,this.i)?this.l.extUri.relativePath(this.i,i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),r=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(s){if((0,b.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",i.toString());let l;try{const s=JSON.parse(o);Array.isArray(s)&&s.every(u=>D(u))?l=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,b.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(i)}catch(s){(0,b.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(r)}catch(s){(0,b.toFileOperationResult)(s)!==1&&this.n.error(s)}return l})()),this.u}w(i){let r=this.h.get(i);return r||(r=new S.Queue,this.h.set(i,r)),r}};E=ve([Q(1,b.IFileService),Q(2,h.IUserDataProfilesService),Q(3,p.IUriIdentityService),Q(4,f.ITelemetryService),Q(5,y.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function D(c){return(0,w.isObject)(c)&&(0,g.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,w.isString)(c.location))&&((0,w.isUndefined)(c.relativeLocation)||(0,w.isString)(c.relativeLocation))&&c.version&&(0,w.isString)(c.version)}function t(c){return c?(0,w.isString)(c.path)&&(0,w.isString)(c.scheme):!1}}),define(Z[120],ee([0,1,25,8,40,17,13,43,142,2,14,9,4,18,195,72,10,7,162,33,114,112,194,16,6,5,20,3,83,77,39,38,192,193]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(me){function G(B,O){if(B===O)return!0;const q=Object.keys(B),J=new Set;for(const te of Object.keys(O))J.add(te);if(q.length!==J.size)return!1;for(const te of q){if(B[te]!==O[te])return!1;J.delete(te)}return J.size===0}me.equals=G})(z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends d.Disposable{constructor(G,B,O,q,J,te,ne,L,F,W,U,$){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=B,this.l=O,this.m=q,this.n=J,this.p=te,this.r=ne,this.s=L,this.t=F,this.u=W,this.v=U,this.w=$,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(oe,(0,h.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(oe,(0,h.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(G,B,O){const[q,J]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(B)]),te=O?await this.scanExtensionsUnderDevelopment(G,[...q,...J]):[];return this.F(q,J,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const B=[];B.push(this.G(!!G.useCache,G.language)),B.push(this.H(G.language,!!G.checkControlFile));const[O,q]=await Promise.all(B);return this.D([...O,...q],0,G,!1)}async scanUserExtensions(G){const B=G.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",B);const O=this.v.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.J(B,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,O),J=G.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let te;try{te=await J.scanExtensions(q)}catch(ne){if(ne instanceof u.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),te=await J.scanExtensions(q);else throw ne}return te=await this.D(te,1,G,!0),this.s.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(G,B){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const O=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(q=>q.scheme===b.Schemas.file).map(async q=>{const J=await this.J(q,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(J)).map(ne=>(ne.type=B.find(L=>(0,E.areSameExtensions)(L.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,J)))}))).flat();return this.D(O,"development",G,!0)}return[]}async scanExistingExtension(G,B,O){const q=await this.J(G,!1,B,!0,O.language,!0,void 0),J=await this.k.scanExtension(q);return!J||!O.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(G,B,O){const q=await this.J(G,!1,B,!0,O.language,!0,void 0),J=await this.k.scanOneOrMultipleExtensions(q);return this.D(J,B,O,!0)}async scanMetadata(G){const B=(0,h.joinPath)(G,"package.json"),O=(await this.r.readFile(B)).value.toString();return JSON.parse(O).__metadata}async updateMetadata(G,B){const O=(0,h.joinPath)(G,"package.json"),q=(await this.r.readFile(O)).value.toString(),J=JSON.parse(q);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,J.__metadata={...J.__metadata,...B},await this.r.writeFile((0,h.joinPath)(G,"package.json"),R.VSBuffer.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof u.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw G}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(B=>[B,B.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,c.toFileOperationResult)(B)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(B))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.s.error(G)}finally{this.z=void 0}})()),this.z}async D(G,B,O,q){return O.includeAllVersions||(G=this.F(B===0?G:void 0,B===1?G:void 0,B==="development"?G:void 0,await this.getTargetPlatform(),q)),O.includeInvalid||(G=G.filter(J=>J.isValid)),G.sort((J,te)=>{const ne=v.basename(J.location.fsPath),L=v.basename(te.location.fsPath);return ne<L?-1:ne>L?1:0})}F(G,B,O,q,J){const te=(L,F,W)=>{if(L.isValid&&!F.isValid)return!1;if(L.isValid===F.isValid){if(J&&p.gt(L.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${L.location.path} with version ${L.manifest.version}`),!1;if(p.eq(L.manifest.version,F.manifest.version)){if(L.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${L.location.path} with same version`),!1;if(L.targetPlatform===q)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${L.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${L.location.path} with ${F.location.path}.`),!0},ne=new Map;return G?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);(!W||te(W,L,!1))&&ne.set(F,L)}),B?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);if(!W&&G&&L.type===0){this.s.debug(`Skipping obsolete system extension ${L.location.path}.`);return}(!W||te(W,L,!1))&&ne.set(F,L)}),O?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);(!W||te(W,L,!0))&&ne.set(F,L),ne.set(F,L)}),[...ne.values()]}async G(G,B){this.s.trace("Started scanning system extensions");const O=await this.J(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),J=await(G&&!O.devMode?this.i:this.k).scanExtensions(O);return this.s.trace("Scanned system extensions:",J.length),J}async H(G,B){const O=this.t.isBuilt?[]:this.u.builtInExtensions;if(!O?.length)return[];this.s.trace("Started scanning dev system extensions");const q=B?await this.I():{},J=[],te=f.URI.file(v.normalize(v.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const L of O){const F=q[L.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":J.push((0,h.joinPath)(te,L.name));break;default:J.push(f.URI.file(F));break}}const ne=await Promise.all(J.map(async L=>this.k.scanExtension(await this.J(L,!1,0,!0,G,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ne.length),(0,S.coalesce)(ne)}async I(){try{const G=await this.r.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,B,O,q,J,te,ne){const L=await this.f(J??y.language),F=await this.L(G),W=B&&!this.v.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=W?await this.L(W):void 0;return new ie(G,F,W,U,B,ne,O,q,te,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,J,L)}async L(G){try{const B=await this.r.stat(G);if(typeof B.mtime=="number")return B.mtime}catch{}}};H=ve([Q(4,I.IUserDataProfilesService),Q(5,u.IExtensionsProfileScannerService),Q(6,c.IFileService),Q(7,r.ILogService),Q(8,P.IEnvironmentService),Q(9,o.IProductService),Q(10,A.IUriIdentityService),Q(11,i.IInstantiationService)],H),e.AbstractExtensionsScannerService=H;class ie{constructor(G,B,O,q,J,te,ne,L,F,W,U,$,V,j,K){this.location=G,this.mtime=B,this.applicationExtensionslocation=O,this.applicationExtensionslocationMtime=q,this.profile=J,this.profileScanOptions=te,this.type=ne,this.excludeObsolete=L,this.validate=F,this.productVersion=W,this.productDate=U,this.productCommit=$,this.devMode=V,this.language=j,this.translations=K}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,B){return(0,h.isEqual)(G.location,B.location)&&G.mtime===B.mtime&&(0,h.isEqual)(G.applicationExtensionslocation,B.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&G.profile===B.profile&&n.equals(G.profileScanOptions,B.profileScanOptions)&&G.type===B.type&&G.excludeObsolete===B.excludeObsolete&&G.validate===B.validate&&G.productVersion===B.productVersion&&G.productDate===B.productDate&&G.productCommit===B.productCommit&&G.devMode===B.devMode&&G.language===B.language&&z.equals(G.translations,B.translations)}}e.ExtensionScannerInput=ie;let se=class extends d.Disposable{constructor(G,B,O,q,J){super(),this.f=G,this.g=B,this.h=O,this.i=q,this.j=J}async scanExtensions(G){const B=G.profile?await this.l(G):await this.k(G);let O={};if(G.excludeObsolete&&G.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();O=JSON.parse(q)}catch{}return(0,a.isEmptyObject)(O)?B:B.filter(q=>!O[E.ExtensionKey.create(q).toString()])}async k(G){const B=await this.i.resolve(G.location);if(!B.children?.length)return[];const O=await Promise.all(B.children.map(async q=>{if(!q.isDirectory||G.type===1&&(0,h.basename)(q.resource).indexOf(".")===0)return null;const J=new ie(q.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(J)}));return(0,S.coalesce)(O).sort((q,J)=>q.location.path<J.location.path?-1:1)}async l(G){let B=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){B=B.filter(q=>!q.metadata?.isApplicationScoped);const O=await this.m(G.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,G);B.push(...O)}return B}async m(G,B,O){const q=await this.g.scanProfileExtensions(G,O.profileScanOptions);if(!q.length)return[];const J=await Promise.all(q.map(async te=>{if(B(te)){const ne=new ie(te.location,O.mtime,O.applicationExtensionslocation,O.applicationExtensionslocationMtime,O.profile,O.profileScanOptions,O.type,O.excludeObsolete,O.validate,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations);return this.scanExtension(ne,te.metadata)}return null}));return(0,S.coalesce)(J)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,h.joinPath)(G.location,"package.json"))){const B=await this.scanExtension(G);return B?[B]:[]}else return await this.scanExtensions(G)}catch(B){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,C.getErrorMessage)(B)),[]}}async scanExtension(G,B){try{let O=await this.scanExtensionManifest(G.location);if(O){O.publisher||(O.publisher=D.UNDEFINED_PUBLISHER),B=B??O.__metadata,delete O.__metadata;const q=(0,E.getGalleryExtensionId)(O.publisher,O.name),J=B?.id?{id:q,uuid:B.id}:{id:q},te=B?.isSystem?0:G.type,ne=te===0||!!B?.isBuiltin;N.ImplicitActivationEvents.updateManifest(O),O=await this.n(G.location,O,ie.createNlsConfiguration(G));const L={type:te,identifier:J,manifest:O,location:G.location,isBuiltin:ne,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return G.validate?this.validate(L,G):L}}catch(O){G.type!==0&&this.j.error(O)}return null}validate(G,B){let O=!0;const q=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,G.manifest,G.isBuiltin);for(const[J,te]of q)J===w.default.Error&&(O=!1,this.j.error(this.t(B.location,te)));return G.isValid=O,G.validations=q,G}async scanExtensionManifest(G){const B=(0,h.joinPath)(G,"package.json");let O;try{O=(await this.i.readFile(B)).value.toString()}catch(J){return(0,c.toFileOperationResult)(J)!==1&&this.j.error(this.t(G,(0,m.localize)(0,null,B.path,J.message))),null}let q;try{q=JSON.parse(O)}catch{const te=[];(0,k.parse)(O,te);for(const ne of te)this.j.error(this.t(G,(0,m.localize)(1,null,B.path,ne.offset,ne.length,(0,g.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(q)!=="object"?(this.j.error(this.t(G,(0,m.localize)(2,null,B.path))),null):q}async n(G,B,O){const q=await this.p(G,B,O);if(q)try{const J=[],te=await this.r(q.default,J);if(J.length>0)return J.forEach(L=>{this.j.error(this.t(G,(0,m.localize)(3,null,q.default?.path,(0,g.getParseErrorMessage)(L.error))))}),B;if((0,k.getNodeType)(q)!=="object")return this.j.error(this.t(G,(0,m.localize)(4,null,q.default?.path))),B;const ne=q.values||Object.create(null);return(0,T.localizeManifest)(B,ne,te)}catch{}return B}async p(G,B,O){const q=(0,h.joinPath)(G,"package.nls.json"),J=(F,W)=>{W.forEach(U=>{this.j.error(this.t(G,(0,m.localize)(5,null,F?.path,(0,g.getParseErrorMessage)(U.error))))})},te=F=>{this.j.error(this.t(G,(0,m.localize)(6,null,F?.path)))},ne=`${B.publisher}.${B.name}`,L=O.translations[ne];if(L)try{const F=f.URI.file(L),W=(await this.i.readFile(F)).value.toString(),U=[],$=(0,k.parse)(W,U);return U.length>0?(J(F,U),{values:void 0,default:q}):(0,k.getNodeType)($)!=="object"?(te(F),{values:void 0,default:q}):{values:$.contents?$.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let W;try{W=await this.s(G,O)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const U=(await this.i.readFile(W.localized)).value.toString(),$=[],V=(0,k.parse)(U,$);return $.length>0?(J(W.localized,$),{values:void 0,default:W.original}):(0,k.getNodeType)(V)!=="object"?(te(W.localized),{values:void 0,default:W.original}):{values:V,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(G,B){if(G)try{const O=(await this.i.readFile(G)).value.toString();return(0,k.parse)(O,B)}catch{}}s(G,B){return new Promise((O,q)=>{const J=te=>{const ne=(0,h.joinPath)(G,`package.nls.${te}.json`);this.i.exists(ne).then(L=>{L&&O({localized:ne,original:(0,h.joinPath)(G,"package.nls.json")});const F=te.lastIndexOf("-");F===-1?O({localized:(0,h.joinPath)(G,"package.nls.json"),original:null}):(te=te.substring(0,F),J(te))})};if(B.devMode||B.pseudo||!B.language)return O({localized:(0,h.joinPath)(G,"package.nls.json"),original:null});J(B.language)})}t(G,B){return`[${G.path}]: ${B}`}};se=ve([Q(1,u.IExtensionsProfileScannerService),Q(2,A.IUriIdentityService),Q(3,c.IFileService),Q(4,r.ILogService)],se);let oe=class extends se{constructor(G,B,O,q,J,te){super(B,O,q,J,te),this.y=G,this.v=this.B(new M.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(G){const B=await this.z();if(this.u=G,B&&B.input&&ie.equals(B.input,this.u))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.v.trigger(()=>this.D()),B.result.map(q=>(q.location=f.URI.revive(q.location),q));const O=await super.scanExtensions(G);return await this.C({input:G,result:O}),O}async z(){try{const G=await this.i.readFile(this.y),B=JSON.parse(G.value.toString());return{result:B.result,input:(0,s.revive)(B.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,C.getErrorMessage)(G))}return null}async C(G){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(G)))}catch(B){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,C.getErrorMessage)(B))}}async D(){if(!this.u)return;const G=await this.z();if(!G)return;const B=G.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(O,B))try{await this.i.del(this.y),this.w.fire()}catch(q){this.j.error(q)}}};oe=ve([Q(2,u.IExtensionsProfileScannerService),Q(3,A.IUriIdentityService),Q(4,c.IFileService),Q(5,r.ILogService)],oe);function ue(me,G){const B=(0,E.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:B,identifier:new D.ExtensionIdentifier(B),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:G,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ue;class le extends H{constructor(G,B,O,q,J,te,ne,L,F,W,U,$){super(G,B,(0,h.joinPath)(O,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(q,D.MANIFEST_CACHE_FOLDER),J,te,ne,L,F,W,U,$),this.M=(async()=>{if(y.translationsConfigFile)try{const V=await this.r.readFile(f.URI.file(y.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=le}),define(Z[265],ee([0,1,5,39,38,24,77,16,33,7]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends C.AbstractExtensionsProfileScannerService{constructor(y,h,p,w,a,f){super(d.URI.file(y.extensionsPath),h,p,w,a,f)}};b=ve([Q(0,g.INativeEnvironmentService),Q(1,k.IFileService),Q(2,M.IUserDataProfilesService),Q(3,n.IUriIdentityService),Q(4,R.ITelemetryService),Q(5,S.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[266],ee([0,1,7,33,77,120,16,6,5,20,38,39]),function(x,e,S,M,n,R,C,k,g,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(p,w,a,f,m,P,E,D){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,S.URI.file(m.userDataPath),p,w,a,f,m,P,E,D)}};y=ve([Q(0,v.IUserDataProfilesService),Q(1,n.IExtensionsProfileScannerService),Q(2,C.IFileService),Q(3,g.ILogService),Q(4,M.INativeEnvironmentService),Q(5,d.IProductService),Q(6,b.IUriIdentityService),Q(7,k.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(Z[267],ee([0,1,15,2,14,9,4,60,7,31,42,33,5,39]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends M.Disposable{constructor(a,f,m){super(),this.c=a,this.f=m,this.a=k.TernarySearchTree.forPaths(!C.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(f.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:a}=S.session;a.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(f,m)=>this.i(f,m)),a.protocol.interceptFileProtocol(n.Schemas.file,(f,m)=>this.h(f,m)),this.B((0,M.toDisposable)(()=>{a.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(a){const f=(0,R.normalize)(a);return this.a.get(f)?M.Disposable.None:(this.a.set(f,!0),(0,M.toDisposable)(()=>this.a.delete(f)))}h(a,f){const m=g.URI.parse(a.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${n.Schemas.file}: protocol (original URL: ${a.url})`),f({error:-3})}i(a,f){const m=this.j(a);let P;return this.c.crossOriginIsolated&&((0,R.basename)(m)==="workbench.html"||(0,R.basename)(m)==="workbench-dev.html"?P=n.COI.CoopAndCoep:P=n.COI.getHeadersFromQuery(a.url)),this.a.findSubstr(m)?f({path:m,headers:P}):this.b.has((0,R.extname)(m).toLowerCase())?f({path:m}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),f({error:-3}))}j(a){const f=g.URI.parse(a.url),m=n.FileAccess.uriToFileUri(f);return(0,R.normalize)(m.fsPath)}createIPCObjectUrl(){let a;const f=g.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),m=f.toString(),P=async()=>a;return b.validatedIpcMain.handle(m,P),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:f,update:E=>a=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),b.validatedIpcMain.removeHandler(m)}}}};p=ve([Q(0,v.INativeEnvironmentService),Q(1,h.IUserDataProfilesService),Q(2,y.ILogService)],p),e.ProtocolMainService=p}),define(Z[268],ee([0,1,15,42,8,3,2,14,10,104,28,21,5,65,66,68,44,39,37,64]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends C.Disposable{constructor(t,c,i,r,o,l,s,u,I,A){super(),this.g=t,this.h=c,this.i=i,this.j=r,this.k=o,this.l=l,this.m=s,this.n=u,this.p=I,this.r=A,this.a=new n.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){M.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,c)=>this.t(t,c)),M.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,c)=>this.u(t,c)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,c){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[i])}u(t,c){this.l.trace("SharedProcess: onWorkerConnection",c);const i=new C.DisposableStore,r=l=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${l}')`,c),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",c))},o=S.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){r("unavailable");return}i.add(R.Event.filter(this.k.onWillLoadWindow,l=>l.window.win===o)(()=>r("load"))),i.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>r("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,t.ports)}v(){this.l.trace("SharedProcess: onWillShutdown");const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{this.l.trace("SharedProcess: onWillShutdown window.close()"),t.close()}catch(c){this.l.trace(`SharedProcess: onWillShutdown window.close() error: ${c}`)}this.b=void 0},0))}w(t,...c){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...c)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,a.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new S.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),product:h.default,policiesData:this.n.serialize()}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,c)=>this.f.fire({type:2,details:c})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,c,i)=>this.f.fire({type:3,details:{reason:i,exitCode:c}})))}async connect(){await this.C;const t=(0,g.assertIsDefined)(this.b);return(0,d.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};E=ve([Q(2,b.IEnvironmentMainService),Q(3,f.IUserDataProfilesService),Q(4,v.ILifecycleMainService),Q(5,y.ILogService),Q(6,P.ILoggerMainService),Q(7,m.IPolicyService),Q(8,w.IThemeMainService),Q(9,p.IProtocolMainService)],E),e.SharedProcess=E}),define(Z[94],ee([0,1,8,3,2,63,10,105,6,39]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function h(m){const P=m.get(e.TARGET_KEY);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}e.loadKeyTargets=h;class p extends n.Disposable{constructor(P={flushInterval:p.a}){super(),this.j=P,this.b=this.B(new M.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new M.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new S.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,S.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(P,E){if(E===e.TARGET_KEY){switch(P){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:E,target:this.F(P)[E]})}r(P){this.f.fire({reason:P})}get(P,E,D){return this.L(E)?.get(P,D)}getBoolean(P,E,D){return this.L(E)?.getBoolean(P,D)}getNumber(P,E,D){return this.L(E)?.getNumber(P,D)}store(P,E,D,t){if((0,C.isUndefinedOrNull)(E)){this.remove(P,D);return}this.t(()=>{this.u(P,D,t),this.L(D)?.set(P,E)})}remove(P,E){this.t(()=>{this.u(P,E,void 0),this.L(E)?.delete(P)})}t(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,E){const D=[],t=this.F(P);for(const c of Object.keys(t))t[c]===E&&D.push(c);return D}u(P,E,D){const t=this.F(E);typeof D=="number"?t[P]!==D&&(t[P]=D,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[P]=="number"&&(delete t[P],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(P){switch(P){case-1:return this.D;case 0:return this.z;default:return this.w}}G(P){const E=this.L(P);return E?h(E):Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=b.NONE){this.f.fire({reason:P});const E=this.L(-1),D=this.L(0),t=this.L(1);switch(P){case b.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return f(P,E,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(P,E){return this.r(b.NONE),(0,d.isUserDataProfile)(P)?this.N(P,E):this.O(P,E)}H(P,E){return!(P.id===E.id||w(E)&&w(P))}I(P,E,D,t){this.t(()=>{if(t)for(const[c,i]of P)E.set(c,i);else{const c=new Set;for(const[i,r]of P)c.add(i),E.get(i)!==r&&this.n(D,i);for(const[i]of E.items)c.has(i)||this.n(D,i)}})}}p.a=60*1e3,e.AbstractStorageService=p;function w(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class a extends p{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(P=>this.n(1,P))),this.B(this.P.onDidChangeStorage(P=>this.n(0,P))),this.B(this.p.onDidChangeStorage(P=>this.n(-1,P)))}L(P){switch(P){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(P){switch(P){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(P){return!1}}e.InMemoryStorageService=a;async function f(m,P,E,D,t,c){const i=N=>{try{return JSON.parse(N)}catch{return N}},r=new Map,o=new Map;m.forEach((N,z)=>{r.set(z,N),o.set(z,i(N))});const l=new Map,s=new Map;P.forEach((N,z)=>{l.set(z,N),s.set(z,i(N))});const u=new Map,I=new Map;E.forEach((N,z)=>{u.set(z,N),I.set(z,i(N))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const A=[];if(r.forEach((N,z)=>{A.push({key:z,value:N})}),console.table(A),console.groupEnd(),console.log(o),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach((z,H)=>{N.push({key:H,value:z})}),console.table(N),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${c})`);const T=[];u.forEach((N,z)=>{T.push({key:z,value:N})}),console.table(T),console.groupEnd(),console.log(I)}e.logStorage=f}),define(Z[269],ee([0,1,25,8,3,2,9,70,7,23,105,153,5,94,24,29]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends R.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new M.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(r=>this.b.fire({key:r}))),await this.m(c);const i=c.getBoolean(h.IS_NEW_KEY);i===void 0?c.set(h.IS_NEW_KEY,!0):i&&c.set(h.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new k.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>a.a&&await this.r(c),this.c.fire()}async r(c){if(!!this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([o,l])=>({key:o,length:l.length})),(o,l)=>l.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),r=(await this.k.stat(g.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}a.a=2e3;class f extends a{get path(){if(!this.v.useInMemoryStorage)return(0,C.join)(this.u.globalStorageHome.fsPath,f.t)}constructor(c,i,r,o){super(r,o),this.u=c,this.v=i}async n(){return new b.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}f.t="state.vscdb";class m extends f{constructor(c,i,r,o){super(c,i,r,o)}}e.ProfileStorageMain=m;class P extends f{constructor(c,i,r,o){super(i.defaultProfile,c,r,o)}async m(c){await super.m(c),this.z(c)}z(c){c.get(p.firstSessionDateStorageKey,void 0)===void 0&&c.set(p.firstSessionDateStorageKey,new Date().toUTCString());const r=c.get(p.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(p.lastSessionDateStorageKey,typeof r>"u"?null:r),c.set(p.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=P;class E extends a{get path(){if(!this.w.useInMemoryStorage)return(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(c,i,r,o,l){super(r,l),this.v=c,this.w=i,this.y=o}async n(){const{storageFilePath:c,wasCreated:i}=await this.C();return new b.Storage(new v.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,C.join)(c,E.t);return await d.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await d.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:i,wasCreated:!0})}async D(c){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const r=(0,C.join)(c,E.u);await d.Promises.exists(r)||await d.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}E.t="state.vscdb",E.u="workspace.json",e.WorkspaceStorageMain=E;class D extends a{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(Z[270],ee([0,1,3,2,94]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends M.Disposable{constructor(k,g,d){super(),this.b=k,this.c=g,this.f=d;const b=this.B(new M.MutableDisposable);this.a=this.B(new S.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new M.DisposableStore;return k.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,d)=>(g?g.push(d.key):g=[d.key],g),100)(g=>this.h(g))),k.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(g,d)=>{g||(g=new Map);let b=g.get(d.profile.id);return b||g.set(d.profile.id,b={profile:d.profile,keys:[],storage:d.storage}),b.keys.push(d.key),g},100)(g=>this.i(g))),k}h(k){const g=k.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],d=[];if(k=k.filter(b=>b!==n.TARGET_KEY),k.length){const b=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);d.push({profile:this.c.defaultProfile,changes:k.map(v=>({key:v,scope:0,target:b[v]}))})}this.j(g,d)}i(k){const g=[],d=new Map;for(const[b,v]of k.entries()){v.keys.includes(n.TARGET_KEY)&&g.push(v.profile);const y=v.keys.filter(h=>h!==n.TARGET_KEY);if(y.length){const h=(0,n.loadKeyTargets)(v.storage.storage);d.set(b,{profile:v.profile,changes:y.map(p=>({key:p,scope:0,target:h[p]}))})}}this.j(g,[...d.values()])}j(k,g){(k.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:k})}listen(k,g,d){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(k,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[271],ee([0,1,10,7,33,16,5,236,38,39]),function(x,e,S,M,n,R,C,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends d.UserDataProfilesService{constructor(h,p,w,a){super(p,w,h,a),this.a=p}N(){return this.r.extUri.joinPath(M.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=ve([Q(0,g.IUriIdentityService),Q(1,n.INativeEnvironmentService),Q(2,R.IFileService),Q(3,C.ILogService)],b),e.ServerUserDataProfilesService=b;let v=class dt extends b{constructor(h,p,w,a,f){super(p,w,a,f),this.Q=h}I(){return this.Q.getItem(dt.b,[]).map(p=>({...p,location:(0,S.isString)(p.location)?this.r.extUri.joinPath(this.profilesHome,p.location):M.URI.revive(p.location)}))}L(){const h=this.Q.getItem(dt.c,{});return this.Q.getItem(dt.P,!1)?h:this.H(h)}N(){return this.r.extUri.joinPath(M.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v.P="profileAssociationsMigration",v=ve([Q(0,k.IStateService),Q(1,g.IUriIdentityService),Q(2,n.INativeEnvironmentService),Q(3,R.IFileService),Q(4,C.ILogService)],v),e.UserDataProfilesService=v}),define(Z[52],ee([0,1,7,33,16,6,5,34,38,39,271]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(d.IUserDataProfilesService);let v=class st extends b.UserDataProfilesService{constructor(h,p,w,a,f){super(h,p,w,a,f),this.W=h}getAssociatedEmptyWindows(){const h=[];for(const p of this.u.emptyWindows.keys())h.push({id:p});return h}J(h){h.length?this.W.setItem(st.b,h.map(p=>({...p,location:this.r.extUri.basename(p.location)}))):this.W.removeItem(st.b)}I(){const h=super.I();return this.W.getItem("userDataProfilesMigration",!1)||(this.J(h),this.W.setItem("userDataProfilesMigration",!0)),h}M(h){h.emptyWindows||h.workspaces?this.W.setItem(st.c,h):this.W.removeItem(st.c)}L(){const h="workspaceAndProfileInfo",p=this.W.getItem(h,void 0);if(p){this.W.removeItem(h);const a=p.reduce((f,{workspace:m,profile:P})=>(f[S.URI.revive(m).toString()]=S.URI.revive(P).toString(),f),{});this.W.setItem(st.c,{workspaces:a})}const w=super.L();return this.W.getItem(b.UserDataProfilesService.P,!1)||(this.M(w),this.W.setItem(b.UserDataProfilesService.P,!0)),w}};v=ve([Q(0,k.IStateMainService),Q(1,g.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,n.IFileService),Q(4,C.ILogService)],v),e.UserDataProfilesMainService=v}),define(Z[95],ee([0,1,7,49,3,2,33,16,6,21,5,94,269,39,52,38]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let a=class extends R.Disposable{constructor(P,E,D,t,c,i){super(),this.c=P,this.f=E,this.g=D,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(P=>{P.window.profile&&this.profileStorage(P.window.profile).init(),P.workspace&&this.workspaceStorage(P.workspace).init()})),this.B(this.h.onWillShutdown(P=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=P.reason,P.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.n)P.join("profileStorage",E.close());for(const[,E]of this.r)P.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(P=>{P.join((async()=>{await this.i.exists(P.profile.globalStorageHome)||await this.i.createFolder(P.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(P=>{const E=this.n.get(P.profile.id);E&&P.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const P=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,M.once)(P.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),P}profileStorage(P){if((0,v.isProfileUsingDefaultStorage)(P))return this.applicationStorage;let E=this.n.get(P.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${P.name})`),E=this.p(P),this.n.set(P.id,E);const D=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:P})));(0,M.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${P.name})`),this.n.delete(P.id),D.dispose()})}return E}p(P){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(P,this.k(),this.c,this.i)}workspaceStorage(P){let E=this.r.get(P.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${P.id})`),E=this.s(P),this.r.set(P.id,E),(0,M.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${P.id})`),this.r.delete(P.id)})),E}s(P){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(P,this.k(),this.c,this.f,this.i)}isUsed(P){const E=S.URI.file(P);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(S.URI.file(D.path),E))return!0;return!1}};a=ve([Q(0,b.ILogService),Q(1,C.IEnvironmentService),Q(2,p.IUserDataProfilesMainService),Q(3,d.ILifecycleMainService),Q(4,k.IFileService),Q(5,w.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let f=class extends v.AbstractStorageService{constructor(P,E){super(),this.p=P,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(P){if(P===-1)return this.s.applicationStorage.storage}M(P){if(P===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};f=ve([Q(0,h.IUserDataProfilesService),Q(1,e.IStorageMainService)],f),e.ApplicationStorageMainService=f}),define(Z[272],ee([0,1,2,21,52,29,8,30]),function(x,e,S,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends S.Disposable{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(b.onBeforeCloseWindow(h=>this.c(h))),this.B(new C.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y?.isTransient&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,R.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(h=>h.id===y.id)||this.a.unsetWorkspace(y,!1)}};g=ve([Q(0,M.ILifecycleMainService),Q(1,n.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(Z[121],ee([0,1,18,7,29]),function(x,e,S,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(g,d,b){for(const y of g){const h=y.openedWorkspace;if((0,n.isWorkspaceIdentifier)(h)){const p=await b(h);if(p){if(p.folders.some(w=>S.extUriBiasedIgnorePathCase.isEqualOrParent(d,w.uri)))return y}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(d,h.configPath))return y}}const v=g.filter(y=>(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(d,y.openedWorkspace.uri));if(v.length)return v.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function C(g,d){for(const b of g)if((0,n.isWorkspaceIdentifier)(b.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,d)||(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,d))return b}e.findWindowOnWorkspaceOrFolder=C;function k(g,d){const b=v=>d.some(y=>S.extUriBiasedIgnorePathCase.isEqual(M.URI.file(y),M.URI.file(v)));for(const v of g)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.findWindowOnExtensionDevelopmentPath=k}),define(Z[273],ee([0,1,15,2,4,18,7,19,21,5,34,30,119,29]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class pt extends M.Disposable{get state(){return this.b}constructor(E,D,t,c,i){super(),this.g=E,this.h=D,this.i=t,this.j=c,this.k=i,this.b=w(this.h.getItem(pt.a)),this.c=void 0,this.f=!1,this.l()}l(){S.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.r(i),D.lastActiveWindow.uiState.mode===3&&E.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.r(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(D.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.r(i);return r.uiState.mode===3&&(E.has(r.uiState.display)?n.isMacintosh&&r.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):E.add(r.uiState.display)),r}));const c=f(D);this.h.setItem(pt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(E){if(this.i.quitRequested)return;const D=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,h.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(c||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(E){return{windowId:E.id,workspace:(0,h.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const D=this.s(E),t=this.k.getValue("window");if(D.mode===3){let c;D.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(D.mode=1)}return D}s(E){const D=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=E.workspace;if((0,h.isWorkspaceIdentifier)(l)){const u=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===l.id).map(I=>I.uiState);if(u.length)return u[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(l)){const u=this.state.openedWindows.filter(I=>I.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(I.folderUri,l.uri)).map(I=>I.uiState);if(u.length)return u[0]}else if(E.backupPath){const u=this.state.openedWindows.filter(I=>I.backupPath===E.backupPath).map(I=>I.uiState);if(u.length)return u[0]}const s=this.c||this.state.lastActiveWindow;if(!D&&s)return s.uiState}let t;const c=S.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(n.isMacintosh){const l=S.screen.getCursorScreenPoint();t=S.screen.getDisplayNearestPoint(l)}!t&&D&&(t=S.screen.getDisplayMatching(D.getBounds())),t||(t=S.screen.getPrimaryDisplay()||c[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const r=this.k.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&D){const l=D.serializeWindowState();l.mode===3?i.mode=3:i=l,o=i.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};p.a="windowsState",p=ve([Q(0,v.IWindowsMainService),Q(1,b.IStateMainService),Q(2,g.ILifecycleMainService),Q(3,d.ILogService),Q(4,k.IConfigurationService)],p),e.WindowsStateHandler=p;function w(P){const E={openedWindows:[]},D=P||{openedWindows:[]};return D.lastActiveWindow&&(E.lastActiveWindow=a(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=a(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(E.openedWindows=D.openedWindows.map(t=>a(t))),E}e.restoreWindowsState=w;function a(P){const E={uiState:P.uiState};return P.backupPath&&(E.backupPath=P.backupPath),P.remoteAuthority&&(E.remoteAuthority=P.remoteAuthority),P.folder&&(E.folderUri=C.URI.parse(P.folder)),P.workspaceIdentifier&&(E.workspace={id:P.workspaceIdentifier.id,configPath:C.URI.parse(P.workspaceIdentifier.configURIPath)}),E}function f(P){return{lastActiveWindow:P.lastActiveWindow&&m(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&m(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(E=>m(E))}}e.getWindowsStateStoreData=f;function m(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Z[96],ee([0,1,32,43,126,45,14,9,4,18,7,6,55,29]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function p(I){return I.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function w(I){return I.hasOwnProperty("folderUri")}e.isRecentFolder=w;function a(I){return I.hasOwnProperty("fileUri")}e.isRecentFile=a;function f(I){return m(I)||P(I)}e.isStoredWorkspaceFolder=f;function m(I){const A=I;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function P(I){const A=I;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function E(I,A,T,N,z){if(I.scheme!==N.scheme)return{name:T,uri:I.toString(!0)};let H=A?void 0:z.relativePath(N,I);if(H!==void 0)H.length===0?H=".":g.isWindows&&(H=D(H));else if(I.scheme===C.Schemas.file)H=I.fsPath,g.isWindows&&(H=D(H));else if(z.isEqualAuthority(I.authority,N.authority))H=I.path;else return{name:T,uri:I.toString(!0)};return{name:T,path:H}}e.getStoredWorkspaceFolder=E;function D(I){return I=(0,R.normalizeDriveLetter)(I),(0,S.isUNC)(I)||(I=(0,S.toSlashes)(I)),I}function t(I,A,T){const N=[],z=new Set,H=T.dirname(A);for(const ie of I){let se;if(m(ie))ie.path&&(se=T.resolvePath(H,ie.path));else if(P(ie))try{se=b.URI.parse(ie.uri),se.path[0]!==k.posix.sep&&(se=se.with({path:k.posix.sep+se.path}))}catch(oe){console.warn(oe)}if(se){const oe=T.getComparisonKey(se);if(!z.has(oe)){z.add(oe);const ue=ie.name||T.basenameOrAuthority(se);N.push(new h.WorkspaceFolder({uri:se,name:ue,index:N.length},ie))}}}return N}e.toWorkspaceFolders=t;function c(I,A,T,N,z){const H=i(A,I),ie=z.dirname(A),se=z.dirname(N),oe=[];for(const G of H.folders){const B=m(G)?z.resolvePath(ie,G.path):b.URI.parse(G.uri);let O;T?O=!1:O=!m(G)||(0,k.isAbsolute)(G.path),oe.push(E(B,O,G.name,se,z))}const ue={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},le=n.setProperty(I,["folders"],oe,ue);let me=n.applyEdits(I,le);return(0,d.isEqualAuthority)(H.remoteAuthority,(0,y.getRemoteAuthority)(N))&&(me=n.applyEdits(me,n.removeProperty(me,["remoteAuthority"],ue))),me}e.rewriteWorkspaceFileForNewLocation=c;function i(I,A){const T=M.parse(A);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>f(N));else throw new Error(`${I} looks like an invalid workspace file.`);return T}function r(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function o(I){return typeof I.folderUri=="string"}function l(I){return typeof I.fileUri=="string"}function s(I,A){const T={workspaces:[],files:[]};if(I){const N=function(H,ie){for(let se=0;se<H.length;se++)try{ie(H[se],se)}catch(oe){A.warn(`Error restoring recent entry ${JSON.stringify(H[se])}: ${oe.toString()}. Skip entry.`)}},z=I;Array.isArray(z.entries)&&N(z.entries,H=>{const ie=H.label,se=H.remoteAuthority;r(H)?T.workspaces.push({label:ie,remoteAuthority:se,workspace:{id:H.workspace.id,configPath:b.URI.parse(H.workspace.configPath)}}):o(H)?T.workspaces.push({label:ie,remoteAuthority:se,folderUri:b.URI.parse(H.folderUri)}):l(H)&&T.files.push({label:ie,remoteAuthority:se,fileUri:b.URI.parse(H.fileUri)})})}return T}e.restoreRecentlyOpened=s;function u(I){const A={entries:[]};for(const T of I.workspaces)w(T)?A.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):A.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of I.files)A.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return A}e.toStoreData=u}),define(Z[97],ee([0,1,80,14,4,18]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(d){function b(){let v=d.scheme===M.Schemas.file?(0,R.originalFSPath)(d):d.toString();return n.isLinux||(v=v.toLowerCase()),(0,S.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:d}}e.getWorkspaceIdentifier=C;function k(d,b){function v(){if(d.scheme!==M.Schemas.file)return(0,S.createHash)("md5").update(d.toString()).digest("hex");if(!b)return;let h;return n.isLinux?h=b.ino:n.isMacintosh?h=b.birthtime.getTime():n.isWindows&&(typeof b.birthtimeMs=="number"?h=Math.floor(b.birthtimeMs):h=b.birthtime.getTime()),(0,S.createHash)("md5").update(d.fsPath).update(h?String(h):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:d}}e.getSingleFolderWorkspaceIdentifier=k;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(Z[274],ee([0,1,80,32,14,9,4,18,23,184,19,28,34,16,5,183,29,97]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class wt{constructor(E,D,t,c){this.j=E,this.k=D,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,r)=>(0,M.isEqual)(i,r,!C.isLinux)}}async initialize(){const E=this.m.getItem(wt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,d.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,d.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.HotExitConfiguration.OFF}q(){return this.s()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,D){this.d.some(c=>E.workspace.id===c.workspace.id)||(this.d.push(E),this.C());const t=(0,R.join)(this.c,E.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(E,D){if(await g.Promises.exists(E)&&await this.z(E),await g.Promises.exists(D))try{await g.Promises.rename(D,E)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.e.some(D=>this.h.isEqual(E.folderUri,D.folderUri))||(this.e.push(E),this.C()),(0,R.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,R.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const D=new Set,t=[];for(const c of E){const i=c.workspace;if(!(0,a.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const r=(0,R.join)(this.c,i.id);await this.B(r)?i.configPath.scheme!==n.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(r):await this.x(r)}}return t}async v(E){if(!Array.isArray(E))return[];const D=[],t=new Set;for(const c of E){const i=c.folderUri,r=this.h.getComparisonKey(i);if(!t.has(r)){t.add(r);const o=(0,R.join)(this.c,this.D(c));await this.B(o)?i.scheme!==n.Schemas.file||await g.Promises.exists(i.fsPath)?D.push(c):await this.z(o):await this.x(o)}}return D}async w(E){if(!Array.isArray(E))return[];const D=[],t=new Set;for(const c of E){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const r=(0,R.join)(this.c,i);await this.B(r)?D.push(c):await this.x(r)}}return D}async x(E){try{await g.Promises.rm(E,g.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let E=(0,f.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,E.id));)E=(0,f.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const D=this.y(),t=(0,R.join)(this.c,D.backupFolder);try{await g.Promises.rename(E,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const E=[];for(const D of this.d)await this.A(D)&&E.push(D);for(const D of this.e)await this.A(D)&&E.push(D);return E}A(E){let D;return(0,d.isEmptyWindowBackupInfo)(E)?D=(0,R.join)(this.c,E.backupFolder):(0,w.isFolderBackupInfo)(E)?D=(0,R.join)(this.c,this.D(E)):D=(0,R.join)(this.c,E.workspace.id),this.B(D)}async B(E){try{const D=await g.Promises.readdir(E);for(const t of D)try{if((await g.Promises.readdir((0,R.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const c={id:D.id,configURIPath:D.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const c={folderUri:D.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const c={backupFolder:D};return t&&(c.remoteAuthority=t),c})};this.m.setItem(wt.a,E)}D(E){const D=E.folderUri;let t;return D.scheme===n.Schemas.file?t=C.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,S.createHash)("md5").update(t).digest("hex")}};m.a="backupWorkspaces",m=ve([Q(0,v.IEnvironmentMainService),Q(1,b.IConfigurationService),Q(2,p.ILogService),Q(3,y.IStateMainService)],m),e.BackupMainService=m}),define(Z[53],ee([0,1,15,3,43,2,14,9,18,10,23,182,62,57,28,6,5,52,121,29,96,97]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let t=class extends R.Disposable{constructor(i,r,o,l,s){super(),this.g=i,this.h=r,this.i=o,this.j=l,this.k=s,this.a=this.B(new M.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new M.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await b.Promises.readdir(this.c.fsPath)).map(r=>(0,g.joinPath)(this.c,r,P.UNTITLED_WORKSPACE_NAME));for(const r of i){const o=(0,D.getWorkspaceIdentifier)(r),l=await this.resolveLocalWorkspace(r);l?this.f.push({workspace:o,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,r=>b.Promises.readFile(r,"utf8"))}l(i,r){if(!!this.m(i)&&i.scheme===C.Schemas.file)try{const o=r(i.fsPath);return o instanceof Promise?o.then(l=>this.n(i,l),l=>{}):this.n(i,o)}catch{return}}m(i){return(0,P.isUntitledWorkspace)(i,this.g)||(0,P.hasWorkspaceFileExtension)(i)}n(i,r){try{const o=this.p(i,r),l=(0,D.getWorkspaceIdentifier)(i);return{id:l.id,configPath:l.configPath,folders:(0,E.toWorkspaceFolders)(o.folders,l.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,r){const o=(0,n.parse)(r);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(l=>(0,E.isStoredWorkspaceFolder)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,r){const{workspace:o,storedWorkspace:l}=this.r(i,r),s=o.configPath.fsPath;return await b.Promises.mkdir((0,k.dirname)(s),{recursive:!0}),await b.Promises.writeFile(s,JSON.stringify(l,null,"	")),this.f.push({workspace:o,remoteAuthority:r}),o}r(i=[],r){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,g.joinPath)(this.c,o),s=(0,g.joinPath)(l,P.UNTITLED_WORKSPACE_NAME),u=[];for(const I of i)u.push((0,E.getStoredWorkspaceFolder)(I.uri,!0,I.name,l,g.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(s),storedWorkspace:{folders:u,remoteAuthority:r}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,P.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const r=(0,g.originalFSPath)(i.configPath);try{await b.Promises.rm((0,k.dirname)(r));const o=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await b.Promises.exists(o)&&await b.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${r} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,r,o){if(!i||!i.win||!i.isReady||!await this.t(i,r,o))return;const s=await this.u(i,(0,D.getWorkspaceIdentifier)(o));if(!!s)return this.b.fire({window:i,workspace:s.workspace}),s}async t(i,r,o){return o?(0,P.isWorkspaceIdentifier)(i.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,m.findWindowOnWorkspaceOrFolder)(r,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,g.basename)(o)),detail:(0,v.localize)(2,null)},(0,d.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,r){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:i.remoteAuthority})),(0,P.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=r,i.config.backupPath=o,{workspace:r,backupPath:o}}};t=ve([Q(0,p.IEnvironmentMainService),Q(1,a.ILogService),Q(2,f.IUserDataProfilesMainService),Q(3,y.IBackupMainService),Q(4,h.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(Z[122],ee([0,1,15,42,22,6,30,29,53,10,5]),function(x,e,S,M,n,R,C,k,g,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let v=class{constructor(h,p,w){this.a=h,this.b=p,this.c=w}async getRemoteDiagnostics(h){const p=this.a.getWindows();return(await Promise.all(p.map(async a=>{const f=a.remoteAuthority;if(!f)return;const m=`vscode:getDiagnosticInfoResponse${a.id}`,P={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(a):void 0};return new Promise(E=>{a.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:P}),M.validatedIpcMain.once(m,(D,t)=>{t||E({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),E(t)}),setTimeout(()=>{E({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const p of S.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(p.id);w?h.push(await this.d(w)):h.push(this.e(p))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(h){const p=await this.f(h),w=(0,d.assertIsDefined)(h.win);return this.e(w,p,h.remoteAuthority)}e(h,p=[],w){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:p,remoteAuthority:w}}async f(h){const p=[],w=h.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(w))p.push(w.uri);else if((0,k.isWorkspaceIdentifier)(w)){const a=await this.b.resolveLocalWorkspace(w.configPath);a&&a.folders.forEach(m=>{p.push(m.uri)})}return p}};v=ve([Q(0,C.IWindowsMainService),Q(1,g.IWorkspacesManagementMainService),Q(2,b.ILogService)],v),e.DiagnosticsMainService=v}),define(Z[58],ee([0,1,46,15,26,147,54,3,2,14,9,4,7,101,84,23,99,172,57,28,6,21,5,20,68,30,29,53,17,230,223,34]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let T=class extends g.Disposable{constructor(z,H,ie,se,oe,ue,le,me,G,B){super(),this.a=z,this.b=H,this.c=ie,this.f=se,this.g=oe,this.h=ue,this.i=le,this.j=me,this.k=G,this.l=B,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,O=>O.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:O,x:q,y:J})=>({windowId:O.id,x:q,y:J})),({windowId:O})=>!!this.b.getWindowById(O)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),O=>!!O),O=>O.id),k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(O,q)=>q.id),O=>!!this.b.getWindowById(O))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(O,q,J)=>J),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),k.Event.fromNodeEventEmitter(M.screen,"display-added"),k.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(H=>({id:H.id,workspace:H.openedWorkspace??(0,o.toWorkspaceIdentifier)(H.backupPath,H.isExtensionDevelopmentHost),title:H.win?.getTitle()??"",filename:H.getRepresentedFilename(),dirty:H.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const H=M.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(H)return H.id}openWindow(z,H,ie){return Array.isArray(H)?this.n(z,H,ie):this.p(z,H)}async n(z,H,ie=Object.create(null)){H.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:H,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(z,H){await this.b.openEmptyWindow({context:5,contextWindowId:z},H)}async toggleFullScreen(z){this.w(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.w(z)?.handleTitleDoubleClick()}async isMaximized(z){const H=this.w(z);return H?.win?H.win.isMaximized():!1}async maximizeWindow(z){const H=this.w(z);H?.win&&H.win.maximize()}async unmaximizeWindow(z){const H=this.w(z);H?.win&&H.win.unmaximize()}async minimizeWindow(z){const H=this.w(z);H?.win&&H.win.minimize()}async updateWindowControls(z,H){const ie=this.w(z);ie&&ie.updateWindowControls(H)}async focusWindow(z,H){H&&typeof H.windowId=="number"&&(z=H.windowId),this.w(z)?.focus({force:H?.force??!1})}async setMinimumSize(z,H,ie){const se=this.w(z);if(se?.win){const[oe,ue]=se.win.getSize(),[le,me]=se.win.getMinimumSize(),[G,B]=[H??le,ie??me],[O,q]=[Math.max(oe,G),Math.max(ue,B)];(le!==G||me!==B)&&se.win.setMinimumSize(G,B),(oe!==O||ue!==q)&&se.win.setSize(O,q)}}async saveWindowSplash(z,H){this.j.saveWindowSplash(z,H)}async installShellCommand(z){const{source:H,target:ie}=await this.r();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(H);if(se&&!se.dangling){const oe=await(0,h.realpath)(H);if(ie===oe)return}await w.Promises.unlink(H)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(ie,H)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:oe}=await this.showMessageBox(z,{type:"info",message:(0,f.localize)(0,null,this.i.nameShort),buttons:[(0,f.localize)(1,null),(0,f.localize)(2,null)]});if(oe===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${H}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ue)}catch{throw new Error((0,f.localize)(3,null,H))}}}async uninstallShellCommand(z){const{source:H}=await this.r();try{await w.Promises.unlink(H)}catch(ie){switch(ie.code){case"EACCES":{const{response:se}=await this.showMessageBox(z,{type:"info",message:(0,f.localize)(4,null,this.i.nameShort),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]});if(se===0)try{const oe=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(oe)}catch{throw new Error((0,f.localize)(7,null,H))}break}case"ENOENT":break;default:throw ie}}}async r(){const z=(0,b.resolve)(this.g.appRoot,"bin","code"),H=`/usr/local/bin/${this.i.applicationName}`;if(!await w.Promises.exists(z))throw new Error((0,f.localize)(8,null,z));return{source:H,target:z}}async showMessageBox(z,H){return this.c.showMessageBox(H,this.s(z))}async showSaveDialog(z,H){return this.c.showSaveDialog(H,this.s(z))}async showOpenDialog(z,H){return this.c.showOpenDialog(H,this.s(z))}s(z){const H=this.w(z);if(H?.win)return H.win}async pickFileFolderAndOpen(z,H){const ie=await this.c.pickFileFolder(H);ie&&await this.t(await Promise.all(ie.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:y.URI.file(se)}:{fileUri:y.URI.file(se)})),H,z)}async pickFolderAndOpen(z,H){const ie=await this.c.pickFolder(H);ie&&await this.t(ie.map(se=>({folderUri:y.URI.file(se)})),H,z)}async pickFileAndOpen(z,H){const ie=await this.c.pickFile(H);ie&&await this.t(ie.map(se=>({fileUri:y.URI.file(se)})),H,z)}async pickWorkspaceAndOpen(z,H){const ie=await this.c.pickWorkspace(H);ie&&await this.t(ie.map(se=>({workspaceUri:y.URI.file(se)})),H,z)}async t(z,H,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:z,forceNewWindow:H.forceNewWindow})}async showItemInFolder(z,H){M.shell.showItemInFolder(H)}async setRepresentedFilename(z,H){this.w(z)?.setRepresentedFilename(H)}async setDocumentEdited(z,H){this.w(z)?.setDocumentEdited(H)}async openExternal(z,H){return v.isLinuxSnap?this.u(H):M.shell.openExternal(H),!0}u(z){const H=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,M.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=H,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(z,H){return M.shell.trashItem(H)}async isAdmin(){let z;return v.isWindows?z=(await new Promise((H,ie)=>{x(["native-is-elevated"],H,ie)}))():z=process.getuid()===0,z}async writeElevated(z,H,ie,se){const oe=await new Promise((ue,le)=>{x(["@vscode/sudo-prompt"],ue,le)});return new Promise((ue,le)=>{const me=[`"${this.v}"`];se?.unlock&&me.push("--file-chmod"),me.push("--file-write",`"${H.fsPath}"`,`"${ie.fsPath}"`);const G={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,b.join)((0,b.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};oe.exec(me.join(" "),G,(B,O,q)=>{O&&this.h.trace(`[sudo-prompt] received stdout: ${O}`),q&&this.h.trace(`[sudo-prompt] received stderr: ${q}`),B?le(B):ue(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,b.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.join)(this.g.appRoot,"bin","code"):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,u.hasWSLFeatureInstalled)()}async killProcess(z,H,ie){process.kill(H,ie)}async readClipboardText(z,H){return M.clipboard.readText(H)}async writeClipboardText(z,H,ie){return M.clipboard.writeText(H,ie)}async readClipboardFindText(z){return M.clipboard.readFindText()}async writeClipboardFindText(z,H){return M.clipboard.writeFindText(H)}async writeClipboardBuffer(z,H,ie,se){return M.clipboard.writeBuffer(H,Buffer.from(ie.buffer),se)}async readClipboardBuffer(z,H){return s.VSBuffer.wrap(M.clipboard.readBuffer(H))}async hasClipboard(z,H,ie){return M.clipboard.has(H,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,H){this.w(z)?.updateTouchBar(H)}async notifyReady(z){this.w(z)?.setReady()}async relaunch(z,H){return this.f.relaunch(H)}async reload(z,H){const ie=this.w(z);if(ie){if((0,o.isWorkspaceIdentifier)(ie.openedWorkspace)){const se=ie.openedWorkspace.configPath;if(se.scheme===d.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,H){const ie=this.w(H);if(ie?.win)return ie.win.close()}async quit(z){const H=this.b.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&H.win?H.win.close():this.f.quit()}async exit(z,H){await this.f.kill(H)}async resolveProxy(z,H){const se=this.w(z)?.win?.webContents?.session;if(se)return se.resolveProxy(H)}findFreePort(z,H,ie,se,oe=1){return(0,a.findFreePort)(H,ie,se,oe)}async openDevTools(z,H){const ie=this.w(z);ie?.win&&ie.win.webContents.openDevTools(H)}async toggleDevTools(z){const H=this.w(z);H?.win&&H.win.webContents.toggleDevTools()}async sendInputEvent(z,H){const ie=this.w(z);ie?.win&&(H.type==="mouseDown"||H.type==="mouseUp")&&ie.win.webContents.sendInputEvent(H)}async enableSandbox(z,H){H?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,H,ie){const se=this.w(z);if(!se||!se.win)throw new Error;return await new I.WindowProfiler(se.win,H,this.h).inspect(ie)}async windowsGetStringRegKey(z,H,ie,se){if(!v.isWindows)return;const oe=await new Promise((ue,le)=>{x(["@vscode/windows-registry"],ue,le)});try{return oe.GetStringRegKey(H,ie,se)}catch{return}}w(z){if(typeof z=="number")return this.b.getWindowById(z)}};ve([C.memoize],T.prototype,"v",null),T=ve([Q(1,r.IWindowsMainService),Q(2,m.IDialogMainService),Q(3,D.ILifecycleMainService),Q(4,P.IEnvironmentMainService),Q(5,t.ILogService),Q(6,c.IProductService),Q(7,i.IThemeMainService),Q(8,A.IStateMainService),Q(9,l.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(Z[275],ee([0,1,15,42,26,2,14,4,102,170,87,122,57,28,6,5,58,65,20,66,76,32,10,34]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");const i="issue.processExplorerWindowState";let r=class Pt{constructor(s,u,I,A,T,N,z,H,ie,se){this.g=s,this.h=u,this.i=I,this.j=A,this.k=T,this.l=N,this.m=z,this.n=H,this.o=ie,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){M.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[u,I]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),A=await this.j.getSystemInfo(u,I);this.r(s,"vscode:issueSystemInfoResponse",A)}),M.validatedIpcMain.on("vscode:listProcesses",async s=>{const u=[];try{u.push({name:(0,d.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,b.isRemoteDiagnosticError)(A)?u.push({name:A.hostName,rootProcess:A}):A.processes&&u.push({name:A.hostName,rootProcess:A.processes})})}catch(I){this.i.error(`Listing processes failed: ${I}`)}this.r(s,"vscode:listProcessesResponse",u)}),M.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{if(this.b){const{response:u}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(1,null),buttons:[(0,d.localize)(2,null),(0,d.localize)(3,null)]},this.b);this.r(s,"vscode:issueReporterClipboardResponse",u===0)}}),M.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const u=await this.v();this.r(s,"vscode:issuePerformanceInfoResponse",u)}),M.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:s}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(4,null),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]},this.b);s===0&&this.b&&(this.b.destroy(),this.b=null)}}),M.validatedIpcMain.on("vscode:workbenchCommand",(s,u)=>{const{id:I,from:A,args:T}=u;let N;switch(A){case"issueReporter":N=this.c;break;case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${A}`)}N?.webContents.send("vscode:runAction",{id:I,from:A,args:T})}),M.validatedIpcMain.on("vscode:openExternal",(s,u)=>{this.m.openExternal(void 0,u)}),M.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.b?.close()}),M.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.d?.close()}),M.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const u=await this.k.getMainDiagnostics();this.r(s,"vscode:windowsInfoResponse",u.windows)})}r(s,u,...I){s.sender.isDestroyed()||s.sender.send(u,...I)}async openReporter(s){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const u=new R.DisposableStore,I=u.add(this.n.createIPCObjectUrl()),A=this.u(this.c,700,800);this.b=this.t(A,I,{backgroundColor:s.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),I.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:s,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:f.default}),this.b.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,u.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,u.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(s){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const u=new R.DisposableStore,I=u.add(this.n.createIPCObjectUrl()),A=this.p.getItem(i,void 0),T=o(A)?A:this.u(this.f,800,500),N=S.screen.getDisplayNearestPoint({x:T.x,y:T.y});T.width/=N.scaleFactor,T.height/=N.scaleFactor,this.d=this.t(T,I,{backgroundColor:s.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),I.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:s,product:f.default}),this.d.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,u.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,u.dispose())});const z=()=>{if(!this.d)return;const H=this.d.getSize(),ie=this.d.getPosition();if(!H||!ie)return;const se={width:H[0],height:H[1],x:ie[0],y:ie[1]};this.p.setItem(i,se)};this.d.on("moved",z),this.d.on("resized",z)}this.d&&this.s(this.d)}s(s){s.isMinimized()&&s.restore(),s.focus()}t(s,u,I,A){const T=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:I.title,backgroundColor:I.backgroundColor||Pt.a,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${u.resource.toString()}`,`--vscode-window-kind=${A}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,E.zoomLevelToZoomFactor)(I.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:I.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}async getSystemStatus(){const[s,u]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(s,u)}u(s,u,I){let A;const T=S.screen.getAllDisplays();if(T.length===1)A=T[0];else{if(k.isMacintosh){const H=S.screen.getCursorScreenPoint();A=S.screen.getDisplayNearestPoint(H)}!A&&s&&(A=S.screen.getDisplayMatching(s.getBounds())),A||(A=S.screen.getPrimaryDisplay()||T[0])}const N=A.bounds,z={width:u,height:I,x:N.x+N.width/2-u/2,y:N.y+N.height/2-I/2};return N.width>0&&N.height>0&&(z.x<N.x&&(z.x=N.x),z.y<N.y&&(z.y=N.y),z.x>N.x+N.width&&(z.x=N.x),z.y>N.y+N.height&&(z.y=N.y),z.width>N.width&&(z.width=N.width),z.height>N.height&&(z.height=N.height)),z}async v(){try{const[s,u]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(s,u)}catch(s){throw this.i.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.h.args.trace)return;const s=await S.contentTracing.stopRecording(`${(0,D.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,d.localize)(9,null),detail:(0,d.localize)(10,null,s),buttons:[(0,d.localize)(11,null)]},(0,t.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,s)}};r.a="#1E1E1E",r=ve([Q(1,h.IEnvironmentMainService),Q(2,w.ILogService),Q(3,b.IDiagnosticsService),Q(4,v.IDiagnosticsMainService),Q(5,y.IDialogMainService),Q(6,a.INativeHostMainService),Q(7,P.IProtocolMainService),Q(8,m.IProductService),Q(9,c.IStateMainService)],r),e.IssueMainService=r;function o(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(Z[276],ee([0,1,22,19,28,21,5,58,20,56,24,48,93]),function(x,e,S,M,n,R,C,k,g,d,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends y.AbstractUpdateService{constructor(w,a,f,m,P,E,D,t){super(w,a,m,P,E,t),this.e=f,this.t=D}r(w){return(0,y.createUpdateURL)(`linux-${process.arch}`,w,this.k)}s(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},S.CancellationToken.None).then(d.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(a))}).then(void 0,a=>{this.j.error(a),this.e.publicLog2("update:notAvailable",{explicit:!!w});const f=w?a.message||a:void 0;this.d(v.State.Idle(1,f))}))}async n(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.t.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};h=ve([Q(0,R.ILifecycleMainService),Q(1,M.IConfigurationService),Q(2,b.ITelemetryService),Q(3,n.IEnvironmentMainService),Q(4,d.IRequestService),Q(5,C.ILogService),Q(6,k.INativeHostMainService),Q(7,g.IProductService)],h),e.LinuxUpdateService=h}),define(Z[277],ee([0,1,46,41,26,8,22,54,9,7,133,23,19,28,16,21,5,58,20,56,24,48,93]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(l,s=1e3){for(;!l();)await(0,R.timeout)(s)}let i;function r(){return typeof i>"u"&&(i=M.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends t.AbstractUpdateService{get cachePath(){const s=g.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,u,I,A,T,N,z,H,ie){super(s,u,A,T,N,ie),this.t=I,this.u=z,this.v=H}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(s){let u="win32";return process.arch!=="ia32"&&(u+=`-${process.arch}`),r()===1?u+="-archive":this.k.target==="user"&&(u+="-user"),(0,t.createUpdateURL)(u,s,this.k)}s(s){!this.a||(this.d(D.State.CheckingForUpdates(s)),this.i.request({url:this.a},C.CancellationToken.None).then(P.asJson).then(u=>{const I=r();return!u||!u.url||!u.version||!u.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!s}),this.d(D.State.Idle(I)),Promise.resolve(null)):I===1?(this.d(D.State.AvailableForDownload(u)),Promise.resolve(null)):(this.d(D.State.Downloading(u)),this.A(u.version).then(()=>this.z(u.version).then(A=>v.Promises.exists(A).then(T=>{if(T)return Promise.resolve(A);const N=u.url,z=u.hash,H=`${A}.tmp`;return this.i.request({url:N},C.CancellationToken.None).then(ie=>this.u.writeFile(d.URI.file(H),ie.stream)).then(z?()=>(0,b.checksum)(H,u.hash):()=>{}).then(()=>v.Promises.rename(H,A)).then(()=>A)})).then(A=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},T&&u.supportsFastUpdate?this.k.target==="user"?this.o():this.d(D.State.Downloaded(u)):this.d(D.State.Ready(u))})))}).then(void 0,u=>{this.j.error(u),this.t.publicLog2("update:notAvailable",{explicit:!!s});const I=s?u.message||u:void 0;this.d(D.State.Idle(r(),I))}))}async n(s){s.update.url&&this.v.openExternal(void 0,s.update.url),this.d(D.State.Idle(r()))}async z(s){const u=await this.cachePath;return g.join(u,`CodeSetup-${this.k.quality}-${s}.exe`)}async A(s=null){const u=s?N=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(N):()=>!0,I=await this.cachePath,T=(await v.Promises.readdir(I)).filter(u).map(async N=>{try{await v.Promises.unlink(g.join(I,N))}catch{}});await Promise.all(T)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(D.State.Updating(s));const u=await this.cachePath;this.e.updateFilePath=g.join(u,`CodeSetup-${this.k.quality}-${s.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(r()))});const A=`${this.k.win32MutexName}-ready`,T=await new Promise((N,z)=>{x(["windows-mutex"],N,z)});c(()=>T.isActive(A)).then(()=>this.d(D.State.Ready(s)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?M.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return r()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const u=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!u};this.d(D.State.Downloading(I)),this.e={packagePath:s},u?this.k.target==="user"?this.o():this.d(D.State.Downloaded(I)):this.d(D.State.Ready(I))}};ve([k.memoize],o.prototype,"cachePath",null),o=ve([Q(0,w.ILifecycleMainService),Q(1,y.IConfigurationService),Q(2,E.ITelemetryService),Q(3,h.IEnvironmentMainService),Q(4,P.IRequestService),Q(5,a.ILogService),Q(6,p.IFileService),Q(7,f.INativeHostMainService),Q(8,m.IProductService)],o),e.Win32UpdateService=o}),define(Z[278],ee([0,1,15,8,22,44,3,2,14,9,63,4,7,178,62,19,57,28,61,16,21,5,20,66,241,95,24,132,68,76,30,29,53,119,123,37,34,52,58,243,115,51,92,26,116,64]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var J;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(J||(J={}));let te=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const L=this.P.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.P.getProfileForWorkspace(this.config.workspace??(0,A.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(L,F,W,U,$,V,j,K,Y,re,de,Re,Ce,De,Oe,$e,fe,pe,Me,_,ce){super(),this.L=F,this.M=W,this.N=U,this.O=$,this.P=V,this.Q=j,this.R=K,this.S=Y,this.U=re,this.W=de,this.X=Re,this.Y=Ce,this.Z=De,this.ab=Oe,this.bb=$e,this.db=fe,this.eb=pe,this.fb=Me,this.gb=_,this.hb=ce,this.c=this.B(new C.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new C.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new C.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.Emitter),this.onDidClose=this.h.event,this.j=this.B(new C.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;let he=!1;{const[Ie,Ae]=this.tb(L.state);this.r=Ie,this.L.trace("window#ctor: using window state",Ie);const Te=this.r.mode===0||this.r.mode===3;typeof ot.b>"u"&&(ot.b=this.gb.getItem("window.experimental.useSandbox",!1));const Fe=this.U.getValue("window");typeof Fe?.experimental?.useSandbox=="boolean"?he=Fe.experimental.useSandbox:this.db.quality==="stable"&&ot.b?he=!0:he=typeof this.db.quality=="string"&&this.db.quality!=="stable";const je={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:u.WindowMinimumSize.WIDTH,minHeight:u.WindowMinimumSize.HEIGHT,show:!Te,title:this.db.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...he?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?je.icon=(0,d.join)(this.N.appRoot,"resources/linux/code.png"):v.isWindows&&!this.N.isBuilt&&(je.icon=(0,d.join)(this.N.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Ab()&&(je.fullscreenable=!1),v.isMacintosh&&(je.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const ze=v.isMacintosh&&Fe?.nativeTabs===!0;ze&&(je.tabbingIdentifier=this.db.nameShort);const We=(0,u.getTitleBarStyle)(this.U)==="custom";if(We&&(je.titleBarStyle="hidden",v.isMacintosh||(je.frame=!1),(0,u.useWindowControlsOverlay)(this.U))){const He=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),X=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:He,symbolColor:X},this.z=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.l=new S.BrowserWindow(je),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&We&&this.l.setSheetOffset(22),We&&(v.isWindows&&(0,u.useWindowControlsOverlay)(this.U)||v.isMacintosh)){const He=this.gb.getItem(ot.a);He&&this.updateWindowControls({height:He})}v.isWindows&&We&&this.l.hookWindowMessage(278,()=>{const[X,ae]=this.l.getPosition(),ge=S.screen.getCursorScreenPoint(),be=ge.x-X,we=ge.y-ae;return(()=>!(be>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:be,y:we})),0}),(v.isMacintosh||v.isWindows)&&Ae&&(!ze||S.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),Te&&((0,b.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb(he)}setRepresentedFilename(L){v.isMacintosh?this.l.setRepresentedFilename(L):this.v=L}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(L){v.isMacintosh&&this.l.setDocumentEdited(L),this.w=L}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(L){v.isMacintosh&&L?.force&&S.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.C.push(L)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(L=>{function F(){W.dispose(),U.dispose(),L()}const W=this.onDidClose(()=>F()),U=this.onWillLoad(()=>F())})}jb(L){this.l.on("unresponsive",()=>this.mb(1,{sandboxed:L})),this.l.webContents.on("render-process-gone",(W,U)=>this.mb(2,{...U,sandboxed:L})),this.l.webContents.on("did-fail-load",(W,U,$)=>this.mb(3,{reason:$,exitCode:U,sandboxed:L})),this.l.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",W=>{this.n&&(this.n.maximized=!0),S.app.emit("browser-window-maximize",W,this.l)}),this.l.on("unmaximize",W=>{this.n&&(this.n.maximized=!1),S.app.emit("browser-window-unmaximize",W,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(W=>this.qb(W))),this.B(this.X.onDidDeleteUntitledWorkspace(W=>this.pb(W)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(W,U)=>{const $=await this.lb();U({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,$)})})}lb(){return this.kb||(this.kb=(0,i.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(L,F){switch(L){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:L,reason:F?.reason,code:F?.exitCode,sandboxed:F?.sandboxed?"1":"0"}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:W,checkboxChecked:U}=await this.ab.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this.n?.workspace?(0,h.localize)(5,null):void 0},this.l);if(W!==2){const $=W===0;await this.ob($,U)}}else if(L===2)if(v.isWindows&&F?.reason==="launch-failed"&&F.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(F);else{let W;F?W=(0,h.localize)(7,null,F.reason,F.exitCode??"<unknown>"):W=(0,h.localize)(6,null);const{response:U,checkboxChecked:$}=await this.ab.showMessageBox({type:"warning",buttons:[this.n?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:W,detail:this.n?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this.n?.workspace?(0,h.localize)(13,null):void 0},this.l),V=U===0;await this.ob(V,$)}break}}async nb(L){const F=[],W=(0,me.isInternalTelemetry)(this.db,this.U);if((0,me.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&F.push(new ue.OneDataSystemAppender(W,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:$}=this.N,V=await(0,O.resolveMachineId)(this.gb),j={appenders:F,sendErrorTelemetry:!1,commonProperties:(0,G.resolveCommonProperties)(this.Q,(0,B.release)(),(0,B.hostname)(),process.arch,this.db.commit,this.db.version,V,W,$),piiPaths:(0,me.getPiiPathsFromEnvironment)(this.N)};await new le.TelemetryService(j,this.U,this.db).publicLog2("windowadminerror",{reason:L.reason,code:L.exitCode})}const{response:U}=await this.ab.showMessageBox({type:"error",buttons:[(0,h.localize)(14,null),(0,h.localize)(15,null)],message:(0,h.localize)(16,null),detail:(0,h.localize)(17,null,this.db.nameLong)},this.l);U===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(F.map($=>$.flush())),await this.ob(!1,!1)}async ob(L,F){const W=this.n?.workspace;if(F&&W)try{const U=this.S.workspaceStorage(W);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.L.error(U)}if(this.j.fire(),this.l?.destroy(),L&&this.n){let U,$;(0,A.isSingleFolderWorkspaceIdentifier)(W)?U={folderUri:W.uri}:(0,A.isWorkspaceIdentifier)(W)?U={workspaceUri:W.configPath}:$=!0;const[V]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}pb(L){this.n?.workspace?.id===L.id&&(this.n.workspace=void 0)}qb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const F=this.Bb();F!==this.s&&(this.s=F,this.Cb(F))}if(!L||L.affectsConfiguration("http.proxy")){let F=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.F||W!==this.G)){this.F=F,this.G=W;const U=F||"",$=W?`${W},<local>`:"<local>";this.L.trace(`Setting proxy to '${U}', bypassing '${$}'`),this.l.webContents.session.setProxy({proxyRules:U,proxyBypassRules:$,pacScript:""})}}}addTabbedWindow(L){v.isMacintosh&&L.win&&this.l.addTabbedWindow(L.win)}load(L,F=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!F.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(L,F),this.ib===0?this.n=L:this.I=L,this.ib=1,this.l.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new M.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:L.workspace,reason:F.isReload?3:W?2:1})}rb(L,F){const W=(this.n??this.I)?.userEnv;if(W){const U=(0,m.isLaunchedFromCli)(W)&&!(0,m.isLaunchedFromCli)(L.userEnv),$=this.isExtensionDevelopmentHost;(U||$)&&(L.userEnv={...W,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(L["disable-extensions"]=F.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.l.isMaximized(),L.partsSplash=this.W.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),L.perfMarks=(0,b.getMarks)(),this.H.update(L)}async reload(L){const F=Object.assign({},this.n);F.workspace=await this.sb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&L&&(F.verbose=L.verbose,F.debugId=L.debugId,F.extensionEnvironment=L.extensionEnvironment,F["inspect-extensions"]=L["inspect-extensions"],F["inspect-brk-extensions"]=L["inspect-brk-extensions"],F["extensions-dir"]=L["extensions-dir"]),F.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.O.serialize(),F.continueOn=this.N.continueOn,F.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},F.logLevel=this.M.getLogLevel(),F.loggers={window:this.M.getRegisteredLoggers(this.id),global:this.M.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async sb(L){if((0,A.isWorkspaceIdentifier)(L.workspace)){const F=L.workspace.configPath;if(F.scheme===g.Schemas.file&&!await this.Q.exists(F))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(L.workspace)){const F=L.workspace.uri;if(F.scheme===g.Schemas.file&&!await this.Q.exists(F))return}return L.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let W;try{W=S.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,N.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const L=Object.create(null);let F;if(!v.isMacintosh&&this.l.isMaximized()?F=0:F=1,F===0?L.mode=0:L.mode=1,F===1||F===0){let W;F===1?W=this.getBounds():W=this.l.getNormalBounds(),L.x=W.x,L.y=W.y,L.width=W.width,L.height=W.height}return L}updateWindowControls(L){if(L.height&&this.gb.setItem(ot.a,L.height),v.isWindows&&this.z)this.l.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(v.isMacintosh&&L.height!==void 0){const F=(L.height-15)/2;this.l.setTrafficLightPosition({x:F,y:F})}}tb(L){(0,b.mark)("code/willRestoreCodeWindowState");let F=!1;if(L)try{const W=S.screen.getAllDisplays();F=W.length>1,L=this.ub(L,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[L||(0,N.defaultWindowState)(),F]}ub(L,F){if(this.L.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const $=this.vb(F[0]);if($){let V=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!$||(L.x<$.x&&(L.x=$.x),L.y<$.y&&(L.y=$.y))};this.L.trace("window#validateWindowState: 1 monitor working area",$),V(),L.width>$.width&&(L.width=$.width),L.height>$.height&&(L.height=$.height),L.x>$.x+$.width-128&&(L.x=$.x+$.width-L.width),L.y>$.y+$.height-128&&(L.y=$.y+$.height-L.height),V()}return L}if(L.display&&L.mode===3){const $=F.find(V=>V.id===L.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,N.defaultWindowState)(3);return V.x=$.bounds.x,V.y=$.bounds.y,V}}let W,U;try{W=S.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),U=this.vb(W)}catch{}if(W&&U&&L.x+L.width>U.x&&L.y+L.height>U.y&&L.x<U.x+U.width&&L.y<U.y+U.height)return this.L.trace("window#validateWindowState: multi-monitor working area",U),L}vb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,F]=this.l.getPosition(),[W,U]=this.l.getSize();return{x:L,y:F,width:W,height:U}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(L){this.Ab()?this.xb(L):this.zb(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(L){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(L)}yb(L){v.isMacintosh&&(this.t=L,this.u=new M.DeferredPromise,Promise.race([this.u.p,(0,M.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(L)}zb(L){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(L),this.l.webContents.focus()}Ab(){const L=this.U.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let L=(0,u.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Cb(L,F=!0){v.isMacintosh||(L==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,h.localize)(18,null)),L==="hidden"?setTimeout(()=>{this.Db(L)}):this.Db(L))}Db(L){const F=this.isFullScreen;switch(L){case"classic":this.l.setMenuBarVisibility(!F),this.l.autoHideMenuBar=F;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(L,F,...W){this.isReady?this.send(L,...W):this.ready().then(()=>{F.isCancellationRequested||this.send(L,...W)})}send(L,...F){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.l.webContents.send(L,...F)}catch(W){this.L.warn(`Error sending IPC message to channel '${L}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(L){!v.isMacintosh||this.D.forEach((F,W)=>{const U=L[W];F.segments=this.Gb(U)})}Eb(){if(!!v.isMacintosh){for(let L=0;L<10;L++){const F=this.Fb();this.D.push(F)}this.l.setTouchBar(new S.TouchBar({items:this.D}))}}Fb(L=[]){const F=this.Gb(L),W=new S.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:W.segments[U].id,from:"touchbar"})}});return W}Gb(L=[]){return L.map(W=>{let U;W.icon&&!l.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===g.Schemas.file&&(U=S.nativeImage.createFromPath(y.URI.revive(W.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:U?void 0:$,icon:U}})}dispose(){super.dispose(),this.M.deregisterLoggers(this.id),this.l=null}};te.a="windowControlHeight",te.b=void 0,te=ve([Q(1,D.ILogService),Q(2,q.ILoggerMainService),Q(3,f.IEnvironmentMainService),Q(4,H.IPolicyService),Q(5,se.IUserDataProfilesMainService),Q(6,P.IFileService),Q(7,r.IApplicationStorageMainService),Q(8,r.IStorageMainService),Q(9,w.IConfigurationService),Q(10,s.IThemeMainService),Q(11,T.IWorkspacesManagementMainService),Q(12,p.IBackupMainService),Q(13,o.ITelemetryService),Q(14,a.IDialogMainService),Q(15,E.ILifecycleMainService),Q(16,t.IProductService),Q(17,c.IProtocolMainService),Q(18,I.IWindowsMainService),Q(19,ie.IStateMainService),Q(20,oe.INativeHostMainService)],te),e.CodeWindow=te}),define(Z[78],ee([0,1,15,25,8,3,45,2,14,4,18,7,23,181,6,21,5,95,96,29,53,35]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,r,o,l){super(),this.f=i,this.g=r,this.h=o,this.j=l,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let r=[],o=[];for(const s of i)if((0,m.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(r,s.workspace)&&r.push(s);else if((0,m.isRecentFolder)(s))this.s(r,s.folderUri)||r.push(s);else{const u=this.t(o,s.fileUri),I=s.fileUri.scheme===g.Schemas.file&&tt.y.indexOf((0,b.basename)(s.fileUri))>=0;!u&&!I&&(o.push(s),d.isWindows&&s.fileUri.scheme===g.Schemas.file&&S.app.addRecentDocument(s.fileUri.fsPath))}const l=await this.l({workspaces:r,files:o});r=l.workspaces,o=l.files,r.length>tt.a&&(r.length=tt.a),o.length>tt.a&&(o.length=tt.a),await this.n({workspaces:r,files:o}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const r=u=>{const I=this.p(u);for(const A of i)if(b.extUriBiasedIgnorePathCase.isEqual(A,I))return!1;return!0},o=await this.getRecentlyOpened(),l=o.workspaces.filter(r),s=o.files.filter(r);(l.length!==o.workspaces.length||s.length!==o.files.length)&&(await this.n({files:s,workspaces:l}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const r=new D.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.workspaces)for(const s of i.workspaces)r.set(this.p(s),s);const o=new D.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.files)for(const s of i.files)o.set(this.p(s),s);const l=await this.m();for(const s of l.workspaces){const u=r.get(this.p(s));u?u.label=u.label??s.label:r.set(this.p(s),s)}for(const s of l.files){const u=o.get(this.p(s));u?u.label=u.label??s.label:o.set(this.p(s),s)}return{workspaces:[...r.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const r=this.j.get(tt.b,-1);if(typeof r=="string")try{i=JSON.parse(r)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,m.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,m.toStoreData)(i)),-1,1)}p(i){return(0,m.isRecentFolder)(i)?i.folderUri:(0,m.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,r){return!!i.find(o=>(0,m.isRecentWorkspace)(o)&&o.workspace.id===r.id)}s(i,r){return!!i.find(o=>(0,m.isRecentFolder)(o)&&b.extUriBiasedIgnorePathCase.isEqual(o.folderUri,r))}t(i,r){return!!i.find(o=>b.extUriBiasedIgnorePathCase.isEqual(o.fileUri,r))}async C(){!d.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!d.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const s of S.app.getJumpListSettings().removedItems){const u=s.args;if(u){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);I&&r.push(v.URI.parse(I[2]))}}await this.removeRecentlyOpened(r);let o=!1;const l=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.w).map(s=>{const u=(0,m.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:I,description:A}=this.F(u,s.label);let T;return v.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(o=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:A.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:o?(0,h.localize)(2,null):(0,h.localize)(3,null),items:l})}i.push({type:"recent"});try{const r=S.app.setJumpList(i);r&&r!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.f.warn("updateWindowsJumpList#setJumpList",r)}}F(i,r){if(r)return{title:(0,C.splitName)(r).name,description:r};if(v.URI.isUri(i))return{title:(0,b.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let o=(0,b.basename)(i.configPath);return o.endsWith(P.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,C.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!d.isMacintosh)return;S.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),r=[];let o=0;for(let s=0;s<i.workspaces.length&&o<tt.u;s++){const u=this.p(i.workspaces[s]);if(u.scheme===g.Schemas.file){const I=(0,b.originalFSPath)(u);await y.Promises.exists(I)&&(r.push(I),o++)}}const l=[];for(let s=0;s<i.files.length&&o<tt.v;s++){const u=this.p(i.files[s]);if(u.scheme===g.Schemas.file){const I=(0,b.originalFSPath)(u);if(tt.y.includes((0,b.basename)(u))||r.includes(I))continue;await y.Promises.exists(I)&&(l.push(I),o++)}}l.reverse().forEach(s=>S.app.addRecentDocument(s)),r.reverse().forEach(s=>S.app.addRecentDocument(s))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([Q(0,a.ILogService),Q(1,E.IWorkspacesManagementMainService),Q(2,w.ILifecycleMainService),Q(3,f.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(Z[279],ee([0,1,15,8,22,45,4,7,171,19,28,21,5,219,58,20,34,24,48,76,30,78]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class vt{constructor(o,l,s,u,I,A,T,N,z,H,ie){this.n=o,this.o=l,this.p=s,this.q=u,this.r=I,this.s=A,this.t=T,this.u=N,this.v=z,this.w=H,this.x=ie,this.m=Object.create(null),this.g=new M.RunOnceScheduler(()=>this.E(),0),this.h=new M.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.isMacintosh||(0,P.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(vt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(A,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(A,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(A,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(A,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(A,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const u=this.x.licenseUrl;u&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.language){const A=u.indexOf("?")>0?"&":"?";this.Z(`${u}${A}lang=${C.language}`,"openLicenseUrl")}else this.Z(u,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&u&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(I,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,l){this.k=o.menus,this.l=o.keybindings,this.t.setItem(vt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!C.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!C.isMacintosh||(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=S.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(C.isMacintosh?new S.Menu:null);return}const l=new S.Menu;let s;if(C.isMacintosh){const I=new S.Menu;s=new S.MenuItem({label:this.x.nameShort,submenu:I}),this.I(I),l.append(s)}if(C.isMacintosh&&!this.c){this.c=!0;const I=new S.Menu;I.append(new S.MenuItem({label:this.bb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(I)}if(this.K("File")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(1,null)),submenu:I});this.M(I,"File"),l.append(A)}if(this.K("Edit")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(2,null)),submenu:I});this.M(I,"Edit"),l.append(A)}if(this.K("Selection")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(3,null)),submenu:I});this.M(I,"Selection"),l.append(A)}if(this.K("View")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(4,null)),submenu:I});this.M(I,"View"),l.append(A)}if(this.K("Go")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(5,null)),submenu:I});this.M(I,"Go"),l.append(A)}if(this.K("Run")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(6,null)),submenu:I});this.M(I,"Run"),l.append(A)}if(this.K("Terminal")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(7,null)),submenu:I});this.M(I,"Terminal"),l.append(A)}let u;if(this.K("Window")){const I=new S.Menu;u=new S.MenuItem({label:this.bb(g.localize(8,null)),submenu:I,role:"window"}),this.S(I)}if(u&&l.append(u),this.K("Help")){const I=new S.Menu,A=new S.MenuItem({label:this.bb(g.localize(9,null)),submenu:I,role:"help"});this.M(I,"Help"),l.append(A)}l.items&&l.items.length>0?S.Menu.setApplicationMenu(l):S.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const l=this.U(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let u;if(this.K("Preferences")){const se=new S.Menu;this.M(se,"Preferences"),u=new S.MenuItem({label:this.bb(g.localize(11,null)),submenu:se})}const I=new S.Menu,A=new S.MenuItem({label:g.localize(12,null),role:"services",submenu:I}),T=new S.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new S.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new S.MenuItem({label:g.localize(15,null),role:"unhide"}),H=new S.MenuItem(this.Y("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(se,oe,ue)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),ie=[l];ie.push(...s),u&&ie.push(i(),u),ie.push(i(),A,i(),T,N,z,i(),H),ie.forEach(se=>o.append(se))}async J(o){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(o)){const{response:s}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return s===0}return!0}K(o){if(!C.isMacintosh&&(0,P.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,l){l.forEach(s=>{if((0,h.isMenubarMenuItemSeparator)(s))o.append(i());else if((0,h.isMenubarMenuItemSubmenu)(s)){const u=new S.Menu,I=new S.MenuItem({label:this.bb(s.label),submenu:u});this.L(u,s.submenu.items),o.append(I)}else(0,h.isMenubarMenuItemRecentAction)(s)?o.append(this.O(s)):(0,h.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(o),C.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?o.append(new S.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):o.append(this.U(s.label,s.id,!1,s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(o,l){this.k&&this.k[l]&&this.L(o,this.k[l].items)}N(o){const l=this.T();l.length&&(l.forEach(s=>o.append(s)),o.append(i()))}O(o){const l=k.URI.revive(o.uri),s=o.id,u=s==="openRecentFile"?{fileUri:l}:s==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new S.MenuItem(this.Y(s,{label:o.label,click:async(I,A,T)=>{const N=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[u],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(o){return!!(o&&(!C.isMacintosh&&(o.ctrlKey||o.shiftKey)||C.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,l,s){const u={label:this.bb(o),role:s,enabled:!0};return new S.MenuItem(this.X(l,u))}S(o){const l=new S.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new S.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),u=new S.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.U(g.localize(23,null),"workbench.action.switchWindow"),A=[];this.C&&(A.push(i()),A.push(this.U(g.localize(24,null),"workbench.action.newWindowTab")),A.push(this.R(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.R(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.R(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.R(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,s,i(),I,...A,i(),u].forEach(T=>o.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.bb(g.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.bb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.bb(g.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.bb(g.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,l,s,u){const I=this.bb(o),A=typeof l=="function"?l:(ie,se,oe)=>{const ue=ie?ie.userSettingsLabel:null;let le=l;Array.isArray(l)&&(le=this.P(oe)?l[1]:l[0]),ue&&oe.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:le})},T=typeof s=="boolean"?s:this.p.getWindowCount()>0,N=typeof u=="boolean"?u:!1,z={label:I,click:A,enabled:T};N&&(z.type="checkbox",z.checked=N);let H;return typeof l=="string"?H=l:Array.isArray(l)&&(H=l[0]),C.isMacintosh&&(H==="editor.action.clipboardCutAction"?z.role="cut":H==="editor.action.clipboardCopyAction"?z.role="copy":H==="editor.action.clipboardPasteAction"&&(z.role="paste"),H==="undo"?z.click=this.V(A,{inDevTools:ie=>ie.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?z.click=this.V(A,{inDevTools:ie=>ie.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(z.click=this.V(A,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(H,z))}V(o,l){return(s,u,I)=>{const A=S.BrowserWindow.getFocusedWindow();if(!A)return l.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return l.inDevTools(A.webContents.devToolsWebContents);o(s,u||A,I)}}W(o){let l=S.BrowserWindow.getFocusedWindow();if(!l){const u=this.p.getLastActiveWindow();u?.isMinimized()&&(l=u.win)}const s=l?this.p.getWindowById(l.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",o),C.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const u={id:o.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",n.CancellationToken.None,u)}else{const u={userSettingsLabel:o.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,u)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,l){const s=typeof o=="string"?this.l[o]:void 0;if(s?.label){if(s.isNative!==!1)l.accelerator=s.label,l.userSettingsLabel=s.userSettingsLabel;else if(typeof l.label=="string"){const u=l.label.indexOf("[");u>=0?l.label=`${l.label.substr(0,u)} [${s.label}]`:l.label=`${l.label} [${s.label}]`}}else l.accelerator=void 0;return l}Y(o,l,s=!l.accelerator){s&&(l=this.X(o,l));const u=l.click;return l.click=(I,A,T)=>{this.ab(o),u?.(I,A,T)},l}Z(o,l){this.w.openExternal(void 0,o),this.ab(l)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,R.mnemonicMenuLabel)(o,!this.B)}};c.a="lastKnownMenubarData",c=ve([Q(0,m.IUpdateService),Q(1,d.IConfigurationService),Q(2,E.IWindowsMainService),Q(3,b.IEnvironmentMainService),Q(4,f.ITelemetryService),Q(5,D.IWorkspacesHistoryMainService),Q(6,a.IStateMainService),Q(7,v.ILifecycleMainService),Q(8,y.ILogService),Q(9,p.INativeHostMainService),Q(10,w.IProductService)],c),e.Menubar=c;function i(){return new S.MenuItem({type:"separator"})}}),define(Z[280],ee([0,1,6,21,5,279]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let C=class{constructor(g,d,b){this.b=g,this.c=d,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(g,d){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(d,g)}};C=ve([Q(0,S.IInstantiationService),Q(1,M.ILifecycleMainService),Q(2,n.ILogService)],C),e.MenubarMainService=C}),define(Z[281],ee([0,1,15,23,26,25,22,3,32,49,45,2,14,9,63,4,36,18,10,7,179,62,19,57,28,16,6,21,5,65,66,55,34,76,278,121,273,29,97,78,53,68,37,52,64]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(ne){return(0,se.isWorkspaceIdentifier)(ne?.workspace)}function J(ne){return(0,se.isSingleFolderWorkspaceIdentifier)(ne?.workspace)}let te=class at extends v.Disposable{constructor(L,F,W,U,$,V,j,K,Y,re,de,Re,Ce,De,Oe,$e,fe,pe){super(),this.k=L,this.l=F,this.m=W,this.n=U,this.r=$,this.s=V,this.t=j,this.u=K,this.v=Y,this.w=re,this.z=de,this.C=Re,this.D=Ce,this.F=De,this.G=Oe,this.H=$e,this.I=fe,this.J=pe,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const F=new v.DisposableStore;if(F.add(k.Event.any(L.onDidClose,L.onDidDestroy)(()=>F.dispose())),L.config.extensionDevelopmentPath)for(const W of L.config.extensionDevelopmentPath)F.add(this.I.addValidFileRoot(W));L.config.extensionTestsPath&&F.add(this.I.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,F){const W=this.t.args,U=F?.remoteAuthority||void 0,$=!0,V=F?.forceReuseWindow,j=!V;return this.open({...L,cli:W,forceEmpty:$,forceNewWindow:j,forceReuseWindow:V,remoteAuthority:U})}openExistingWindow(L,F){L.focus(),this.M(F,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const F=[],W=[],U=[],$=[],V=[];let j,K=0;const Y=await this.S(L);this.m.trace("windowsManager#open pathsToOpen",Y);for(const De of Y)J(De)?L.addMode?F.push(De):W.push(De):q(De)?U.push(De):De.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),j.filesToOpenOrCreate.push(De)):De.backupPath?V.push({backupFolder:(0,h.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):K++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?($.push(...this.D.getUntitledWorkspaces()),U.push(...$),V.push(...this.w.getEmptyWindowBackups())):V.length=0;const{windows:re,filesOpenedInWindow:de}=await this.N(L,U,W,V,K,j,F);if(this.m.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${W.length}, emptyToRestore: ${V.length}, emptyToOpen: ${K})`),re.length>1)if(de)de.focus();else{const De=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Oe=!0,$e=!0;if(De){const fe=re.filter(pe=>this.j.state.lastActiveWindow&&pe.backupPath===this.j.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),Oe=!1,$e=!1)}if(Oe)for(let fe=re.length-1;fe>=0;fe--){const pe=re[fe];if(!(pe.openedWorkspace&&$.some(Me=>pe.openedWorkspace&&Me.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&V.some(Me=>pe.backupPath&&Me.backupFolder===(0,h.basename)(pe.backupPath)))){pe.focus(),$e=!1;break}}$e&&re[re.length-1].focus()}const Re=j&&j.filesToDiff.length>0,Ce=j&&j.filesToMerge.length>0;if(!re.some(De=>De.isExtensionDevelopmentHost)&&!Re&&!Ce&&!L.noRecentEntry){const De=[];for(const Oe of Y)q(Oe)&&!Oe.transient?De.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):J(Oe)?De.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&De.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.C.addRecentlyOpened(De)}return this.M(L,re),re}M(L,F){const W=L.waitMarkerFileURI;L.context===0&&W&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async N(L,F,W,U,$,V,j){const K=[];let Y;function re(fe,pe){K.push(fe),pe&&(Y=fe,V=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:Re}=this.fb(L);if(!L.initialStartup&&j.length>0){const fe=j[0].remoteAuthority,pe=this.kb(fe);pe&&re(this.P(pe,j.map(Me=>Me.workspace.uri)))}const Ce=W.length+F.length+U.length;if(V&&Ce===0){const fe=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],pe=this.getWindows().filter(_=>V&&(0,f.isEqualAuthority)(_.remoteAuthority,V.remoteAuthority));let Me;fe?.fileUri&&!Re&&((L.context===4||L.context===0||L.context===1)&&(Me=await(0,H.findWindowOnFile)(pe,fe.fileUri,async _=>_.configPath.scheme===y.Schemas.file?this.D.resolveLocalWorkspace(_.configPath):void 0)),Me||(Me=this.lb(pe))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?W.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):re(this.O(L,Me,V),!0):re(await this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const De=(0,R.distinct)(F,fe=>fe.workspace.id);if(De.length>0){const fe=(0,R.coalesce)(De.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],Me=(0,f.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of De){if(fe.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===pe.workspace.id))continue;const Me=pe.remoteAuthority,_=(0,f.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,_),!!_),de=!0}}const Oe=(0,R.distinct)(W,fe=>f.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(Oe.length>0){const fe=(0,R.coalesce)(Oe.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],Me=(0,f.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of Oe){if(fe.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,pe.workspace.uri)))continue;const Me=pe.remoteAuthority,_=(0,f.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,_),!!_),de=!0}}const $e=(0,R.distinct)(U,fe=>fe.backupFolder);if($e.length>0)for(const fe of $e){const pe=fe.remoteAuthority,Me=(0,f.isEqualAuthority)(V?.remoteAuthority,pe)?V:void 0;re(await this.Q(L,!0,pe,Me,fe),!!Me),de=!0}if(K.length===0||V){V&&!$&&$++;const fe=V?V.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<$;pe++)re(await this.Q(L,de,fe,V),!!V),de=!0}return{windows:(0,R.distinct)(K),filesOpenedInWindow:Y}}O(L,F,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),F.focus();const U={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",C.CancellationToken.None,U),F}P(L,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),L.focus();const W={foldersToAdd:F};return L.sendWhenReady("vscode:addFolders",C.CancellationToken.None,W),L}Q(L,F,W,U,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:U,forceNewWindow:F});let V;return!F&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:U,windowToUse:V,emptyWindowBackupInfo:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}R(L,F,W,U,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:U}),!W&&!$&&typeof L.contextWindowId=="number"&&($=this.getWindowById(L.contextWindowId)),this.gb({workspace:F.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:U,windowToUse:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async S(L){let F,W=!1,U=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(F=await this.U(L),W=!0):L.forceEmpty?F=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(F=await this.W(L.cli),F.length===0&&F.push(Object.create(null)),W=!0):(F=await this.Y(),F.length===0&&F.push(Object.create(null)),U=!0),!L.addMode&&W){const $=F.filter(V=>J(V));if($.length>1){const V=$[0].remoteAuthority;if($.every(j=>(0,f.isEqualAuthority)(j.remoteAuthority,V))){const j=await this.D.createUntitledWorkspace($.map(K=>({uri:K.workspace.uri})));F.push({workspace:j,remoteAuthority:V}),F=F.filter(K=>!J(K))}}}if(L.initialStartup&&!U&&this.z.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();F.unshift(...$.filter(V=>q(V)||J(V)||V.backupPath))}return F}async U(L){const F={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},W=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async U=>{const $=await this.ab(U,F);if($)return $.label=U.label,$;const V=this.cb(U);this.G.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:V.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:V.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,b.getPathLabel)(V,{os:w.OS,tildify:this.t})):(0,E.localize)(4,null,V.toString(!0))},(0,m.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(L){const F=[],W={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},U=L["folder-uri"];if(U){const j=await Promise.all(U.map(K=>{const Y=this.X(K);if(!!Y)return this.ab({folderUri:Y},W)}));F.push(...(0,R.coalesce)(j))}const $=L["file-uri"];if($){const j=await Promise.all($.map(K=>{const Y=this.X(K);if(!!Y)return this.ab((0,se.hasWorkspaceFileExtension)(K)?{workspaceUri:Y}:{fileUri:Y},W)}));F.push(...(0,R.coalesce)(j))}const V=await Promise.all(L._.map(j=>W.remoteAuthority?this.eb(j,W):this.db(j,W)));return F.push(...(0,R.coalesce)(V)),F}X(L){try{const F=P.URI.parse(L);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${L}, ${F.message}`)}}async Y(){const L=this.Z();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];L!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const W=await Promise.all(F.map(async U=>{if(U.workspace){const $=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(q($))return $}else if(U.folderUri){const $=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(J($))return $}else if(L!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async ab(L,F=Object.create(null)){const W=this.cb(L);return W.scheme===y.Schemas.file?((0,N.isFileToOpen)(L)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,F)):this.bb(L,F)}bb(L,F){let W=this.cb(L);const U=(0,A.getRemoteAuthority)(W)||F.remoteAuthority;if(W=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(W)),(0,N.isFileToOpen)(L)){if(F.gotoLineMode){const{path:$,line:V,column:j}=(0,g.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:V?{startLineNumber:V,startColumn:j||1}:void 0},remoteAuthority:U}}return{fileUri:W,remoteAuthority:U}}else if((0,N.isWorkspaceToOpen)(L))return{workspace:(0,oe.getWorkspaceIdentifier)(W),remoteAuthority:U};return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:U}}cb(L){return(0,N.isWorkspaceToOpen)(L)?L.workspaceUri:(0,N.isFolderToOpen)(L)?L.folderUri:L.fileUri}async db(L,F){let W,U;F.gotoLineMode&&({path:L,line:W,column:U}=(0,g.parseLineAndColumnAware)(L)),L=(0,g.sanitizeFilePath)((0,h.normalize)(L),(0,a.cwd)());try{const $=await M.Promises.stat(L);if($.isFile()){if(!F.forceOpenWorkspaceAsFile){const V=await this.D.resolveLocalWorkspace(P.URI.file(L));if(V)return V.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:r.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:P.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:U||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(P.URI.file(L),$),type:r.FileType.Directory,exists:!0};if(!w.isWindows&&L==="/dev/null")return{fileUri:P.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const V=P.URI.file(L);if(this.C.removeRecentlyOpened([V]),F.ignoreFileNotFound)return{fileUri:V,type:r.FileType.File,exists:!1}}}eb(L,F){const W=L.charCodeAt(0),U=F.remoteAuthority;let $,V;F.gotoLineMode&&({path:L,line:$,column:V}=(0,g.parseLineAndColumnAware)(L)),W!==47&&((0,g.isWindowsDriveLetter)(W)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,g.toSlashes)(L)),L=`/${L}`);const j=P.URI.from({scheme:y.Schemas.vscodeRemote,authority:U,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return F.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,oe.getWorkspaceIdentifier)(j),remoteAuthority:U};if(F.gotoLineMode||h.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:U}}return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:U}}fb(L){const F=this.z.getValue("window"),W=F?.openFoldersInNewWindow||"default",U=F?.openFilesInNewWindow||"off";let $=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let V=!1;return L.forceNewWindow||L.forceReuseWindow?V=!!L.forceNewWindow&&!L.forceReuseWindow:(w.isMacintosh?L.context===1&&(V=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!L.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(V=U==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(L,F){const W=(0,H.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(W)return this.v.reload(W,F.cli),W.focus(),[W];let U=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],V=F.cli._;if(!V.length&&!U.length&&!$.length&&!F.cli.extensionTestsPath){const Y=this.j.state.lastPluginDevelopmentHostWindow,re=Y?.workspace??Y?.folderUri;re&&(P.URI.isUri(re)?re.scheme===y.Schemas.file?V=[re.fsPath]:U=[re.toString()]:re.configPath.scheme===y.Schemas.file?V=[(0,f.originalFSPath)(re.configPath)]:$=[re.configPath.toString()])}let j=F.remoteAuthority;for(const Y of L)if(Y.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=P.URI.parse(Y),de=(0,A.getRemoteAuthority)(re);de&&(j?(0,f.isEqualAuthority)(de,j)||this.m.error("more than one extension development path authority"):j=de)}V=V.filter(Y=>{const re=P.URI.file(Y);return(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,f.isEqualAuthority)((0,A.getRemoteAuthority)(re),j)}),U=U.filter(Y=>{const re=this.X(Y);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,f.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),$=$.filter(Y=>{const re=this.X(Y);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,f.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),F.cli._=V,F.cli["folder-uri"]=U,F.cli["file-uri"]=$;const K={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!V.length&&!U.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(K)}async gb(L){const F=this.z.getValue("window"),W=this.getLastActiveWindow(),U=W?.profile??this.u.defaultProfile;let $;!L.forceNewWindow&&!L.forceNewTabbedWindow&&($=L.windowToUse||W,$&&$.focus());const V={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,h.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:U},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:u.default,isInitialStartup:L.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if($){const j=$.config;!V.extensionDevelopmentPath&&j?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=j.extensionDevelopmentPath,V.extensionDevelopmentKind=j.extensionDevelopmentKind,V["enable-proposed-api"]=j["enable-proposed-api"],V.verbose=j.verbose,V["inspect-extensions"]=j["inspect-extensions"],V["inspect-brk-extensions"]=j["inspect-brk-extensions"],V.debugId=j.debugId,V.extensionEnvironment=j.extensionEnvironment,V["extensions-dir"]=j["extensions-dir"],V["disable-extensions"]=j["disable-extensions"]),V.loggers=j?.loggers??V.loggers}else{const j=this.j.getNewWindowState(V);(0,p.mark)("code/willCreateCodeWindow");const K=$=this.F.createInstance(z.CodeWindow,{state:j,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),at.a.push(K),this.b.fire(K),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(K.onDidSignalReady)(()=>this.c.fire(K)),(0,d.once)(K.onDidClose)(()=>this.jb(K)),(0,d.once)(K.onDidDestroy)(()=>this.f.fire(K)),K.onDidTriggerSystemContextMenu(({x:re,y:de})=>this.h.fire({window:K,x:re,y:de}));const Y=(0,m.assertIsDefined)(K.win?.webContents);Y.removeAllListeners("devtools-reload-page"),Y.on("devtools-reload-page",()=>this.v.reload(K)),this.v.registerWindow(K)}return V.windowId=$.id,$.isReady?this.v.unload($,4).then(async j=>{j||await this.hb($,V,L,U)}):await this.hb($,V,L,U),$}async hb(L,F,W,U){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.w.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,oe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.u.isEnabled()){const $=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),V=this.ib(W,$,U),j=V instanceof Promise?await V:V;F.profiles.profile=j,F.extensionDevelopmentPath||await this.u.setProfileForWorkspace($,j)}L.load(F)}ib(L,F,W){return L.forceProfile?this.u.profiles.find(U=>U.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(F)??W}jb(L){const F=at.a.indexOf(L);at.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(L){return this.lb(this.getWindows().filter(F=>(0,f.isEqualAuthority)(F.remoteAuthority,L)))}lb(L){const F=Math.max.apply(Math,L.map(W=>W.lastFocusTime));return L.find(W=>W.lastFocusTime===F)}sendToFocused(L,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,C.CancellationToken.None,...F)}sendToAll(L,F,W){for(const U of this.getWindows())W&&W.indexOf(U.id)>=0||U.sendWhenReady(L,C.CancellationToken.None,F)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(L){const F=this.getWindows().filter(W=>W.id===L);return(0,R.firstOrDefault)(F)}getWindowByWebContents(L){const F=S.BrowserWindow.fromWebContents(L);if(!!F)return this.getWindowById(F.id)}};te.a=[],te=ve([Q(2,s.ILogService),Q(3,O.ILoggerMainService),Q(4,T.IStateMainService),Q(5,G.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,B.IUserDataProfilesMainService),Q(8,l.ILifecycleMainService),Q(9,D.IBackupMainService),Q(10,t.IConfigurationService),Q(11,ue.IWorkspacesHistoryMainService),Q(12,le.IWorkspacesManagementMainService),Q(13,o.IInstantiationService),Q(14,c.IDialogMainService),Q(15,r.IFileService),Q(16,I.IProtocolMainService),Q(17,me.IThemeMainService)],te),e.WindowsMainService=te}),define(Z[282],ee([0,1,62,30,78,53]),function(x,e,S,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(g,d,b,v){this.a=g,this.b=d,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,d){const b=this.b.getWindowById(g);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),d)}createUntitledWorkspace(g,d,b){return this.a.createUntitledWorkspace(d,b)}deleteUntitledWorkspace(g,d){return this.a.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(g,d){return this.a.getWorkspaceIdentifier(d)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,d){return this.c.addRecentlyOpened(d)}removeRecentlyOpened(g,d){return this.c.removeRecentlyOpened(d)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};C=ve([Q(0,R.IWorkspacesManagementMainService),Q(1,M.IWindowsMainService),Q(2,n.IWorkspacesHistoryMainService),Q(3,S.IBackupMainService)],C),e.WorkspacesMainService=C}),define(Z[283],ee([0,1,15,42,26,17,44,13,32,49,43,45,2,14,9,4,10,7,31,137,47,151,104,256,154,62,274,19,74,187,87,122,57,107,209,28,61,113,199,222,200,261,109,201,202,16,213,90,73,6,89,275,235,258,21,5,280,58,20,55,268,91,34,264,95,92,24,240,115,51,48,247,248,276,249,277,118,251,252,253,254,262,30,281,263,29,96,78,282,53,257,37,221,52,231,56,77,120,266,272,270,8,116,265,216,64,88]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q,J,te,ne,L,F,W,U,$,V,j,K,Y,re,de,Re,Ce,De,Oe,$e,fe,pe,Me,_,ce,he,Ie,Ae,Te,Fe,je,ze,We,He,X,ae,ge,be,we,Le,Ue,Ve,Ge,Ke,Ye,Ze,rt,ct,ft,kt,Dt,Ct,Rt,Mt,At,Lt,gt,Ot,Tt,Ft,Wt,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends y.Disposable{constructor(Pe,Ee,ye,Se,ke,Be,Xe,Qe,qe,Ne,xe){super(),this.c=Pe,this.f=Ee,this.g=ye,this.h=Se,this.i=ke,this.j=Be,this.k=Xe,this.l=Qe,this.m=qe,this.n=Ne,this.p=xe,this.r(),this.s()}r(){const Pe=qe=>qe?.startsWith(`${h.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?xe(Ee.has(Ne)):xe(!1)),S.session.defaultSession.setPermissionCheckHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?Ee.has(Ne):!1);const ye=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},ke=qe=>qe.resourceType==="xhr"||Se(qe.frame),Be=qe=>{const Ne=qe.frame;if(!Ne||!this.a)return!1;const xe=S.BrowserWindow.getAllWindows();for(const Je of xe)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const xe=f.URI.parse(qe.url);return xe.scheme===h.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):xe.scheme===h.Schemas.vscodeFileResource&&!Be(qe)?(this.h.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!ye.has(xe.scheme)?Ne({cancel:!ke(qe)}):Ne({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=f.URI.parse(qe.url);if(_e.path.endsWith(".svg")&&ye.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(h.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!ke(qe)})}return Ne({cancel:!1})});const Qe=S.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,p.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(ye=>this.u(ye)),process.on("uncaughtException",ye=>(0,k.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye)),this.j.onWillShutdown(()=>this.dispose()),(0,P.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(ye,Se)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Se)}),S.app.on("activate",async(ye,Se)=>{this.h.trace("app#activate"),Se||await this.a?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(ye,Se)=>{Se.on("will-navigate",ke=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.b?.openExternal(void 0,ke),{action:"deny"}))});let Pe=[],Ee;S.app.on("open-file",(ye,Se)=>{this.h.trace("app#open-file: ",Se),ye.preventDefault(),Pe.push((0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:f.URI.file(Se)}:{fileUri:f.URI.file(Se)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),M.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const Se=this.a?.getWindowByWebContents(ye.sender);let ke,Be;return Se?.config?(ke=Se.config,Be={...process.env,...Se.config.userEnv}):(ke=this.i.args,Be=process.env),this.M(ke,Be,!1)}),M.validatedIpcMain.handle("vscode:writeNlsFile",(ye,Se,ke)=>{const Be=this.t([Se]);if(!Be||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,R.VSBuffer.fromString(ke))}),M.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...Se)=>{const ke=this.t(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(ke)).value.toString()}),M.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),M.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),M.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}t(Pe){let Ee;for(const ye of Pe)typeof ye=="string"&&(typeof Ee!="string"?Ee=ye:Ee=(0,p.join)(Ee,ye));if(!(typeof Ee!="string"||!(0,p.isAbsolute)(Ee)||!(0,g.isEqualOrParent)(Ee,this.i.cachedLanguagesPath,!w.isLinux)))return f.URI.file(Ee)}u(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;w.isWindows&&Pe&&S.app.setAppUserModelId(Pe);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ee=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ee.dispose()}),this.h.trace("Resolving machine identifier...");const ye=await(0,Ot.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:Be}=this.D(ye),Xe=await this.F(ye,Se,ke);this.B(Xe.createInstance(c.ProxyAuthHandler)),this.B(Xe.createInstance(At.UserDataProfilesHandler)),Xe.invokeFunction(Ne=>this.G(Ne,Ee,Be));const Qe=Xe.invokeFunction(Ne=>this.v(Ne,Ee));this.j.phase=2,await Xe.invokeFunction(Ne=>this.H(Ne,Qe)),this.j.phase=3,Xe.invokeFunction(Ne=>this.I(Ne,Se)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=Pe.get(ze.IURLService),ke=this.b=Pe.get(Y.INativeHostMainService),Be=this;Se.registerHandler({async handleURL(Je,_e){return Be.C(ye,Se,Je,_e)}});const Xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new E.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),qe=new We.URLHandlerRouter(Qe,this.h),Ne=Ee.getChannel("urlHandler",qe);Se.registerHandler(new We.URLHandlerChannelClient(Ne));const xe=this.w();return this.B(new X.ElectronURLListener(xe?.urls,Se,ye,this.i,this.n,this.h)),xe}w(){const Pe=this.i.args["open-url"]?this.i.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const ye=[];return{urls:[...Pe,...Ee].map(ke=>{try{return{uri:f.URI.parse(ke),originalUrl:ke}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.y(ke.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Be=this.z(ke.uri);return Be?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Be),ye.push(Be),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:ye}}y(Pe){if(Pe.authority===h.Schemas.file&&w.isWindows){const{options:Ee,buttonIndeces:ye}=(0,Ut.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(Pe,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(ye[S.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}z(Pe){if(!!Pe.path){if(Pe.authority===h.Schemas.file){const Ee=f.URI.file(Pe.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===h.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(p.posix.sep,1);if(Ee!==-1){const ye=Pe.path.substring(1,Ee),Se=Pe.path.substring(Ee),ke=f.URI.from({scheme:h.Schemas.vscodeRemote,authority:ye,path:Se,query:Pe.query,fragment:Pe.fragment});return(0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}async C(Pe,Ee,ye,Se){if(this.h.trace("app#handleProtocolUrl():",ye.toString(!0),Se),ye.scheme===this.n.urlProtocol&&ye.path==="workspace"&&(ye=ye.with({authority:"file",path:f.URI.parse(ye.query).path,query:""})),this.y(ye))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",ye.toString(!0)),!0;let ke=!1;const Be=new URLSearchParams(ye.query);Be.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ye.toString(!0)),Be.delete("windowId"),ye=ye.with({query:Be.toString()}),ke=!0):w.isMacintosh&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ye.toString(!0)),ke=!0);const Xe=Be.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ye.toString(!0)),Be.delete("continueOn"),ye=ye.with({query:Be.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.z(ye);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0});return qe.focus(),!0}if(ke){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(ye)});return await qe.ready(),Ee.open(ye,Se)}return this.h.trace("app#handleProtocolUrl(): not handled",ye.toString(!0),Se),!1}D(Pe){const Ee=this.B(this.g.createInstance(Re.SharedProcess,Pe,this.f)),ye=(async()=>{this.h.trace("Main->SharedProcess#connect");const ke=await Ee.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(ke,"main")})(),Se=(async()=>(await Ee.whenReady(),ye))();return{sharedProcess:Ee,sharedProcessReady:Se,sharedProcessClient:ye}}async F(Pe,Ee,ye){const Se=new F.ServiceCollection;switch(process.platform){case"win32":Se.set(he.IUpdateService,new ne.SyncDescriptor(je.Win32UpdateService));break;case"linux":w.isLinuxSnap?Se.set(he.IUpdateService,new ne.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(he.IUpdateService,new ne.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Se.set(he.IUpdateService,new ne.SyncDescriptor(Ae.DarwinUpdateService));break}Se.set(be.IWindowsMainService,new ne.SyncDescriptor(we.WindowsMainService,[Pe,this.f],!1));const ke=new T.DialogMainService(this.h,this.n);Se.set(T.IDialogMainService,ke),Se.set($.ILaunchMainService,new ne.SyncDescriptor($.LaunchMainService,void 0,!1)),Se.set(A.IDiagnosticsMainService,new ne.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),Se.set(I.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(ye.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(W.IIssueMainService,new ne.SyncDescriptor(W.IssueMainService,[this.f])),Se.set(N.IEncryptionMainService,new ne.SyncDescriptor(z.EncryptionMainService,[Pe])),Se.set(U.IKeyboardLayoutMainService,new ne.SyncDescriptor(U.KeyboardLayoutMainService)),Se.set(Y.INativeHostMainService,new ne.SyncDescriptor(Y.NativeHostMainService,[Ee],!1)),Se.set(s.ICredentialsMainService,new ne.SyncDescriptor(Ze.CredentialsNativeMainService)),Se.set(ae.IWebviewManagerService,new ne.SyncDescriptor(ge.WebviewMainService)),Se.set(K.IMenubarMainService,new ne.SyncDescriptor(K.MenubarMainService)),Se.set(oe.IExtensionUrlTrustService,new ne.SyncDescriptor(ue.ExtensionUrlTrustService)),Se.set(le.IExtensionHostStarter,new ne.SyncDescriptor(me.ExtensionHostStarter)),Se.set($e.IStorageMainService,new ne.SyncDescriptor($e.StorageMainService)),Se.set($e.IApplicationStorageMainService,new ne.SyncDescriptor($e.ApplicationStorageMainService)),w.isWindows?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.WindowsExternalTerminalService)):w.isMacintosh?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.MacExternalTerminalService)):w.isLinux&&Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.LinuxExternalTerminalService));const Be=new o.BackupMainService(this.i,this.k,this.h,this.l);Se.set(r.IBackupMainService,Be);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,Be,ke);if(Se.set(Ye.IWorkspacesManagementMainService,Xe),Se.set(Ve.IWorkspacesService,new ne.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new ne.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(ze.IURLService,new ne.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,ce.supportsTelemetry)(this.n,this.i)){const Qe=(0,ce.isInternalTelemetry)(this.n,this.k),qe=(0,E.getDelayedChannel)(ye.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new Me.TelemetryAppenderClient(qe),xe=(0,fe.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,Pe,Qe,this.i.installSourcePath),Je=(0,ce.getPiiPathsFromEnvironment)(this.i),_e={appenders:[Ne],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Se.set(pe.ITelemetryService,new ne.SyncDescriptor(_.TelemetryService,[_e],!1))}else Se.set(pe.ITelemetryService,ce.NullTelemetryService);return Se.set(Ct.IExtensionsProfileScannerService,new ne.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),Se.set(Rt.IExtensionsScannerService,new ne.SyncDescriptor(Mt.ExtensionsScannerService,void 0,!0)),await gt.Promises.settled([Be.initialize(),Xe.initialize()]),this.g.createChild(Se)}G(Pe,Ee,ye){const Se=E.ProxyChannel.fromService(Pe.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Se);const ke=E.ProxyChannel.fromService(Pe.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",ke);const Be=new ct.PolicyChannel(Pe.get(rt.IPolicyService));Ee.registerChannel("policy",Be),ye.then(et=>et.registerChannel("policy",Be));const Xe=this.m.getProvider(h.Schemas.file);(0,a.assertType)(Xe instanceof te.DiskFileSystemProvider);const Qe=new J.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ee.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),ye.then(et=>et.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const qe=E.ProxyChannel.fromService(Pe.get(ft.IUserDataProfilesMainService));Ee.registerChannel("userDataProfiles",qe),ye.then(et=>et.registerChannel("userDataProfiles",qe));const Ne=new kt.RequestChannel(Pe.get(Dt.IRequestService));ye.then(et=>et.registerChannel("request",Ne));const xe=new Ie.UpdateChannel(Pe.get(he.IUpdateService));Ee.registerChannel("update",xe);const Je=E.ProxyChannel.fromService(Pe.get(W.IIssueMainService));Ee.registerChannel("issue",Je);const _e=E.ProxyChannel.fromService(Pe.get(N.IEncryptionMainService));Ee.registerChannel("encryption",_e);const nt=E.ProxyChannel.fromService(Pe.get(s.ICredentialsMainService));Ee.registerChannel("credentials",nt);const it=E.ProxyChannel.fromService(Pe.get(Ce.ISignService));Ee.registerChannel("sign",it);const lt=E.ProxyChannel.fromService(Pe.get(U.IKeyboardLayoutMainService));Ee.registerChannel("keyboardLayout",lt),this.b=Pe.get(Y.INativeHostMainService);const bt=E.ProxyChannel.fromService(this.b);Ee.registerChannel("nativeHost",bt),ye.then(et=>et.registerChannel("nativeHost",bt));const Nt=E.ProxyChannel.fromService(Pe.get(Ve.IWorkspacesService));Ee.registerChannel("workspaces",Nt);const jt=E.ProxyChannel.fromService(Pe.get(K.IMenubarMainService));Ee.registerChannel("menubar",jt);const Bt=E.ProxyChannel.fromService(Pe.get(ze.IURLService));Ee.registerChannel("url",Bt);const $t=E.ProxyChannel.fromService(Pe.get(oe.IExtensionUrlTrustService));Ee.registerChannel("extensionUrlTrust",$t);const zt=E.ProxyChannel.fromService(Pe.get(ae.IWebviewManagerService));Ee.registerChannel("webview",zt);const yt=this.B(new Oe.StorageDatabaseChannel(this.h,Pe.get($e.IStorageMainService)));Ee.registerChannel("storage",yt),ye.then(et=>et.registerChannel("storage",yt));const qt=this.B(new Lt.ProfileStorageChangesListenerChannel(Pe.get($e.IStorageMainService),Pe.get(ft.IUserDataProfilesMainService),this.h));ye.then(et=>et.registerChannel("profileStorageListener",qt));const Ht=E.ProxyChannel.fromService(Pe.get(G.IExternalTerminalMainService));Ee.registerChannel("externalTerminal",Ht);const St=new Ft.LoggerChannel(Pe.get(Wt.ILoggerMainService));Ee.registerChannel("logger",St),ye.then(et=>et.registerChannel("logger",St));const Vt=new u.ElectronExtensionHostDebugBroadcastChannel(Pe.get(be.IWindowsMainService));Ee.registerChannel("extensionhostdebugservice",Vt);const xt=E.ProxyChannel.fromService(Pe.get(le.IExtensionHostStarter));Ee.registerChannel(le.ipcExtensionHostStarterChannelName,xt)}async H(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=(0,ie.isLaunchedFromCli)(process.env)?0:4,ke=this.i.args;if(Ee){if(Ee.openables.length>0)return ye.open({context:Se,cli:ke,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Xe=ke._.length,Qe=!!ke["folder-uri"],qe=!!ke["file-uri"],Ne=ke["skip-add-to-recently-opened"]===!0,xe=ke.wait&&ke.waitMarkerFilePath?f.URI.file(ke.waitMarkerFilePath):void 0,Je=ke.remote||void 0,_e=ke.profile,nt=ke["profile-temp"];if(!Xe&&!Qe&&!qe){if(ke["new-window"]||_e||nt)return ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(Be.length)return ye.open({context:1,cli:ke,urisToOpen:Be.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:f.URI.file(it)}:{fileUri:f.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return ye.open({context:Se,cli:ke,forceNewWindow:ke["new-window"]||!Xe&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(Pe,Ee){const ye=Pe.get(pe.ITelemetryService),Se=Pe.get(he.IUpdateService);this.L(ye,Ee),this.J(),S.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(ke,Be)=>{Be({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),(Se instanceof je.Win32UpdateService||Se instanceof Te.LinuxUpdateService||Se instanceof Ae.DarwinUpdateService)&&Se.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Pe=this.n.win32MutexName;if(w.isWindows&&Pe)try{const Ee=await new Promise((Se,ke)=>{x(["windows-mutex"],Se,ke)}),ye=new Ee.Mutex(Pe);(0,d.once)(this.j.onWillShutdown)(()=>ye.release())}catch(Ee){this.h.error(Ee)}}L(Pe,Ee){let ye=!1;(0,d.once)(this.j.onWillShutdown)(()=>ye=!0),this.B(Ee.onDidError(({type:Se,details:ke})=>{switch(Se){case 2:this.h.error(`SharedProcess: renderer process gone (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break;case 1:this.h.error("SharedProcess: detected unresponsive");break;case 3:this.h.error(`SharedProcess: failed to load (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break}Pe.publicLog2("sharedprocesserror",{type:Se,reason:ke?.reason,code:ke?.exitCode,visible:Ee.isVisible(),shuttingdown:ye})}))}async M(Pe,Ee,ye){try{return await(0,se.getResolvedShellEnv)(this.k,this.h,Pe,Ee)}catch(Se){const ke=(0,C.toErrorMessage)(Se);ye?this.a?.sendToFocused("vscode:showResolveShellEnvError",ke):this.h.error(ke)}return{}}async N(){try{const Ee=(await this.m.readFile(this.i.argvResource)).value.toString(),ye=JSON.parse((0,b.stripComments)(Ee)),ke=(0,ce.getTelemetryLevel)(this.k)>=1;if(ye["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],Xe=Ee.substring(0,Ee.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Xe))}else{const Be=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Be!==Ee&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};mt=ve([Q(2,L.IInstantiationService),Q(3,j.ILogService),Q(4,H.IEnvironmentMainService),Q(5,V.ILifecycleMainService),Q(6,l.IConfigurationService),Q(7,De.IStateMainService),Q(8,q.IFileService),Q(9,re.IProductService),Q(10,ft.IUserDataProfilesMainService)],mt),e.CodeApplication=mt}),define(Z[284],ee([0,1,37,8,291,2,5]),function(x,e,S,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends S.AbstractPolicyService{constructor(d,b){super(),this.j=d,this.k=b,this.a=new M.Throttler,this.b=this.B(new R.MutableDisposable)}async i(d){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`),await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,d,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}m(d){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const b in d){const v=d[b];v===void 0?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(d))}};k=ve([Q(0,C.ILogService)],k),e.NativePolicyService=k}),define(Z[285],ee([0,1,233,8,17,13,2,10,19,33,113,5,232,292]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends C.Disposable{constructor(a,f,m){super(),this.h=a,this.i=f,this.j=m,this.k(),this.B(a.onDidChangeConfiguration(P=>{P.affectsConfiguration("http")&&this.k()}))}k(){const a=this.h.getValue("http");this.a=a?.proxy,this.b=!!a?.proxyStrictSSL,this.f=a?.proxyAuthorization}async request(a,f){this.j.trace("RequestService#request (node) - begin",a.url);const{a:m,b:P}=this;let E;try{E=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(c){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",c))}const D={...process.env,...E},t=a.agent?a.agent:await(0,y.getProxyAgent)(a.url||"",D,{proxyUrl:m,strictSSL:P});a.agent=t,a.strictSSL=P,this.f&&(a.headers={...a.headers||{},"Proxy-Authorization":this.f});try{const c=await this.m(a,f);return this.j.trace("RequestService#request (node) - success",a.url),c}catch(c){throw this.j.trace("RequestService#request (node) - error",a.url,c),c}}async l(a){return((0,S.parse)(a.url).protocol==="https:"?await new Promise((P,E)=>{x(["https"],P,E)}):await new Promise((P,E)=>{x(["http"],P,E)})).request}m(a,f){return M.Promises.withAsyncBody(async(m,P)=>{const E=(0,S.parse)(a.url),D=a.getRawRequest?a.getRawRequest(a):await this.l(a),t={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,k.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password);const c=D(t,i=>{const r=(0,k.isNumber)(a.followRedirects)?a.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.m({...a,url:i.headers.location,followRedirects:r-1},f).then(m,P);else{let o=i;!a.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,h.createGunzip)())),m({res:i,stream:(0,n.streamToBufferReadableStream)(o)})}});c.on("error",P),a.timeout&&c.setTimeout(a.timeout),a.isChromiumNetwork&&c.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&c.write(a.data),c.end(),f.onCancellationRequested(()=>{c.abort(),P(new R.CancellationError)})})}async resolveProxy(a){}};p=ve([Q(0,g.IConfigurationService),Q(1,d.INativeEnvironmentService),Q(2,v.ILogService)],p),e.RequestService=p}),define(Z[286],ee([0,1,15,285]),function(x,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(C){return S.net.request}class R extends M.RequestService{request(k,g){return super.request({...k||{},getRawRequest:n,isChromiumNetwork:!0},g)}}e.RequestMainService=R}),define(Z[293],ee([0,1,15,41,7,25,8,44,13,32,49,45,14,9,63,4,36,27,23,47,86,283,11,19,226,239,28,61,191,16,211,90,73,207,89,21,214,5,65,20,66,267,117,245,56,286,91,234,34,238,51,68,52,37,284,220,2,38,250,64,215,88,246]),function(x,e,S,M,n,R,C,k,g,d,b,v,y,h,p,w,a,f,m,P,E,D,t,c,i,r,o,l,s,u,I,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q,J,te,ne,L,F,W,U,$,V,j,K,Y,re,de,Re,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class De{main(){try{this.a()}catch(fe){console.error(fe.message),S.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(Te=>console.error(Te));const[fe,pe,Me,_,ce,he,Ie,Ae]=this.b();try{try{await this.d(Me,Ae,_,ce,Ie)}catch(Te){throw this.f(Me,Ie,Te),Te}await fe.invokeFunction(async Te=>{const Fe=Te.get(se.ILogService),je=Te.get(H.ILifecycleMainService),ze=Te.get(u.IFileService),We=Te.get(se.ILoggerService),He=await this.e(Fe,Me,je,fe,Ie,!0);return m.Promises.writeFile(Me.mainLockfile,String(process.pid)).catch(X=>{Fe.warn(`app#startup(): Error writing main lockfile: ${X.stack}`)}),he.logger=We.createLogger(n.URI.file((0,h.join)(Me.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,b.once)(je.onWillShutdown)(X=>{ze.dispose(),_.dispose(),X.join("instanceLockfile",m.Promises.unlink(Me.mainLockfile).catch(()=>{}))}),fe.createInstance(D.CodeApplication,He,pe).startup()})}catch(Te){fe.invokeFunction(this.i,Te)}}b(){const fe=new z.ServiceCollection,pe=new K.DisposableStore;process.once("exit",()=>pe.dispose());const Me={_serviceBrand:void 0,...oe.default};fe.set(ue.IProductService,Me);const _=new o.EnvironmentMainService(this.j(),Me),ce=this.c(_);fe.set(o.IEnvironmentMainService,_);const he=new de.LoggerMainService((0,se.getLogLevel)(_));fe.set(de.ILoggerMainService,he);const Ie=new ie.BufferLogger(he.getLogLevel()),Ae=pe.add(new Re.LogService(Ie,[new se.ConsoleMainLogger(he.getLogLevel())]));fe.set(se.ILogService,Ae);const Te=new I.FileService(Ae);fe.set(u.IFileService,Te);const Fe=new A.DiskFileSystemProvider(Ae);Te.registerProvider(y.Schemas.file,Fe);const je=new re.UriIdentityService(Te);fe.set(Y.IUriIdentityService,je);const ze=new L.StateMainService(_,Ae,Te);fe.set(ne.IStateMainService,ze);const We=new U.UserDataProfilesMainService(ze,je,_,Te,Ae);fe.set(U.IUserDataProfilesMainService,We);const He=w.isWindows&&Me.win32RegValueName?pe.add(new V.NativePolicyService(Ae,Me.win32RegValueName)):_.policyFile?pe.add(new j.FilePolicyService(_.policyFile,Te,Ae)):new $.NullPolicyService;fe.set($.IPolicyService,He);const X=new i.ConfigurationService(We.defaultProfile.settingsResource,Te,He,Ae);return fe.set(c.IConfigurationService,X),fe.set(H.ILifecycleMainService,new T.SyncDescriptor(H.LifecycleMainService,void 0,!1)),fe.set(O.IRequestService,new T.SyncDescriptor(q.RequestMainService,void 0,!0)),fe.set(W.IThemeMainService,new T.SyncDescriptor(W.ThemeMainService)),fe.set(J.ISignService,new T.SyncDescriptor(te.SignService,void 0,!1)),fe.set(G.ITunnelService,new T.SyncDescriptor(B.TunnelService)),fe.set(le.IProtocolMainService,new me.ProtocolMainService(_,We,Ae)),[new N.InstantiationService(fe,!0),ce,_,X,ze,Ie,Me,We]}c(fe){const pe={VSCODE_IPC_HOOK:fe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Me=>{const _=process.env[Me];typeof _=="string"&&(pe[Me]=_)}),Object.assign(process.env,pe),pe}async d(fe,pe,Me,_,ce){await C.Promises.settled([Promise.all([fe.extensionsPath,fe.codeCachePath,fe.logsPath,pe.defaultProfile.globalStorageHome.fsPath,fe.workspaceStorageHome.fsPath,fe.localHistoryHome.fsPath,fe.backupHome].map(he=>he?m.Promises.mkdir(he,{recursive:!0}):void 0)),_.init(),Me.initialize()]),pe.init()}async e(fe,pe,Me,_,ce,he){let Ie;try{(0,p.mark)("code/willStartMainServer"),Ie=await(0,E.serve)(pe.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,b.once)(Me.onWillShutdown)(()=>Ie.dispose())}catch(Ae){if(Ae.code!=="EADDRINUSE")throw this.f(pe,ce,Ae),Ae;let Te;try{Te=await(0,E.connect)(pe.mainIPCHandle,"main")}catch(We){if(!he||w.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.g((0,t.localize)(1,null,ce.nameShort),(0,t.localize)(2,null),ce),We;try{(0,M.unlinkSync)(pe.mainIPCHandle)}catch(He){throw fe.warn("Could not delete obsolete instance handle",He),He}return this.e(fe,pe,Me,_,ce,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const We=`Running extension tests from the command line is currently only supported if no other instance of ${ce.nameShort} is running.`;throw fe.error(We),Te.dispose(),new Error(We)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,ce.nameShort),(0,t.localize)(4,null),ce)},1e4));const je=P.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=P.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return _.invokeFunction(async()=>{const We=new r.DiagnosticsService(F.NullTelemetryService,ce),He=await ze.getMainDiagnostics(),X=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ae=await We.getDiagnostics(He,X);throw console.log(ae),new g.ExpectedError});throw w.isWindows&&await this.h(je,fe),fe.trace("Sending env to running instance..."),await je.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new g.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw fe.warn(`Warning: The --status argument can only be used if ${ce.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}f(fe,pe,Me){if(Me.code==="EACCES"||Me.code==="EPERM"){const _=(0,R.coalesce)([fe.userDataPath,fe.extensionsPath,E.XDG_RUNTIME_DIR]).map(ce=>(0,v.getPathLabel)(n.URI.file(ce),{os:w.OS,tildify:fe}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Me),_.join(`
`)),pe)}}g(fe,pe,Me){S.dialog.showMessageBoxSync((0,Ce.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:fe,detail:pe},Me).options)}async h(fe,pe){if(w.isWindows){const Me=await fe.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Me);try{(await new Promise((_,ce)=>{x(["windows-foreground-love"],_,ce)})).allowSetForegroundWindow(Me)}catch(_){pe.error(_)}}}i(fe,pe){const Me=fe.get(se.ILogService),_=fe.get(H.ILifecycleMainService);let ce=0;pe&&(pe.isExpected?pe.message&&Me.trace(pe.message):(ce=1,pe.stack?Me.error(pe.stack):Me.error(`Startup error: ${pe.toString()}`))),_.kill(ce)}j(){const fe=this.k((0,l.parseMainProcessArgv)(process.argv));if(fe.wait&&!fe.waitMarkerFilePath){const pe=(0,s.createWaitMarkerFileSync)(fe.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),fe.waitMarkerFilePath=pe)}return fe}k(fe){if(fe["open-url"]&&(fe._urls=fe._,fe._=[]),!fe.remote){const pe=this.l(fe._,fe.goto);fe._=pe}return fe}l(fe,pe){const Me=(0,a.cwd)(),_=fe.map(Ie=>{let Ae=String(Ie),Te;pe&&(Te=(0,d.parseLineAndColumnAware)(Ae),Ae=Te.path),Ae&&(Ae=this.m(Me,Ae));const Fe=(0,d.sanitizeFilePath)(Ae,Me),je=(0,h.basename)(Fe);return je&&!(0,d.isValidBasename)(je)?null:pe&&Te?(Te.path=Fe,this.n(Te)):Fe}),ce=w.isWindows||w.isMacintosh,he=(0,R.distinct)(_,Ie=>Ie&&ce?Ie.toLowerCase():Ie||"");return(0,R.coalesce)(he)}m(fe,pe){return w.isWindows&&(pe=(0,f.rtrim)(pe,'"')),pe=(0,f.trim)((0,f.trim)(pe," "),"	"),w.isWindows&&(pe=(0,h.resolve)(fe,pe),pe=(0,f.rtrim)(pe,".")),pe}n(fe){const pe=[fe.path];return typeof fe.line=="number"&&pe.push(String(fe.line)),typeof fe.column=="number"&&pe.push(String(fe.column)),pe.join(":")}}new De().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89bba3d93ace9f6799c7fa7b98969ef52b3663c3/core/vs/code/electron-main/main.js.map
